Package: midasHLA
Title: R package for immunogenomics data handling and association
        analysis
Version: 1.21.0
Authors@R: c(
  person("Christian", "Hammer", email = "hammerc6@gene.com", role = "aut"),
  person("Maciej", "Migdał", email = "mcjmigdal@gmail.com", role = c("aut", "cre")))
Description: MiDAS is a R package for immunogenetics data transformation and statistical analysis. MiDAS accepts input data in the form of HLA alleles and KIR types, and can transform it into biologically meaningful variables, enabling HLA amino acid fine mapping, analyses of HLA evolutionary divergence, KIR gene presence, as well as validated HLA-KIR interactions. Further, it allows comprehensive statistical association analysis workflows with phenotypes of diverse measurement scales. MiDAS closes a gap between the inference of immunogenetic variation and its efficient utilization to make relevant discoveries related to T cell, Natural Killer cell, and disease biology.
License: MIT + file LICENCE
Encoding: UTF-8
LazyData: true
Depends: R (>= 4.1), MultiAssayExperiment (>= 1.8.3)
Imports: assertthat (>= 0.2.0), broom (>= 0.5.1), dplyr (>= 0.8.0.1),
        formattable (>= 0.2.0.1), HardyWeinberg (>= 1.6.3), kableExtra
        (>= 1.1.0), knitr (>= 1.21), magrittr (>= 1.5), methods,
        stringi (>= 1.2.4), rlang (>= 0.3.1), S4Vectors (>= 0.20.1),
        stats, SummarizedExperiment (>= 1.12.0), tibble (>= 2.0.1),
        utils, qdapTools (>= 1.3.3)
Suggests: broom.mixed (>= 0.2.4), cowplot (>= 1.0.0), devtools (>=
        2.0.1), ggplot2 (>= 3.1.0), ggpubr (>= 0.2.5), rmarkdown,
        seqinr (>= 3.4-5), survival (>= 2.43-3), testthat (>= 2.0.1),
        tidyr (>= 1.1.2)
RoxygenNote: 7.1.1
VignetteBuilder: knitr
Collate: 'asserts.R' 'class.R' 'data.R' 'global.R' 'midasHLA.R'
        'parsingFunctions.R' 'stats.R' 'summarise.R'
        'transformationFunctions.R' 'utils.R'
biocViews: CellBiology, Genetics, StatisticalMethod
git_url: https://git.bioconductor.org/packages/midasHLA
git_branch: devel
git_last_commit: 3a3e981
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 23:48:23 UTC; biocbuild
Author: Christian Hammer [aut],
  Maciej Migdał [aut, cre]
Maintainer: Maciej Migdał <mcjmigdal@gmail.com>

# Meaningful Immunogenetic Data at Scale <img src="vignettes/MiDAS_logo.png" align="right" alt="" width="120" />

Human immunogenetic variation in the form of HLA and KIR 
types has been shown to be strongly associated with a 
multitude of immune-related phenotypes. We present MiDAS, 
an R package enabling statistical association analysis and 
using immunogenetic data transformation functions for HLA 
amino acid fine mapping, analysis of HLA evolutionary 
divergence as well as HLA-KIR interactions. MiDAS closes the 
gap between inference of immunogenetic variation and its 
efficient utilization to make meaningful discoveries.

## Installation

``` r
# Install from Bioconductor
BiocManager::install("midasHLA")

# Install development version from GitHub
devtools::install_github("Genentech/MiDAS")
```

## Usage

A user tutorial is available here: 
[https://genentech.github.io/midasHLA/articles/MiDAS_tutorial.html](https://genentech.github.io/MiDAS/articles/MiDAS_tutorial.html)

## Developers notes

### External data

The package is shipped together with external data such as 
alignment files or allele frequencies. With time, it is 
possible that those resources will become outdated. Here 
follows a brief description of scripts that can be used for
updating those data. It should be noted that data storage details,
at the external sources, may be changed. In such circumstances, 
the scripts might become obsolete. Nevertheless, they should be
a good starting point to update those sources in next package 
iterations.

`inst/scripts/download_extdata.R` script is used to download HLA 
alignments files. Those are used for translating HLA alleles to 
amino acid level. The alignments are downloaded from 
[EBI's IPD-IMGT/HLA database](www.ebi.ac.uk/ipd/imgt/hla/).
In some cases alignment files contain sequences for multiple genes,
 those will be split into separate files (eg. DRB genes)

`inst/scripts/parse_alignments.R` script pre-parses alignments files 
for package use. Purpose of using pre-parsed files is to speed up 
allele to amino acid sequence translation. Resulting `.Rdata` files 
should be then placed in `inst/extdata` replacing the old alignment 
files. 

`data-raw/allele_frequencies.R` script fetches HLA allele frequencies 
(for genes A, B, C, DQA1, DQB1, DPA1, DPB1, DRB1, DRB3, DRB4, DRB5) from 
[www.allelefrequencies.net](www.allelefrequencies.net)
database and save it in a usable format in `data` directory. This data is
then available under the `allele_frequencies` variable.

`data-raw/kir_frequencies.R` script fetches KIR genes frequencies 
(for genes 3DL3, 2DS2, 2DL2, 2DL3, 2DP1, 2DL1, 3DP1, 2DL4, 3DL1, 3DS1, 
2DL5, 2DS3, 2DS5, 2DS4, 2DS1, 3DL2) from 
[www.allelefrequencies.net](www.allelefrequencies.net)
database and save it in a usable format in `data` directory. This data is
then available under the `kir_frequencies` variable.

### Package performance

Package performance can be checked using scripts located in `inst/benchmark`. 
Briefly, we used GNU's `time` (`/usr/bin/time -v`) to measure time and memory 
consumption of data transformation and 2 workflows. All tests include loading 
package and reading in input files steps. Look into `inst/benchmark/*` for more 
details. 

## Citing
Migdal M, Ruan DF, Forrest WF, Horowitz A, Hammer C (2021) MiDAS—Meaningful Immunogenetic Data at Scale. PLOS Computational Biology 17(7): e1009131. https://doi.org/10.1371/journal.pcbi.1009131

#!/usr/bin/env R
# Download HLA frequencies from http://www.allelefrequencies.net/
devtools::load_all()
library("rvest")
library("xml2")

midas_var_hla_locus_vector <-
  c("A", "B", "C", "DQA1", "DQB1", "DPA1", "DPB1", "DRB1", "DRB3", "DRB4", "DRB5")
base_url <- "http://www.allelefrequencies.net/hla6006a.asp?"
qloci <- "hla_locus="
tab_list <- list()
for (loci in midas_var_hla_locus_vector) {
  i <- 1
  query <- paste0(base_url, "page=", as.character(i), "&", qloci, loci)
  res <- xml2::read_html(query)
  node <- rvest::html_node(res, xpath = "//*[@id='divGenDetail']/table")
  if (is.na(node)) next()
  tab <-  rvest::html_table(node)
  colnames(tab) <-
    gsub("[[:blank:]]+", " ", gsub("[^a-zA-Z%() ]", "", colnames(tab)))
  while (! is.na(node) && nrow(tab) > 0) {
    tab_list[[length(tab_list) + 1]] <- tab
    i <- i + 1
    query <- paste0(base_url, "page=", as.character(i), "&", qloci, loci)
    res <- xml2::read_html(query)
    node <- rvest::html_node(res, xpath = "//*[@id='divGenDetail']/table")
    tab <- rvest::html_table(node)
    colnames(tab) <-
      gsub("[[:blank:]]+", " ", gsub("[^a-zA-Z%() ]", "", colnames(tab)))
  }
}

tab_total <- do.call(rbind, tab_list)
# Some cols contains NA other links to external website
i_na <- vapply(tab_total, function(x) length(unique(x)) == 1, logical(1))
allelefrequency_df <- tab_total[, ! i_na]
# 'Line' column specifies record number in search results
allelefrequency_df <-
  allelefrequency_df[, colnames(allelefrequency_df) != "Line"]
colnames(allelefrequency_df) <-
  c("var", "population", "proc.ind.with.allele", "frequency", "sample.size")

# Allele Frequencies marked with (*) were calculated from all alleles in the corresponding G group.
# These symbols can be found in "proc.ind.with.allele", "frequency" columns
star_cols <- c("proc.ind.with.allele", "frequency")
new_star_cols <-
  c(
    "proc.ind.with.allele",
    "proc.ind.with.allele.ggroup",
    "frequency",
    "frequency.ggroup"
  )
ggroup_cols <- c("proc.ind.with.allele.ggroup", "frequency.ggroup")
data.table::setDT(allelefrequency_df)
allelefrequency_df[,
                   (new_star_cols) := unlist(
                     lapply(
                       X = .SD,
                       FUN = function(x) {
                         data.table::tstrsplit(x,
                                               split = " ",
                                               fixed = TRUE,
                                               type.convert = TRUE
                         )
                       }
                     ),
                     recursive = FALSE
                   ),
                   .SDcols =  star_cols
                   ][,
                     (ggroup_cols) := lapply(
                       X = .SD,
                       FUN = function(x) {
                         ! is.na(x)
                       }
                     ),
                     .SDcols = ggroup_cols
                     ][,
                       sample.size := as.numeric(gsub(",", "", sample.size))
                       ]
data.table::setDF(allelefrequency_df)

# order columns
allele_frequencies <-
  allelefrequency_df[, c(
    "var",
    "population",
    "frequency"
    # "frequency.ggroup",
    # "sample.size",
    # "proc.ind.with.allele",
    # "proc.ind.with.allele.ggroup"
  )]

usethis::use_data(allele_frequencies, overwrite = TRUE)

#' Assert hla calls data frame format
#'
#' \code{checkHlaCallsFormat} asserts if hla calls data frame have proper
#' format.
#'
#' @param hla_calls HLA calls data frame, as returned by
#'   \code{\link{readHlaCalls}} function.
#'
#' @return Logical indicating if \code{hla_calls} follows hla calls data frame
#'   format. Otherwise raise an error.
#'
#' @importFrom assertthat assert_that see_if
#'
checkHlaCallsFormat <- function(hla_calls) {
  an <- deparse(substitute(hla_calls))
  assert_that(
    is.data.frame(hla_calls),
    see_if(nrow(hla_calls) >= 1 & ncol(hla_calls) >= 2,
           msg = paste0(an, " have to have at least 1 rows and 2 columns.")
    ),
    see_if(! any(vapply(hla_calls, is.factor, logical(length = 1))),
           msg = paste0(an, " can't contain factors")
    ),
    see_if(! all(checkAlleleFormat(as.character(hla_calls[, 1])), na.rm = TRUE),
           msg = paste0("first column of ", an, " should specify samples id")
    )
  )

  alleles <- unlist(hla_calls[, -1])
  test_values <- checkAlleleFormat(alleles)
  alleles <- alleles[! test_values & ! is.na(alleles)]
  if (length(alleles) > 10) { alleles <- alleles[seq_len(10)] }
  truncated <- ifelse(length(alleles) < 10, "", ", ...")
  msg <- sprintf("values: %s%s in %s doesn't follow HLA numbers specification", paste(alleles, collapse = ", "), truncated, an)
  assert_that(
    all(test_values, na.rm = TRUE),
    msg = msg
  )

  return(TRUE)
}

#' Assert KIR counts data frame format
#'
#' \code{checkKirCallsFormat} asserts if KIR counts data frame have proper
#' format.
#'
#' @param kir_calls KIR calls data frame, as returned by
#'   \code{\link{readKirCalls}} function.
#'
#' @return Logical indicating if \code{kir_calls} follow KIR counts data frame
#'   format. Otherwise raise an error.
#'
#' @importFrom assertthat assert_that see_if
#'
checkKirCallsFormat <- function(kir_calls) {
  assert_that(
    is.data.frame(kir_calls),
    see_if(!any(vapply(
      kir_calls, is.factor, logical(length = 1)
    )),
    msg = paste0(
      "kir_calls can't contain factors"
    )),
    colnamesMatches(
      kir_calls,
      c("ID",
        "KIR3DL3",
        "KIR2DS2",
        "KIR2DL2",
        "KIR2DL3",
        "KIR2DP1",
        "KIR2DL1",
        "KIR3DP1",
        "KIR2DL4",
        "KIR3DL1",
        "KIR3DS1",
        "KIR2DL5",
        "KIR2DS3",
        "KIR2DS5",
        "KIR2DS4",
        "KIR2DS1",
        "KIR3DL2"
      )
    )
  )

  return(TRUE)
}

#' Check if frequencies can be calculated for an experiment
#'
#' \code{isExperimentCountsOrZeros} checks if experiment contains only positive
#' integers or zeros.
#'
#' @param x Matrix or SummarizedExperiment object.
#' @param na.rm Logical indicating if \code{NA} values should be accepted.
#'
#' @return Logical indicating if \code{x} contains only positive integers or
#'   zeros.
#'
isExperimentCountsOrZeros <- function(x, na.rm = TRUE) {
  test <- if (is.matrix(x)) {
    isCountsOrZeros(x)
  } else if (isClass(x, "SummarizedExperiment")) {
    isCountsOrZeros(assay(x))
  } else {
    FALSE
  }

  return(test)
}

#' Assert statistical model
#'
#' \code{checkStatisticalModel} asserts if object is an existing fit from a
#' model functions such as lm, glm and many others. Containing MiDAS object as
#' its data atribute.
#'
#' @inheritParams updateModel
#'
#' @return Logical indicating if \code{object} is an existing fit from a
#' model functions such as lm, glm and many others. Containing MiDAS object as
#' its data attribute. Otherwise raise an error.
#'
#' @importFrom assertthat assert_that see_if
#' @importFrom rlang is_formula
#' @importFrom stats getCall
#'
checkStatisticalModel <- function(object) {
  on <- deparse(substitute(object))
  msg <- " was not recognized as a fit from a model function (such as lm, glm and many others)."
  assert_that(
    is.object(object),
    msg = paste0(on, msg)
  )

  object_call <- getCall(object)
  assert_that(
    ! is.null(object_call),
    msg = paste0(on, msg, " ", on, " does not have 'call' attribute.")
  )

  # Preserve object environment; this is important because arguments are given
  # in specific environment, but it is useful to be able to evaluate it in
  # original context -- doh!
  object_env <- attr(object$terms, ".Environment")

  object_formula <- eval(object_call[["formula"]], envir = object_env)
  assert_that(
    is_formula(object_formula),
    msg = paste0(on, msg, " ", on, " does not have 'formula' attribute.")
  )

  object_data <- eval(object_call[["data"]], envir = object_env)
  assert_that(!is.null(object_data),
              msg = paste0(on, msg, " ", on, " does not have 'data' attribute.")
  )

  return(TRUE)
}

#' Check if tidy method for class exist
#'
#' \code{hasTidyMethod} check if there is a tidy method available for a given class.
#'
#' @param class String giving object class.
#'
#' @return Logical indicating if there is a tidy method for a given class.
#'
#' @importFrom utils methods
#'
hasTidyMethod <- function(class) {
  cl_fun <- paste0("tidy.", class)
  test <- cl_fun %in% methods("tidy")

  return(test)
}

assertthat::on_failure(hasTidyMethod) <- function(call, env) {
  paste0("Could not find 'tidy' function for statistical model '",
         eval(expr = call$class, envir = env),
         "'. Please ensure that 'tidy' for selected model is available. See the 'broom' package for more information on 'tidy' function."
  )
}

#' Check if vector contains only counts or zeros
#'
#' \code{isCountsOrZeros} checks if vector contains only positive integers or
#' zeros.
#'
#' @param x Numeric vector or object that can be \code{unlist} to numeric
#'   vector.
#' @param na.rm Logical indicating if \code{NA} values should be accepted.
#'
#' @return Logical indicating if provided vector contains only positive integers
#'   or zeros.
#'
#' @importFrom rlang is_integerish
#'
isCountsOrZeros <- function(x, na.rm = TRUE) {
  x <- unlist(x)
  test <- is_integerish(x) & x >= 0
  test <- all(test, na.rm = na.rm)

  return(test)
}

assertthat::on_failure(isCountsOrZeros) <- function(call, env) {
  paste0("values in ", deparse(call$x), " are not counts (a positive integers) or zeros.")
}

#' Check if object is character vector or NULL
#'
#' \code{isCharacterOrNULL} checks if the object is a character vector or NULL.
#'
#' @param x object to test.
#'
#' @return Logical indicating if object is character vector or NULL
#'
isCharacterOrNULL <- function(x) {
  test <- is.character(x) | is.null(x)

  return(test)
}

assertthat::on_failure(isCharacterOrNULL) <- function(call, env) {
  paste0(deparse(call$x), " is not a character vector or NULL.")
}

#' Check if object is number or NULL
#'
#' \code{isNumberOrNULL} checks if object is number (a length one numeric
#' vector) or NULL.
#'
#' @param x object to test.
#'
#' @return Logical indicating if object is number or NULL
#'
#' @importFrom assertthat is.number
#'
isNumberOrNULL <- function(x) {
  test <- is.number(x) | is.null(x)

  return(test)
}

assertthat::on_failure(isNumberOrNULL) <- function(call, env) {
  paste0(deparse(call$x),
         " is not a number (a length one numeric vector) or NULL."
  )
}

#' Check if object is string or NULL
#'
#' \code{isStringOrNULL} checks if object is string (a length one character
#' vector) or NULL.
#'
#' @param x object to test.
#'
#' @return Logical indicating if object is string or NULL
#'
#' @importFrom assertthat is.string
#'
isStringOrNULL <- function(x) {
  test <- is.string(x) | is.null(x)

  return(test)
}

assertthat::on_failure(isStringOrNULL) <- function(call, env) {
  paste0(deparse(call$x),
         " is not a string (a length one character vector) or NULL."
  )
}

#' Check if string matches one of possible values
#'
#' \code{stringMatches} checks if string is equal to one of the choices.
#'
#' @param x string to test.
#' @param choice Character vector with possible values for \code{x}.
#'
#' @return Logical indicating if \code{x} matches one of the strings in
#'   \code{choice}.
#'
stringMatches <- function(x, choice) {
  test <- x %in% choice

  return(test)
}

assertthat::on_failure(stringMatches) <- function(call, env) {
  paste0(deparse(call$x),
         ' should be one of "',
         paste(eval(call$choice, envir = env), collapse = '", "'),
         '".'
  )
}

#' Check if object is flag or NULL
#'
#' \code{isFlagOrNULL} checks if object is flag (a length one logical vector) or
#' NULL.
#'
#' @param x object to test.
#'
#' @return Logical indicating if object is flag or NULL
#'
#' @importFrom assertthat is.flag
#'
isFlagOrNULL <- function(x) {
  test <- (is.flag(x) && ! is.na(x)) || is.null(x)

  return(test)
}

assertthat::on_failure(isFlagOrNULL) <- function(call, env) {
  paste0(deparse(call$x),
         " is not a flag (a length one logical vector) or NULL."
  )
}

#' Check if character matches one of possible values
#'
#' \code{characterMatches} checks if all elements of a character vector matches
#' values in choices.
#'
#' @param x Character vector to test.
#' @param choice Character vector with possible values for \code{x}.
#'
#' @return Logical indicating if \code{x}'s elements matches any of the values
#' in \code{choice}.
#'
#' @importFrom assertthat assert_that
characterMatches <- function(x, choice) {
  assert_that(is.character(x))
  test <- if (length(x)) {
    all(x %in% choice)
  } else {
    FALSE
  }

  return(test)
}

assertthat::on_failure(characterMatches) <- function(call, env) {
  paste0(deparse(call$x),
         ' should match values "',
         paste(eval(call$choice, envir = env), collapse = '", "'),
         '".'
  )
}

#' Check if object is of class x or null
#'
#' \code{isClassOrNULL} checks if object is an instance of a specified class or
#' is null.
#'
#' @param x object to test.
#' @param class String specifying class to test.
#'
#' @return Logical indicating if \code{x} is an instance of \code{class}.
#'
#' @importFrom assertthat assert_that
#' @importFrom methods is
#'
isClassOrNULL <- function(x, class) {
  test <- is(x, class) | is.null(x)

  return(test)
}

assertthat::on_failure(isClassOrNULL) <- function(call, env) {
  paste0(deparse(call$x),
         " must be an instance of ",
         deparse(call$class),
         " or NULL."
  )
}

#' Check column names
#'
#' \code{colnamesMatches} check if  data frame's columns are named as specified
#'
#' @param x Data frame to test.
#' @param cols Ordered character vector to test against \code{x}'s colnames.
#'
#' @return Logical indicating if \code{x}'s colnames equals \code{choice}.
#'
#' @importFrom assertthat assert_that
#'
colnamesMatches <- function(x, cols) {
  assert_that(
    is.data.frame(x),
    see_if(ncol(x) == length(cols),
           msg = sprintf(
             "%s shiuld have %i columns: %s",
             deparse(substitute(x)),
             length(cols),
             paste(cols, collapse = ", ")
           )
    )
  )

  columns_names <- colnames(x)
  columns_test <- columns_names == cols
  test <- all(columns_test)

  return(test)
}

assertthat::on_failure(colnamesMatches) <- function(call, env) {
  curr_colnames <- colnames(eval(call$x, envir = env))
  future_colnames <- eval(call$cols, envir = env)
  mask <- ! curr_colnames %in% future_colnames

  sprintf("Columns: '%s' in %s should be named '%s'",
          paste(curr_colnames[mask], collapse = "', '"),
          deparse(call$x),
          paste(future_colnames[mask], collapse = "', '")
  )
}

#' Check if object is count or NULL
#'
#' \code{isCountOrNULL} check if object is a count (a single positive integer)
#' or NULL.
#'
#' @param x object to test.
#'
#' @return Logical indicating if object is count or NULL
#'
#' @importFrom assertthat is.count
#'
isCountOrNULL <- function(x) {
  test <- is.count(x) | is.null(x)

  return(test)
}

assertthat::on_failure(isCountOrNULL) <- function(call, env) {
  paste0(deparse(call$x),
         " is not a count (a single positive integer) or NULL."
  )
}

#' Check if object is TRUE or FALSE flag
#'
#' \code{isTRUEorFALSE} check if object is a flag (a length one logical vector)
#' except NA.
#'
#' @param x object to test.
#'
#' @return Logical indicating if object is TRUE or FALSE flag
#'
#' @importFrom assertthat is.flag
#'
isTRUEorFALSE <- function(x) {
  test <- is.flag(x) && ! is.na(x)

  return(test)
}

assertthat::on_failure(isTRUEorFALSE) <- function(call, env) {
  paste0(deparse(call$x),
         " is not a flag (a length one logical vector)."
  )
}

#' Check if placeholder is present in object formula
#'
#' \code{isTRUEorFALSE} check if object is a flag (a length one logical vector)
#' except NA.
#'
#' @param object statistical model to test.
#' @param placeholder string specifying name of placeholder.
#'
#' @return Logical indicating if placeholder is present in object formula.
#'
objectHasPlaceholder <- function(object, placeholder) {
  object_env <- attr(object$terms, ".Environment")
  object_call <- getCall(object)
  object_form <- object_call[["formula"]] %>%
    eval(envir = object_env)
  test <- placeholder %in% all.vars(object_form)

  return(test)
}

assertthat::on_failure(objectHasPlaceholder) <- function(call, env) {
  paste0("placeholder '",
         eval(call$placeholder, envir = env),
         "' could not be found in object's formula"
  )
}

#' Assert colData data
#'
#' \code{checkColDataFormat} asserts if the colData data frame has proper format.
#'
#' @param data_frame Data frame containing colData data used to construct
#'   \code{\link{MiDAS}} object.
#'
#' @return Logical indicating if \code{data_frame} is properly formatted.
#'   Otherwise raise an error.
#'
#' @importFrom assertthat assert_that see_if
#'
checkColDataFormat <- function(data_frame) {
  data_frame_name <- deparse(substitute(data_frame))
  assert_that(
    see_if(
      is.data.frame(data_frame),
      msg = sprintf("%s have to be a data frame",
                    data_frame_name)
    ),
    see_if(
      nrow(data_frame) >= 1 & ncol(data_frame) >= 2,
      msg = sprintf("%s have to have at least 1 row and 2 columns",
                    data_frame_name)
    ),
    see_if(
      colnames(data_frame)[1] == "ID",
      msg = sprintf(
        "first column in %s must be named 'ID'",
        data_frame_name
      )
    )
  )

  return(TRUE)
}

#' Check if object is of class x
#'
#' \code{isClassOrNULL} checks if object is an instance of a specified class or
#' is null.
#'
#' @param x object to test.
#' @param class String specifying class to test.
#'
#' @return Logical indicating if \code{x} is an instance of \code{class}.
#'
#' @importFrom methods is
#'
isClass <- function(x, class) {
  test <- is(x, class)

  return(test)
}

assertthat::on_failure(isClass) <- function(call, env) {
  paste0(deparse(call$x),
         " must be an instance of ",
         deparse(call$class),
         "."
  )
}

#' Validate frequency cutoffs
#'
#' \code{validateFrequencyCutoffs} checks if \code{lower_frequency_cutoff} and
#' \code{upper_frequency_cutoff} are valid.
#'
#' \code{lower_frequency_cutoff} and \code{upper_frequency_cutoff} should be a
#' positive numbers, giving either frequency or counts.
#' \code{lower_frequency_cutoff} has to be lower than
#' \code{upper_frequency_cutoff}.
#'
#' @param lower_frequency_cutoff Number
#' @param upper_frequency_cutoff Number
#'
#' @return Logical indicating if \code{lower_frequency_cutoff} and
#'   \code{upper_frequency_cutoff} are valid.
#'
#' @importFrom assertthat assert_that see_if
#'
validateFrequencyCutoffs <- function(lower_frequency_cutoff, upper_frequency_cutoff) {
  assert_that(
    isNumberOrNULL(lower_frequency_cutoff),
    if (! is.null(lower_frequency_cutoff)) {
      see_if(lower_frequency_cutoff >= 0,
             msg = "lower_frequency_cutoff must be a number greater than 0."
      )
    } else TRUE,
    isNumberOrNULL(upper_frequency_cutoff),
    if (! is.null(upper_frequency_cutoff)) {
      see_if(upper_frequency_cutoff >= 0,
             msg = "upper_frequency_cutoff must be a number greater than 0."
      )
    } else TRUE,
    if (! is.null(lower_frequency_cutoff) && ! is.null(upper_frequency_cutoff)) {
      see_if(! lower_frequency_cutoff > upper_frequency_cutoff,
             msg = "lower_frequency_cutoff cannot be higher than upper_frequency_cutoff."
      )
    } else TRUE,
    if (! is.null(lower_frequency_cutoff) && ! is.null(upper_frequency_cutoff)) {
      see_if((lower_frequency_cutoff <= 1 && upper_frequency_cutoff <= 1) ||
               (lower_frequency_cutoff >= 1 && upper_frequency_cutoff >= 1),
             msg = "Both lower_frequency_cutoff and upper_frequency_cutoff have to be either frequencies or counts."
      )
    } else TRUE
  )
}

test_that("checkHlaCallsFormat", {
  file <- system.file("extdata", "MiDAS_tut_HLA.txt", package = "midasHLA")
  hla_calls <- readHlaCalls(file)
  expect_equal(checkHlaCallsFormat(hla_calls), TRUE)

  expect_error(checkHlaCallsFormat("A"), "hla_calls is not a data frame")
  expect_error(checkHlaCallsFormat(data.frame()),
               "data.frame\\(\\) have to have at least 1 rows and 2 columns"
  )
  hla_calls[, 1] <- as.factor(hla_calls[, 1])
  expect_error(checkHlaCallsFormat(hla_calls),
               "hla_calls can't contain factors"
  )
  fake_calls <- data.frame(ID = c("Sample1", "Sample2", "Sample3"),
                           A_1 = c("A*01", "A*02", "A*03"),
                           A_2 = c("A*01", "B*02", "C*03"),
                           stringsAsFactors = FALSE
  )
  expect_error(checkHlaCallsFormat(fake_calls[, c(2, 1, 3)]),
               "first column of fake_calls\\[, c\\(2, 1, 3\\)\\] should specify samples id"
  )

  expect_error(checkHlaCallsFormat(fake_calls[, c(1, 1, 3)]),
               "values: Sample1, Sample2, Sample3 in fake_calls\\[, c\\(1, 1, 3\\)\\] doesn't follow HLA numbers specification"
  )
})

test_that("checkKirCallsFormat", {
  expect_equal(checkKirCallsFormat(MiDAS_tut_KIR), TRUE)

  fake_kir_counts <- MiDAS_tut_KIR
  fake_kir_counts[, 1] <- as.factor(fake_kir_counts[, 1, drop = TRUE])
  expect_error(
    checkKirCallsFormat(fake_kir_counts),
    "kir_calls can't contain factors"
  )


  expect_error(
    checkKirCallsFormat(MiDAS_tut_KIR[, 1, drop = FALSE]),
    "kir_calls shiuld have 17 columns: ID, KIR3DL3, KIR2DS2, KIR2DL2, KIR2DL3, KIR2DP1, KIR2DL1, KIR3DP1, KIR2DL4, KIR3DL1, KIR3DS1, KIR2DL5, KIR2DS3, KIR2DS5, KIR2DS4, KIR2DS1, KIR3DL2"
  )

  fake_kir_counts <- MiDAS_tut_KIR
  colnames(fake_kir_counts) <- c("FOO", colnames(fake_kir_counts)[-1])
  expect_error(
    checkKirCallsFormat(fake_kir_counts),
    "Columns: 'FOO' in kir_calls should be named 'ID'"
  )
})

test_that("isExperimentCountsOrZeros", {
  expect_equal(isExperimentCountsOrZeros(MiDAS_tut_object[["hla_alleles"]]), TRUE)

  expect_equal(isExperimentCountsOrZeros(MiDAS_tut_object[["hla_aa"]]), TRUE)

  expect_equal(isExperimentCountsOrZeros(matrix(runif(15), nrow = 3)), FALSE)

  expect_equal(isExperimentCountsOrZeros(LETTERS), FALSE)
})

test_that("checkStatisticalModel", {
  midas <- midasToWide(MiDAS_tut_object,"kir_genes")

  object <- lm(disease ~ term, data = midas)
  expect_equal(checkStatisticalModel(object), TRUE)

  expect_error(checkStatisticalModel(list(1)),
               "list\\(1\\) was not recognized as a fit from a model function \\(such as lm, glm and many others\\)."
  )

  expect_error(checkStatisticalModel(speed ~ cars),
               "speed ~ cars was not recognized as a fit from a model function \\(such as lm, glm and many others\\). speed ~ cars does not have 'call' attribute."
  )

  fake_model <- list(call = list(formula = "foo"))
  class(fake_model) <- "fake"
  expect_error(checkStatisticalModel(fake_model),
               "fake_model was not recognized as a fit from a model function \\(such as lm, glm and many others\\). fake_model does not have 'formula' attribute."
  )

  fake_model <- list(call = list(formula = 1 ~ 1))
  class(fake_model) <- "fake"
  expect_error(checkStatisticalModel(fake_model),
               "fake_model was not recognized as a fit from a model function \\(such as lm, glm and many others\\). fake_model does not have 'data' attribute."
  )
})

test_that("hasTidyMethod", {
  expect_equal(hasTidyMethod("lm"), TRUE)
  expect_equal(hasTidyMethod("foo"), FALSE)

  expect_error(
    assertthat::assert_that(hasTidyMethod("bar")),
    "Could not find 'tidy' function for statistical model 'bar'. Please ensure that 'tidy' for selected model is available. See the 'broom' package for more information on 'tidy' function."
  )
})

test_that("isCountsOrZeros", {
  expect_equal(isCountsOrZeros(c(1, 0, 2, NA)), TRUE)

  expect_error(
    assertthat::assert_that(isCountsOrZeros(c(1, 0, 2, NA, 1.5))),
    "values in c\\(1, 0, 2, NA, 1.5\\) are not counts \\(a positive integers\\) or zeros."
  )
})

test_that("isCharacterOrNULL", {
  expect_equal(isCharacterOrNULL(LETTERS), TRUE)
  expect_equal(isCharacterOrNULL(NULL), TRUE)

  expect_error(
    assertthat::assert_that(isCharacterOrNULL(1)),
    "1 is not a character vector or NULL."
  )
})

test_that("isNumberOrNULL", {
  expect_equal(isNumberOrNULL(1), TRUE)
  expect_equal(isNumberOrNULL(NULL), TRUE)

  expect_error(
    assertthat::assert_that(isNumberOrNULL("a")),
    "\"a\" is not a number \\(a length one numeric vector\\) or NULL."
  )
})

test_that("isStringOrNULL", {
  expect_equal(isStringOrNULL("foo"), TRUE)
  expect_equal(isStringOrNULL(NULL), TRUE)

  expect_error(
    assertthat::assert_that(isStringOrNULL(1)),
    "1 is not a string \\(a length one character vector\\) or NULL."
  )
})

test_that("stringMatches", {
  expect_equal(stringMatches("foo", c("foo", "bar")), TRUE)

  expect_error(
    assertthat::assert_that(stringMatches("foo", c("bar", "Foo"))),
    "\"foo\" should be one of \"bar\", \"Foo\"."
  )
})

test_that("isFlagOrNULL", {
  expect_equal(isFlagOrNULL(TRUE), TRUE)
  expect_equal(isFlagOrNULL(NULL), TRUE)
  expect_equal(isFlagOrNULL(NA), FALSE)

  expect_error(
    assertthat::assert_that(isFlagOrNULL(1)),
    "1 is not a flag \\(a length one logical vector\\) or NULL."
  )
})

test_that("characterMatches", {
  expect_equal(characterMatches("foo", c("foo", "bar")), TRUE)

  expect_error(
    assertthat::assert_that(characterMatches("foo", "bar")),
    '"foo" should match values "bar".'
  )
})

test_that("isClassOrNULL", {
  expect_equal(isClassOrNULL("foo", "character"), TRUE)
  expect_equal(isClassOrNULL(NULL, "character"), TRUE)

  expect_error(
    assertthat::assert_that(isClassOrNULL("foo", "bar")),
    "\"foo\" must be an instance of \"bar\" or NULL."
  )
})

test_that("colnamesMatches", {
  df <- data.frame(a = 1:5, b = 1:5)
  expect_equal(colnamesMatches(df, c("a", "b")), TRUE)

  expect_error(colnamesMatches(1:2, c("foo", "bar")), "x is not a data frame")

  expect_error(colnamesMatches(data.frame(one = 1:2), c("foo", "bar")),
               "data.frame\\(one = 1:2\\) shiuld have 2 columns: foo, bar"
  )

  expect_error(
    assertthat::assert_that(colnamesMatches(df, c("foo", "bar"))),
    "Columns: 'a', 'b' in df should be named 'foo', 'bar'"
  )
})

test_that("isCountOrNULL", {
  expect_equal(isCountOrNULL(1), TRUE)
  expect_equal(isCountOrNULL(NULL), TRUE)

  expect_error(
    assertthat::assert_that(isCountOrNULL(1.5)),
    "1.5 is not a count \\(a single positive integer\\) or NULL."
  )
})

test_that("isTRUEorFALSE", {
  expect_equal(isTRUEorFALSE(TRUE), TRUE)
  expect_equal(isTRUEorFALSE(FALSE), TRUE)
  expect_equal(isTRUEorFALSE(NA), FALSE)

  expect_error(
    assertthat::assert_that(isTRUEorFALSE(1.5)),
    "1.5 is not a flag \\(a length one logical vector\\)."
  )
})

test_that("objectHasPlaceholder", {
  object <- lm(speed ~ dist, data = cars)
  expect_equal(objectHasPlaceholder(object, "dist"), TRUE)
  expect_equal(objectHasPlaceholder(object, "foo"), FALSE)

  expect_error(
    assertthat::assert_that(objectHasPlaceholder(object, "foo")),
    "placeholder 'foo' could not be found in object's formula"
  )
})

test_that("checkColDataFormat", {
  pheno <- data.frame(
    ID = 1:5,
    letter = LETTERS[1:5]
  )

  expect_equal(checkColDataFormat(pheno), TRUE)

  expect_error(
    checkColDataFormat(LETTERS),
    "LETTERS have to be a data frame"
  )

  expect_error(
    checkColDataFormat(data.frame()),
    "data.frame\\(\\) have to have at least 1 row and 2 columns"
  )

  expect_error(
    checkColDataFormat(pheno[, 2, drop = FALSE]),
    "pheno\\[, 2, drop = FALSE\\] have to have at least 1 row and 2 columns"
  )
})

test_that("isClass", {
  expect_equal(isClass("foo", "character"), TRUE)

  expect_error(
    assertthat::assert_that(isClassOrNULL("foo", "bar")),
    "\"foo\" must be an instance of \"bar\"."
  )
})

test_that("Frequency cutoffs validation", {
  # lower_frequency_cutof must be a number
  lower_frequency_cutoff <- "foo"
  upper_frequency_cutoff <- 0.5
  expect_error(
    validateFrequencyCutoffs(lower_frequency_cutoff, upper_frequency_cutoff),
    "lower_frequency_cutoff is not a number \\(a length one numeric vector\\)."
  )

  # lower_frequency_cutof must be positive
  lower_frequency_cutoff <- -1
  upper_frequency_cutoff <- 0.5
  expect_error(
    validateFrequencyCutoffs(lower_frequency_cutoff, upper_frequency_cutoff),
    "lower_frequency_cutoff must be a number greater than 0."
  )

  # upper_frequency_cutoff must be a number
  lower_frequency_cutoff <- 0.5
  upper_frequency_cutoff <- "foo"
  expect_error(
    validateFrequencyCutoffs(lower_frequency_cutoff, upper_frequency_cutoff),
    "upper_frequency_cutoff is not a number \\(a length one numeric vector\\)."
  )

  # upper_frequency_cutoff must be positive
  lower_frequency_cutoff <- 0
  upper_frequency_cutoff <- -1
  expect_error(
    validateFrequencyCutoffs(lower_frequency_cutoff, upper_frequency_cutoff),
    "upper_frequency_cutoff must be a number greater than 0."
  )

  # lower_frequency_cutoff is lower than upper_frequency_cutoff
  lower_frequency_cutoff <- 5
  upper_frequency_cutoff <- 1
  expect_error(
    validateFrequencyCutoffs(lower_frequency_cutoff, upper_frequency_cutoff),
    "lower_frequency_cutoff cannot be higher than upper_frequency_cutoff."
  )

  # Both lower_frequency_cutoff and upper_frequency_cutoff have to be either frequencies or counts
  lower_frequency_cutoff <- 0.5
  upper_frequency_cutoff <- 2
  expect_error(
    validateFrequencyCutoffs(lower_frequency_cutoff, upper_frequency_cutoff),
    "Both lower_frequency_cutoff and upper_frequency_cutoff have to be either frequencies or counts."
  )
})

#!/usr/bin/env R
# Download KIR frequencies from http://www.allelefrequencies.net/
devtools::load_all()
library("rvest")
library("xml2")

kir_gene_vector <-
  c("3DL3", "2DS2", "2DL2", "2DL3", "2DP1", "2DL1", "3DP1", "2DL4", "3DL1", "3DS1", "2DL5", "2DS3", "2DS5", "2DS4", "2DS1", "3DL2")
base_url <- "http://www.allelefrequencies.net/kir6002a.asp?"
qloci <- "kir_locus="
tab_list <- list()
for (loci in kir_gene_vector) {
  i <- 1
  query <-
    paste0(base_url, "page=", as.character(i), "&", qloci, loci)
  res <- xml2::read_html(query)
  node <-
    rvest::html_node(res, xpath = "//*[@id='divGenDetail']/table")
  if (is.na(node))
    next()
  tab <-  rvest::html_table(node)
  colnames(tab) <-
    gsub("[[:blank:]]+", " ", gsub("[^a-zA-Z%() ]", "", colnames(tab)))
  while (!is.na(node) && nrow(tab) > 0) {
    cat(loci, i, "\n")
    tab_list[[length(tab_list) + 1]] <- tab
    i <- i + 1
    query <-
      paste0(base_url, "page=", as.character(i), "&", qloci, loci)
    res <- xml2::read_html(query)
    node <-
      rvest::html_node(res, xpath = "//*[@id='divGenDetail']/table")
    tab <- rvest::html_table(node)
    colnames(tab) <-
      gsub("[[:blank:]]+", " ", gsub("[^a-zA-Z%() ]", "", colnames(tab)))
  }
}

# drop NA columns
# some columns are duplicated, and sometimes both duplicates are empty we want
# to keep one
tab_list <- lapply(
  X = tab_list,
  FUN = function(x) {
    cols <- setNames(1:ncol(x), colnames(x))
    sel <- c()
    for (i in cols) {
      is_na <- all(is.na(x[, i, drop = TRUE]))
      if (!is_na) {
        sel <- c(sel, i)
      } else {
        dup <- sum(names(cols) == names(cols)[i]) > 1
        if (dup) {
          names(cols)[i] <- ""
        } else {
          sel <- c(sel, i)
        }
      }
    }
    x[, sel]
  }
)

tab_total <- do.call(rbind, tab_list)
i_na <-
  vapply(tab_total, function(x)
    length(unique(x)) == 1, logical(1))
kirfrequency_df <- tab_total[,!i_na]
# 'Line' column specifies record number in search results
kirfrequency_df <-
  kirfrequency_df[, colnames(kirfrequency_df) != "Line"]
# here we are interested only in KIR genes, but some are alleles we remove them
sel <- grep("\\*.*", kirfrequency_df$Allele, invert = TRUE)
kirfrequency_df <- kirfrequency_df[sel,]
colnames(kirfrequency_df) <-
  c("var",
    "population",
    "proc.ind.with.allele",
    "frequency",
    "sample.size")


# order columns
kir_frequencies <-
  kirfrequency_df[, c(
    "var",
    "population",
    "proc.ind.with.allele" # here we take carrier frequency, as it is only relevant to current KIR typing implementations (present/absent)
  )]
colnames(kir_frequencies)[colnames(kir_frequencies) == "proc.ind.with.allele"] <- "frequency"

# set frequencies to decimals
kir_frequencies$frequency <- kir_frequencies$frequency / 100

# add KIR prefix to gene names
kir_frequencies$var <- paste0("KIR", kir_frequencies$var)

usethis::use_data(kir_frequencies, overwrite = TRUE)

#!/usr/bin/env R
# Script pre-parses alignment files for package use
# By Migdal
devtools::load_all()
library(stringi)

alignment_files <- list.files(path = "alignments", full.names = TRUE)
for (file in alignment_files) {
  # parse aln files without any processing
  alignment <-
    readHlaAlignments(file,
                      trim = FALSE,
                      unkchar = "*")
  # infer missing lower resolution alleles
  for (res in c(6, 4)) {
    allele_numbers <- reduceAlleleResolution(rownames(alignment), resolution = res)
    missing_alleles <- unique(allele_numbers[! allele_numbers %in% rownames(alignment)])
    missing_aln <- list()
    for (allele in missing_alleles) {
      i <- allele_numbers == allele
      missing_aln[[allele]] <- apply(alignment[i, , drop=FALSE], 2, function(col) {
        if (all(col == col[1])) col[1]
        else "*"
      })
    }
    missing_aln <- do.call(rbind, missing_aln)
    alignment <- rbind(alignment, missing_aln)
  }

  # find first codon idx
  aln_raw <- stri_read_lines(file)
  aln <- stri_split_regex(aln_raw, "\\s+")
  nonempty_lines <- vapply(aln, length, integer(length = 1)) >= 2
  allele_numbers <- vapply(aln, `[`, character(length = 1), 2)
  allele_lines <- checkAlleleFormat(allele_numbers)
  aln_raw <- aln_raw[nonempty_lines]
  raw_first_codon_idx <- nchar(stri_subset_fixed(aln_raw, "Prot")[1])
  raw_alignment_line <- stri_sub(aln_raw[allele_lines][1],
                                 1,
                                 raw_first_codon_idx
  )
  raw_alignment_seq <- stri_split_regex(raw_alignment_line, "\\s+")
  raw_alignment_seq <- unlist(raw_alignment_seq)[-c(1, 2)]
  first_codon_idx <- nchar(stri_flatten(raw_alignment_seq))
  
  # find AA positions numbers
  if (first_codon_idx > 1) {
    aln_colnames <- c(seq(1 - first_codon_idx, -1, 1),
                      seq(1, ncol(alignment) + 1 - first_codon_idx, 1)
    )
  } else {
    aln_colnames <- seq(1, ncol(alignment) + 1 - first_codon_idx, 1)
  }
  colnames(alignment) <- aln_colnames

  cached_aln_obj <- list(alignment, first_codon_idx)
  gene <- gsub(".*/([A-Z]+[0-9]*)_prot.txt", "\\1", file)
  saveRDS(cached_aln_obj,
          file = paste0(gene, "_prot.Rdata"))
}

#' @include class.R
NULL

#' MiDAS class
#'
#' @description
#' The \code{MiDAS} class is a \code{\link{MultiAssayExperiment}} object
#' containing data and metadata required for MiDAS analysis.
#'
#' Valid \code{MiDAS} object must have unique features names across all
#' experiments and colData. It's metadata list needs to have a \code{placeholder}
#' element, which is a string specifying name of column in colData used when
#' defining statistical model for downstream analyses (see
#' \code{\link{runMiDAS}} for more details). Optionally the object's metadata
#' can also store \code{'hla_calls'} and \code{'kir_calls'} data frames (see
#' \code{\link{prepareMiDAS}} for more details).
#' 
#' @return Instance of class MiDAS
#'
#' @importFrom methods setClass new
#' @importClassesFrom MultiAssayExperiment MultiAssayExperiment
#' @export
MiDAS <- setClass(
  Class = "MiDAS",
  contains = "MultiAssayExperiment"
)

# MiDAS class initialize method
#
# @inheritParams methods::initialize
# @inheritParams MultiAssayExperiment
#
# @return MiDAS object
#
# @importFrom MultiAssayExperiment MultiAssayExperiment
#
setMethod("initialize", "MiDAS", function(.Object, experiments, colData, metadata) {
  midas <- MultiAssayExperiment(
    experiments = experiments,
    colData = colData,
    metadata = metadata
  )
  class(midas) <- structure("MiDAS", package = "midasHLA")

  return(midas)
})

# Validity method for class MiDAS
#
# A valid \code{MiDAS} object must have unique features names across all
# experiments and colData. It's metadata list need to have "placeholder"
# element, which is a string specifying name of column in colData that should
# be used in statistical model definitions for downstream analyses. Optionally
# the object's metadata can also store \code{'hla_calls'} and \code{'kir_calls'}
# data frames. See \code{\link{prepareMiDAS}} for more details.
#
# @importFrom assertthat assert_that is.string see_if
#
setValidity(Class = "MiDAS", method = function(object) {
  hla_calls <- getHlaCalls(object)
  kir_calls <- getKirCalls(object)
  placeholder <- getPlaceholder(object)
  variables <- c(unlist(rownames(object)), colnames(colData(object)))

  assert_that(
    if (! is.null(hla_calls)) { checkHlaCallsFormat(hla_calls) } else { TRUE },
    if (! is.null(kir_calls)) { checkKirCallsFormat(kir_calls) } else { TRUE },
    is.string(placeholder),
    see_if(
      ! getPlaceholder(object) %in% unlist(rownames(object)),
      msg = sprintf("Placeholder '%s' is used in one of object's experiments",
                    getPlaceholder(object))
    ),
    see_if(
      getPlaceholder(object) %in% colnames(colData(object)),
      msg = sprintf("Placeholder '%s' can not be found in object's colData",
                    getPlaceholder(object))
    ),
    see_if(
      getPlaceholder(object) %in% colnames(colData(object)),
      msg = sprintf("Placeholder '%s' can not be found in object's colData",
                    getPlaceholder(object))
    ),
    see_if(
      ! any(duplicated(variables)),
      msg = sprintf("Object contain duplicated features: %s",
                    paste(variables[duplicated(variables)], collapse = ", "))
    )
  )

  return(TRUE)
})

#' Get available experiments in MiDAS object.
#'
#' @param object \code{\link{MiDAS}} object.
#'
#' @return Character vector giving names of experiments in \code{object}.
#' 
#' @examples
#' getExperiments(object = MiDAS_tut_object)
#'
#' @importFrom S4Vectors metadata
#' @export
setGeneric(
  name = "getExperiments",
  def = function(object) standardGeneric("getExperiments")
)

#' @rdname MiDAS-class
#'
#' @title Get available experiments in MiDAS object.
#'
#' @export
setMethod(
  f = "getExperiments",
  signature = "MiDAS",
  definition = function (object) names(object)
)

#' Get HLA calls from MiDAS object.
#'
#' @param object \code{\link{MiDAS}} object.
#'
#' @return HLA calls data frame.
#' 
#' @examples
#' getHlaCalls(object = MiDAS_tut_object)
#'
#' @importFrom S4Vectors metadata
#' @export
setGeneric(
  name = "getHlaCalls",
  def = function(object) standardGeneric("getHlaCalls")
)

#' @rdname MiDAS-class
#'
#' @title Get HLA calls from MiDAS object.
#'
#' @importFrom S4Vectors metadata
#' @export
setMethod(
  f = "getHlaCalls",
  signature = "MiDAS",
  definition = function (object) { metadata(object)[["hla_calls"]] }
)

#' Get KIR calls from MiDAS object.
#'
#' @param object \code{\link{MiDAS}} object.
#'
#' @return KIR calls data frame.
#' 
#' @examples
#' getKirCalls(object = MiDAS_tut_object)
#'
#' @importFrom S4Vectors metadata
#' @export
setGeneric(
  name = "getKirCalls",
  def = function(object) standardGeneric("getKirCalls")
)

#' @rdname MiDAS-class
#'
#' @title Get KIR calls from MiDAS object.
#'
#' @importFrom S4Vectors metadata
#' @export
setMethod(
  f = "getKirCalls",
  signature = "MiDAS",
  definition = function (object) { metadata(object)[["kir_calls"]] }
)

#' Get placeholder name from MiDAS object.
#'
#' @param object \code{\link{MiDAS}} object.
#'
#' @return String giving name of placeholder.
#' 
#' @examples
#' getPlaceholder(object = MiDAS_tut_object)
#'
#' @importFrom S4Vectors metadata
#' @export
setGeneric(
  name = "getPlaceholder",
  def = function(object) standardGeneric("getPlaceholder")
)

#' @rdname MiDAS-class
#'
#' @title Get placeholder name from MiDAS object.
#'
#' @importFrom S4Vectors metadata
#' @export
setMethod(
  f = "getPlaceholder",
  signature = "MiDAS",
  definition = function (object) {
    placeholder <- metadata(object)[["placeholder"]]

    return(placeholder)
  }
)

#' Get omnibus groups from MiDAS object.
#'
#' @details For some experiments features can be naturally divided into groups
#' (here called omnibus groups). For example, in \code{"hla_aa"} experiment
#' features can be grouped by amino acid position (\code{"B_46_E"},
#' \code{"B_46_A"}) can be grouped into \code{B_46} group). Such groups can be
#' then used to perform omnibus test, see \code{\link{runMiDAS}} for more
#' details.
#'
#' @param object \code{\link{MiDAS}} object.
#' @param experiment String specifying experiment.
#'
#' @return List of omnibus groups for a given experiment.
#' 
#' @examples
#' getOmnibusGroups(object = MiDAS_tut_object,
#'                  experiment = "hla_aa")
#'
#' @importFrom assertthat assert_that is.string
#' @importFrom S4Vectors metadata
#' @export
setGeneric(
  name = "getOmnibusGroups",
  def = function(object, experiment) standardGeneric("getOmnibusGroups")
)

#' @rdname MiDAS-class
#'
#' @title Get omnibus groups from MiDAS object.
#'
#' @param object \code{\link{MiDAS}} object.
#' @param experiment String specifying experiment.
#'
#' @importFrom assertthat assert_that is.string
#' @importFrom S4Vectors metadata
#' @export
setMethod(
  f = "getOmnibusGroups",
  signature = "MiDAS",
  definition = function (object, experiment) {
    assert_that(is.string(experiment))
    experiment <- object[[experiment]]
    omnibus_groups <- if (isClass(experiment, "SummarizedExperiment")) {
      og <- metadata(experiment)$omnibus_groups
      if (is.null(og)) {
        NULL
      } else {
        el <- rownames(experiment)
        filterListByElements(og, el)
      }
    } else {
      NULL
    }

    return(omnibus_groups)
  }
)

#' Calculate features frequencies for a given experiment in MiDAS object.
#'
#' @inheritParams getExperimentFrequencies
#' @param object \code{\link{MiDAS}} object.
#' @param compare Logical flag indicating if \code{hla_calls} frequencies
#'   should be compared to reference frequencies given in \code{ref}.
#' @param ref_pop Named list of character vectors giving names of reference
#'   populations in \code{ref} to compare with. Optionally vectors can be named,
#'   then those names will be used as population names. Each vector should
#'   correspond to a specific experiment.
#' @param ref Named list of reference frequencies data frames. Each element
#'   should give reference for a specific experiment. See
#'   \code{\link{allele_frequencies}} for an example on how reference
#'   frequency data frame should be formatted.
#'
#' @return Data frame with features from selected experiment and their
#'   corresponding frequencies. Column \code{"term"} hold features names, 
#'   \code{"Counts"} hold number of feature occurrences, \code{"Freq"} hold 
#'   feature frequencies. If argument \code{compare} is set to \code{TRUE}, 
#'   further columns will hold frequencies in reference populations.
#'   
#' @examples
#' # using default reference populations
#' getFrequencies(object = MiDAS_tut_object, 
#'                experiment = "hla_alleles", 
#'                compare = TRUE)
#' 
#' # using customized set of reference populations
#' getFrequencies(
#'   object = MiDAS_tut_object, 
#'   experiment = "hla_alleles", 
#'   compare = TRUE,
#'   ref_pop = list(
#'     hla_alleles = c("USA NMDP Chinese", "USA NMDP European Caucasian")
#'   ),
#'   ref = list(hla_alleles = allele_frequencies)
#' )
#'
#' @importFrom assertthat assert_that is.string
#' @importFrom dplyr select
#' @importFrom rlang !!
#' @importFrom stats reshape
#' @importFrom S4Vectors metadata
#' @export
setGeneric(
  name = "getFrequencies",
  def = function(object,
                 experiment,
                 carrier_frequency = FALSE,
                 compare = FALSE,
                 ref_pop = list(
                   hla_alleles = c(
                     "USA NMDP African American pop 2",
                     "USA NMDP Chinese",
                     "USA NMDP European Caucasian",
                     "USA NMDP Hispanic South or Central American",
                     "USA NMDP Japanese",
                     "USA NMDP North American Amerindian",
                     "USA NMDP South Asian Indian"
                   ),
                   kir_genes = c(
                     "USA California African American KIR",
                     "USA California Asian American KIR",
                     "USA California Caucasians KIR",
                     "USA California Hispanic KIR"
                   )
                 ),
                 ref = list(hla_alleles = allele_frequencies,
                            kir_genes = kir_frequencies)
  ) {
    standardGeneric("getFrequencies")
  }
)

#' @rdname MiDAS-class
#'
#' @title Calculate features frequencies for a given experiment in MiDAS object.
#'
#' @inheritParams getExperimentFrequencies
#' @param compare Logical flag indicating if \code{hla_calls} frequencies
#'   should be compared to reference frequencies given in \code{ref}.
#' @param ref_pop Named list of character vectors giving names of reference
#'   populations in \code{ref} to compare with. Optionally vectors can be named,
#'   then those names will be used as population names. Each vector should
#'   correspond to a specific experiment.
#' @param ref Named list of reference frequencies data frames. Each element
#'   should give reference for a specific experiment. See
#'   \code{\link{allele_frequencies}} for an example on how reference
#'   frequency data frame should be formatted.
#'
#' @importFrom assertthat assert_that is.string
#' @importFrom dplyr select
#' @importFrom rlang !!
#' @importFrom stats reshape
#' @importFrom S4Vectors metadata
#' @export
setMethod(
  f = "getFrequencies",
  signature = "MiDAS",
  definition = function (object,
                         experiment,
                         carrier_frequency = FALSE,
                         compare = FALSE,
                         ref_pop = list(
                           hla_alleles = c(
                             "USA NMDP African American pop 2",
                             "USA NMDP Chinese",
                             "USA NMDP European Caucasian",
                             "USA NMDP Hispanic South or Central American",
                             "USA NMDP Japanese",
                             "USA NMDP North American Amerindian",
                             "USA NMDP South Asian Indian"
                           ),
                           kir_genes = c(
                             "USA California African American KIR",
                             "USA California Asian American KIR",
                             "USA California Caucasians KIR",
                             "USA California Hispanic KIR"
                           )
                         ),
                         ref = list(hla_alleles = allele_frequencies,
                                    kir_genes = kir_frequencies)
  ) {
    assert_that(
      is.string(experiment),
      stringMatches(experiment, getExperiments(object)),
      isTRUEorFALSE(carrier_frequency),
      isTRUEorFALSE(compare),
      is.list(ref_pop),
      is.list(ref)
    )
    ex <- object[[experiment]]
    assert_that(
      ! is.null(getExperimentPopulationMultiplicator(ex)), # if pop_mul is not set frequency cannot be calculated
      msg = sprintf("Frequencies can not be calculated for experiment '%s'",
                    experiment
            )
    )

    ref_pop <- ref_pop[[experiment]]
    ref <- ref[[experiment]]
    if (compare && ! is.null(ref)) {
      assert_that(
        length(ref_pop) > 0,
        msg = "Please specify reference populations using 'ref_pop' argument."
      )
      ref <- getReferenceFrequencies(ref, ref_pop, carrier_frequency)
      freq <- getExperimentFrequencies(experiment = ex,
                                       carrier_frequency = carrier_frequency,
                                       ref = ref)
    } else {
      if (compare) warn(sprintf("Could not find reference frequencies for experiment: '%s'", experiment))
      freq <- getExperimentFrequencies(experiment = ex,
                                       carrier_frequency = carrier_frequency)
    }

    return(freq)
  }
)

#' Filter MiDAS object by frequency
#'
#' @inheritParams getExperimentFrequencies
#' @param object \code{\link{MiDAS}} object.
#' @param experiment String specifying experiment.
#' @param lower_frequency_cutoff Number giving lower frequency threshold.
#'   Numbers greater than 1 are interpreted as the number of feature occurrences,
#'   numbers between 0 and 1 as fractions.
#' @param upper_frequency_cutoff Number giving upper frequency threshold.
#'   Numbers greater than 1 are interpreted as the number of feature occurrences,
#'   numbers between 0 and 1 as fractions.
#'
#' @return Filtered \code{\link{MiDAS}} object.
#' 
#' @examples
#' filterByFrequency(object = MiDAS_tut_object, 
#'                   experiment = "hla_alleles",
#'                   lower_frequency_cutoff = 0.05,
#'                   upper_frequency_cutoff = 0.95,
#'                   carrier_frequency = TRUE)
#'
#' @importFrom assertthat assert_that is.string
#' @importFrom S4Vectors metadata
#' @export
setGeneric(
  name = "filterByFrequency",
  def = function(object,
                 experiment,
                 lower_frequency_cutoff = NULL,
                 upper_frequency_cutoff = NULL,
                 carrier_frequency = FALSE) {
    standardGeneric("filterByFrequency")
  }
)

#' @rdname MiDAS-class
#'
#' @title Filter MiDAS object by frequency
#'
#' @param lower_frequency_cutoff Number giving lower frequency threshold.
#'   Numbers greater than 1 are interpreted as the number of feature occurrences,
#'   numbers between 0 and 1 as fractions.
#' @param upper_frequency_cutoff Number giving upper frequency threshold.
#'   Numbers greater than 1 are interpreted as the number of feature occurrences,
#'   numbers between 0 and 1 as fractions.
#'
#' @importFrom assertthat assert_that is.string
#' @importFrom S4Vectors metadata
#' @export
setMethod(
  f = "filterByFrequency",
  signature = "MiDAS",
  definition = function(object,
                        experiment,
                        lower_frequency_cutoff = NULL,
                        upper_frequency_cutoff = NULL,
                        carrier_frequency = FALSE) {
  assert_that(
    is.character(experiment),
    characterMatches(experiment, getExperiments(object)),
    validateFrequencyCutoffs(lower_frequency_cutoff, upper_frequency_cutoff)
  )

  for (ex in experiment) {
    mat <- object[[ex]]
    assert_that(
      ! is.null(getExperimentPopulationMultiplicator(mat)), # if pop_mul is not set frequency cannot be calculated
      msg = sprintf("Frequency filtration does not support experiment '%s'", ex)
    )
    object[[ex]] <- filterExperimentByFrequency(
      experiment = mat,
      carrier_frequency = carrier_frequency,
      lower_frequency_cutoff = lower_frequency_cutoff,
      upper_frequency_cutoff = upper_frequency_cutoff
    )
  }

  return(object)
})


#' Filter MiDAS object by omnibus groups
#'
#' @param object \code{\link{MiDAS}} object.
#' @param experiment String specifying experiment.
#' @param groups Character vector specifying omnibus groups to select. See
#'   \code{\link{getOmnibusGroups}} for more details.
#'
#' @return Filtered \code{\link{MiDAS}} object.
#' 
#' @examples
#' filterByOmnibusGroups(object = MiDAS_tut_object,
#'                       experiment = "hla_aa",
#'                       groups = c("A_3", "A_6", "C_1"))
#'
#' @importFrom assertthat assert_that is.string see_if
#' @importFrom S4Vectors metadata
#' @export
setGeneric(
  name = "filterByOmnibusGroups",
  def = function(object,
                 experiment,
                 groups) {
    standardGeneric("filterByOmnibusGroups")
  }
)

#' @rdname MiDAS-class
#'
#' @title Filter MiDAS object by omnibus groups
#'
#' @param object \code{\link{MiDAS}} object.
#' @param experiment String specifying experiment.
#' @param groups Character vector specifying omnibus groups to select. See
#'   \code{\link{getOmnibusGroups}} for more details.
#'
#' @importFrom assertthat assert_that is.string see_if
#' @importFrom S4Vectors metadata
#' @export
setMethod(
  f = "filterByOmnibusGroups",
  signature = "MiDAS",
  definition = function(object,
                        experiment,
                        groups) {
    assert_that(
      is.string(experiment),
      characterMatches(experiment, getExperiments(object)),
      is.character(groups)
    )
    omnibus_groups <- getOmnibusGroups(object, experiment)
    se <- object[[experiment]]
    assert_that(
      see_if(
        !is.null(omnibus_groups),
        msg = sprintf(
          "Omnibus groups filtration does not support experiment '%s'",
          experiment
        )
      ),
      see_if(
        isClass(se, "SummarizedExperiment"),
        msg = sprintf(
          "Omnibus groups filtration does not support experiment '%s'",
          experiment
        )
      ),
      characterMatches(groups, names(omnibus_groups))
    )

    mask <- unlist(omnibus_groups[groups]) # TODO what if some groups are missing due to smth
    object[[experiment]] <- se[mask, ]

    return(object)
  })


#' Filter MiDAS object by features
#'
#' @param object \code{\link{MiDAS}} object.
#' @param experiment String specifying experiment.
#' @param variables Character vector specifying features to select.
#'
#' @return Filtered \code{\link{MiDAS}} object.
#' 
#' @examples
#' filterByVariables(object = MiDAS_tut_object,
#'                   experiment = "hla_alleles",
#'                   variables = c("A*25:01", "A*26:01", "B*07:02"))
#'
#' @export
setGeneric(
  name = "filterByVariables",
  def = function(object, experiment, variables) standardGeneric("filterByVariables")
)

#' @rdname MiDAS-class
#'
#' @title Filter MiDAS object by features
#'
#' @param variables Character vector specifying features to select.
#'
#' @importFrom S4Vectors metadata
#' @export
setMethod(
  f = "filterByVariables",
  signature = "MiDAS",
  definition = function (object, experiment, variables) {
    assert_that(
      validObject(object),
      is.string(experiment),
      stringMatches(experiment, getExperiments(object)),
      is.character(variables),
      characterMatches(variables, unlist(rownames(object)))
    )
    object[[experiment]] <- filterExperimentByVariables(object[[experiment]], variables)

    return(object)
  }
)

#' Get HLA alleles for amino acid position
#'
#' List HLA alleles and amino acid residues at a given position.
#'
#' @inheritParams summariseAAPosition
#' @param object \code{\link{MiDAS}} object.
#'
#' @return Data frame containing HLA alleles, their corresponding amino acid
#'   residues and frequencies at requested position.
#'   
#' @examples
#' getAllelesForAA(object = MiDAS_tut_object, aa_pos = "A_9")
#'
#' @export
setGeneric(
  name = "getAllelesForAA",
  def = function(object, aa_pos) standardGeneric("getAllelesForAA")
)

#' @rdname MiDAS-class
#'
#' @title Get HLA alleles for amino acid position
#'
#' @inheritParams summariseAAPosition
#'
#' @importFrom S4Vectors metadata
#' @export
setMethod(
  f = "getAllelesForAA",
  signature = "MiDAS",
  definition = function (object, aa_pos) {
    assert_that(
      validObject(object),
      is.string(aa_pos),
      see_if(grepl("^[A-Z]+[0-9]*_-*[0-9]+$", aa_pos),
             msg = "amino acid position should be formatted like: A_9."
      )
    )

    hla_calls <- getHlaCalls(object)
    assert_that(
      see_if(! is.null(hla_calls),
             msg = "Could not find HLA calls associated with MiDAS object. Make sure to use prepareMiDAS for MiDAS object creation."
      )
    )
    if (! is.null(object[["hla_alleles"]])) { # filter hla calls to match hla_alleles experiment
      alleles <- rownames(object[["hla_alleles"]])
      hla_calls[, -1] <- rapply(
        object = hla_calls[, -1],
        f = function(x) ifelse(x %in% alleles, x, as.character(NA)),
        how = "replace"
      )
    }

    alleles_for_aa <- summariseAAPosition(hla_calls, aa_pos)

    return(alleles_for_aa)
  }
)

#' Coerce MiDAS to Data Frame
#'
#' @method as.data.frame MiDAS
#' 
#' @return Data frame representation of MiDAS object. Consecutive columns hold
#'   values of variables from MiDAS's experiments and colData. The metadata
#'   associated with experiments is not preserved.
#'
#' @inheritParams base::as.data.frame
#' @export
as.data.frame.MiDAS <- function(x, ...) {
  midasToWide(object = x,
              experiment = getExperiments(x))
}

#' Construct a MiDAS object
#'
#' \code{prepareMiDAS} transform HLA alleles calls and KIR calls according
#' to selected \code{experiment}s creating a \code{\link{MiDAS}} object.
#'
#' \code{experiment} specifies analysis types for which \code{hla_calls} and
#' \code{kir_call} should be prepared.
#' \describe{
#'   \item{\code{'hla_alleles'}}{
#'     \code{hla_calls} are transformed to counts matrix describing number of
#'     allele occurrences for each sample. This experiment is used to test
#'     associations on HLA alleles level.
#'   }
#'   \item{\code{'hla_aa'}}{
#'     \code{hla_calls} are transformed to a matrix of variable amino acid
#'     positions. See \code{\link{hlaToAAVariation}} for more details. This
#'     experiment is used to test associations on amino acid level.
#'   }
#'   \item{\code{"hla_g_groups"}}{
#'     \code{hla_calls} are translated into HLA G groups and transformed to
#'     matrix describing number of G group occurrences for each sample. See
#'     \code{\link{hlaToVariable}} for more details. This experiment is used to
#'     test associations on HLA G groups level.
#'   }
#'   \item{\code{"hla_supertypes"}}{
#'     \code{hla_calls} are translated into HLA supertypes and transformed to
#'     matrix describing number of G group occurrences for each sample. See
#'     \code{\link{hlaToVariable}} for more details. This experiment is used to
#'     test associations on HLA supertypes level.
#'   }
#'   \item{\code{"hla_NK_ligands"}}{
#'     \code{hla_calls} are translated into NK ligands, which includes HLA
#'     Bw4/Bw6 and HLA C1/C2 groups and transformed to matrix describing number
#'     of their occurrences for each sample. See \code{\link{hlaToVariable}} for
#'     more details.This experiment is used to test associations on HLA NK
#'     ligands level.
#'   }
#'   \item{\code{"kir_genes"}}{
#'     \code{kir_calls} are transformed to counts matrix describing number of
#'     KIR gene occurrences for each sample. This experiment is used to test
#'     associations on KIR genes level.
#'   }
#'   \item{\code{"hla_kir_interactions"}}{
#'     \code{hla_calls} and \code{kir_calls} are translated to HLA - KIR
#'     interactions as defined in
#'     \href{https://www.ncbi.nlm.nih.gov/pmc/articles/PMC6558367/}{Pende et al., 2019.}.
#'     See \code{\link{getHlaKirInteractions}} for more details. This experiment
#'     is used to test associations on HLA - KIR interactions level.
#'   }
#'   \item{\code{"hla_divergence"}}{
#'     Grantham distance for class I HLA alleles is calculated based on
#'     \code{hla_calls} using original formula by
#'     \href{http://www.sciencemag.org/content/185/4154/862.long}{Grantham R. 1974.}.
#'     See \code{\link{hlaCallsGranthamDistance}} for more details. This
#'     experiment is used to test associations on HLA divergence level measured
#'     by Grantham distance.
#'   }
#'   \item{\code{"hla_het"}}{
#'     \code{hla_calls} are transformed to heterozygosity status, where \code{1}
#'     designates a heterozygote and \code{0} homozygote. Heterozygosity status
#'     is calculated only for classical HLA genes (A, B, C, DQA1, DQB1, DRA,
#'     DRB1, DPA1, DPB1). This experiment is used to test associations on HLA
#'     divergence level measured by heterozygosity.
#'   }
#' }
#'
#' @inheritParams checkHlaCallsFormat
#' @inheritParams checkKirCallsFormat
#' @inheritParams hlaCallsToCounts
#' @inheritParams filterByFrequency
#' @inheritParams prepareMiDAS_hla_het
#' @param colData Data frame holding additional variables like phenotypic
#'   observations or covariates. It have to contain \code{'ID'} column holding
#'   samples identifiers corresponding to identifiers in \code{hla_calls} and
#'   \code{kir_calls}. Importantly rows of \code{hla_calls} and
#'   \code{kir_calls} without corresponding phenotype are discarded.
#' @param experiment Character vector indicating analysis type for which data
#'   should be prepared. Valid choices are \code{"hla_alleles"},
#'   \code{"hla_aa"}, \code{"hla_g_groups"}, \code{"hla_supertypes"},
#'   \code{"hla_NK_ligands"}, \code{"kir_genes"}, \code{"hla_kir_interactions"},
#'   \code{"hla_divergence"}, \code{"hla_het"}.
#'   See details for further explanations.
#' @param placeholder String giving name for dummy variable inserted to
#'   \code{colData}. This variable can be than used to define base statistical
#'   model used by \code{\link{runMiDAS}}.
#' @param indels Logical indicating whether indels should be considered when
#'   checking amino acid variability in \code{'hla_aa'} experiment.
#' @param unkchar Logical indicating whether unknown characters in the alignment
#'   should be considered when checking amino acid variability in
#'   \code{'hla_aa'} experiment.
#' @param hla_divergence_aa_selection String specifying variable region in peptide binding
#'   groove which should be considered for Grantham distance calculation. Valid
#'   choices includes: \code{"binding_groove"}, \code{"B_pocket"},
#'   \code{"F_pocket"}. See details for more information.
#' @param hla_het_resolution Number specifying HLA alleles resolution used to
#'   calculate heterogeneity in \code{"hla_het"} experiment.
#' @param hla_dictionary Data frame giving HLA allele dictionary used in
#'   \code{'hla_custom'} experiment. See \code{\link{hlaToVariable}} for more
#'   details.
#' @param kir_dictionary Data frame giving KIR genes dictionary used in
#'   \code{'kir_custom'} experiment. See \code{\link{countsToVariables}} for more
#'   details.
#'
#' @return Object of class \code{\link{MiDAS}}
#'
#' @examples
#' midas <- prepareMiDAS(hla_calls = MiDAS_tut_HLA,
#'                       kir_calls = MiDAS_tut_KIR,
#'                       colData = MiDAS_tut_pheno,
#'                       experiment = "hla_alleles")
#'
#' @importFrom assertthat assert_that see_if
#' @importFrom MultiAssayExperiment ExperimentList MultiAssayExperiment
#' @importFrom rlang is_empty
#' @importFrom stats runif
#' @importFrom S4Vectors DataFrame
#' @export
prepareMiDAS <- function(hla_calls = NULL,
                         kir_calls = NULL,
                         colData,
                         experiment = c(
                           "hla_alleles",
                           "hla_aa",
                           "hla_g_groups",
                           "hla_supertypes",
                           "hla_NK_ligands",
                           "kir_genes",
                           "kir_haplotypes",
                           "hla_kir_interactions",
                           "hla_divergence",
                           "hla_het",
                           "hla_custom",
                           "kir_custom"
                         ),
                         placeholder = "term",
                         lower_frequency_cutoff = NULL,
                         upper_frequency_cutoff = NULL,
                         indels = TRUE,
                         unkchar = FALSE,
                         hla_divergence_aa_selection = "binding_groove",
                         hla_het_resolution = 8,
                         hla_dictionary = NULL,
                         kir_dictionary = NULL
) {
  experiment_choice <- eval(formals()[["experiment"]])
  assert_that(
    see_if(
      ! is.null(hla_calls) | ! is.null(kir_calls),
      msg = "hla_calls or kir_calls argument has to be specified"
    ),
    if (! is.null(hla_calls)) {
      checkHlaCallsFormat(hla_calls)
    } else { TRUE },
    if (! is.null(kir_calls)) {
      checkKirCallsFormat(kir_calls)
    } else { TRUE },
    checkColDataFormat(colData),
    is.character(experiment),
    characterMatches(experiment, experiment_choice),
    is.string(placeholder),
    see_if(
      !placeholder %in% c(colnames(hla_calls), colnames(kir_calls), colnames(colData)),
      msg = sprintf(
        "Placeholder '%s' can not be used, it is already used as column name in one of the inputs.",
        placeholder
      )
    )
  )

  metadata <- list(placeholder = placeholder)
  if (! is.null(hla_calls)) { metadata[["hla_calls"]] <- hla_calls }
  if (! is.null(kir_calls)) { metadata[["kir_calls"]] <- kir_calls }

  # prepare data for different analyses types
  experiments <- ExperimentList()
  args <- list(
    hla_calls = hla_calls,
    kir_calls = kir_calls,
    indels = indels,
    unkchar = unkchar,
    hla_divergence_aa_selection = hla_divergence_aa_selection,
    hla_het_resolution = hla_het_resolution,
    hla_dictionary = hla_dictionary,
    kir_dictionary = kir_dictionary
  )
  for (e in experiment) {
    fun <- paste0("prepareMiDAS_", e)
    E <- do.call(
      what = fun,
      args = args
    )

    # frequency filter
    if ((!is.null(lower_frequency_cutoff) ||
         !is.null(upper_frequency_cutoff))
        && is.integer(E)) {
      E <- filterExperimentByFrequency(
        experiment = E,
        lower_frequency_cutoff = lower_frequency_cutoff,
        upper_frequency_cutoff = upper_frequency_cutoff
      )
    }

    experiments[[e]] <- E
  }

  # insert placeholder
  colData[[placeholder]] <- runif(nrow(colData))

  colData <- DataFrame(colData[, ! colnames(colData) == "ID"],
                       row.names = colData[["ID"]],
                       check.names = TRUE)

  new("MiDAS", experiments = experiments, colData = colData, metadata = metadata)
}

# Note
# Experiment metadata can contain following elements:
# \code{inheritance_model_applicable} - logical flag indicating if inheritance
# model can be applied to this experiment, \code{pop_mul} - population
# multiplicator used for features frequency calcualtions (for experiments like
# \code{"hla_alleles"} population size have to take into account presence of
# two gene copies (2 * number of samples)), \code{omnibus_groups} - named list
# of chartacter vectors giving the features groupins used for omnibus test and
# omnibus groups filtering. Set them to \code{NULL} where not applicable.

#' Prepare MiDAS data on HLA allele level
#'
#' @inheritParams prepareMiDAS
#' @param ... Not used
#'
#' @return Matrix
#'
#' @importFrom assertthat assert_that is.flag
#' @importFrom SummarizedExperiment SummarizedExperiment
#'
prepareMiDAS_hla_alleles <- function(hla_calls, ...) {
  assert_that(
    checkHlaCallsFormat(hla_calls)
  )

  hla_alleles <- hlaCallsToCounts(hla_calls = hla_calls) %>%
    dfToExperimentMat()

  hla_alleles <- SummarizedExperiment(
    assays = hla_alleles,
    metadata = list(
      inheritance_model_applicable = TRUE,
      pop_mul = 2,
      omnibus_groups = NULL)
  )

  return(hla_alleles)
}

#' Prepare MiDAS data on HLA amino acid level
#'
#' @inheritParams checkHlaCallsFormat
#' @inheritParams hlaToAAVariation
#' @param ... Not used
#'
#' @return SummarizedExperiment
#'
#' @importFrom assertthat assert_that is.flag
#' @importFrom SummarizedExperiment SummarizedExperiment
#'
prepareMiDAS_hla_aa <- function(hla_calls,
                                indels = TRUE,
                                unkchar = FALSE,
                                ...) {
  assert_that(
    checkHlaCallsFormat(hla_calls),
    is.flag(indels),
    is.flag(unkchar)
  )

  counts <-
    hlaToAAVariation(
      hla_calls = hla_calls,
      indels = indels,
      unkchar = unkchar
    ) %>%
    aaVariationToCounts() %>%
    dfToExperimentMat()
  vars <- counts %>%
    rownames()
  pos <- vars %>%
    gsub(pattern = "_.{1}$", replacement = "") %>%
    unique()
  omnibus_groups <- lapply(
    pos,
    FUN = function(p) {
      grep(pattern = paste0("^", p, "_"),
           x = vars,
           value = TRUE)
    }
  )
  names(omnibus_groups) <- pos

  hla_aa <- SummarizedExperiment(
    assays = counts,
    metadata = list(
      inheritance_model_applicable = TRUE,
      pop_mul = 2,
      omnibus_groups = omnibus_groups
    )
  )

  return(hla_aa)
}

#' Prepare MiDAS data on HLA allele's G groups level
#'
#' @inheritParams checkHlaCallsFormat
#' @param ... Not used
#'
#' @return Matrix
#'
#' @importFrom assertthat assert_that
#' @importFrom SummarizedExperiment SummarizedExperiment
#'
prepareMiDAS_hla_g_groups <- function(hla_calls, ...) {
  assert_that(
    checkHlaCallsFormat(hla_calls)
  )

  lib <- "allele_HLA_Ggroup"
  hla_g_groups <- hlaToVariable(hla_calls = hla_calls,
                                dictionary = lib,
                                na.value = 0
  )

  assert_that(
    ncol(hla_g_groups) > 1,
    msg = "no allele could be assigned to G group for input hla_calls"
  )

  hla_g_groups <-
    hlaCallsToCounts(
      hla_calls = hla_g_groups,
      check_hla_format = FALSE
    ) %>%
    dfToExperimentMat()

  hla_g_groups <- SummarizedExperiment(
    assays = hla_g_groups,
    metadata = list(
      inheritance_model_applicable = TRUE,
      pop_mul = 2,
      omnibus_groups = NULL)
  )

  return(hla_g_groups)
}

#' Prepare MiDAS data on HLA allele's supertypes level
#'
#' @inheritParams checkHlaCallsFormat
#' @param ... Not used
#'
#' @return Matrix
#'
#' @importFrom assertthat assert_that
#' @importFrom dplyr select
#' @importFrom rlang .data
#' @importFrom SummarizedExperiment SummarizedExperiment
#'
prepareMiDAS_hla_supertypes <- function(hla_calls, ...) {
  assert_that(
    checkHlaCallsFormat(hla_calls)
  )

  lib <- "allele_HLA_supertype"
  hla_supertypes <- hlaToVariable(hla_calls = hla_calls,
                                    dictionary = lib,
                                    na.value = 0
  )

  assert_that(
    ncol(hla_supertypes) > 1,
    msg = "no allele could be assigned to supertype for input hla_calls"
  )

  hla_supertypes <-
    hlaCallsToCounts(
      hla_calls = hla_supertypes,
      check_hla_format = FALSE
    )
  hla_supertypes <-
    hla_supertypes[, ! colnames(hla_supertypes) == "Unclassified"] %>%
    dfToExperimentMat()

  hla_supertypes <- SummarizedExperiment(
    assays = hla_supertypes,
    metadata = list(
      inheritance_model_applicable = TRUE,
      pop_mul = 2,
      omnibus_groups = NULL)
  )

  return(hla_supertypes)
}

#' Prepare MiDAS data on HLA allele's groups level
#'
#' @inheritParams checkHlaCallsFormat
#' @param ... Not used
#'
#' @return Matrix
#'
#' @importFrom assertthat assert_that
#' @importFrom SummarizedExperiment SummarizedExperiment
#'
prepareMiDAS_hla_NK_ligands <- function(hla_calls, ...) {
  assert_that(
    checkHlaCallsFormat(hla_calls)
  )

  # Bw6 is defined both in Bw and Bw HLA-B only dictionaries, here this unambiguity is removed
  bw_with_A <-
    system.file("extdata", "Match_allele_HLA_Bw.txt", package = "midasHLA")
  bw_with_A <-
    read.table(
      file = bw_with_A,
      header = TRUE,
      sep = "\t",
      stringsAsFactors = FALSE
    )
  mask <- bw_with_A$group != "Bw6"
  bw_with_A <- bw_with_A[mask, ]
  
  lib <- list(bw_with_A, "allele_HLA-Bw_only_B", "allele_HLA-C_C1-2")
  hla_NK_ligands <- Reduce(
    f = function(...) left_join(..., by = "ID"),
    x = lapply(lib, hlaToVariable, hla_calls = hla_calls, na.value = 0)
  )

  assert_that(
    ncol(hla_NK_ligands) > 1,
    msg = "no allele could be assigned to allele groups for input hla_calls"
  )

  hla_NK_ligands <-
    hlaCallsToCounts(
      hla_calls = hla_NK_ligands,
      check_hla_format = FALSE
    ) %>%
    dfToExperimentMat()

  hla_NK_ligands <- SummarizedExperiment(
    assays = hla_NK_ligands,
    metadata = list(
      inheritance_model_applicable = TRUE,
      pop_mul = 2,
      omnibus_groups = NULL)
  )

  return(hla_NK_ligands)
}

#' Prepare MiDAS data on KIR genes level
#'
#' @inheritParams checkKirCallsFormat
#' @param ... Not used
#'
#' @return Matrix
#'
#' @importFrom assertthat assert_that
#' @importFrom SummarizedExperiment SummarizedExperiment
#'
prepareMiDAS_kir_genes <- function(kir_calls, ...) {
  assert_that(
    checkKirCallsFormat(kir_calls)
  )

  kir_genes <-
    kir_calls %>%
    dfToExperimentMat()

  kir_genes <- SummarizedExperiment(
    assays = kir_genes,
    metadata = list(
      inheritance_model_applicable = FALSE,
      pop_mul = 1,
      omnibus_groups = NULL)
  )

  return(kir_genes)
}

#' Prepare MiDAS data on KIR haplotypes level
#'
#' @inheritParams checkKirCallsFormat
#' @param ... Not used
#'
#' @return Matrix
#'
#' @importFrom assertthat assert_that
#'
prepareMiDAS_kir_haplotypes <- function(kir_calls, ...) {
  assert_that(
    checkKirCallsFormat(kir_calls)
  )

  kir_haplotypes <- countsToVariables(counts = kir_calls,
                                      dictionary = "kir_haplotypes")

  assert_that(
    ncol(kir_haplotypes) > 1,
    msg = "None of the KIR genes could be assigned to custom variables."
  )

  kir_haplotypes <- dfToExperimentMat(kir_haplotypes)

  kir_haplotypes <- SummarizedExperiment(
    assays = kir_haplotypes,
    metadata = list(
      inheritance_model_applicable = FALSE,
      pop_mul = 1,
      omnibus_groups = NULL)
  )

  return(kir_haplotypes)
}

#' Prepare MiDAS data on HLA - KIR interactions level
#'
#' @inheritParams checkHlaCallsFormat
#' @inheritParams checkKirCallsFormat
#' @param ... Not used
#'
#' @return Matrix
#'
#' @importFrom magrittr %>%
#' @importFrom SummarizedExperiment SummarizedExperiment
#'
prepareMiDAS_hla_kir_interactions <- function(hla_calls, kir_calls, ...) {
  assert_that(
    checkHlaCallsFormat(hla_calls),
    checkKirCallsFormat(kir_calls)
  )

  hla_kir_interactions <-
    getHlaKirInteractions(
      hla_calls = hla_calls,
      kir_calls = kir_calls
    ) %>%
    dfToExperimentMat()

  hla_kir_interactions <- SummarizedExperiment(
    assays = hla_kir_interactions,
    metadata = list(
      inheritance_model_applicable = FALSE,
      pop_mul = 1,
      omnibus_groups = NULL)
  )

  return(hla_kir_interactions)
}

#' Prepare MiDAS data on HLA divergence level
#'
#' @inheritParams checkHlaCallsFormat
#' @param hla_divergence_aa_selection String specifying variable region in peptide binding
#'   groove which should be considered for Grantham distance calculation. Valid
#'   choices includes: \code{"binding_groove"}, \code{"B_pocket"},
#'   \code{"F_pocket"}. See details for more information.
#' @param ... Not used
#'
#' @return Matrix
#'
prepareMiDAS_hla_divergence <- function(hla_calls,
                                        hla_divergence_aa_selection = "binding_groove",
                                        ...) {
  assert_that(
    checkHlaCallsFormat(hla_calls)
  )
  genes <- getHlaCallsGenes(hla_calls)
  assert_that(
    any(c("A", "B", "C") %in% genes),
    msg = "Grantham distance can be calculated only for class I HLA alleles (A, B, C)."
  )

  hla_divergence <-
    hlaCallsGranthamDistance(
      hla_calls = hla_calls,
      genes = genes[genes %in% c("A", "B", "C")],
      aa_selection = hla_divergence_aa_selection
    )
  hla_divergence$ABC_avg <- rowMeans(hla_divergence[-1])
  experiment_mat <- dfToExperimentMat(hla_divergence)

  return(experiment_mat)
}

#' Prepare MiDAS data on HLA heterozygosity level
#'
#' @inheritParams checkHlaCallsFormat
#' @param hla_het_resolution Number specifying HLA alleles resolution used to
#'   calculate heterogeneity.
#' @param ... Not used
#'
#' @return Matrix
#'
prepareMiDAS_hla_het <- function(hla_calls, hla_het_resolution = 8, ...) {
  assert_that(
    checkHlaCallsFormat(hla_calls),
    is.count(hla_het_resolution)
  )

  genes <- getHlaCallsGenes(hla_calls)
  classical_genes <- c("A", "B", "C", "DQA1", "DQB1", "DRA", "DRB1", "DPA1", "DPB1")
  assert_that(
    any(classical_genes %in% genes),
    msg = "Heterozygosity status can be calculated only for classical genes (A, B, C, DQA1, DQB1, DRA, DRB1, DPA1, DPB1)."
  )

  # filter non-classical genes
  sel <- c("ID", paste0(rep(classical_genes, each = 2), "_", seq_len(2)))
  hla_calls <- hla_calls[, colnames(hla_calls) %in% sel, drop = FALSE]
  genes <- getHlaCallsGenes(hla_calls)

  # resolution
  hla_calls <- reduceHlaCalls(hla_calls, hla_het_resolution)

  hla_het <- hla_calls[, "ID", drop = FALSE]
  for (g in genes) {
    i <- paste0(g, "_1")
    j <- paste0(g, "_2")
    het <- hla_calls[, i, drop = TRUE] != hla_calls[, j, drop = TRUE]
    nm <- paste0(g, "_het")
    hla_het[[nm]] <- as.integer(het)
  }

  hla_het <- SummarizedExperiment(
    assays = dfToExperimentMat(hla_het),
    metadata = list(
      inheritance_model_applicable = FALSE,
      pop_mul = 1,
      omnibus_groups = NULL)
  )

  return(hla_het)
}

#' Prepare MiDAS data on custom HLA level
#'
#' @inheritParams checkHlaCallsFormat
#' @param hla_dictionary Data frame giving HLA allele dictionary. See
#'   \code{\link{hlaToVariable}} for more details.
#' @param ... Not used
#'
#' @return Matrix
#'
#' @importFrom assertthat assert_that
#'
prepareMiDAS_hla_custom <- function(hla_calls, hla_dictionary, ...) {
  assert_that(
    checkHlaCallsFormat(hla_calls),
    is.data.frame(hla_dictionary)
  )

  hla_custom <- hlaToVariable(hla_calls = hla_calls,
                              dictionary = hla_dictionary)

  assert_that(
    ncol(hla_custom) > 1,
    msg = "None of the HLA alleles could be assigned to custom variables."
  )

  # check variables types, character need to be summarized into counts
  if (is.character(unlist(hla_custom[, -1]))) {
    hla_custom <-
      hlaCallsToCounts(
        hla_calls = hla_custom,
        check_hla_format = FALSE
      ) %>%
      dfToExperimentMat()
    hla_custom <- SummarizedExperiment(
      assays = list(hla_custom),
      metadata = list(
        inheritance_model_applicable = TRUE,
        pop_mul = 2,
        omnibus_groups = NULL
      )
    )
  } else {
    hla_custom <- dfToExperimentMat(hla_custom)
    hla_custom <- SummarizedExperiment(
      assays = list(hla_custom),
      metadata = list(
        inheritance_model_applicable = FALSE,
        pop_mul = NULL,
        omnibus_groups = NULL
      )
    )
  }

  return(hla_custom)
}

#' Prepare MiDAS data on custom KIR level
#'
#' @inheritParams checkKirCallsFormat
#' @param kir_dictionary Data frame giving KIR genes dictionary. See
#'   \code{\link{countsToVariables}} for more details.
#' @param ... Not used
#'
#' @return Matrix
#'
#' @importFrom assertthat assert_that
#'
prepareMiDAS_kir_custom <- function(kir_calls, kir_dictionary, ...) {
  assert_that(
    checkKirCallsFormat(kir_calls),
    is.data.frame(kir_dictionary)
  )

  kir_custom <- countsToVariables(counts = kir_calls,
                                  dictionary = kir_dictionary)

  assert_that(
    ncol(kir_calls) > 1,
    msg = "None of the KIR genes could be assigned to custom variables."
  )

  kir_custom <- dfToExperimentMat(kir_custom)

  kir_custom <- SummarizedExperiment(
    assays = kir_custom,
    metadata = list(
      inheritance_model_applicable = FALSE,
      pop_mul = 1,
      omnibus_groups = NULL)
  )

  return(kir_custom)
}

#' Summarize amino acid position
#'
#' List HLA alleles and amino acid residues at a given position.
#'
#' @inheritParams checkHlaCallsFormat
#' @inheritParams hlaToAAVariation
#' @param aa_pos String specifying gene and amino acid position, example
#'   \code{"A_9"}.
#' @param aln Matrix containing amino acid sequence alignments as returned by
#'   \code{\link{readHlaAlignments}} function. By default function will use
#'   alignment files shipped with the package.
#' @param na.rm Logical flag indicating if \code{NA} values should be considered
#'   for frequency calculations.
#'
#' @return Data frame containing HLA alleles, their corresponding amino acid
#'   residues and frequencies at requested position.
#'
#' @examples
#' summariseAAPosition(MiDAS_tut_HLA, "A_9")
#'
#' @importFrom assertthat assert_that
#' @importFrom dplyr group_by n select starts_with summarise
#' @importFrom formattable percent
#' @importFrom magrittr %>%
#' @importFrom stats na.omit
#' @importFrom rlang .data
#' @export
summariseAAPosition <- function(hla_calls,
                                aa_pos,
                                aln = NULL,
                                na.rm = FALSE) {
  assert_that(
    checkHlaCallsFormat(hla_calls),
    is.string(aa_pos),
    see_if(grepl("^[A-Z]+[0-9]*_-*[0-9]+$", aa_pos),
           msg = "amino acid position should be formatted like: A_9."
    ),
    see_if(
      is.matrix(aln) || is.null(aln),
      msg = "aln is not a matrix or NULL."
    ),
    isTRUEorFALSE(na.rm)
  )

  gene <- gsub("-*[0-9]+$", "", aa_pos)
  aa_pos <- gsub(".*_(-*[0-9]+)$", "\\1", aa_pos)

  alleles <- select(hla_calls, starts_with(gene)) %>%
    unlist()
  alleles_wo_na <- alleles[! is.na(alleles)]
  assert_that(length(alleles_wo_na) != 0,
              msg = "hla_calls for given gene contains only NA."
  )

  if (na.rm) {
    alleles <- alleles_wo_na
  }

  hla_resolution <- min(getAlleleResolution(alleles_wo_na))
  alleles_wo_na <- reduceAlleleResolution(alleles_wo_na, hla_resolution)
  aln <- readHlaAlignments(
    gene = gsub("_", "", gene),
    unkchar = "*"
  )

  assert_that(
    see_if(
      aa_pos %in% colnames(aln),
      msg = sprintf("amino acid position %s was not found in amino acid sequence.", aa_pos)
    ),
    see_if(
      all(i <- alleles_wo_na %in% rownames(aln)),
      msg = sprintf(
        fmt = "allele %s could not be found in the alignment file.",
        paste(unique(alleles_wo_na[! i]), collapse = ", ")
      )
    )
  )

  aa <- data.frame(
    allele = gsub("[A-Z]+[0-9]*", "", alleles_wo_na),
    residue = aln[alleles_wo_na, aa_pos],
    stringsAsFactors = FALSE
  ) %>%
    group_by(.data$residue) %>%
    summarise(
      allele = paste(sort(unique(.data$allele)), collapse = ", "),
      count = n(),
      frequency = percent(.data$count / length(alleles))
    ) %>%
    dplyr::select(
      !! sprintf("HLA-%s (%s)", gsub("_", "", gene), aa_pos) := .data$residue,
      !! sprintf("HLA-%s alleles", gsub("_", "", gene)) := .data$allele,
      .data$count,
      .data$frequency
    ) %>%
    as.data.frame()

  return(aa)
}

context("Summarising MiDAS results")

test_that("summarize amino acid position", {
  aa_sum <- summariseAAPosition(MiDAS_tut_HLA, "DRA_2")
  aa_sum_test <- data.frame(
    `HLA-DRA (2)` = c("*", "K"),
    `HLA-DRA alleles` = c("*01:02", "*01:01"),
    count = c(711L, 1289L),
    frequency = formattable::percent(c(0.3555, 0.6445)),
    stringsAsFactors = FALSE,
    check.names = FALSE
  )
  expect_equal(aa_sum, aa_sum_test)
  
  aa_sum <- summariseAAPosition(MiDAS_tut_HLA, "DRA_-25")
  aa_sum_test <- data.frame(
    `HLA-DRA (-25)` = c("*", "M"),
    `HLA-DRA alleles` = c("*01:02", "*01:01"),
    count = c(711L, 1289L),
    frequency = formattable::percent(c(0.3555, 0.6445)),
    stringsAsFactors = FALSE,
    check.names = FALSE
  )
  expect_equal(aa_sum, aa_sum_test)

  # checkHlaCalls Format test is ommited here
  expect_error(
    summariseAAPosition(MiDAS_tut_HLA, NA),
    "pos is not a string \\(a length one character vector\\)."
  )

  expect_error(
    summariseAAPosition(MiDAS_tut_HLA, "1"),
    "amino acid position should be formatted like: A_9."
  )

  expect_error(
    summariseAAPosition(MiDAS_tut_HLA, "A_1", aln = "foo"),
    "aln is not a matrix or NULL."
  )

  expect_error(
    summariseAAPosition(MiDAS_tut_HLA, "A_1", na.rm = "foo"),
    "na.rm is not a flag \\(a length one logical vector\\)."
  )

  hla_calls <- MiDAS_tut_HLA
  hla_calls[, c("DMA_1", "DMA_2")] <- NA
  expect_error(
    summariseAAPosition(hla_calls, "DMA_100"),
    "hla_calls for given gene contains only NA."
  )

  expect_error(
    summariseAAPosition(MiDAS_tut_HLA, "DRB1_10000"),
    "amino acid position 10000 was not found in amino acid sequence."
  )

  hla_calls <- MiDAS_tut_HLA
  hla_calls[1, "DRB1_1"] <- "DRB1*00:00"
  expect_error(
    summariseAAPosition(hla_calls, "DRB1_100"),
    "allele DRB1\\*00:00 could not be found in the alignment file."
  )
})

#' Check HLA allele format
#'
#' \code{checkAlleleFormat} test if the input character follows HLA nomenclature
#' specifications.
#'
#' Correct HLA number should consist of HLA gene name followed by "*" and sets
#' of digits separated with ":". Maximum number of sets of digits is 4 which
#' is termed 8-digit resolution. Optionally HLA numbers can be supplemented with
#' additional suffix indicating its expression status. See
#' \url{http://hla.alleles.org/nomenclature/naming.html} for more details.
#'
#' HLA alleles with identical sequences across exons encoding the peptide
#' binding domains might be designated with G group allele numbers. Those
#' numbers have additional G or GG suffix. See
#' \url{http://hla.alleles.org/alleles/g_groups.html} for more details. They are
#' interpreted as valid HLA alleles designations.
#'
#' @param allele Character vector with HLA allele numbers.
#'
#' @return Logical vector specifying if \code{allele} elements follows HLA
#'   alleles naming conventions.
#'
#' @examples
#' allele <- c("A*01:01", "A*01:02")
#' checkAlleleFormat(allele)
#'
#' @importFrom assertthat assert_that
#' @importFrom stringi stri_detect_regex
#' @export
checkAlleleFormat <- function(allele) {
  pattern <- "^[A-Z0-9]+[*][0-9]+(:[0-9]+){0,3}((?=G)(G|GG)|(N|L|S|C|A|Q)){0,1}$"
  is_correct <- stri_detect_regex(allele, pattern)
  return(is_correct)
}

#' Infer HLA allele resolution
#'
#' \code{getAlleleResolution} returns the resolution of input HLA allele
#' numbers.
#'
#' HLA allele resolution can take the following values: 2, 4, 6, 8. See
#' \url{http://hla.alleles.org/nomenclature/naming.html} for more details.
#'
#' \code{NA} values are accepted and returned as \code{NA}.
#'
#' @inheritParams checkAlleleFormat
#'
#' @return Integer vector specifying allele resolutions.
#'
#' @examples
#' allele <- c("A*01:01", "A*01:02")
#' getAlleleResolution(allele)
#'
#' @importFrom assertthat assert_that see_if
#' @importFrom stringi stri_count_fixed
#' @export
getAlleleResolution <- function(allele) {
  assert_that(
    see_if(all(checkAlleleFormat(allele), na.rm = TRUE),
         msg = "allele have to be a valid HLA allele number"
    )
  )
  allele_resolution <- 2 * (stri_count_fixed(allele, ":") + 1)
  return(allele_resolution)
}

#' Reduce HLA alleles
#'
#' \code{reduceAlleleResolution} reduce HLA allele numbers resolution.
#'
#' In cases when allele number contain additional suffix their resolution
#' can not be unambiguously reduced. These cases are returned unchanged.
#' Function behaves in the same manner if \code{resolution} is higher than
#' resolution of input HLA allele numbers.
#'
#' \code{NA} values are accepted and returned as \code{NA}.
#'
#' TODO here we give such warning when alleles have G or GG suffix (see
#' http://hla.alleles.org/alleles/g_groups.html)
#'   "Reducing G groups alleles, major allele gene name will be used."
#' I dond't really remember why we are doing this xd These allele numbers are
#' processed as normal alleles (without suffix). Let me know if this warning is
#' relevant or we could go without it. If we want to leave it lets also add text
#' in documentation.
#'
#' @inheritParams checkAlleleFormat
#' @param resolution Number specifying desired resolution.
#'
#' @return Character vector containing reduced HLA allele numbers.
#'
#' @examples
#' reduceAlleleResolution(c("A*01", "A*01:24", "C*05:24:55:54"), 2)
#'
#' @importFrom assertthat assert_that is.count see_if
#' @importFrom stringi stri_split_fixed stri_detect_regex
#' @importFrom rlang warn
#' @export
reduceAlleleResolution <- function(allele,
                                   resolution=4) {
  assert_that(
    see_if(all(checkAlleleFormat(allele), na.rm = TRUE),
           msg = "allele have to be a valid HLA allele number"
    ),
    is.count(resolution)
  )
  na_idx <- is.na(allele)
  letter_alleles <- stri_detect_regex(allele, pattern = "(N|L|S|C|A|Q){1}$")
  is_ggroup <- stri_detect_regex(allele, pattern = "(G|GG){1}$")
  allele_res <- getAlleleResolution(allele)
  to_reduce <- allele_res > resolution & ! letter_alleles & ! na_idx
  resolution <- floor(resolution) / 2
  if (any(is_ggroup & to_reduce)) {
    warn("Reducing G groups alleles, major allele gene name will be used.")
  }
  allele[to_reduce] <- vapply(
    X = stri_split_fixed(allele[to_reduce], ":"),
    FUN = function(a) {
      paste(a[seq_len(resolution)], collapse = ":")
    },
    FUN.VALUE = character(length = 1)
  )
  allele[na_idx] <- NA
  return(allele)
}

#' Find variable positions in sequence alignment
#'
#' \code{getVariableAAPos} finds variable amino acid positions in protein
#' sequence alignment.
#'
#' The variable amino acid positions in the alignment are those at which
#' different amino acids can be found. As the alignments can also contain indels
#' and unknown characters, the user choice might be to consider those positions
#' as variable or not. This can be achieved by passing appropriate regular
#' expression in \code{varchar}. Eg. when \code{varchar = "[A-Z]"} occurence of
#' deletion/insertion (".") will not be treated as variability. In order to
#' detect this kind of variability \code{varchar = "[A-Z\\\\.]"} should be used.
#'
#' @param alignment Matrix containing amino acid level alignment, as returned by
#'   \code{\link{readHlaAlignments}},
#' @param varchar Regex matching characters that should be considered when
#'   looking for variable amino acid positions. See details for further
#'   explanations.
#'
#' @return Integer vector specifying which alignment columns are variable.
#'
#' @examples
#' alignment <- readHlaAlignments(gene = "TAP1")
#' getVariableAAPos(alignment)
#'
#' @importFrom assertthat assert_that is.count see_if
#' @export
getVariableAAPos <- function(alignment,
                             varchar = "[A-Z]") {
  assert_that(is.matrix(alignment))
  var_cols <- apply(alignment,
        2,
        function(col) {
          col <- col[grepl(sprintf("^%s$", varchar), col)]
          is.variable <- logical(length = 1)
          if (length(col) == 0) {
            is.variable <- FALSE
          } else {
            is.variable <- any(col != col[1])
          }
          return(is.variable)
        }
  )
  return(which(var_cols))
}

#' Convert allele numbers to additional variables
#'
#' \code{convertAlleleToVariable} converts input HLA allele numbers to additional
#' variables based on the supplied dictionary.
#'
#' \code{dictionary} file should be a tsv format with header and two columns.
#' First column should hold allele numbers, second additional variables (eg.
#' expression level).
#'
#' Type of the returned vector depends on the type of the additional variable.
#'
#' @inheritParams checkAlleleFormat
#' @param dictionary Path to file containing HLA allele dictionary or a
#'   data frame.
#'
#' @return Vector containing HLA allele numbers converted to additional
#'   variables according to \code{dictionary}.
#'
#' @examples
#' dictionary <- system.file("extdata", "Match_allele_HLA_supertype.txt", package = "midasHLA")
#' convertAlleleToVariable(c("A*01:01", "A*02:01"), dictionary = dictionary)
#'
#' @importFrom assertthat assert_that is.string is.readable see_if
#' @importFrom stats setNames
#' @importFrom utils read.table
#' @export
convertAlleleToVariable <- function(allele,
                                    dictionary) {
  assert_that(
    see_if(all(checkAlleleFormat(allele), na.rm = TRUE),
           msg = "allele have to be a valid HLA allele number"
    ),
    see_if(is.string(dictionary) | is.data.frame(dictionary),
           msg = "dictionary have to be either a path or a data.frame"
    )
  )
  if (is.character(dictionary)) {
    assert_that(
      is.readable(dictionary)
    )
    dictionary <- read.table(
      file = dictionary,
      header = TRUE,
      sep = "\t",
      stringsAsFactors = FALSE
    )
  }
  assert_that(
    see_if(ncol(dictionary) == 2,
           msg = "dictionary must have two columns"
    ),
    see_if(all(checkAlleleFormat(dictionary[, 1]), na.rm = TRUE),
           msg = "first column in dictionary must contain valid HLA allele numbers"
    ),
    see_if(! any(duplicated(dictionary[, 1]), na.rm = TRUE),
           msg = "dictionary contains duplicated allele numbers")
  )
  dictionary <- setNames(dictionary[, 2], dictionary[, 1])
  variable <- dictionary[as.character(allele)] # for all NAs vectrors default type is logical; recycling mechanism leads to unwanted results
  names(variable) <- NULL

  return(variable)
}

#' Backquote character
#'
#' \code{backquote} places backticks around elements of character vector
#'
#' \code{backquote} is useful when using HLA allele numbers in formulas, where
#' \code{'*'} and \code{':'} characters have special meanings.
#'
#' @param x Character vector.
#'
#' @return Character vector with its elements backticked.
#'
#' @importFrom assertthat assert_that
#'
backquote <- function(x) {
  assert_that(is.character(x))
  x <- gsub("`", "", x)
  backquoted <- paste0("`", x, "`")
  return(backquoted)
}

#' Extend and Re-fit a Model Call
#'
#' \code{updateModel} adds new variables to model and re-fit it.
#'
#' @param object An existing fit from a model function such as lm, glm and many
#'   others.
#' @param x Character vector specifying variables to be added to model.
#' @param placeholder String specifying term to substitute with value from
#'   \code{x}. Ignored if set to \code{NULL}.
#' @param backquote Logical indicating if added variables should be quoted.
#'   Elements of this vector are recycled over \code{x}.
#' @param collapse String specifying how variables should be combined. Defaults
#'   to \code{" + "} ie. linear combination.
#'
#' @return Updated fitted object.
#'
#' @importFrom assertthat assert_that is.string
#' @importFrom magrittr %>%
#' @importFrom stats update
#'
updateModel <- function(object,
                        x,
                        placeholder = NULL,
                        backquote = TRUE,
                        collapse = " + ") {
  assert_that(
    checkStatisticalModel(object),
    is.character(x),
    isStringOrNULL(placeholder),
    isTRUEorFALSE(backquote),
    is.string(collapse)
  )

  object_env <- attr(object$terms, ".Environment")

  if (backquote) {
    x <- backquote(x)
  }

  if (is.null(placeholder)) {
    x <- paste0(". ~ . + ", paste(x, collapse = collapse))
  } else {
    x <- paste0("(", paste(x, collapse = collapse), ")")
    object_call <- getCall(object)
    object_form <- object_call[["formula"]] %>%
      eval(envir = object_env)
    assert_that(
      objectHasPlaceholder(object, placeholder = placeholder)
    )
    x <- gsub(pattern = placeholder, replacement = x, x = deparse(object_form))
  }

  new_object <- update(object = object, x, evaluate = FALSE)
  new_object <- eval(new_object, envir = object_env)

  return(new_object)
}

#' List HLA alleles dictionaries
#'
#' \code{listMiDASDictionaries} lists dictionaries shipped with the MiDAS package.
#' See \code{\link{hlaToVariable}} for more details on dictionaries.
#'
#' @param file.names Logical value. If FALSE, only the names of dictionaries are
#' returned. If TRUE their paths are returned.
#' @param pattern String used to match dictionary names, it can be a regular
#'   expression. By default all names are matched.
#'
#' @return Character vector giving names of available HLA alleles dictionaries.
#'
listMiDASDictionaries <- function(pattern = "allele", file.names = FALSE) {
  pattern <- paste0("^Match.*", pattern, ".*.txt$")
  lib <- list.files(
    path = system.file("extdata", package = "midasHLA"),
    pattern = pattern,
    full.names = file.names
  )

  if (! file.names) {
    lib <- gsub("^Match_", "", gsub(".txt$", "", lib))
  }

  return(lib)
}

#' Likelihood ratio test
#'
#' \code{LRTest} carry out an asymptotic likelihood ratio test for two models.
#'
#' \code{mod0} have to be a reduced version of \code{mod1}. See examples.
#'
#' @param mod0 An existing fit from a model function such as lm, glm and many
#'   others.
#' @param mod1 Object of the same class as \code{mod0} with extra terms
#'   included.
#'
#' @return Data frame with the results of likelihood ratio test of the supplied
#'   models.
#'
#'   Column \code{term} holds new variables appearing in \code{mod1},
#'   \code{df} difference in degrees of freedom between models, \code{logLik}
#'   difference in log likelihoods, \code{statistic} \code{Chisq} statistic and
#'   \code{p.value} corresponding p-value.
#'
#' @importFrom assertthat assert_that
#' @importFrom rlang abort warn
#' @importFrom stats logLik pchisq
#'
LRTest <- function(mod0, mod1) {
  formula0 <- formula(mod0)
  vars0 <- all.vars(formula0)
  formula1 <- formula(mod1)
  vars1 <- all.vars(formula1)
  assert_that(
    all(vars0 %in% vars1),
    msg = sprintf("variables %s were not found in mod1",
                  paste(vars0[! vars0 %in% vars1], collapse = ", ")
    )
  )
  
  # drop vars with NA coefficient
  coefs <- stats::coef(mod1)
  na_vars <- names(coefs)[is.na(coefs)]
  if (length(na_vars)) {
    warning(sprintf(
      "Coefficients for variables: %s could not be estimated, those variables will not be included in likelyhood ratio test result.",
      paste(na_vars, collapse = ",")
    ))
    vars1 <- vars1[! vars1 %in% na_vars]
  }

  new_vars <- vars1[! vars1 %in% vars0]
  if (! length(new_vars)) {
    stop("No new variables found in an extended model. Likely coefficients for new variables could not be estimated, please check previous warning messages.",
         domain = NA
    )
  }
  
  # df <- length(new_vars) - 1
  # according to this post https://stackoverflow.com/questions/37917437/loglik-lm-why-does-r-use-p-1-instead-of-p-for-degree-of-freedom
  # df <- attr(ll1, "df") - attr(ll0, "df") is proper
  ll0 <- logLik(mod0)
  ll1 <- logLik(mod1)
  df <- attr(ll1, "df") - attr(ll0, "df")
  
  statistic <- 2 * (as.numeric(ll1) - as.numeric(ll0))
  p.value <- pchisq(statistic, df = df, lower.tail=FALSE)

  
  res <- data.frame(
    term = paste(new_vars, collapse = ", "),
    df = df,
    logLik = ll1 - ll0,
    statistic = statistic,
    p.value = p.value,
    stringsAsFactors = FALSE
  )

  return(res)
}

#' Get attributes of statistical model object
#'
#' \code{getObjectDetails} extracts some of the statistical model object
#' attributes that are needed for \code{runMiDAS} internal calculations.
#'
#' @inheritParams checkStatisticalModel
#'
#' @return List with following elements:
#' \describe{
#'   \item{call}{Object's call}
#'   \item{formula_vars}{Character containing names of variables in object
#'     formula}
#'   \item{data}{MiDAS object associated with model}
#' }
#'
#' @importFrom MultiAssayExperiment colData
#'
getObjectDetails <- function(object) {
  object_call <- getCall(object)
  object_env <- attr(object$terms, ".Environment")
  object_formula <- eval(object_call[["formula"]], envir = object_env)
  object_call[["formula"]] <- object_formula
  object_data <- eval(object_call[["data"]], envir = object_env)

  object_details <- list(
    call = object_call,
    formula_vars = all.vars(object_formula),
    data = object_data
  )

  return(object_details)
}

#' Get variables frequencies from MiDAS
#'
#' Helper getting variables frequencies from MiDAS object. Additionally for
#' binary test covariate frequencies per phenotype are added. Used in scope of 
#' \code{runMiDAS}.
#'
#' @param midas MiDAS object.
#' @param experiment String specifying experiment from \code{midas}.
#' @param test_covar String giving name of test covariate.
#'
#' @return Data frame with variable number of columns. First column,
#'   \code{"term"} holds experiment's variables, further columns hold number of
#'   variable occurrence and their frequencies.
#'
#' @importFrom dplyr filter left_join mutate rename select
#' @importFrom formattable percent
#' @importFrom magrittr %>%
#' @importFrom rlang !! :=
#' @importFrom stats na.omit
#'
runMiDASGetVarsFreq <- function(midas, experiment, test_covar) {
  variables_freq <- midas[[experiment]] %>%
    getExperimentFrequencies() %>%
    mutate(Freq = percent(.data$Freq)) %>%
    rename(Ntotal = .data$Counts, Ntotal.percent = .data$Freq)

  test_covar_vals <- factor(colData(midas)[[test_covar]])
  if (nlevels(test_covar_vals) == 2) {
    ids <- rownames(colData(midas))

    lvl1_ids <- ids[test_covar_vals == levels(test_covar_vals)[1]] %>% 
      na.omit()
    lvl1_freq <- midas[, lvl1_ids] %>%
      `[[`(experiment) %>%
      getExperimentFrequencies() %>%
      mutate(Freq = percent(.data$Freq)) %>%
      rename(
        !!sprintf("N(%s=%s)", test_covar, levels(test_covar_vals)[1]) := .data$Counts,
        !!sprintf("N(%s=%s).percent", test_covar, levels(test_covar_vals)[1]) := .data$Freq
      )
    variables_freq <- left_join(variables_freq, lvl1_freq, by = "term")

    lvl2_ids <- ids[test_covar_vals == levels(test_covar_vals)[2]] %>%
      na.omit()
    lvl2_freq <- midas[, lvl2_ids] %>%
      `[[`(experiment) %>%
      getExperimentFrequencies() %>%
      mutate(Freq = percent(.data$Freq)) %>%
      rename(
        !!sprintf("N(%s=%s)", test_covar, levels(test_covar_vals)[2]) := .data$Counts,
        !!sprintf("N(%s=%s).percent", test_covar, levels(test_covar_vals)[2]) := .data$Freq
      )
    variables_freq <- left_join(variables_freq, lvl2_freq, by = "term")
  }

  return(variables_freq)
}

#' Calculate Grantham distance between amino acid sequences
#'
#' \code{distGrantham} calculates normalized Grantham distance between two
#' amino acid sequences. For details on calculations see
#' \href{http://www.sciencemag.org/content/185/4154/862.long}{Grantham R. 1974.}.
#'
#' Distance between amino acid sequences is normalized by length of compared
#' sequences.
#'
#' Lengths of \code{aa1} and \code{aa2} must be equal.
#'
#' @param aa1 Character vector giving amino acid sequence using one letter
#'   codings. Each element must correspond to single amino acid.
#' @param aa2 Character vector giving amino acid sequence using one letter
#'   codings. Each element must correspond to single amino acid.
#'
#' @return Numeric vector of normalized Grantham distance between \code{aa1} and
#'   \code{aa2}.
#'
#' @importFrom assertthat assert_that see_if
#'
distGrantham <- function(aa1, aa2) {
  assert_that(
    is.character(aa1),
    is.character(aa2),
    see_if(
      length(aa1) == length(aa2),
      msg = "aa1 and aa2 must have equal lengths."
    )
  )

  idx <- paste(aa1, aa2, sep = "")
  assert_that(
    all(test <- idx %in% names(dict_dist_grantham)),
    msg = sprintf(
      fmt = "%s are not valid amino acids pairs",
      paste(idx[! test], collapse = ", ")
    )
  )

  d <- sum(dict_dist_grantham[idx]) / length(idx)

  return(d)
}

#' Calculate Grantham distance between HLA alleles
#'
#' \code{hlaCallsGranthamDistance} calculate Grantham distance between two HLA
#' alleles of a given, using original formula by
#' \href{http://www.sciencemag.org/content/185/4154/862.long}{Grantham R. 1974.}.
#'
#' Grantham distance is calculated only for class I HLA alleles. First
#' exons forming the variable region in the peptide binding groove are selected.
#' Here we provide option to choose either  \code{"binding_groove"} - exon 2 and
#' 3 (positions 1-182 in IMGT/HLA alignments, however here we take 2-182 as many
#' 1st positions are missing), \code{"B_pocket"} -  residues 7, 9, 24, 25, 34,
#' 45, 63, 66, 67, 70, 99 and \code{"F_pocket"} - residues 77, 80, 81, 84, 95,
#' 116, 123, 143, 146, 147. Then all the alleles containing gaps, stop codons or
#' indels are discarded. Finally distance is calculated for each pair.
#'
#' See \href{https://europepmc.org/article/med/28650991}{Robinson J. 2017.} for
#' more details on the choice of exons 2 and 3.
#'
#' @inheritParams checkHlaCallsFormat
#' @param genes Character vector specifying genes for which allelic distance
#'   should be calculated.
#' @param aa_selection String specifying variable region in peptide binding
#'   groove which should be considered for Grantham distance calculation. Valid
#'   choices includes: \code{"binding_groove"}, \code{"B_pocket"},
#'   \code{"F_pocket"}. See details for more information.
#'
#' @return Data frame of normalized Grantham distances between pairs of alleles
#'   for each specified HLA gene. First column (\code{ID}) is the same as in
#'   \code{hla_calls}, further columns are named as given by \code{genes}.
#'
#' @examples
#' hlaCallsGranthamDistance(MiDAS_tut_HLA, genes = "A")
#'
#' @importFrom assertthat assert_that is.string noNA see_if
#' @importFrom magrittr %>%
#' @importFrom rlang warn
#' @importFrom stats na.omit
#' @export
hlaCallsGranthamDistance <- function(hla_calls,
                                     genes = c("A", "B", "C"),
                                     aa_selection = "binding_groove") {
  assert_that(
    checkHlaCallsFormat(hla_calls),
    is.character(genes),
    noNA(genes),
    stringMatches(aa_selection, c("binding_groove", "B_pocket", "F_pocket"))
  )

  target_genes <- getHlaCallsGenes(hla_calls)
  assert_that(
    characterMatches(x = genes, choice = target_genes)
  )
  target_genes <- genes

  d <- list(ID = hla_calls[, 1, drop = TRUE])
  for (gene in target_genes) {
    if (! gene %in% c("A", "B", "C")) {
      warn(sprintf("Grantham distance is calculated only for class I HLA alleles. Omitting gene %s", gene))
      next()
    }

    sel <- paste0(gene, c("_1", "_2"))
    pairs <- hla_calls[, sel]
    # resolution <- getAlleleResolution(unlist(pairs)) %>%
    #   na.omit()
    # assert_that( # this should become obsolete
    #   see_if(
    #     all(resolution == resolution[1]),
    #     msg = sprintf("Allele resolutions for gene %s are not equal", gene)
    #   )
    # )

    # process alignment
    aa_sel <- list(
      binding_groove = 2:182,
      B_pocket =  c(7, 9, 24, 25, 34, 45, 63, 66, 67, 70, 99),
      F_pocket = c(77, 80, 81, 84, 95, 116, 123, 143, 146, 147)
    )
    alignment <- hlaAlignmentGrantham(gene, aa_sel[[aa_selection]])

    allele_numbers <- rownames(alignment)
    d[[gene]] <- vapply(
      X = seq_len(nrow(pairs)),
      FUN = function(i) {
        allele1 <- pairs[i, 1]
        allele2 <- pairs[i, 2]
        if (allele1 %in% allele_numbers && allele2 %in% allele_numbers) {
          aa1 <- alignment[allele1, ]
          aa2 <- alignment[allele2, ]
          distGrantham(aa1, aa2)
        } else {
          warn(
            sprintf(
              fmt = "Alleles %s could not be found in the alignment coercing to NA",
              paste(allele1, allele1, sep = ", ")
            )
          )
          as.numeric(NA)
        }
      },
      FUN.VALUE = numeric(length = 1L)
    )
  }

  hla_dist <- data.frame(d, stringsAsFactors = FALSE)

  return(hla_dist)
}

#' Helper function returning alignment for Grantham distance calculations
#'
#' @param gene Character vector specifying HLA gene.
#' @param aa_sel Numeric vector specifying amino acids that should be extracted.
#'
#' @return HLA alignment processed for grantham distance calculation. Processing 
#'   includes extracting specific amino acids, masking indels, gaps and stop 
#'   codons.
#'
hlaAlignmentGrantham <- function(gene, aa_sel = 2:182) {
  alignment <- readHlaAlignments(
    gene = gene,
    trim = TRUE
  )
  alignment <- alignment[, aa_sel] # select amino acids
  mask <- apply(alignment, 1, function(x) any(x == "" | x == "X" | x == ".")) # mask gaps, stop codons, indels
  alignment <- alignment[! mask, ]

  return(alignment)
}

#' Get HLA calls genes
#'
#' \code{getHlaCallsGenes} get's genes found in HLA calls.
#'
#' @inheritParams checkHlaCallsFormat
#'
#' @return Character vector of genes in \code{hla_calls}.
#'
#' @importFrom assertthat assert_that
#'
getHlaCallsGenes <- function(hla_calls) {
  assert_that(
    checkHlaCallsFormat(hla_calls)
  )

  genes <- hla_calls %>%
    colnames() %>%
    `[`(-1) %>% # discard ID column
    gsub(pattern = "_[0-9]+", replacement = "") %>%
    unique()

  return(genes)
}

#' Helper transform data frame to experiment matrix
#'
#' Function deletes 'ID' column from a \code{df}, then transpose it and sets
#' the column names to values from deleted 'ID' column.
#'
#' @param df Data frame
#'
#' @return Matrix representation of \code{df}.
#'
#' @importFrom utils type.convert
#'
dfToExperimentMat <- function(df) {
  cols <- df[["ID"]]
  mat <- t(df[, ! colnames(df) == "ID", drop = FALSE])
  colnames(mat) <- cols

  # convert to apropiate type
  # mat <- type.convert(mat, as.is = TRUE)

  return(mat)
}

#' Helper transform experiment matrix to data frame
#'
#' Function transpose \code{mat} and inserts column names of input \code{mat} as
#' a 'ID' column.
#'
#' @param mat Matrix
#'
#' @return Data frame representation of \code{mat}.
#'
experimentMatToDf <- function(mat) {
  ID <- colnames(mat)
  df <-
    as.data.frame(
      t(mat),
      stringsAsFactors = FALSE,
      make.names = FALSE
    )
  rownames(df) <- NULL
  df <- cbind(ID, df, stringsAsFactors = FALSE)

  return(df)
}

#' Transform MiDAS to wide format data.frame
#'
#' @param object Object of class MiDAS
#' @param experiment Character specifying experiments to include
#'
#' @return Data frame representation of MiDAS object. Consecutive columns holds
#'   values of variables from MiDAS's experiments and colData. The metadata
#'   associated with experiments is not preserved.
#'
#' @importFrom assertthat assert_that
#' @importFrom dplyr left_join
#' @importFrom methods is validObject
#' @importFrom magrittr %>%
#' @importFrom MultiAssayExperiment colData experiments
#' @importFrom tibble rownames_to_column
#'
midasToWide <- function(object, experiment) {
  assert_that(
    validObject(object),
    is.character(experiment),
    characterMatches(experiment, getExperiments(object))
  )

  ex_list <- experiments(object)[experiment]
  ex_list <- lapply(
    X = ex_list,
    FUN = function(x) {
      if (is(x, "SummarizedExperiment")) x <- assay(x)
      x %>%
        t() %>%
        as.data.frame(optional = TRUE) %>%
        rownames_to_column(var = "ID")
    }
  )
  col_data <- colData(object) %>%
    as.data.frame(optional = TRUE) %>%
    rownames_to_column(var = "ID")
  ex_list[[length(ex_list) + 1]] <- col_data # append
  wide_df <- Reduce(function(x, y) left_join(x, y, by = "ID"), ex_list)

  return(wide_df)
}

#' Check KIR genes format
#'
#' \code{checkKirGenesFormat} test if the input character follows KIR gene names
#' naming conventions.
#'
#' KIR genes: "KIR3DL3", "KIR2DS2", "KIR2DL2", "KIR2DL3", "KIR2DP1", "KIR2DL1",
#' "KIR3DP1", "KIR2DL1", "KIR3DP1", "KIR2DL4", "KIR3DL1", "KIR3DS1", "KIR2DL5",
#' "KIR2DS3", "KIR2DS5", "KIR2DS4", "KIR2DS1", "KIR3DL2".
#'
#' @param genes Character vector with KIR gene names.
#'
#' @return Logical vector specifying if \code{genes} elements follow KIR genes
#'   naming conventions.
#'
#' @examples
#' checkKirGenesFormat(c("KIR3DL3", "KIR2DS2", "KIR2DL2"))
#'
#' @importFrom assertthat assert_that
#' @importFrom stringi stri_detect_regex
#' @export
checkKirGenesFormat <- function(genes) {
  pattern <- "^KIR[0-9]{1}D[A-Z]{1}[0-9]{1}$"
  is_correct <- stri_detect_regex(genes, pattern)

  return(is_correct)
}

#' Iterative likelihood ratio test
#'
#' \code{iterativeLRT} performs likelihood ratio test in an iterative manner
#' over groups of variables given in \code{omnibus_groups}.
#'
#' @inheritParams updateModel
#' @inheritParams omnibusTest
#'
#' @return Data frame containing summarised likelihood ratio test results.
#'
#' @importFrom dplyr bind_rows
#'
iterativeLRT <- function(object, placeholder, omnibus_groups) {
  mod0 <- updateModel(
    object = object,
    x = "1",
    placeholder = placeholder,
    backquote = FALSE
  )
  results <- lapply_tryCatch(
    X = omnibus_groups, 
    FUN = function(x)
        LRTest(
          mod0,
          updateModel(
            object = object,
            x = x,
            placeholder = placeholder,
            collapse = " + ",
            backquote = TRUE
          )
        ), 
    err_res = function(x)
      data.frame(
        term = toString(x),
        df = NA,
        logLik = NA,
        statistic = NA,
        p.value = NA,
        stringsAsFactors = FALSE
      )
  )
  results <- bind_rows(results, .id = "group")
  
  return(results)
}

#' Iteratively evaluate model for different variables
#' 
#' Information about variable statistic from each model is extracted using 
#' \code{tidy} function.
#'
#' @inheritParams updateModel
#' @inheritParams analyzeAssociations
#'
#' @return Tibble containing per variable summarised model statistics. The exact
#'   output format is model dependent and controlled by model's dedicated 
#'   \code{tidy} function.
#'   
#' @importFrom dplyr bind_rows tibble
#' @importFrom broom tidy
#'
iterativeModel <- function(object,
                           placeholder,
                           variables,
                           exponentiate = FALSE) {
  results <- lapply_tryCatch(
    X = variables,
    FUN = function(x) {
      obj <- updateModel(
        object = object,
        x = x,
        placeholder = placeholder,
        backquote = TRUE,
        collapse = " + "
      )
      tidy(x = obj,
           conf.int = TRUE,
           exponentiate = exponentiate)
    },
    err_res = function(x) {
      failed_result <- tidy(x = object, conf.int = TRUE)[1,]
      failed_result[1,] <- NA
      failed_result$term <- x
      failed_result
    }
  )
  results <- bind_rows(results)
  
  # drop covariates
  results$term <- gsub("`", "", results$term)
  results <- results[results$term %in% variables, ]

  # add entries for variables dropped by tidy due to NA estimate
  mask <- ! variables %in% results$term
  if (any(mask)) {
    failed_results <- tibble(
      term = variables[mask],
      estimate = rep(NA, sum(mask)),
      std.error = rep(NA, sum(mask)),
      statistic = rep(NA, sum(mask)),
      p.value = rep(NA, sum(mask))
    )
    results <- bind_rows(results, failed_results)
  }

  return(results)
}

#' Helper transforming reference frequencies
#'
#' @param ref Long format data frame with three columns "var", "population",
#'   "frequency".
#' @param pop Character giving names of populations to include
#' @param carrier_frequency Logical indicating if carrier frequency should be
#'   returned instead of frequency. Carrier frequency is calculated based on
#'   Hardy-Weinberg equilibrium model.
#'
#' @return Wide format data frame with population frequencies as columns.
#'
#' @importFrom assertthat assert_that
#' @importFrom dplyr filter select
#' @importFrom rlang .data !!
#' @importFrom stats reshape
#'
getReferenceFrequencies <- function(ref, pop, carrier_frequency = FALSE) {
  assert_that(
    is.data.frame(ref),
    colnamesMatches(ref, c("var", "population", "frequency")),
    is.character(pop),
    characterMatches(pop, unique(ref$population)),
    isTRUEorFALSE(carrier_frequency)
  )

  ref <- dplyr::filter(ref, .data$population %in% pop)
  ref <- reshape(
    data = ref,
    idvar = "var",
    timevar = "population",
    direction = "wide"
  )
  colnames(ref)[-1] <-
    gsub("frequency\\.", "", colnames(ref)[-1])
  cols <- c("var", pop)
  ref <- select(ref, !!cols) # rename populations if needed

  if (carrier_frequency) {
    ref[, -1] <- lapply(ref[, -1, drop = FALSE], function (x) 2 * x * (1 - x) + x^2) # HWE 2qp + q^2
  }

  return(ref)
}

#' Adjust P-values for Multiple Comparisons
#'
#' Given a set of p-values, returns p-values adjusted using one of several
#' methods.
#'
#' This function modifies \code{stats::p.adjust} method such that for Bonferroni
#' correction it is possible to specify \code{n} lower than \code{length(p)}.
#' This feature is useful in cases when knowledge about the biology or
#' redundance of alleles reduces the need for correction.
#'
#' See \code{\link[stats]{p.adjust}} for more details.
#'
#' @inheritParams stats::p.adjust
#' @param n number of comparisons, must be at least \code{length(p)}; only set
#'   this (to non-default) when you know what you are doing! Note that for
#'   Bonferroni correction it is possible to specify number lower than
#'   \code{length(p)}.
#'
#' @return A numeric vector of corrected p-values (of the same length as p, with
#'   names copied from p).
#'
#' @importFrom assertthat assert_that is.number is.string
#' @importFrom stats p.adjust
#'
adjustPValues <- function(p, method, n = length(p)) {
  assert_that(
    assertthat::see_if(
      is.numeric(p),
      msg = sprintf("%s that is bad", as.character(p))
    ),
    is.numeric(p),
    is.string(method),
    is.number(n)
  )

  if (method == "bonferroni") {
    assert_that(
      n >= 1,
      msg = "n must be >= 1"
    )
    p_adj <- p * n
    p_adj <- ifelse(p_adj > 1, 1, p_adj)
  } else {
    p_adj <- p.adjust(p, method, n)
  }

  return(p_adj)
}

#' Filter list by elements
#'
#' Filter two level list by its secondary elements and remove empty items
#'
#' @param list A list.
#' @param elements Character vector of elements to keep.
#'
#' @return List filtered according to \code{elements} argument.
#'
#' @importFrom stats setNames
#'
filterListByElements <- function(list, elements) {
  list_names <- names(list)
  list_vec <- setNames(
    object = unlist(x = list, recursive = TRUE),
    nm = rep(x = list_names, times = vapply(X = list, FUN = length, FUN.VALUE = integer(1L)))
  )
  list_vec <- list_vec[list_vec %in% elements]
  new_list <- lapply(
    X = list_names,
    FUN = function(x) {
      vec <- list_vec[names(list_vec) == x]
      names(vec) <- NULL
      vec
    }
  )
  names(new_list) <- list_names
  new_list <- new_list[vapply(X = new_list, FUN = function(x) length(x) != 0, FUN.VALUE = logical(1L))]
  
  return(new_list)
}

#' lapply with tryCatch routine
#'
#' Used to run function iteratively over list, while using tryCatch to
#' catch warnings and errors to finally present a summary of issues rather
#' than error on each and every one. Used in \code{iterativeLRT} and
#' \code{iterativeModel}.
#'
#' @inheritParams base::lapply
#' @param err_res Function creating a result that should be output in case of 
#'   error.
#'
#' @return List of elements as returned by \code{FUN}.
#'
#'
lapply_tryCatch <- function(X, FUN, err_res, ...) {
  conditional_msgs <- environment()
  conditional_msgs$error <- character()
  conditional_msgs$warning <- character()
  
  result <- lapply(
    X = X,
    FUN = function(x) suppressWarnings(tryCatch(
      expr = FUN(x, ...),
      error = function(e) {
        err <- get(x = "error", envir = conditional_msgs)
        err <- c(err, conditionMessage(e))
        names(err)[length(err)] <- x[1] # take first variable, len(x) >= 1 
        assign(x = "error", value = err, envir = conditional_msgs)
        
        return(err_res(x))
      },
      warning = function(w) { # if there is a warning followed by an error the function will actually crash dramatically
        wrr <- get(x = "warning", envir = conditional_msgs)
        wrr <- c(wrr, conditionMessage(w))
        names(wrr)[length(wrr)] <- x[1] # take first variable, len(x) >= 1 
        assign(x = "warning", value = wrr, envir = conditional_msgs)
        
        res <- suppressWarnings(try(expr = FUN(x, ...), silent = TRUE))
        if (assertthat::is.error(res)) {
          err <- get(x = "error", envir = conditional_msgs)
          err <- c(err, toString(res))
          names(err)[length(err)] <- x[1] # take first variable, len(x) >= 1 
          assign(x = "error", value = err, envir = conditional_msgs)

          res <- err_res(x)
        }
        
        res
      }  
    ))
  )
  
  # messages in this section has been created specifically for iterativeLRT and iterativeModel  
  # communicate errors and warnings <--------------------------------------------------------------
  had_error <- length(conditional_msgs$error)
  had_warning <- length(conditional_msgs$warning)
  if (had_error || had_warning) {
    msg <- "While evaluating the model problems occured:\n"
    if (had_error) {
      msg <- c(msg, "Errors:\n")
      err <- table(conditional_msgs$error)
      for (i in seq_along(err)) {
        n <- err[i]
        val <- names(err)[i]
        vars <- conditional_msgs$error[conditional_msgs$error == val]
        vars <-
          ifelse(
            test = length(vars) <= 5,
            yes = paste(names(vars), collapse = ", "),
            no = paste(c(names(vars)[seq_len(5)], "..."), collapse = ", ")
          )
        msg <- c(
          msg,
          sprintf("%s; occured %i times, including variables: %s", val, n, vars)
        )
      }
      msg <- c(msg, "") # spacer
    }
    
    if (had_warning) {
      msg <- c(msg, "Warnings:")
      wrr <- table(conditional_msgs$warning)
      for (i in seq_along(wrr)) {
        n <- wrr[i]
        val <- names(wrr)[i]
        vars <- conditional_msgs$warning[conditional_msgs$warning == val]
        vars <-
          ifelse(
            test = length(vars) <= 5,
            yes = paste(names(vars), collapse = ", "),
            no = paste(c(names(vars)[seq_len(5)], "..."), collapse = ", ")
          )
        msg <- c(
          msg,
          sprintf("%s; occured %i times, including variables: %s", val, n, vars)
        )
      }
    }
    
    warn(msg)
  }
  
  return(result)
}

context("UTILS")

test_that("checkAlleleFormat", {
  expect_equal(checkAlleleFormat(c("A*01", "A*01:24", "B*01:25:22",
                                   "C*050:24:55:54")
               ),
               c(TRUE, TRUE, TRUE, TRUE)
  )
  expect_equal(checkAlleleFormat(c("01", "01:24", "01:25:22",
                                   "050:24:55:54")
               ),
               c(FALSE, FALSE, FALSE, FALSE)
  )
  expect_equal(checkAlleleFormat(c("*01", "A*:22", "C*05:24:55:54:89")
               ),
               c(FALSE, FALSE, FALSE)
  )
  expect_equal(checkAlleleFormat(c("*01", "A*:22", NA)
               ),
               c(FALSE, FALSE, NA)
  )
})

test_that("getAlleleResolution", {
  expect_equal(getAlleleResolution(c("A*01", "A*01:24", "B*01:25:22",
                                     "C*05:24:55:54", NA)
               ),
               c(2, 4, 6, 8, NA)
  )
  expect_error(getAlleleResolution("word"),
               "allele have to be a valid HLA allele number"
  )
})

test_that("reduceAlleleResolution", {
  expect_equal(reduceAlleleResolution(c("A*01", "A*01:24", "B*01:25:22",
                                        "C*05:24:55:54", "C*05:24:55:54N"), 2
               ),
               c("A*01", "A*01", "B*01", "C*05", "C*05:24:55:54N")
  )
  expect_error(getAlleleResolution("word"),
               "allele have to be a valid HLA allele number"
  )
  expect_error(reduceAlleleResolution("C*05:24:55:54", resolution = "four"),
               "resolution is not a count \\(a single positive integer\\)"
  )
})

test_that("getVariableAAPos", {
  allele <- c("TAP1*01:01:01:01", "TAP1*02:01:02")
  aln <- readHlaAlignments(system.file("extdata",
                                       "TAP1_prot.txt",
                                       package = "midasHLA"))
  aln <- aln[allele, ]
  expect_equal(getVariableAAPos(aln), c(`333` = 333, `637` = 637))

  expect_error(getVariableAAPos(c()), "alignment is not a matrix")
})

test_that("convertAlleleToVariable", {
  path <- system.file("extdata", "Match_allele_HLA_supertype.txt", package = "midasHLA")
  addvar <- convertAlleleToVariable(c("A*01:01", "A*02:01", "B*01", NA), dictionary = path)
  expect_equal(addvar, c("A01", "A02", NA, NA))
  dictionary <- read.table(path, header = TRUE, stringsAsFactors = FALSE)
  addvar <- convertAlleleToVariable(c("A*01:01", "A*02:01", "B*01", NA), dictionary = dictionary)
  expect_equal(addvar, c("A01", "A02", NA, NA))

  expect_error(
    convertAlleleToVariable(c("a", "b", "c"), dictionary = path),
    "allele have to be a valid HLA allele number"
  )

  expect_error(
    convertAlleleToVariable(c("A*01", "A*02", "A*03"), dictionary = c("foo", "bar")),
    "dictionary have to be either a path or a data.frame"
  )

  expect_error(
    convertAlleleToVariable(
      allele = c("A*01", "A*02", "A*03"),
      dictionary = file.path("foo", "bar")
    ),
    sprintf("Path '%s' does not exist", file.path("foo", "bar"))
  )

  expect_error(
    convertAlleleToVariable(c("A*01", "A*02", "A*03"), dictionary = dictionary[, 1, drop=FALSE]),
    "dictionary must have two columns"
  )

  expect_error(
    convertAlleleToVariable(c("A*01", "A*02", "A*03"), dictionary = dictionary[, c(2, 2)]),
    "first column in dictionary must contain valid HLA allele numbers"
  )

  expect_error(
    convertAlleleToVariable(c("A*01", "A*02", "A*03"), dictionary = dictionary[c(1, 1),]),
    "dictionary contains duplicated allele numbers"
  )
})

test_that("backquote", {
  expect_equal(backquote(c("A:01:01", "A:02:01")), c("`A:01:01`", "`A:02:01`"))
  expect_error(backquote(1), "x is not a character vector")
})

test_that("updateModel", {
  midas_data <- midasToWide(MiDAS_tut_object, experiment = "hla_alleles")
  mod <- lm(disease ~ 1, data = midas_data)
  mod$call$data <- midas_data
  mod_test <- lm(disease ~ `A*01:01`, data = midas_data)
  mod_test$call$data <- midas_data
  expect_equal(updateModel(mod, "A*01:01"),
               mod_test
  )

  expect_error(updateModel(mod, 1),
               "x is not a character vector"
  )

  expect_error(updateModel(mod, x = "A*01:01", placeholder = 1),
               "placeholder is not a string \\(a length one character vector\\)."
  )

  expect_error(updateModel(mod, x = "A*01:01", backquote = 1),
               "backquote is not a flag \\(a length one logical vector\\)."
  )

  expect_error(updateModel(mod, x = "A*01:01", collapse = 1),
               "collapse is not a string \\(a length one character vector\\)."
  )

  expect_error(
    updateModel(
      mod,
      x = "A*01:01",
      placeholder = "foo"
    ),
    "placeholder 'foo' could not be found in object's formula"
  )
})

test_that("listMiDASDictionaries", {
  # NOTE ordering is somehow OS dependent
  expect_equal(
    sort(listMiDASDictionaries(pattern = ".*")),
    sort(c(
      "allele_HLA_Bw",
      "allele_HLA_Ggroup",
      "allele_HLA_supertype",
      "allele_HLA-Bw_only_B",
      "allele_HLA-C_C1-2",
      "counts_hla_kir_interactions",
      "counts_kir_haplotypes",
      "kir_haplotype_gene",
      "kir_nomenclature_gene"
    ))
  )
})

test_that("LRTest", {
  df <- data.frame(OS = c(20, 30, 40), AGE = c(50, 60, 70))
  mod0 <- lm(OS ~ 1, data = df)
  mod1 <- lm(OS ~ AGE, data = df)
  lrt_res <- LRTest(mod0, mod1)
  expect_equal(
    lrt_res,
    data.frame(
      term = "AGE",
      df = 1,
      logLik = 109.840111592134,
      statistic = 219.680223184268,
      p.value = 1.06202635429558e-49,
      stringsAsFactors = FALSE
    )
  )

  expect_error(LRTest(mod1, mod0), "variables AGE were not found in mod1")
})

test_that("getObjectDetails", {
  midas <- prepareMiDAS(
    kir_calls = MiDAS_tut_KIR,
    colData = MiDAS_tut_pheno,
    experiment = c("kir_genes"))
  obj <- lm(disease ~ term, data = midas)
  obj_det <- getObjectDetails(obj)
  expect_equal(
    obj_det,
    list(
      call = quote(lm(formula = disease ~ term, data = midas)),
      formula_vars = c("disease", "term"),
      data = midas
    )
  )
})

test_that("runMiDASGetVarsFreq", {
  midas <- prepareMiDAS(
    kir_calls = MiDAS_tut_KIR,
    colData = MiDAS_tut_pheno,
    experiment = c("kir_genes"))
  freq <- runMiDASGetVarsFreq(midas, "kir_genes", "disease")[1, ]
  freq_test <- data.frame(
    term = "KIR3DL3",
    Ntotal = 935,
    Ntotal.percent = formattable::percent(1),
    `N(disease=0)` = 467,
    `N(disease=0).percent` = formattable::percent(1),
    `N(disease=1)` = 468,
    `N(disease=1).percent` = formattable::percent(1),
    stringsAsFactors = FALSE,
    check.names = FALSE
  )
  expect_equal(freq, freq_test)
})

test_that("distGrantham", {
  aa1 <- c("A", "S", "W")
  aa2 <- c("A", "S", "V")
  d <- distGrantham(aa1, aa2)
  d_test <- sum(dict_dist_grantham[paste0(aa1, aa2)]) / length(aa1)
  expect_equal(d, d_test)

  expect_error(distGrantham(1, aa2), "aa1 is not a character vector")

  expect_error(distGrantham(aa1, 1), "aa2 is not a character vector")

  expect_error(distGrantham(aa1, aa2[-3]),
               "aa1 and aa2 must have equal lengths.")

  expect_error(distGrantham(aa1, c("F", "O", "O")),
               "SO, WO are not valid amino acids pairs")
})

test_that("hlaCallsGranthamDistance", {
  gdist <- hlaCallsGranthamDistance(MiDAS_tut_HLA[1:5, ], genes = c("A", "B", "C"))
  gdist_test <- structure(list(
    ID = c("C001", "C002", "C003", "C004", "C005"),
    A = c(3.8121546961326, 0.87292817679558, 3.55801104972376, 10.6077348066298, 9.17127071823204),
    B = c(8.8121546961326, 6.64640883977901, 11.4088397790055, 9.41436464088398, 7.68508287292818),
    C = c(4.74585635359116, 2.90055248618785, 6.23204419889503, 7.05524861878453, 4.46961325966851)
    ),
    class = "data.frame",
    row.names = c(NA,-5L)
  )
  expect_equal(gdist, gdist_test)

  gdist <-
    hlaCallsGranthamDistance(MiDAS_tut_HLA[1:5,],
                             genes = c("A", "B", "C"),
                             aa_selection = "B_pocket")
  gdist_test <- structure(list(
    ID = c("C001", "C002", "C003", "C004", "C005"),
    A = c(0, 2, 0, 26.5454545454545, 7.72727272727273),
    B = c(30.7272727272727, 16.1818181818182, 48, 52.9090909090909, 27.3636363636364),
    C = c(36.6363636363636, 23.5454545454545, 37.1818181818182, 32.0909090909091, 32.0909090909091)
    ),
    class = "data.frame",
    row.names = c(NA,-5L)
  )
  expect_equal(gdist, gdist_test)

  # checkHlaCallsFormat test is ommitted here

  expect_error(hlaCallsGranthamDistance(MiDAS_tut_HLA, genes = 1),
               "genes is not a character vector")

  expect_error(hlaCallsGranthamDistance(MiDAS_tut_HLA, genes = c("A", NA)),
               "genes contains 1 missing values")

  expect_error(hlaCallsGranthamDistance(MiDAS_tut_HLA, genes = "A", aa_selection = "Z"),
               "aa_selection should be one of \"binding_groove\", \"B_pocket\", \"F_pocket\".")
})

test_that("hlaAlignmentGrantham", {
  aln <- hlaAlignmentGrantham("TAP1", 2:182)
  aln_test <- readHlaAlignments(gene = "TAP1")
  aln_test <- aln_test[, 2:182]
  mask <- apply(aln_test, 1, function(x) any(x == "" | x == "X" | x == "."))
  aln_test <- aln_test[! mask, ]
  expect_equal(aln, aln_test)
})

test_that("getHlaCallsGenes", {
  genes <- getHlaCallsGenes(MiDAS_tut_HLA)
  expect_equal(genes, c("A", "B", "C", "DPA1", "DPB1", "DQA1", "DQB1", "DRA", "DRB1"))
})

test_that("dfToExperimentMat", {
  mat <- dfToExperimentMat(MiDAS_tut_HLA)
  ids <- MiDAS_tut_HLA[["ID"]]
  test_mat <- MiDAS_tut_HLA[, -1]
  test_mat <- t(test_mat)
  colnames(test_mat) <- ids
  expect_equal(mat, test_mat)
})

test_that("experimentMatToDf", {
  ids <- MiDAS_tut_HLA[["ID"]]
  mat <- MiDAS_tut_HLA[, -1]
  mat <- t(mat)
  colnames(mat) <- ids
  expect_equal(experimentMatToDf(mat), MiDAS_tut_HLA)
})

test_that("midasToWide", {
  midas <- prepareMiDAS(
    hla_calls = MiDAS_tut_HLA[MiDAS_tut_HLA$ID %in% c("P001", "P002"), 1:2],
    colData = MiDAS_tut_pheno[MiDAS_tut_pheno$ID %in% c("P001", "P002"), ],
    experiment = "hla_alleles"
  )

  wide <- midasToWide(midas, "hla_alleles")
  test_wide <- data.frame(
    ID = c("P001", "P002"),
    `A*02:01` = 0:1,
    `A*11:88` = 1:0,
    disease = c(1L, 1L),
    lab_value = c(-0.85, -1.6),
    outcome = c(1L, 1L),
    term = colData(midas)$term,
    stringsAsFactors = FALSE,
    check.names = FALSE
  )
  test_wide <- test_wide[, colnames(wide)] # somehow order of columns is R version dependent...
  expect_equal(wide, test_wide)

  expect_error(midasToWide(midas, 1), "experiment is not a character vector")

  expect_error(
    midasToWide(midas, "foo"),
    "experiment should match values \"hla_alleles\"."
  )
})

test_that("checkKirGenesFormat", {
  genes <- c("KIR3DL3", "KIR2DS4")
  expect_equal(checkKirGenesFormat(genes), c(TRUE, TRUE))
  expect_equal(checkKirGenesFormat(LETTERS), rep(FALSE, length(LETTERS)))
})

test_that("iterativeLRT", {
  MiDASdat <-
    filterByOmnibusGroups(MiDAS_tut_object, "hla_aa", c("A_29", "A_44", "A_65"))
  omnibus_groups <- getOmnibusGroups(MiDASdat, "hla_aa")
  placeholder <- getPlaceholder(MiDASdat)
  MiDASdat <- as.data.frame(MiDASdat)
  object <- lm(disease ~ outcome + term, data = MiDASdat)

  res <- iterativeLRT(object, placeholder, omnibus_groups)
  
  fun <- function (x) {
    mod0 <- updateModel(
      object = object,
      x = "1",
      placeholder = placeholder,
      backquote = FALSE
    )
    LRTest(
      mod0,
      updateModel(
        object = object,
        x = x,
        placeholder = placeholder,
        collapse = " + ",
        backquote = TRUE
      )
    )
  }
  test_res <- lapply(
    X = omnibus_groups,
    FUN = function(x) suppressWarnings(tryCatch(
      expr = fun(x),
      error = function(e) {
        
        data.frame(
          term = toString(x),
          df = NA,
          logLik = NA,
          statistic = NA,
          p.value = NA,
          stringsAsFactors = FALSE
        )
      }  
    ))
  )
  test_res <- dplyr::bind_rows(test_res, .id = "group")
  expect_equal(res, test_res)

  MiDASdat$A_29_D <- NA
  MiDASdat$A_29_A <- NA
  res <- iterativeLRT(object, placeholder, omnibus_groups)
  test_res <- lapply(
    X = omnibus_groups[c("A_44", "A_65")], 
    FUN = function (gr) {
      mod0 <- updateModel(
        object = object,
        x = "1",
        placeholder = placeholder,
        backquote = FALSE
      )
      test <- LRTest(
        mod0,
        updateModel(
          object = object,
          x = gr,
          placeholder = placeholder,
          collapse = " + ",
          backquote = TRUE
        )
      )
    })
  test_res[["A_29"]] <- data.frame(
    term = "A_29_D, A_29_A",
    df = NA,
    logLik = NA,
    statistic = NA,
    p.value = NA
  )
  test_res <- test_res[c("A_29", "A_44", "A_65")]
  test_res <- dplyr::bind_rows(test_res, .id = "group")
  expect_equal(res, test_res)
})

test_that("iterativeModel", {
  MiDASdat <-
    filterByVariables(MiDAS_tut_object,
                      "hla_alleles",
                      c("A*01:01", "A*01:02", "A*01:234"))
  placeholder <- getPlaceholder(MiDASdat)
  variables <- c("A*01:01", "A*01:02", "A*01:234")
  MiDASdat <- midasToWide(MiDASdat, "hla_alleles")
  object <- lm(disease ~ outcome + term, data = MiDASdat)

  res <- iterativeModel(object, placeholder, variables)
  res_test <- lapply(
    X = variables,
    FUN = function(x) {
        obj <- updateModel(
          object = object,
          x = x,
          placeholder = placeholder,
          backquote = TRUE,
          collapse = " + "
        )
        r <- tidy(x = obj, conf.int = TRUE)
        r$term <- gsub("`", "", r$term)
        r <- r[r$term %in% variables, ]
    }
  )
  res_test <- dplyr::bind_rows(res_test)

  expect_equal(as.data.frame(res), as.data.frame(res_test))
})

test_that("getReferenceFrequencies", {
  freq <-
    getReferenceFrequencies(ref = allele_frequencies, pop = "USA NMDP Chinese")[1:3,]
  attr(freq, "reshapeWide") <- NULL
  freq_test <- data.frame(
    var = c("A*01:01", "A*01:03", "A*02:01"),
    `USA NMDP Chinese` = c(0.0145, 7e-05, 0.0946),
    stringsAsFactors = FALSE,
    check.names = FALSE
  )
  expect_equal(freq, freq_test)

  freq <-
    getReferenceFrequencies(ref = allele_frequencies,
                            pop = "USA NMDP Chinese",
                            carrier_frequency = TRUE)[1:3,]
  attr(freq, "reshapeWide") <- NULL
  freq_test <- data.frame(
    var = c("A*01:01", "A*01:03", "A*02:01"),
    `USA NMDP Chinese` = c(0.02878975, 0.0001399951, 0.18025084),
    stringsAsFactors = FALSE,
    check.names = FALSE
  )
  expect_equal(freq, freq_test)
})

test_that("adjustPValues", {
  p_val <- c(0.1, 0.001, 0.01)
  p_adj <- adjustPValues(p = p_val, method = "bonferroni", n = 3)
  expect_equal(p_adj, p_val * 3)

  p_adj <- adjustPValues(p = p_val, method = "bonferroni", n = 1)
  expect_equal(p_adj, p_val)

  expect_error(adjustPValues(p = p_val, method = "bonferroni", n = 0),
               "n must be >= 1")
})

test_that("filterListByElements", {
  A <- list(
    A = c("A", "B"),
    B = c("B", "C")
  )
  
  a <- filterListByElements(list = A, elements = c("B"))
  test_a <- list(
    A = c("B"),
    B = c("B")
  )
  expect_equal(a, test_a)
  
  a <- filterListByElements(list = A, elements = c("C"))
  test_a <- list(B = c("C"))
  expect_equal(a, test_a)
  
  a <- filterListByElements(list = A, elements = c())
  expect_equal(a, structure(list(), .Names = character(0)))
})

#' Generate amino acid variation matrix
#'
#' \code{hlaToAAVariation} convert HLA calls data frame to a matrix of variable
#'  amino acid positions.
#'
#' Variable amino acid positions are found by comparing elements of the
#' alignment column wise. Some of the values in alignment can be treated
#' specially using \code{indels} and \code{unkchar} arguments. Function
#' processes alignments for all HLA genes found in \code{hla_calls}.
#'
#' Variable amino acid position uses protein alignments from
#' \href{ftp://ftp.ebi.ac.uk/pub/databases/ipd/imgt/hla/alignments/}{EBI database}.
#'
#' @inheritParams checkHlaCallsFormat
#' @param indels Logical indicating whether indels should be considered when
#'   checking variability.
#' @param unkchar Logical indicating whether unknown characters in the alignment
#'   should be considered when checking variability.
#' @param as_df Logical indicating if data frame should be returned.
#'   Otherwise a matrix is returned.
#'
#' @return Matrix or data frame containing variable amino acid positions.
#'   Rownames corresponds to ID column in \code{hla_calls}, and colnames to
#'   alignment positions. If no variation is found one column matrix filled with
#'   \code{NA}'s is returned.
#'
#' @examples
#' hlaToAAVariation(MiDAS_tut_HLA)
#'
#' @importFrom assertthat assert_that see_if
#' @importFrom stringi stri_split_fixed
#' @export
hlaToAAVariation <- function(hla_calls,
                             indels = TRUE,
                             unkchar = FALSE,
                             as_df = TRUE){
  assert_that(
    checkHlaCallsFormat(hla_calls),
    isTRUEorFALSE(indels),
    isTRUEorFALSE(unkchar),
    isTRUEorFALSE(as_df)
  )
  ids <- hla_calls[, 1]
  hla_calls <- hla_calls[, -1]

  # get names of genes
  gene_names <- vapply(X = colnames(hla_calls),
                       FUN = function(x) stri_split_fixed(x, "_")[[1]][1], # colnames are of form A_1, A_2, B_1, ...
                       FUN.VALUE = character(length = 1)
  )
  gene_names_uniq <- unique(gene_names)

  # assert that alignment files are available
  available_genes <- list.files(
    path = system.file("extdata", package = "midasHLA"),
    pattern = "_prot.Rdata$"
  )
  available_genes <- vapply(
    X = stri_split_fixed(available_genes, "_prot.Rdata"),
    `[[`, 1,
    FUN.VALUE = character(length = 1)
  )
  av_genes_idx <- gene_names_uniq %in% available_genes
  assert_that(
    any(av_genes_idx),
    msg = sprintf("Alignments for genes %s are not available.",
                  paste(gene_names_uniq[! av_genes_idx], collapse = ", ")
    )
  )
  if (! all(av_genes_idx)) {
    warn(sprintf(
      "Alignments for genes %s are not available and will be omitted.",
      paste(gene_names_uniq[! av_genes_idx], collapse = ", ")
    ))
    gene_names_uniq <- gene_names_uniq[av_genes_idx]
  }

  # read alignment matrices
  hla_aln <- lapply(
    X = gene_names_uniq,
    FUN = function(x) {
      readHlaAlignments(gene = x,
                        unkchar = "*")
    }
  )

  # helper function
  truncVector <- function(vec, len, append) {
    if (length(vec) > len) {
      vec <- vec[1:len]
      vec <- c(vec, append)
    }
    
    return(vec)
  }
  
  # get aa variations for each gene
  aa_variation <- list()
  for (i in seq_along(gene_names_uniq)) {
    x_calls <- hla_calls[, gene_names == gene_names_uniq[i], drop = FALSE]

    # mark alleles w/o reference as NAs
    x_calls_unlist <- unlist(x_calls)
    ref_allele <- rownames(hla_aln[[i]])
    mask_alleles_wo_ref <- ! x_calls_unlist %in% ref_allele
    if (any(mask_alleles_wo_ref[! is.na(x_calls_unlist)], na.rm = TRUE)) {
      warn(sprintf(
        "Alignments for alleles %s are not available and will be omitted.",
        paste(truncVector(x_calls_unlist[mask_alleles_wo_ref], 10, "..."), collapse = ", ")
      ))
      x_calls_unlist[mask_alleles_wo_ref] <- NA
    }

    # check if there is possibility for variability
    x_calls_uniq <- na.omit(unique(x_calls_unlist))
    if (length(x_calls_uniq) <= 1) next()

    # get variable aa positions
    hla_aln[[i]] <- hla_aln[[i]][x_calls_uniq, ]
    var_pos <- getVariableAAPos(hla_aln[[i]],
                                varchar = sprintf("[A-Z%s%s]",
                                                  ifelse(indels, "\\.", ""),
                                                  ifelse(unkchar, "\\*", "")
                                )
    )
    var_aln <- lapply(colnames(x_calls), function(allele) {
      mask <- seq_len(nrow(hla_aln[[i]])) # NAs in character index gives oob error, so it is needed to refer to indexes
      names(mask) <- rownames(hla_aln[[i]])
      x <- hla_aln[[i]][mask[x_calls[, allele]], var_pos, drop = FALSE]
      colnames(x) <- paste0(allele, "_", "AA_", colnames(x))
      return(x)
    })
    var_aln <- do.call(cbind, var_aln)
    ord <- as.vector(vapply(seq_along(var_pos),
                  function(j) {
                    c(j, j + length(var_pos))
                  },
                  FUN.VALUE = numeric(length = 2)
    ))
    var_aln <- var_aln[, ord, drop = FALSE]

    aa_variation[[length(aa_variation) + 1]] <- var_aln
  }

  if (length(aa_variation) > 1) {
    aa_variation <- do.call(cbind, aa_variation)
    rownames(aa_variation) <- ids
  } else if (length(aa_variation) == 1) {
    aa_variation <- aa_variation[[1]]
    rownames(aa_variation) <- ids
  } else {
    aa_variation <- matrix(nrow = length(ids))
    rownames(aa_variation) <- ids
  }

  if (as_df) {
    aa_variation <- as.data.frame(aa_variation,
                                  optional = TRUE,
                                  stringsAsFactors = FALSE)
    aa_variation <- cbind(ID = ids, aa_variation, stringsAsFactors = FALSE)
    rownames(aa_variation) <- NULL
  }

  return(aa_variation)
}

#' Convert HLA calls to variables
#'
#' \code{hlaToVariable} converts HLA calls data frame to additional variables.
#'
#' \code{dictionary} file should be a tsv format with header and two columns.
#' First column should hold allele numbers and second corresponding additional
#' variables. Optionally a data frame formatted in the same manner can be passed
#' instead.
#'
#' \code{dictionary} can be also used to access dictionaries shipped with the
#' package. They can be referred to by using one of the following strings:
#' \describe{
#'   \item{\code{"allele_HLA_Bw"}}{
#'     Translates HLA-B alleles together with A*23, A*24 and A*32 into Bw4 and
#'     Bw6 allele groups. In some cases HLA alleles containing Bw4 epitope, on
#'     nucleotide level actually carries a premature stop codon. Meaning that
#'     although on nucleotide level the allele would encode a Bw4 epitope it's
#'     not really there and it is assigned to Bw6 group. However in 4-digit
#'     resolution these alleles can not be distinguished from other Bw4 groups.
#'     Since alleles with premature stop codons are rare, Bw4 group is assigned.
#'   }
#'   \item{\code{"allele_HLA-B_only_Bw"}}{
#'     Translates HLA-B alleles (without A*23, A*24 and A*32) into Bw4 and Bw6
#'     allele groups.
#'   }
#'   \item{\code{"allele_HLA-C_C1-2"}}{
#'     Translates HLA-C alleles into C1 and C2 allele groups.
#'   }
#'   \item{\code{"allele_HLA_supertype"}}{
#'    Translates HLA-A and HLA-B alleles into supertypes, a classification that
#'    group HLA alleles based on peptide binding specificities.
#'   }
#'   \item{\code{"allele_HLA_Ggroup"}}{
#'     Translates HLA alleles into G groups, which defines amino acid identity
#'     only in the exons relevant for peptide binding. Note that alleles
#'     DRB1*01:01:01 and DRB1*01:16 match more than one G group, here this
#'     ambiguity was removed by deleting matching with DRB5*01:01:01G group.
#'   }
#' }
#'
#' \code{reduce} control if conversion should happen in a greedy way, such that
#' if some HLA number cannot be converted, it's resolution is reduced by 2 and
#' another attempt is taken. This process stops when alleles cannot be further
#' reduced or all have been successfully converted.
#'
#' @inheritParams checkHlaCallsFormat
#' @inheritParams convertAlleleToVariable
#' @param reduce Logical indicating if function should try to reduce allele
#'   resolution when no matching entry  in the dictionary is found. See details.
#' @param na.value Vector of length one speciyfing value for alleles with
#'   no matching entry in \code{dictionary}. Default is to use \code{0}.
#' @param nacols.rm Logical indicating if result columns that contain only
#'   \code{NA} should be removed.
#'
#' @return Data frame with variable number of columns. First column named 
#'   \code{"ID"} corresponds to \code{"ID"} column in \code{hla_calls}, further
#'   columns holds converted HLA variables.
#'
#' @examples
#' hlaToVariable(MiDAS_tut_HLA, dictionary = "allele_HLA_supertype")
#'
#' @importFrom assertthat assert_that is.string see_if
#' @importFrom rlang warn
#' @export
hlaToVariable <- function(hla_calls,
                          dictionary,
                          reduce = TRUE,
                          na.value = 0,
                          nacols.rm = TRUE) {
  assert_that(
    checkHlaCallsFormat(hla_calls),
    isTRUEorFALSE(reduce),
    see_if(length(na.value) == 1, msg = "na.value length must equal 1."),
    isTRUEorFALSE(nacols.rm)
  )

  if (is.string(dictionary)) {
    lib <- listMiDASDictionaries()
    if (dictionary %in% lib) {
      if (dictionary %in% c("allele_HLA-B_Bw", "allele_HLA-Bw_only_B")) {
        warn("In ambiguous cases Bw4 will be assigned! See 'hlaToVariable' documentation for more details.")
      }
      dictionary <- system.file(
        "extdata",
        paste0("Match_", dictionary, ".txt"),
        package = "midasHLA"
      )
    }
  }

  variable <- as.data.frame(
    lapply(hla_calls[, -1], convertAlleleToVariable, dictionary = dictionary),
    stringsAsFactors = FALSE,
    row.names = NULL
  )

  if (reduce) {
    max_resolution <- getAlleleResolution(unlist(hla_calls[, -1]))
    max_resolution <- max(max_resolution, na.rm = TRUE)
    while (any(is.na(variable)) & max_resolution > 2) {
      max_resolution <- max_resolution - 2
      hla_calls <- reduceHlaCalls(hla_calls, resolution = max_resolution)
      variable[is.na(variable)] <- convertAlleleToVariable(
        allele = hla_calls[, -1][is.na(variable)],
        dictionary = dictionary
      )
    }
  }

  # add dictionary prefix to column names
  if (is.string(dictionary)) {
    dict_prefix <- gsub(".txt$", "", gsub("^.*_", "", dictionary))
  } else {
    dict_prefix <- colnames(dictionary)[2] # colnames are allele, name_of_variable
  }
  colnames(variable) <- paste0(dict_prefix, "_", colnames(variable))

  # get all na columns
  j <- vapply(variable, function(x) ! all(is.na(x)), logical(length = 1))

  if (nacols.rm) {
    variable <- variable[, j, drop = FALSE]
  }

  variable <- cbind(hla_calls[, 1, drop = FALSE], variable, stringsAsFactors = FALSE)
  colnames(variable) <- c("ID", colnames(variable)[-1])

  if (ncol(variable) <= 1) {
    warn("HLA alleles could not be converted to any new variables.")
  }

  return(variable)
}

#' Reduce HLA calls resolution
#'
#' \code{reduceHlaCalls} reduces HLA calls data frame to specified resolution.
#'
#' Alleles with resolution greater than \code{resolution} or optional suffixes
#' are returned unchanged.
#'
#' @inheritParams checkHlaCallsFormat
#' @inheritParams reduceAlleleResolution
#'
#' @return HLA calls data frame reduced to specified resolution.
#'
#' @examples
#' reduceHlaCalls(MiDAS_tut_HLA, resolution = 2)
#'
#' @export
reduceHlaCalls <- function(hla_calls, resolution = 4) {
  assert_that(checkHlaCallsFormat(hla_calls))
  hla_calls[, -1] <- as.data.frame(
    lapply(hla_calls[, -1], reduceAlleleResolution, resolution = resolution),
    stringsAsFactors = FALSE
  )

  return(hla_calls)
}

#' Transform HLA calls to counts table
#'
#' \code{hlaCallsToCounts} converts HLA calls data frame into a counts table.
#'
#' @inheritParams checkHlaCallsFormat
#' @param check_hla_format Logical indicating if \code{hla_calls} format should
#'   be checked. This is useful if one wants to use \code{hlaCallsToCounts} with
#'   input not adhering to HLA nomenclature standards. See examples.
#'
#' @return HLA allele counts data frame. First column holds samples ID's, further 
#'   columns, corresponding to specific alleles, give information on the number 
#'   of their occurrences in each sample.
#'
#' @importFrom assertthat assert_that is.string
#' @importFrom qdapTools mtabulate
#'
hlaCallsToCounts <- function(hla_calls,
                             check_hla_format = TRUE) {
  assert_that(
    isTRUEorFALSE(check_hla_format),
    if (check_hla_format) {
      checkHlaCallsFormat(hla_calls)
    } else {
      TRUE
    }
  )

  hla_counts <- hla_calls[, -1, drop = FALSE]
  hla_counts <- mtabulate(as.data.frame(t(hla_counts)))
  rownames(hla_counts) <- NULL

  hla_counts <- cbind(ID = hla_calls[, 1, drop = FALSE],
                      hla_counts,
                      stringsAsFactors = FALSE
  )

  return(hla_counts)
}

#' Calculate HLA allele frequencies
#'
#' \code{getHlaFrequencies} calculates allele frequencies in HLA calls data
#' frame.
#'
#' Both gene copies are taken into consideration for frequencies calculation,
#' \code{frequency = n / (2 * j)} where \code{n} is the number of allele
#' occurrences and \code{j} is the number of samples in \code{hla_calls}.
#'
#' @inheritParams checkHlaCallsFormat
#' @inheritParams getExperimentFrequencies
#' @param compare Logical flag indicating if \code{hla_calls} frequencies
#'   should be compared to reference frequencies given in \code{ref}.
#' @param ref_pop Character vector giving names of reference populations in
#'   \code{ref} to compare with. Optionally vector can be named, then those
#'   names will be used as population names.
#' @param ref Data frame giving reference allele frequencies. See
#'   \code{\link{allele_frequencies}} for an example.
#'
#' @return Data frame with each row holding HLA allele, it's count and 
#'   frequency.
#'
#' @examples
#' getHlaFrequencies(MiDAS_tut_HLA)
#'
#' @importFrom assertthat assert_that
#' @importFrom dplyr left_join rename
#' @export
getHlaFrequencies <- function(hla_calls,
                              carrier_frequency = FALSE,
                              compare = FALSE,
                              ref_pop = c(
                                "USA NMDP African American pop 2",
                                "USA NMDP Chinese",
                                "USA NMDP European Caucasian",
                                "USA NMDP Hispanic South or Central American",
                                "USA NMDP Japanese",
                                "USA NMDP North American Amerindian",
                                "USA NMDP South Asian Indian"
                              ),
                              ref = allele_frequencies) {
  assert_that(
    checkHlaCallsFormat(hla_calls),
    isTRUEorFALSE(compare),
    is.data.frame(ref),
    colnamesMatches(ref, c("var", "population", "frequency")),
    is.character(ref_pop),
    characterMatches(ref_pop, unique(ref$population))
  )

  if (compare) {
    ref <- getReferenceFrequencies(ref, ref_pop, carrier_frequency)
  } else {
    ref <- NULL
  }
  
  hla_counts <- hlaCallsToCounts(hla_calls, check_hla_format = FALSE)
  counts_mat <- dfToExperimentMat(hla_counts)
  allele_freq <-
    getExperimentFrequencies(
      experiment = counts_mat,
      pop_mul = 2,
      carrier_frequency = carrier_frequency, 
      ref = ref
    )
  allele_freq <- rename(allele_freq, "allele" = "term")

  return(allele_freq)
}

#' Calculate KIR genes frequencies
#'
#' \code{getKIRFrequencies} calculates KIR genes frequencies in KIR calls data
#' frame.
#'
#' @inheritParams checkKirCallsFormat
#'
#' @return Data frame with each row holding KIR gene, it's count and 
#'   frequency.
#'
#' @examples
#' getKIRFrequencies(MiDAS_tut_KIR)
#'
#' @importFrom assertthat assert_that
#' @importFrom dplyr left_join
#' @export
getKIRFrequencies <- function(kir_calls) {
  assert_that(
    checkKirCallsFormat(kir_calls)
  )
  
  counts_mat <- dfToExperimentMat(kir_calls)
  kir_freq <-
    getExperimentFrequencies(
      experiment = counts_mat,
      pop_mul = 1,
      carrier_frequency = FALSE, 
      ref = NULL
    )
  kir_freq <- rename(kir_freq, "gene" = "term")
  rownames(kir_freq) <- NULL

  return(kir_freq)
}

#' Transform amino acid variation data frame into counts table
#'
#' \code{aaVariationToCounts} convert amino acid variation data frame into
#' counts table.
#'
#' @param aa_variation Amino acid variation data frame as returned by
#'   \link{hlaToAAVariation}.
#'
#' @return Amino acid counts data frame. First column holds samples ID's, 
#'   further columns, corresponding to specific amino acid positions, give 
#'   information on the number of their occurrences in each sample.
#'
#' @importFrom assertthat assert_that is.string
#' @importFrom qdapTools mtabulate
#' @importFrom stats na.omit
#'
aaVariationToCounts <- function(aa_variation) {
  assert_that(
    is.data.frame(aa_variation),
    see_if(colnames(aa_variation)[1] == "ID",
           msg = "first column of aa_variation must be named ID"
    )
  )

  ids <- aa_variation[, 1]
  aa_counts <- aa_variation[, -1]
  aa_ids <- colnames(aa_variation[, -1])
  aa_ids <- gsub("_[12]_AA", "", aa_ids)
  aa_counts <- lapply(seq_len(ncol(aa_counts)),
                         function(i) {
                           x <- paste(aa_ids[i], aa_counts[, i], sep = "_")
                           x[is.na(aa_counts[, i])] <- NA
                           return(x)
                         }
  )
  ord <- na.omit(unique(unlist(aa_counts)))
  aa_counts <- do.call(rbind, aa_counts)
  aa_counts <- mtabulate(as.data.frame(aa_counts, stringsAsFactors = FALSE))
  rownames(aa_counts) <- NULL
  aa_counts <- aa_counts[, ord]
  aa_counts <- cbind(ID = aa_variation[, 1, drop = FALSE],
                     aa_counts,
                     stringsAsFactors = FALSE
  )

  return(aa_counts)
}

#' Calculate amino acid frequencies
#'
#' \code{getAAFrequencies} calculates amino acid frequencies in amino acid
#' data frame.
#'
#' Both gene copies are taken into consideration for frequencies calculation,
#' \code{frequency = n / (2 * j)} where \code{n} is the number of amino acid
#' occurrences and \code{j} is the number of samples in \code{aa_variation}.
#'
#' @inheritParams aaVariationToCounts
#'
#' @return Data frame with each row holding specific amino acid position, it's 
#'   count and frequency.
#'
#' @examples
#' aa_variation <- hlaToAAVariation(MiDAS_tut_HLA)
#' getAAFrequencies(aa_variation)
#'
#' @importFrom assertthat assert_that
#' @export
getAAFrequencies <- function(aa_variation) {
  assert_that(
    is.data.frame(aa_variation),
    see_if(colnames(aa_variation)[1] == "ID",
           msg = "first column of aa_variation must be named ID"
    )
  )
  
  var_counts <- aaVariationToCounts(aa_variation)
  counts_mat <- dfToExperimentMat(var_counts)
  aa_freq <-
    getExperimentFrequencies(
      experiment = counts_mat,
      pop_mul = 2,
      carrier_frequency = FALSE, 
      ref = NULL
    )
  aa_freq <- rename(aa_freq, "aa_pos" = "term")

  return(aa_freq)
}

#' Pretty format statistical analysis results helper
#'
#' \code{formatResults} format statistical analysis results table to html or
#' latex format.
#'
#' @param results Tibble as returned by \code{\link{runMiDAS}}.
#' @param filter_by Character vector specifying conditional expression used to
#'   filter \code{results}, this is equivalent to \code{...} argument passed to
#'   \code{\link[dplyr]{filter}}.
#' @param arrange_by Character vector specifying variable names to use for
#'   sorting. Equivalent to \code{...} argument passed to
#'   \code{\link[dplyr]{arrange}}.
#' @param select_cols Character vector specifying variable names that should be
#'   included in the output table. Can be also used to rename selected
#'   variables, see examples.
#' @param format String \code{"latex"} or \code{"html"}.
#' @param header String specifying header for result table. If \code{NULL} no header is added.
#' @param scroll_box_height A character string indicating the height of the table.
#'
#' @return Character vector of formatted table source code.
#'
#' @examples
#' \dontrun{
#' midas <- prepareMiDAS(hla_calls = MiDAS_tut_HLA,
#'                       colData = MiDAS_tut_pheno,
#'                       experiment = "hla_alleles")
#' object <- lm(disease ~ term, data = midas)
#' res <- runMiDAS(object, 
#'                 experiment = "hla_alleles", 
#'                 inheritance_model = "dominant")
#' formatResults(res,
#'               filter_by = c("p.value <= 0.05", "estimate > 0"),
#'               arrange_by = c("p.value * estimate"),
#'               select_cols = c("allele", "p-value" = "p.value"),
#'               format = "html",
#'               header = "HLA allelic associations")
#' }
#'
#' @importFrom assertthat assert_that
#' @importFrom dplyr arrange filter select
#' @importFrom knitr kable
#' @importFrom kableExtra add_header_above kable_styling scroll_box
#' @importFrom magrittr %>% %<>%
#' @importFrom stats setNames
#' @importFrom rlang parse_exprs .data
#'
formatResults <- function(results,
                          filter_by = "p.value <= 0.05",
                          arrange_by = "p.value",
                          select_cols = c("term", "estimate", "std.error", "p.value", "p.adjusted"),
                          format = c("html", "latex"),
                          header = NULL,
                          scroll_box_height = "400px"
                          ) {
  assert_that(
    is.character(filter_by),
    is.character(arrange_by),
    is.character(select_cols),
    is.string(format),
    stringMatches(format, choice = c("html", "latex")),
    isStringOrNULL(header),
    is.string(scroll_box_height)
  )

  filter_by <- parse_exprs(filter_by)
  arrange_by <- parse_exprs(arrange_by)

  results %<>%
    filter(!!! filter_by) %>%
    arrange(!!! arrange_by) %>%
    select(select_cols)

  if (format == "html" & isTRUE(getOption("knitr.in.progress"))) {
    results <-
      rapply(
        results,
        f = gsub,
        classes = "character",
        how = "replace",
        pattern = "(\\*)",
        replacement = "\\\\\\1"
      )
  }

  if (! (is.null(header) & format == "html")) {
    header <- setNames(ncol(results), header) # Still if format is 'latex' and header = NULL the result is not visualy appealing, and without it gives error. Issue created on github: https://github.com/haozhu233/kableExtra/issues/387
  }

  results %<>%
    kable(format = format, format.args = list(digits = 4, scientific = -3)) %>%
    add_header_above(header = header)

  if (format == "html") {
    results %<>%
      kable_styling(bootstrap_options = c("striped", "hover", "condensed")) %>%
      scroll_box(width = "100%", height = scroll_box_height)
  }

  return(results)
}

#' Create association analysis results table in HTML or LaTeX
#'
#' \code{kableResults} convert results table (\code{\link{runMiDAS}} output) to
#' HTML or LaTeX format.
#'
#' @inheritParams formatResults
#' @param colnames Character vector of form \code{c("new_name" = "old_name")},
#'   used to rename \code{results} colnames.
#' @param header String specifying results table header.
#' @param pvalue_cutoff Number specifying p-value cutoff for results to be
#'   included in output. If \code{NULL} no filtering is done.
#'
#' @return Association analysis results table in HTML or LaTeX.
#'
#' @examples
#' midas <- prepareMiDAS(hla_calls = MiDAS_tut_HLA,
#'                       colData = MiDAS_tut_pheno,
#'                       experiment = "hla_alleles")
#' object <- lm(disease ~ term, data = midas)
#' res <- runMiDAS(object, experiment = "hla_alleles", inheritance_model = "additive")
#' kableResults(results = res,
#'              colnames = c("HLA allele" = "allele"))
#'
#' @importFrom assertthat assert_that is.number is.string see_if
#' @importFrom dplyr ends_with mutate_at vars
#' @importFrom magrittr %>% %<>%
#' @importFrom rlang has_name list2 parse_expr warn !! :=
#' @export
kableResults <- function(results,
                         colnames = NULL,
                         header = "MiDAS analysis results",
                         pvalue_cutoff = NULL,
                         format = 'html', # getOption("knitr.table.format"), started to fail on github runner...
                         scroll_box_height = "400px") {
  assert_that(
    is.data.frame(results),
    isCharacterOrNULL(colnames),
    isNumberOrNULL(pvalue_cutoff),
    is.string(format),
    stringMatches(format, choice = c("html", "latex")),
    is.string(scroll_box_height)
  )
  if (! is.null(colnames)) {
    assert_that(
      characterMatches(colnames, choice = colnames(results))
    )
  }

  filter_by <- ifelse(
    test = is.null(pvalue_cutoff),
    yes = "p.value <= 1",
    no = sprintf("p.value < %f", pvalue_cutoff)
  )

  # create rename vector
  select_cols <- colnames(results)
  names(select_cols) <- select_cols
  i <- na.omit(match(x = select_cols, table = colnames))
  names(select_cols)[i] <- names(colnames)

  # replace .percent with %
  names(select_cols) <- gsub(".percent", " [%]", names(select_cols))

  results %<>%
    formatResults(
      filter_by = filter_by,
      arrange_by = "p.value",
      select_cols = select_cols,
      format = format,
      header = header,
      scroll_box_height = scroll_box_height
    )

  return(results)
}

#' Convert counts table to variables
#'
#' \code{countsToVariables} converts counts table to additional variables.
#'
#' \code{dictionary} file should be a tsv format with header and two columns.
#' First column should be named \code{"Name"} and hold variable name, second
#' should be named \code{"Expression"} and hold expression used to identify
#' variable (eg. \code{"KIR2DL3 & ! KIR2DL2"} will match all samples with
#' \code{KIR2DL3} and without \code{KIR2DL2}). Optionally a data frame formatted
#' in the same manner can be passed instead.
#'
#' Dictionaries shipped with the package:
#' \describe{
#'   \item{\code{kir_haplotypes}}{
#'     KIR genes to KIR haplotypes dictionary.
#'   }
#' }
#'
#' @inheritParams hlaToVariable
#' @param counts Data frame with counts, such as returned by
#'   \code{\link{hlaCallsToCounts}} function. First column should contain
#'   samples IDs, following columns should contain counts (natural numbers
#'   including zero).
#' @param dictionary Path to file containing variables dictionary or data
#'   frame. See details for further explanations.
#' @param na.value Vector of length one speciyfing value for variables with no
#'   matching entry in \code{dictionary}. Default is to use \code{0}.
#'
#' @return Data frame with variable number of columns. First column named 
#'   \code{"ID"} corresponds to \code{"ID"} column in \code{counts}, further
#'   columns hold indicators for converted variables. \code{1} and \code{0} 
#'   code presence and absence of a variable respectively.
#'
#' @examples
#' countsToVariables(MiDAS_tut_KIR, "kir_haplotypes")
#'
#' @importFrom assertthat assert_that is.string
#' @importFrom rlang parse_exprs
#' @export
countsToVariables <- function(counts,
                              dictionary,
                              na.value = NA,
                              nacols.rm = TRUE) {
  assert_that(
    checkColDataFormat(counts),
    see_if(length(na.value) == 1, msg = "na.value length must equal 1."),
    isTRUEorFALSE(nacols.rm)
  )

  if (is.string(dictionary)) {
    pattern <- paste0("counts_", dictionary)
    dict_path <- listMiDASDictionaries(pattern = pattern, file.names = TRUE)
    if(length(dict_path) == 0) {
      dict_path <- dictionary
    }
    assert_that(is.readable(dict_path))

    dictionary <- read.table(
      file = dict_path,
      header = TRUE,
      sep = "\t",
      quote = "",
      stringsAsFactors = FALSE
    )
  }

  assert_that(
    is.data.frame(dictionary),
    colnamesMatches(x = dictionary, cols = c("Name", "Expression"))
  )

  expressions <- dictionary[, "Expression", drop = TRUE]
  expressions <- parse_exprs(expressions)

  variables <- lapply(
    X = expressions,
    FUN = function(expr) {
      vars <- all.vars(expr)
      if (all(has_name(counts, vars))) {
        cl <- do.call(
          what = substitute,
          args = list(expr = expr, env = counts[, vars])
        )
        test <- eval(cl)
      } else {
        test <- rep(NA, nrow(counts))
      }

      test <- as.integer(test)
      return(test)
    }
  )

  res <- do.call(cbind, variables)
  colnames(res) <- dictionary[, "Name", drop = TRUE]

  # add ID column
  res <- cbind(counts[, 1, drop = FALSE], res)

  if (nacols.rm) {
    mask_na <- vapply(res, function(x) ! all(is.na(x)), logical(length = 1))
    res <- res[, mask_na, drop = FALSE]
  }

  return(res)
}

#' Get HLA - KIR interactions
#'
#' \code{getHlaKirInteractions} calculate presence-absence matrix of HLA - KIR
#' interactions.
#'
#' \code{hla_calls} are first reduced to all possible resolutions and converted
#' to additional variables, such as G groups, using dictionaries shipped with
#' the package.
#'
#' \code{interactions_dict} file should be a tsv format with header and two
#' columns. First column should be named \code{"Name"} and hold interactions
#' names, second should be named \code{"Expression"} and hold expression used to
#' identify interaction (eg. \code{"C2 & KIR2DL1"} will match all samples
#' with \code{C2} and \code{KIR2DL1}). The package is shipped with an interactions
#' file based on \href{https://www.ncbi.nlm.nih.gov/pmc/articles/PMC6558367/}{Pende et al., 2019.}
#'
#' @inheritParams checkHlaCallsFormat
#' @inheritParams checkKirCallsFormat
#' @param interactions_dict Path to HLA - KIR interactions dictionary.
#'
#' @return Data frame with variable number of columns. First column named 
#'   \code{"ID"} corresponds to \code{"ID"} column in \code{counts}, further
#'   columns hold indicators for HLA - KIR interactions. \code{1} and \code{0} 
#'   code presence and absence of a variable respectively.
#'   
#' @examples
#' getHlaKirInteractions(
#'   hla_calls = MiDAS_tut_HLA, 
#'   kir_calls = MiDAS_tut_KIR, 
#'   interactions_dict = system.file(
#'     "extdata", "Match_counts_hla_kir_interactions.txt", 
#'     package = "midasHLA")
#' )
#'
#' @importFrom assertthat assert_that is.string
#' @importFrom dplyr left_join
#' @importFrom magrittr %>%
#' @importFrom rlang warn
#' @importFrom stringi stri_detect_regex
#' @export
getHlaKirInteractions <- function(hla_calls,
                                  kir_calls,
                                  interactions_dict = system.file("extdata", "Match_counts_hla_kir_interactions.txt", package = "midasHLA")) {
  assert_that(
    checkHlaCallsFormat(hla_calls),
    checkKirCallsFormat(kir_calls),
    is.string(interactions_dict)
  )
  id_matches <- hla_calls[, 1, drop = TRUE] %in% kir_calls[, 1, drop = TRUE] %>%
    sum()
  assert_that(id_matches > 0,
              msg = "IDs in hla_calls doesn't match IDs in kir_calls"
  )
  if (nrow(hla_calls) != id_matches) {
    msg <- sprintf("%i IDs in hla_calls matched IDs in kir_calls", id_matches)
    warn(msg)
  }

  # transform hla_calls to all possible variables and resolutions
  ## in practice only subset of variables could be used but this should be more time proof
  midas_dicts <- listMiDASDictionaries(pattern = "allele_") %>%
    grep(pattern = "expression", value = TRUE, invert = TRUE)
  hla_variables <- Reduce(
    f = function(x, y) {
      left_join(x, hlaToVariable(hla_calls, dictionary = y), by = "ID")
    },
    x = midas_dicts,
    init = hla_calls
  )
  hla_max_resolution <- hla_calls[, -1] %>%
    unlist() %>%
    getAlleleResolution() %>%
    max(na.rm = TRUE)
  while (hla_max_resolution > 2) {
    hla_variables <- hla_calls %>%
      reduceHlaCalls(resolution = hla_max_resolution - 2) %>%
      left_join(x = hla_variables, by = "ID")
    hla_max_resolution <- hla_max_resolution - 2
  }

  hla_counts <- hlaCallsToCounts(hla_variables, check_hla_format = FALSE)
  hla_counts[, -1] <- ceiling(hla_counts[, -1] / 2) # reduce to presence / absence indicators

  counts <- left_join(hla_counts, kir_calls, by = "ID")
  interactions <- countsToVariables(counts, dictionary = interactions_dict)

  return(interactions)
}

#' Filter experiment by frequency
#'
#' Helper function for experiments filtering
#'
#' @inheritParams getExperimentFrequencies
#' @param lower_frequency_cutoff Positive number or \code{NULL}. Numbers greater
#'   than 1 are interpreted as number of feature occurrences, numbers between 0
#'   and 1 as fractions.
#' @param upper_frequency_cutoff Positive number or \code{NULL}. Numbers greater
#'   than 1 are interpreted as number of feature occurrences, numbers between 0
#'   and 1 as fractions.
#'
#' @return Filtered experiment matrix.
#'
#' @importFrom assertthat assert_that see_if is.number is.string
#' @importFrom magrittr %>%
#'
filterExperimentByFrequency <- function(experiment,
                                        carrier_frequency = FALSE,
                                        lower_frequency_cutoff = NULL,
                                        upper_frequency_cutoff = NULL) {
  UseMethod("filterExperimentByFrequency", experiment)
}

#' @rdname filterExperimentByFrequency
#' @method filterExperimentByFrequency matrix
#'  
filterExperimentByFrequency.matrix <-  function(experiment,
                                                carrier_frequency = FALSE,
                                                lower_frequency_cutoff = NULL,
                                                upper_frequency_cutoff = NULL) {
  inheritance_model_choice <- eval(formals()[["inheritance_model"]])
  assert_that(
    see_if(
     ! is.null(getExperimentPopulationMultiplicator(experiment)), # if pop_mul is not set frequency cannot be calculated
     msg = "Frequency filtration does not support provided experiment."
    ),
    isTRUEorFALSE(carrier_frequency),
    validateFrequencyCutoffs(lower_frequency_cutoff, upper_frequency_cutoff)
  )

  filtered_vars <- getExperimentFrequencies(
    experiment = experiment,
    carrier_frequency = carrier_frequency
  ) %>%
    getFrequencyMask(lower_frequency_cutoff = lower_frequency_cutoff,
                     upper_frequency_cutoff = upper_frequency_cutoff)
  mask <- rownames(experiment) %in% filtered_vars
  experiment <- experiment[mask, , drop = FALSE]

  return(experiment)
}

#' @rdname filterExperimentByFrequency
#' @method filterExperimentByFrequency SummarizedExperiment
#'  
filterExperimentByFrequency.SummarizedExperiment <-
  function(experiment,
           carrier_frequency = FALSE,
           lower_frequency_cutoff = NULL,
           upper_frequency_cutoff = NULL) {
  inheritance_model_choice <- eval(formals()[["inheritance_model"]])
  assert_that(
    see_if(
      ! is.null(getExperimentPopulationMultiplicator(experiment)), # if pop_mul is not set frequency cannot be calculated
      msg = "Frequency filtration does not support provided experiment."
    ),
    isTRUEorFALSE(carrier_frequency),
    validateFrequencyCutoffs(lower_frequency_cutoff, upper_frequency_cutoff)
  )
  
  filtered_vars <- getExperimentFrequencies(
    experiment = experiment,
    carrier_frequency = carrier_frequency
  ) %>%
    getFrequencyMask(lower_frequency_cutoff = lower_frequency_cutoff,
                     upper_frequency_cutoff = upper_frequency_cutoff)
  
  mask <- rownames(experiment) %in% filtered_vars
  new_experiment <- experiment[mask, , drop = FALSE]
  
  # omnibus groubs are static the proper filtering takes place in getOmnibusGroups
  # og <- S4Vectors::metadata(experiment)$omnibus_groups
  # if (! is.null(og)) {
  #   new_og <- filterListByElements(list = og, elements = filtered_vars)
  #   metadata(new_experiment)$omnibus_groups <- new_og
  # }
  
  return(new_experiment)
}

#' Calculate experiment's features frequencies
#'
#' \code{getExperimentFrequencies} calculate features frequencies.
#'
#' @param experiment Matrix or SummarizedExperiment object.
#' @param pop_mul Number by which number of samples should be multiplied to get
#'   the population size.
#' @param carrier_frequency Logical flag indicating if carrier frequency should
#'   be returned.
#' @param ref Wide format data frame with first column named "var" holding
#'   features matching \code{experiment} and specific populations frequencies in
#'   following columns. See \code{\link{getReferenceFrequencies}} for more
#'   details.
#'
#' @return Data frame with each row holding specific variable, it's count and 
#'   frequency.
#'
#' @importFrom assertthat assert_that is.string see_if
#' @importFrom SummarizedExperiment assay
#'
getExperimentFrequencies <-
  function(experiment,
           pop_mul = NULL,
           carrier_frequency = FALSE,
           ref = NULL) {
    UseMethod("getExperimentFrequencies", experiment)
  }

#' @rdname getExperimentFrequencies
#' @method getExperimentFrequencies matrix
#'
getExperimentFrequencies.matrix <-
  function(experiment,
           pop_mul = NULL,
           carrier_frequency = FALSE,
           ref = NULL) {
    assert_that(
      isCountsOrZeros(experiment),
      is.number(pop_mul),
      isTRUEorFALSE(carrier_frequency)
    )
    if (! is.null(ref)) {
      assert_that(is.data.frame(ref))
    }

    if (carrier_frequency) {
      experiment <- applyInheritanceModel(experiment, "dominant")
      pop_mul <- 1 # carrier frequency does not take account of gene copies
    }

    counts_sums <- rowSums(experiment, na.rm = TRUE)
    denom <- apply(experiment, 1, function(row) sum(!is.na(row)))
    allele_freq <- counts_sums / (pop_mul * denom) # remove NA's patients, vectorize the denominator to allow differing number of patients

    counts_df <- data.frame(
      term = rownames(experiment),
      Counts = counts_sums,
      Freq = allele_freq,
      row.names = NULL,
      stringsAsFactors = FALSE
    )

    if (! is.null(ref)) {
      counts_df <-
        left_join(counts_df, ref, by = c("term" = "var"))
    }

#     # format frequencies as percent
#     counts_df[, -c(1, 2)] <-
#       rapply(
#         object = counts_df[, -c(1, 2), drop = FALSE],
#         f = function(col) percent(col),
#         how = "replace"
#       )

    return(counts_df)
  }

#' @rdname getExperimentFrequencies
#' @method getExperimentFrequencies SummarizedExperiment
#'
getExperimentFrequencies.SummarizedExperiment <-
  function(experiment,
           pop_mul = NULL,
           carrier_frequency = FALSE,
           ref = NULL) {
    assert_that(
      isNumberOrNULL(pop_mul),
      isTRUEorFALSE(carrier_frequency)
    )
    if (! is.null(ref)) {
      assert_that(is.data.frame(ref))
    }

    counts <- assay(experiment)
    pop_mul <- getExperimentPopulationMultiplicator(experiment)
    getExperimentFrequencies(experiment = counts,
                             pop_mul = pop_mul,
                             carrier_frequency = carrier_frequency,
                             ref = ref
    )
  }

#' Apply inheritance model
#'
#' Helper function transforming experiment counts to selected
#' \code{inheritance_model}.
#'
#' Under \code{"dominant"} model homozygotes and heterozygotes are coded as
#' \code{1}. In \code{"recessive"} model homozygotes are coded as \code{1} and
#' other as \code{0}. In \code{"additive"} model homozygotes are coded as
#' \code{2} and heterozygotes as \code{1}. In \code{"overdominant"} homozygotes
#' (both \code{0} and \code{2}) are coded as \code{0} and heterozygotes as \code{1}.
#'
#' @param experiment Matrix or SummarizedExperiment object.
#' @param inheritance_model String specifying inheritance model to use.
#'  Available choices are \code{"dominant"}, \code{"recessive"},
#'  \code{"additive"}.
#'
#' @return \code{experiment} converted to specified inheritance model.
#'
applyInheritanceModel <-
  function(experiment,
           inheritance_model = c("dominant", "recessive", "additive", "overdominant")) {
    UseMethod("applyInheritanceModel", experiment)
  }

#' @rdname applyInheritanceModel
#' @method applyInheritanceModel matrix
#'
applyInheritanceModel.matrix <- function(experiment,
                                         inheritance_model =  c("dominant", "recessive", "additive", "overdominant")) {
  .classifyGte <- function(x, val) {
  # classifies vector as being greater than number
  # specificly for 1 we classify as dominat, and 2 as recessive
    x <- x >= val
    mode(x) <- "integer"
    x
  }
  .classifyEq <- function(x, val) {
  # classify vector as being equal to number
  # specificly for 1 we classify as overdominant
    x <- x == val
    mode(x) <- "integer"
    x
  }
  switch (
    inheritance_model,
    "additive" = experiment,
    "dominant" = .classifyGte(experiment, 1), # ifelse(x >= 1, 1, 0)
    "recessive" = .classifyGte(experiment, 2), # ifelse(x >= 2, 1, 0)
    "overdominant" = .classifyEq(experiment, 1) # ifelse(x == 1, 1, 0)
  )
}

#' @rdname applyInheritanceModel
#' @method applyInheritanceModel SummarizedExperiment
#'
applyInheritanceModel.SummarizedExperiment <- function(experiment,
                                                       inheritance_model =  c("dominant", "recessive", "additive", "overdominant")) {
  SummarizedExperiment::assay(experiment) <-
    applyInheritanceModel(SummarizedExperiment::assay(experiment), inheritance_model)

  return(experiment)
}

#' Helper function for filtering frequency data frame
#'
#' @inheritParams filterExperimentByFrequency
#' @param df Data frame as returned by \code{getExperimentFrequencies}.
#'
#' @return Character vector containing names of variables after filtration.
#'
#' @importFrom dplyr filter
#' @importFrom magrittr %>%
#'
getFrequencyMask <- function(df,
                             lower_frequency_cutoff = NULL,
                             upper_frequency_cutoff = NULL) {
  lower_frequency_cutoff <- ifelse(is.null(lower_frequency_cutoff), -Inf, lower_frequency_cutoff)
  upper_frequency_cutoff <- ifelse(is.null(upper_frequency_cutoff), Inf, upper_frequency_cutoff)
  freqs_are_float <- lower_frequency_cutoff <= 1 || upper_frequency_cutoff <= 1
  variables_freq <- df %>%
    filter(.data$Counts > lower_frequency_cutoff |
             freqs_are_float) %>%
    filter(.data$Freq > lower_frequency_cutoff |
             ! freqs_are_float) %>%
    filter(.data$Counts < upper_frequency_cutoff |
             freqs_are_float) %>%
    filter(.data$Freq < upper_frequency_cutoff |
             ! freqs_are_float)

   filtered_vars <- variables_freq$term

  return(filtered_vars)
}

#' Filter experiment by variable
#'
#' Helper function for experiments filtering
#'
#' @param experiment Matrix or SummarizedExperiment object.
#' @param variables Character vector specifying features to choose.
#'
#' @return Filtered \code{experiment} object.
#'
filterExperimentByVariables <-
  function(experiment, variables) {
    UseMethod("filterExperimentByVariables", experiment)
  }

#' @rdname filterExperimentByVariables
#' @method filterExperimentByVariables matrix
#'
filterExperimentByVariables.matrix <- function(experiment, variables) {
  return(experiment[variables, ])
}

#' @rdname filterExperimentByVariables
#' @method filterExperimentByVariables SummarizedExperiment
#'
filterExperimentByVariables.SummarizedExperiment <- function(experiment, variables) {
  og <- S4Vectors::metadata(experiment)$omnibus_groups
  experiment <- experiment[variables, ]
  
  # omnibus groubs are static the proper filtering takes place in getOmnibusGroups
  # if (! is.null(og)) {
  #   og <- filterListByElements(list = og, elements = variables)
  #   S4Vectors::metadata(experiment)$omnibus_groups <- og
  # }

  return(experiment)
}

#' Get experiment's population multiplicator
#'
#' \code{getExperimentPopulationMultiplicator} extracts population multiplicator
#' from experiment's metadata.
#'
#' @param experiment Matrix or SummarizedExperiment object.
#'
#' @return Experiment's population multiplicator number.
#'
#' @importFrom S4Vectors metadata
#'
getExperimentPopulationMultiplicator <-
  function(experiment) {
    UseMethod("getExperimentPopulationMultiplicator", experiment)
  }

#' @rdname getExperimentPopulationMultiplicator
#' @method getExperimentPopulationMultiplicator matrix
#'
getExperimentPopulationMultiplicator.matrix <- function(experiment) return(NULL)

#' @rdname getExperimentPopulationMultiplicator
#' @method getExperimentPopulationMultiplicator SummarizedExperiment
#'
getExperimentPopulationMultiplicator.SummarizedExperiment <-
  function(experiment) {
      pop_mul <- S4Vectors::metadata(experiment)[["pop_mul"]]
      return(pop_mul)
  }

#' Check if experiment is inheritance model applicable
#'
#' \code{isExperimentInheritanceModelApplicable} check experiment's metadata
#' for presence of \code{"inheritance_model_applicable"} flag, indicating if
#' inheritance model can be applied.
#'
#' @param experiment Matrix or SummarizedExperiment object.
#'
#' @return Logical flag.
#'
#' @importFrom S4Vectors metadata
#'
isExperimentInheritanceModelApplicable <-
  function(experiment) {
    UseMethod("isExperimentInheritanceModelApplicable", experiment)
  }

#' @rdname isExperimentInheritanceModelApplicable
#' @method isExperimentInheritanceModelApplicable matrix
#'
isExperimentInheritanceModelApplicable.matrix <- function(experiment) {
  return(FALSE)
}

#' @rdname isExperimentInheritanceModelApplicable
#' @method isExperimentInheritanceModelApplicable SummarizedExperiment
#'
isExperimentInheritanceModelApplicable.SummarizedExperiment <-
  function(experiment) {
    inheritance_model_applicable <-
      metadata(experiment)[["inheritance_model_applicable"]]
    return(inheritance_model_applicable)
  }

context("MiDAS class")

test_that("MiDAS object is valid", {
  pheno <- MiDAS_tut_pheno
  rownames(pheno) <- pheno$ID
  pheno$term <- runif(nrow(pheno))

  midas <-
    MultiAssayExperiment(
      experiments = ExperimentList(
        list(
          hla_calls = dfToExperimentMat(MiDAS_tut_HLA),
          kir_calls = dfToExperimentMat(MiDAS_tut_KIR)
        )
      ),
      colData = pheno,
      metadata = list(placeholder = "term")
    )
  class(midas) <- structure("MiDAS", package = "midasHLA")

  bad_placeholder <- midas
  S4Vectors::metadata(bad_placeholder)$placeholder <- 1
  expect_error(
    validObject(bad_placeholder),
    "placeholder is not a string \\(a length one character vector\\)."
  )

  bad_placeholder <- midas
  S4Vectors::metadata(bad_placeholder)$placeholder <- "A_1"
  expect_error(
    validObject(bad_placeholder),
    "Placeholder 'A_1' is used in one of object's experiments"
  )

  bad_placeholder <- midas
  S4Vectors::metadata(bad_placeholder)$placeholder <- "foo"
  expect_error(
    validObject(bad_placeholder),
    "Placeholder 'foo' can not be found in object's colData"
  )

  duplicated_features <- midas
  rownames(duplicated_features[["hla_calls"]])[1] <- "ID"
  expect_error(
    validObject(duplicated_features),
    "Object contain duplicated features: ID"
  )
})

test_that("getExperiments", {
  expect_equal(
    getExperiments(MiDAS_tut_object),
    c(
      "hla_alleles",
      "hla_aa",
      "hla_g_groups",
      "hla_supertypes",
      "hla_NK_ligands",
      "kir_genes",
      "kir_haplotypes",
      "hla_kir_interactions",
      "hla_divergence",
      "hla_het"
    )
  )
})

test_that("getHlaCalls", {
  expect_equal(getHlaCalls(MiDAS_tut_object), MiDAS_tut_HLA)
})

test_that("getKirCalls", {
  expect_equal(getKirCalls(MiDAS_tut_object), MiDAS_tut_KIR)
})

test_that("getPlaceholder", {
  expect_equal(getPlaceholder(MiDAS_tut_object), "term")
})

test_that("getOmnibusGroups", {
  midas <-
    filterByOmnibusGroups(MiDAS_tut_object, "hla_aa", c("A_-22", "A_-21", "A_-18"))
  
  expect_equal(getOmnibusGroups(midas, "hla_aa"),
               list(
                 `A_-22` = c("A_-22_V", "A_-22_*", "A_-22_I"),
                 `A_-21` = c("A_-21_M", "A_-21_V", "A_-21_*"),
                 `A_-18` = c("A_-18_R", "A_-18_*", "A_-18_P")
               ))

  expect_error(
    getOmnibusGroups(midas, 1),
    "experiment is not a string \\(a length one character vector\\)."
  )
})

test_that("getFrequencies", {
  alleles_subset <-
    c("A*01:01", "A*02:01", "A*02:06", "A*26:01", "B*07:02", "B*08:01", "B*13:02", "B*15:01", "B*27:05", "B*40:01", "B*57:01")
  midas_sub <- MiDAS_tut_object[alleles_subset, ]
  freq <- getFrequencies(midas_sub, "hla_alleles")
  test_freq <- data.frame(
    term = alleles_subset,
    Counts = c(236, 486, 22, 90, 152, 128, 74, 86, 59, 58, 81),
    Freq = c(0.118, 0.243, 0.011, 0.045, 0.076, 0.064, 0.037, 0.043, 0.0295, 0.029, 0.0405),
    stringsAsFactors = FALSE
  )

  expect_equal(freq, test_freq)

  expect_error(
    getFrequencies(MiDAS_tut_object, 1),
    "experiment is not a string \\(a length one character vector\\)."
  )

  expect_error(getFrequencies(MiDAS_tut_object, "foo"),
               "experiment should be one of \"hla_alleles\", \"hla_aa\", \"hla_g_groups\", \"hla_supertypes\", \"hla_NK_ligands\", \"kir_genes\", \"kir_haplotypes\", \"hla_kir_interactions\", \"hla_divergence\", \"hla_het\"."
  )

  expect_error(getFrequencies(MiDAS_tut_object, "hla_divergence"),
               "Frequencies can not be calculated for experiment 'hla_divergence'"
  )
})

test_that("MiDAS's as.data.frame method works properly", {
  midas <- prepareMiDAS(
    kir_calls = MiDAS_tut_KIR,
    colData = MiDAS_tut_pheno,
    experiment = "kir_genes"
  )

  midas_df <- as.data.frame(midas)
  test_midas_df <-
    midasToWide(midas,
                experiment = getExperiments(midas))

  expect_equal(midas_df, test_midas_df)
})

test_that("filterByFrequency", {
  # filtration works as expected
  experiment <- "hla_alleles"
  lower_frequency_cutoff <- 0.53
  upper_frequency_cutoff <- 0.56
  filtered_midas <-
    filterByFrequency(
      object = MiDAS_tut_object,
      experiment = experiment,
      lower_frequency_cutoff = lower_frequency_cutoff,
      upper_frequency_cutoff = upper_frequency_cutoff
    )
  test_filtered_midas <- MiDAS_tut_object
  test_filtered_midas[[experiment]] <-
    filterExperimentByFrequency(
      experiment = test_filtered_midas[[experiment]],
      lower_frequency_cutoff = lower_frequency_cutoff,
      upper_frequency_cutoff = upper_frequency_cutoff
    )
  expect_equal(filtered_midas, test_filtered_midas)

  # unsported experiments raise error
  experiment <- "hla_divergence"
  lower_frequency_cutoff <- 0.53
  upper_frequency_cutoff <- 0.56
  expect_error(
    filterByFrequency(
      object = MiDAS_tut_object,
      experiment = experiment,
      lower_frequency_cutoff = lower_frequency_cutoff,
      upper_frequency_cutoff = upper_frequency_cutoff
    ),
    "Frequency filtration does not support experiment 'hla_divergence'"
  )
})

test_that("filterByOmnibusGroups", {
  # filtration works as expected
  experiment <- "hla_aa"
  mask <- c("A_83", "A_90")
  filtered_midas <-
    filterByOmnibusGroups(
      object = MiDAS_tut_object,
      experiment = experiment,
      groups = mask
    )
  test_filtered_midas <- MiDAS_tut_object
  vars <- c("A_83_R", "A_83_G", "A_90_D", "A_90_A")
  test_filtered_midas[[experiment]] <- test_filtered_midas[[experiment]][vars, ]

  expect_equal(filtered_midas, test_filtered_midas)

  # unsported experiments raise error
  experiment <- "hla_alleles"
  expect_error(
    filterByOmnibusGroups(
      object = MiDAS_tut_object,
      experiment = experiment,
      groups = mask
    ),
    "Omnibus groups filtration does not support experiment 'hla_alleles'"
  )
})

test_that("getAllelesForAA", {
  aa <- getAllelesForAA(MiDAS_tut_object, "DRA_2")
  aa_test <- data.frame(
    `HLA-DRA (2)` = c("*", "A"),
    `HLA-DRA alleles` = c("*01:02", "*01:01"),
    count = c(711L, 1289L),
    frequency = formattable::percent(c(0.3555, 0.6445)),
    stringsAsFactors = FALSE,
    check.names = FALSE
  )

  expect_error(getAllelesForAA(MiDAS_tut_object, 2),
               "aa_pos is not a string \\(a length one character vector\\).")

  expect_error(getAllelesForAA(MiDAS_tut_object, "A"),
               "amino acid position should be formatted like: A_9.")

  MultiAssayExperiment::metadata(MiDAS_tut_object)[["hla_calls"]] <- NULL
  expect_error(getAllelesForAA(MiDAS_tut_object, "A_9"),
               "Could not find HLA calls associated with MiDAS object. Make sure to use prepareMiDAS for MiDAS object creation.")
})

test_that("prepareMiDAS_hla_alleles", {
  args <- list(hla_calls = MiDAS_tut_HLA)
  experiment <- do.call(prepareMiDAS_hla_alleles, args)
  experiment_test <- do.call(hlaCallsToCounts, args)
  experiment_test <- dfToExperimentMat(experiment_test)
  experiment_test <- SummarizedExperiment::SummarizedExperiment(
    assays = list(experiment_test),
    metadata = list(
      inheritance_model_applicable = TRUE,
      pop_mul = 2,
      omnibus_groups = NULL
    )
  )
  expect_equal(experiment, experiment_test)
})

test_that("prepareMiDAS_hla_g_groups", {
  args <- list(hla_calls = MiDAS_tut_HLA)

  experiment <- do.call(prepareMiDAS_hla_g_groups, args)

  experiment_test <-
    hlaToVariable(
      hla_calls = args$hla_calls,
      dictionary = "allele_HLA_Ggroup",
      na.value = 0
    )
  experiment_test <-
    hlaCallsToCounts(experiment_test,
                     check_hla_format = FALSE)
  experiment_test <- dfToExperimentMat(experiment_test)
  experiment_test <- SummarizedExperiment::SummarizedExperiment(
    assays = list(experiment_test),
    metadata = list(
      inheritance_model_applicable = TRUE,
      pop_mul = 2,
      omnibus_groups = NULL
    )
  )

  expect_equal(experiment, experiment_test)

})

test_that("prepareMiDAS_hla_supertypes", {
  args <- list(hla_calls = MiDAS_tut_HLA)

  experiment <- do.call(prepareMiDAS_hla_supertypes, args)

  experiment_test <-
    hlaToVariable(
      hla_calls = args$hla_calls,
      dictionary = "allele_HLA_supertype",
      na.value = 0
    )
  experiment_test <-
    hlaCallsToCounts(experiment_test,
                     check_hla_format = FALSE)
  experiment_test <- dfToExperimentMat(experiment_test)
  experiment_test <-
    experiment_test[rownames(experiment_test) != "Unclassified",]
  experiment_test <- SummarizedExperiment::SummarizedExperiment(
    assays = list(experiment_test),
    metadata = list(
      inheritance_model_applicable = TRUE,
      pop_mul = 2,
      omnibus_groups = NULL
    )
  )

  expect_equal(experiment, experiment_test)

})

test_that("prepareMiDAS_hla_NK_ligands", {
  args <- list(hla_calls = MiDAS_tut_HLA)

  experiment <- do.call(prepareMiDAS_hla_NK_ligands, args)

  allele_HLA_Bw <- read.table(
    file = system.file("extdata", "Match_allele_HLA_Bw.txt", package = "midasHLA"),
    header = TRUE,
    sep = "\t",
    stringsAsFactors = FALSE
  )
  allele_HLA_Bw <- allele_HLA_Bw[allele_HLA_Bw$group != "Bw6", ]
  experiment_test <-
    Reduce(
      f = function(...)
        left_join(..., by = "ID"),
      x = lapply(
        list(
          allele_HLA_Bw,
          "allele_HLA-Bw_only_B",
          "allele_HLA-C_C1-2"
        ),
        hlaToVariable,
        hla_calls = args$hla_calls,
        na.value = 0
      )
    )
  experiment_test <-
    hlaCallsToCounts(experiment_test,
                     check_hla_format = FALSE)
  experiment_test <- dfToExperimentMat(experiment_test)
  experiment_test <- SummarizedExperiment::SummarizedExperiment(
    assays = list(experiment_test),
    metadata = list(
      inheritance_model_applicable = TRUE,
      pop_mul = 2,
      omnibus_groups = NULL
    )
  )

  expect_equal(experiment, experiment_test)
})

test_that("prepareMiDAS_kir_genes", {
  args <- list(kir_calls = MiDAS_tut_KIR)
  experiment <- do.call(prepareMiDAS_kir_genes, args)

  experiment_test <- dfToExperimentMat(args$kir_calls)
  experiment_test <- SummarizedExperiment::SummarizedExperiment(
    assays = list(experiment_test),
    metadata = list(
      inheritance_model_applicable = FALSE,
      pop_mul = 1,
      omnibus_groups = NULL
    )
  )

  expect_equal(experiment, experiment_test)
})

test_that("prepareMiDAS_kir_haplotypes", {
  args <- list(kir_calls = MiDAS_tut_KIR)
  experiment <- do.call(prepareMiDAS_kir_haplotypes, args)

  experiment_test <- countsToVariables(args$kir_calls, "kir_haplotypes")
  experiment_test <- dfToExperimentMat(experiment_test)
  experiment_test <- SummarizedExperiment::SummarizedExperiment(
    assays = list(experiment_test),
    metadata = list(
      inheritance_model_applicable = FALSE,
      pop_mul = 1,
      omnibus_groups = NULL
    )
  )

  expect_equal(experiment, experiment_test)
})

test_that("prepareMiDAS_hla_kir_interactions", {
  args <- list(hla_calls = MiDAS_tut_HLA, kir_calls = MiDAS_tut_KIR)
  experiment <- do.call(prepareMiDAS_kir_genes, args)

  experiment_test <- getHlaKirInteractions(
    hla_calls = args$hla_calls,
    kir_calls = args$kir_calls
  )
  experiment_test <- dfToExperimentMat(args$kir_calls)
  experiment_test <- SummarizedExperiment::SummarizedExperiment(
    assays = list(experiment_test),
    metadata = list(
      inheritance_model_applicable = FALSE,
      pop_mul = 1,
      omnibus_groups = NULL
    )
  )

  expect_equal(experiment, experiment_test)
})

test_that("prepareMiDAS_hla_divergence", {
  hla_calls <- reduceHlaCalls(MiDAS_tut_HLA, 4)
  experiment <- do.call(prepareMiDAS_hla_divergence, list(hla_calls))

  experiment_test <- hlaCallsGranthamDistance(hla_calls = hla_calls,
                                              genes = c("A", "B", "C"))
  experiment_test$ABC_avg <- rowMeans(experiment_test[-1])
  experiment_test <- dfToExperimentMat(experiment_test)

  expect_equal(experiment, experiment_test)


  hla_calls <- hla_calls[, c(1, 8:9)]
  expect_error(
    prepareMiDAS_hla_divergence(hla_calls),
    "Grantham distance can be calculated only for class I HLA alleles \\(A, B, C\\)."
  )
})

test_that("prepareMiDAS_hla_het", {
  hla_calls <- data.frame(
    ID = c("SAM1", "SAM2", "SAM3", "SAM4"),
    A_1 = c("A*01:01:01", "A*01:01:02", "A*01:01:03", "A*01:01:04"),
    A_2 = c("A*01:01:01", "A*01:01:03", "A*01:01:02", "A*01:01:04"),
    stringsAsFactors = FALSE
  )

  experiment <- do.call(prepareMiDAS_hla_het, list(hla_calls))
  experiment_test <- SummarizedExperiment::SummarizedExperiment(
    assay = matrix(c(0L, 1L, 1L, 0L),
                   ncol = 4,
                   dimnames = list("A_het", c("SAM1", "SAM2", "SAM3", "SAM4"))
    ),
    metadata = list(
      inheritance_model_applicable = FALSE,
      pop_mul = 1,
      omnibus_groups = NULL
    )
  ) 
  
  expect_equal(experiment, experiment_test)

  experiment <- do.call(prepareMiDAS_hla_het, list(hla_calls, hla_het_resolution = 4))
  experiment_test <- SummarizedExperiment::SummarizedExperiment(
    assay = matrix(c(0L, 0L, 0L, 0L), 
                   ncol = 4, 
                   dimnames = list("A_het", c("SAM1", "SAM2", "SAM3", "SAM4"))
    ),
    metadata = list(
      inheritance_model_applicable = FALSE,
      pop_mul = 1,
      omnibus_groups = NULL
    )
  )

  expect_equal(experiment, experiment_test)

  expect_error(
    prepareMiDAS_hla_het(hla_calls, hla_het_resolution = "a"),
    "hla_het_resolution is not a count \\(a single positive integer\\)"
  )

  hla_calls <- data.frame(
    ID = c("SAM1", "SAM2", "SAM3", "SAM4"),
    F_1 = c("A*01:01:01", "A*01:01:02", "A*01:01:03", "A*01:01:04"),
    F_2 = c("A*01:01:01", "A*01:01:03", "A*01:01:02", "A*01:01:04"),
    stringsAsFactors = FALSE
  )
  expect_error(
    prepareMiDAS_hla_het(hla_calls),
    "Heterozygosity status can be calculated only for classical genes \\(A, B, C, DQA1, DQB1, DRA, DRB1, DPA1, DPB1\\)."
  )
})

test_that("prepareMiDAS_hla_custom", {
  hla_dictionary <- read.table(
    file = system.file("extdata", "Match_allele_HLA_Ggroup.txt", package = "midasHLA"),
    header = TRUE,
    sep = "\t",
    quote = "",
    stringsAsFactors = FALSE
  )
  midas <- prepareMiDAS(
    hla_calls = MiDAS_tut_HLA,
    colData = MiDAS_tut_pheno,
    experiment = c("hla_g_groups", "hla_custom"),
    hla_dictionary = hla_dictionary
  )
  expect_equal(midas[["hla_g_groups"]], midas[["hla_custom"]])
})

test_that("prepareMiDAS_kir_custom", {
  kir_dictionary <- read.table(
    file = system.file("extdata", "Match_counts_kir_haplotypes.txt", package = "midasHLA"),
    header = TRUE,
    sep = "\t",
    quote = "",
    stringsAsFactors = FALSE
  )
  midas <- prepareMiDAS(
    kir_calls = MiDAS_tut_KIR,
    colData = MiDAS_tut_pheno,
    experiment = c("kir_haplotypes", "kir_custom"),
    kir_dictionary = kir_dictionary
  )
  expect_equal(midas[["kir_haplotypes"]], midas[["kir_custom"]])
})

context("Transforming MiDAS objects")

test_that("hlaToAAVariation", {
  aa_variation <-
    hlaToAAVariation(MiDAS_tut_HLA,
                     indels = TRUE,
                     unkchar = TRUE,
                     as_df = FALSE)
  load(system.file("extdata", "test_aa_variation.Rdata", package = "midasHLA"))
  expect_equal(aa_variation, test_aa_variation)

  expect_error(hlaToAAVariation(MiDAS_tut_HLA, indels = "foo"),
               "indels is not a flag \\(a length one logical vector\\)."
  )

  expect_error(hlaToAAVariation(MiDAS_tut_HLA, unkchar = "foo"),
               "unkchar is not a flag \\(a length one logical vector\\)."
  )

  expect_error(hlaToAAVariation(MiDAS_tut_HLA, as_df = 1),
               "as_df is not a flag \\(a length one logical vector\\)."
  )
})

test_that("hlaToVariable", {
  hla_supertypes <- hlaToVariable(MiDAS_tut_HLA, dictionary = "allele_HLA_supertype")
  test_hla_supertypes <-
    lapply(
      MiDAS_tut_HLA[,-1],
      convertAlleleToVariable,
      dictionary = system.file("extdata", "Match_allele_HLA_supertype.txt", package = "midasHLA")
    )
  na_mask <- vapply(test_hla_supertypes, function(x) all(is.na(x)), FUN.VALUE = logical(1))
  test_hla_supertypes <- test_hla_supertypes[! na_mask]
  test_hla_supertypes <- do.call(cbind, test_hla_supertypes)
  colnames(test_hla_supertypes) <-
    paste0("supertype_", colnames(test_hla_supertypes))
  test_hla_supertypes <-
    cbind(MiDAS_tut_HLA[, 1, drop = FALSE], test_hla_supertypes, stringsAsFactors = FALSE)
  expect_equal(hla_supertypes, test_hla_supertypes)

  expect_error(
    hlaToVariable(c("A*01:01", "A*02:01"), dictionary = "4digit_supertype"),
    "hla_calls is not a data frame"
  )

  expect_error(
    hlaToVariable(
      hla_calls = MiDAS_tut_HLA,
      dictionary = "4digit_supertype",
      reduce = "yes"
    ),
    "reduce is not a flag \\(a length one logical vector\\)."
  )

  expect_error(
    hlaToVariable(
      hla_calls = MiDAS_tut_HLA,
      dictionary = "4digit_supertype",
      na.value = 1:5
    ),
    "na.value length must equal 1."
  )

  expect_error(
    hlaToVariable(
      hla_calls = MiDAS_tut_HLA,
      dictionary = "4digit_supertype",
      nacols.rm = "yes"
    ),
    "nacols.rm is not a flag \\(a length one logical vector\\)."
  )
})

test_that("hlaCallsToCounts", {
  hla_calls <- data.frame(
    ID = c("PAT1", "PAT2", "PAT3", "PAT4"),
    A_1 = c("A*01", "A*02", NA, "A*01"),
    A_2 = c("A*02", "A*01", "A*02", "A*01"),
    stringsAsFactors = FALSE
  )
  hla_counts <- hlaCallsToCounts(hla_calls)
  test_hla_counts <- data.frame(
    ID = c("PAT1", "PAT2", "PAT3", "PAT4"),
    "A*01" = c(1, 1, 0, 2),
    "A*02" = c(1, 1, 1, 0),
    check.names = FALSE,
    stringsAsFactors = FALSE
  )
  expect_equal(hla_counts, test_hla_counts)

  # check if non HLA data frame can be properly processed
  nonhla <-
    data.frame(
      ID = 1:2,
      A_1 = c("a1", "a2"),
      A_2 = c("a2", "a2"),
      stringsAsFactors = FALSE
    )
  nonhla_counts <-  hlaCallsToCounts(nonhla, check_hla_format = FALSE)
  expect_equal(nonhla_counts,
               data.frame(
                 ID = 1:2,
                 a1 = c(1, 0),
                 a2 = c(1, 2),
                 stringsAsFactors = FALSE
               ))

  expect_error(
    hlaCallsToCounts(c("A*01:01", "A*02:01")),
    "hla_calls is not a data frame"
  )

  expect_error(
    hlaCallsToCounts(
      hla_calls,
      check_hla_format = 1
    ),
    "check_hla_format is not a flag \\(a length one logical vector\\)."
  )
})

test_that("getHlaFrequencies", {
  minimal_hla_calls <- data.frame(
    ID = c("P1", "P2"),
    A_1 = c("A*01:01", "A*02:01"),
    A_2 = c("A*02:01", "A*01:01"),
    stringsAsFactors = FALSE
  )
  hla_freq <- getHlaFrequencies(minimal_hla_calls)
  test_hla_freq <- data.frame(
    allele = c("A*01:01", "A*02:01"),
    Counts = c(2, 2),
    Freq = c(0.5, 0.5), 
    row.names = NULL,
    stringsAsFactors = FALSE
  )
  expect_equal(hla_freq, test_hla_freq)
})

test_that("getKIRFrequencies", {
  kir_freq <- getKIRFrequencies(MiDAS_tut_KIR)
  test_kir_freq <- data.frame(
    gene = c("KIR3DL3", "KIR2DS2", "KIR2DL2", "KIR2DL3", "KIR2DP1", "KIR2DL1", "KIR3DP1", "KIR2DL4", 
             "KIR3DL1", "KIR3DS1", "KIR2DL5", "KIR2DS3", "KIR2DS5", "KIR2DS4", "KIR2DS1", "KIR3DL2"),
    Counts = c(935, 455, 449, 849, 925, 918, 935, 935, 853, 365, 485, 294, 288, 853, 371, 935),
    Freq = c(1, 0.486631016042781, 0.480213903743316, 0.908021390374332, 0.989304812834225, 0.981818181818182,
             1, 1, 0.912299465240642, 0.390374331550802, 0.518716577540107, 0.314438502673797, 
             0.308021390374332, 0.912299465240642, 0.396791443850267, 1),
    row.names = NULL,
    stringsAsFactors = FALSE
  )
  expect_equal(kir_freq, test_kir_freq)
})

test_that("hlaToAAVariation", {
  minimal_hla_calls <- data.frame(
    ID = c("P1", "P2"),
    A_1 = c("A*01:01", "A*02:01"),
    A_2 = c("A*02:01", "A*01:01"),
    stringsAsFactors = FALSE
  )
  aa_var <- hlaToAAVariation(minimal_hla_calls)[, 1:5]

  aa_counts <- aaVariationToCounts(aa_var)
  test_aa_counts <- data.frame(
    ID = c("P1", "P2"),
    A_44_K = c(1, 1),
    A_44_R = c(1, 1),
    A_62_Q = c(1, 1),
    A_62_G = c(1, 1),
    stringsAsFactors = FALSE, check.names = FALSE
  )
  expect_equal(aa_counts, test_aa_counts)

  expect_error(
    aaVariationToCounts(c("x", "c")),
    "aa_variation is not a data frame"
  )

  expect_error(
    aaVariationToCounts(aa_var[, -1]),
    "first column of aa_variation must be named ID"
  )
})

test_that("getAAFrequencies", {
  minimal_hla_calls <- data.frame(
    ID = c("P1", "P2"),
    A_1 = c("A*01:01", "A*02:01"),
    A_2 = c("A*02:01", "A*01:01"),
    stringsAsFactors = FALSE
  )
  aa_var <- hlaToAAVariation(minimal_hla_calls)[, 1:5]
  aa_freq <- getAAFrequencies(aa_var)
  test_aa_freq <- data.frame(
    aa_pos = c("A_44_K", "A_44_R", "A_62_Q", "A_62_G"),
    Counts = c(2, 2, 2, 2),
    Freq = c(0.5, 0.5, 0.5, 0.5),
    row.names = NULL,
    stringsAsFactors = FALSE
  )
  expect_equal(aa_freq, test_aa_freq)

  expect_error(
    aaVariationToCounts(c("x", "c")),
    "aa_variation is not a data frame"
  )

  expect_error(
    aaVariationToCounts(aa_var[, -1]),
    "first column of aa_variation must be named ID"
  )
})

test_that("formatResults", {
  res <- tibble(term = c("A*01:01", "A*02:01"),
                estimate = c(5, -6),
                p.value = c(0.05, 0.1))
  restab <- formatResults(res,
                          filter_by = c("p.value <= 0.05", "estimate > 0"),
                          arrange_by = c("p.value * estimate"),
                          select_cols = c("allele" = "term", "p.value"),
                          format = "html",
                          header = "informative header")
  correct_tab <-
    dplyr::filter(res, .data[["p.value"]] <= 0.05, .data[["estimate"]] > 0)
  correct_tab <-
    dplyr::arrange(correct_tab, .data[["p.value"]] * .data[["estimate"]])
  correct_tab <-
    dplyr::select(correct_tab, "allele" = .data[["term"]], .data[["p.value"]])
  correct_tab <-
    knitr::kable(correct_tab, format = "html", format.args = list(digits = 4, scientific = -3))
  correct_tab <-
    kableExtra::add_header_above(correct_tab, header = c("informative header" = 2))
  correct_tab <-
    kableExtra::kable_styling(correct_tab,
                              bootstrap_options = c("striped", "hover", "condensed"))
  correct_tab <-
    kableExtra::scroll_box(correct_tab, width = "100%", height = "400px")

  expect_equal(restab, correct_tab)

  expect_error(formatResults(res, filter_by = 1),
               "filter_by is not a character vector")

  expect_error(formatResults(res, arrange_by = 1),
               "arrange_by is not a character vector")

  expect_error(formatResults(res, select_cols = 1),
               "select_cols is not a character vector")

  expect_error(formatResults(res, format = 1),
               "format is not a string \\(a length one character vector\\).")

  expect_error(formatResults(res, format = "markdown"),
               "format should be one of \"html\", \"latex\".")

  expect_error(formatResults(res, format ="html", header = 1),
               "header is not a string \\(a length one character vector\\) or NULL.")

  expect_error(formatResults(res, format ="html", scroll_box_height = 1),
               "scroll_box_height is not a string \\(a length one character vector\\).")
})

test_that("kableResults", {
  midas <- prepareMiDAS(hla_calls = MiDAS_tut_HLA,
                        colData = MiDAS_tut_pheno,
                        experiment = "hla_alleles")
  object <- lm(disease ~ term, data = midas)
  res <- runMiDAS(object, inheritance_model = "additive", experiment = "hla_alleles")
  res_kable <- kableResults(res)
  res_kable_test <- formatResults(res,
                                  filter_by = "p.value <= 1",
                                  arrange_by = "p.value",
                                  select_cols = c("allele",
                                                  "p.value",
                                                  "p.adjusted",
                                                  "estimate",
                                                  "std.error",
                                                  "conf.low",
                                                  "conf.high",
                                                  "statistic",
                                                  "Ntotal",
                                                  "Ntotal [%]" = "Ntotal.percent",
                                                  "N(disease=0)",
                                                  "N(disease=0) [%]" = "N(disease=0).percent",
                                                  "N(disease=1)",
                                                  "N(disease=1) [%]" = "N(disease=1).percent"
                                  ),
                                  format = "html",
                                  header = "MiDAS analysis results"
  )

  expect_equal(res_kable, res_kable_test)

  expect_error(kableResults(LETTERS), "results is not a data frame")

  expect_error(kableResults(res, 1:5), "colnames is not a character vector or NULL.")

  expect_error(kableResults(res, pvalue_cutoff = "a"),
               "pvalue_cutoff is not a number \\(a length one numeric vector\\) or NULL."
  )

  expect_error(kableResults(res, format = 1),
               "format is not a string \\(a length one character vector\\)."
  )

  expect_error(kableResults(res, format = "foo"),
               "format should be one of \"html\", \"latex\"."
  )

  expect_error(
    kableResults(res, c("foo", "bar")),
    "colnames should match values \"allele\", \"p.value\", \"p.adjusted\", \"estimate\", \"std.error\", \"conf.low\", \"conf.high\", \"statistic\", \"Ntotal\", \"Ntotal.percent\", \"N\\(disease=0\\)\", \"N\\(disease=0\\).percent\", \"N\\(disease=1\\)\", \"N\\(disease=1\\).percent\"."
  )

  expect_error(kableResults(res, scroll_box_height = 1),
               "scroll_box_height is not a string \\(a length one character vector\\)."
  )
})

test_that("countsToVariables", {
  kir_haplotypes <- countsToVariables(MiDAS_tut_KIR[1:2, ], "kir_haplotypes")
  kir_haplotypes_test <- data.frame(
    ID = c("C001", "C002"),
    cenAA = c(1, 1),
    cenBB = c(0, 0),
    cenAB = c(0, 0),
    telAA = c(1, 1),
    telBB = c(0, 0),
    telAB = c(0, 0),
    stringsAsFactors = FALSE
  )
  expect_equal(kir_haplotypes, kir_haplotypes_test)

  # works with a dictionary data frame
  dictionary <- data.frame(
    Name = c("cenAA", "cenAB", "telAA"),
    Expression = c(
      "KIR2DL3 & ! KIR2DL2 & ! KIR2DS2",
      "! (KIR2DL2 & ! KIR2DL3) & ! (KIR2DL3 & ! KIR2DL2 & ! KIR2DS2)",
      "! KIR2DS1 & ! KIR3DS1"
   ),
   stringsAsFactors = FALSE
  )
  kir_haplotypes <- countsToVariables(MiDAS_tut_KIR[1:2, ], dictionary)
  expect_equal(kir_haplotypes,
               kir_haplotypes_test[, c("ID", "cenAA", "cenAB", "telAA")]
  )

  expect_error(
    countsToVariables(iris),
    "first column in counts must be named 'ID'"
  )

  expect_error(
    countsToVariables(MiDAS_tut_KIR, na.value = 1:2),
    "na.value length must equal 1."
  )

  expect_error(
    countsToVariables(MiDAS_tut_KIR, nacols.rm = 1),
    "nacols.rm is not a flag \\(a length one logical vector\\)."
  )

  expect_error(
    countsToVariables(MiDAS_tut_KIR, dictionary = "foo"),
    "Path 'foo' does not exist"
  )

  expect_error(
    countsToVariables(MiDAS_tut_KIR, dictionary = c("foo", "bar")),
    "dictionary is not a data frame"
  )
})

test_that("getHlaKirInteractions", {
  hla_kir <- getHlaKirInteractions(MiDAS_tut_HLA, MiDAS_tut_KIR)
  load(system.file("extdata", "test_hla_kir_interactions.Rdata", package = "midasHLA"))
  expect_equal(hla_kir, test_hla_kir_interactions)

  expect_error(
    getHlaKirInteractions(MiDAS_tut_HLA, MiDAS_tut_KIR, interactions_dict = 1),
    "interactions_dict is not a string \\(a length one character vector\\)."
  )

 fake_kir_counts <- MiDAS_tut_KIR
 fake_kir_counts[, 1] <- paste0("foo", 1:nrow(fake_kir_counts))
 expect_error(
   getHlaKirInteractions(MiDAS_tut_HLA, fake_kir_counts),
   "IDs in hla_calls doesn't match IDs in kir_calls"
 )

 fake_kir_counts <- MiDAS_tut_KIR
 fake_kir_counts[1:5, 1] <- paste0("foo", 1:5)
 expect_warning(
  getHlaKirInteractions(MiDAS_tut_HLA, fake_kir_counts),
  "995 IDs in hla_calls matched IDs in kir_calls"
 )
})

test_that("filterExperimentByFrequency", {
  # filtering works as expected for fractions
  experiment <- MiDAS_tut_object[["hla_alleles"]]
  lower_frequency_cutoff <- 0.50
  upper_frequency_cutoff <- 0.90
  experiment_filtered <- filterExperimentByFrequency(
    experiment = experiment,
    lower_frequency_cutoff = lower_frequency_cutoff,
    upper_frequency_cutoff = upper_frequency_cutoff
  )
  expected_vars <- c("DPA1*01:03", "DRA*01:01")
  expect_equal(experiment_filtered, experiment[expected_vars, ])

  # filtering works as expected for counts
  experiment <- MiDAS_tut_object[["hla_alleles"]]
  lower_frequency_cutoff <- 8
  upper_frequency_cutoff <- 10
  experiment_filtered <- filterExperimentByFrequency(
    experiment = experiment,
    lower_frequency_cutoff = lower_frequency_cutoff,
    upper_frequency_cutoff = upper_frequency_cutoff
  )
  
  # order of rows somehow depends on the R version...
  expected_vars <-
    c("B*27:02",
      "B*41:01",
      "B*41:02",
      "C*08:03",
      "DPA1*02:06",
      "DRB1*01:03",
      "DRB1*08:04")
  expected_vars <- expected_vars[order(expected_vars)]
  experiment_filtered <-
    experiment_filtered[order(rownames(experiment_filtered)),]

  expect_equal(experiment_filtered, experiment[expected_vars, ])

  # filtering works as expected for boundry conditions NULL, NULL
  experiment <- MiDAS_tut_object[["hla_alleles"]]
  lower_frequency_cutoff <- NULL
  upper_frequency_cutoff <- NULL
  experiment_filtered <- filterExperimentByFrequency(
    experiment = experiment,
    lower_frequency_cutoff = lower_frequency_cutoff,
    upper_frequency_cutoff = upper_frequency_cutoff
  )
  expect_equal(experiment_filtered, experiment)

  # filtering works as expected for boundry conditions 0, 0
  experiment <- MiDAS_tut_object[["hla_alleles"]]
  lower_frequency_cutoff <- 0
  upper_frequency_cutoff <- 0
  experiment_filtered <- filterExperimentByFrequency(
    experiment = experiment,
    lower_frequency_cutoff = lower_frequency_cutoff,
    upper_frequency_cutoff = upper_frequency_cutoff
  )
  expected_vars <- character(0L)
  expect_equal(experiment_filtered, experiment[expected_vars, ])

  # filtering works as expected for boundry conditions 1, 1
  experiment <- MiDAS_tut_object[["hla_alleles"]]
  lower_frequency_cutoff <- 1
  upper_frequency_cutoff <- 1
  experiment_filtered <- filterExperimentByFrequency(
    experiment = experiment,
    lower_frequency_cutoff = lower_frequency_cutoff,
    upper_frequency_cutoff = upper_frequency_cutoff
  )
  expected_vars <- character(0L)
  expect_equal(experiment_filtered, experiment[expected_vars, ])
  
  # omnibus groups are filtred correctly
  experiment <- MiDAS_tut_object[["hla_aa"]]
  lower_frequency_cutoff <- 0.86
  upper_frequency_cutoff <- 0.87
  experiment_filtered <- filterExperimentByFrequency(
    experiment = experiment,
    lower_frequency_cutoff = lower_frequency_cutoff,
    upper_frequency_cutoff = upper_frequency_cutoff
  )
  test_experiment <- experiment[c("C_35_R", "C_309_V"), ]

  expect_equal(experiment_filtered, test_experiment)

  # experiment must be of type integer
  experiment <- matrix(LETTERS)
  lower_frequency_cutoff <- 0.1
  upper_frequency_cutoff <- 0.5
  expect_error(
    filterExperimentByFrequency(
      experiment = experiment,
      lower_frequency_cutoff = lower_frequency_cutoff,
      upper_frequency_cutoff = upper_frequency_cutoff
    ),
    "Frequency filtration does not support provided experiment."
  )

  # carrier_frequency must be a string
  experiment <- MiDAS_tut_object[["hla_alleles"]]
  inheritance_model <- 1
  lower_frequency_cutoff <- "foo"
  upper_frequency_cutoff <- 0.5
  expect_error(
    filterExperimentByFrequency(
      experiment = experiment,
      carrier_frequency = 1,
      lower_frequency_cutoff = lower_frequency_cutoff,
      upper_frequency_cutoff = upper_frequency_cutoff
    ),
    "carrier_frequency is not a flag \\(a length one logical vector\\)."
  )

  # lower_frequency_cutof must be a number
  experiment <- MiDAS_tut_object[["hla_alleles"]]
  lower_frequency_cutoff <- "foo"
  upper_frequency_cutoff <- 0.5
  expect_error(
    filterExperimentByFrequency(
      experiment = experiment,
      lower_frequency_cutoff = lower_frequency_cutoff,
      upper_frequency_cutoff = upper_frequency_cutoff
    ),
    "lower_frequency_cutoff is not a number \\(a length one numeric vector\\)."
  )

  # lower_frequency_cutof must be positive
  experiment <- MiDAS_tut_object[["hla_alleles"]]
  lower_frequency_cutoff <- -1
  upper_frequency_cutoff <- 0.5
  expect_error(
    filterExperimentByFrequency(
      experiment = experiment,
      lower_frequency_cutoff = lower_frequency_cutoff,
      upper_frequency_cutoff = upper_frequency_cutoff
    ),
    "lower_frequency_cutoff must be a number greater than 0."
  )

  # upper_frequency_cutoff must be a number
  experiment <- MiDAS_tut_object[["hla_alleles"]]
  lower_frequency_cutoff <- 0.5
  upper_frequency_cutoff <- "foo"
  expect_error(
    filterExperimentByFrequency(
      experiment = experiment,
      lower_frequency_cutoff = lower_frequency_cutoff,
      upper_frequency_cutoff = upper_frequency_cutoff
    ),
    "upper_frequency_cutoff is not a number \\(a length one numeric vector\\)."
  )

  # upper_frequency_cutoff must be positive
  experiment <- MiDAS_tut_object[["hla_alleles"]]
  lower_frequency_cutoff <- 0
  upper_frequency_cutoff <- -1
  expect_error(
    filterExperimentByFrequency(
      experiment = experiment,
      lower_frequency_cutoff = lower_frequency_cutoff,
      upper_frequency_cutoff = upper_frequency_cutoff
    ),
    "upper_frequency_cutoff must be a number greater than 0."
  )

  # lower_frequency_cutoff is lower than upper_frequency_cutoff
  experiment <- MiDAS_tut_object[["hla_alleles"]]
  lower_frequency_cutoff <- 5
  upper_frequency_cutoff <- 1
  expect_error(
    filterExperimentByFrequency(
      experiment = experiment,
      lower_frequency_cutoff = lower_frequency_cutoff,
      upper_frequency_cutoff = upper_frequency_cutoff
    ),
    "lower_frequency_cutoff cannot be higher than upper_frequency_cutoff."
  )

  # Both lower_frequency_cutoff and upper_frequency_cutoff have to be either frequencies or counts
  experiment <- MiDAS_tut_object[["hla_alleles"]]
  lower_frequency_cutoff <- 0.5
  upper_frequency_cutoff <- 2
  expect_error(
    filterExperimentByFrequency(
      experiment = experiment,
      lower_frequency_cutoff = lower_frequency_cutoff,
      upper_frequency_cutoff = upper_frequency_cutoff
    ),
    "Both lower_frequency_cutoff and upper_frequency_cutoff have to be either frequencies or counts."
  )
})

test_that("getExperimentFrequencies", {
  experiment_matrix <- matrix(
    data = c(0, 2, 0, 0, 0,
             0, 2, 0, 0, 0,
             2, 0, 0, 0, 0,
             0, 1, 1, 0, 0,
             0, 0, 0, 0, 0
    ),
    nrow = 5,
    ncol = 5,
    dimnames = list(
      c("A*01:01", "A*02:01", "A*02:06", "A*03:01", "A*23:01"),
      c("PAT1", "PAT2", "PAT3", "PAT4", "PAT5")
    )
  )
  experiment_se <- SummarizedExperiment::SummarizedExperiment(
    assays = list(experiment_matrix),
    metadata = list(
      inheritance_model_applicable = TRUE,
      pop_mul = 2,
      omnibus_groups = NULL
    )
  )

  # allele frequecny
  experiment_freq_test <- data.frame(
    term = c("A*01:01", "A*02:01", "A*02:06", "A*03:01", "A*23:01"),
    Counts = c(2, 5, 1, 0, 0),
    Freq = c(0.2, 0.5, 0.1, 0, 0),
    row.names = NULL,
    stringsAsFactors = FALSE
  )

  # matrix
  expect_equal(getExperimentFrequencies(experiment_matrix, 2), experiment_freq_test)

  # se
  experiment_freq <-
    getExperimentFrequencies(experiment_se)
  expect_equal(experiment_freq, experiment_freq_test)

  # carrier frequency
  experiment_freq <-
    getExperimentFrequencies(experiment_se, carrier_frequency =  TRUE)
  experiment_freq_test <- data.frame(
    term = c("A*01:01", "A*02:01", "A*02:06", "A*03:01", "A*23:01"),
    Counts = c(1, 3, 1, 0, 0),
    Freq = c(0.2, 0.6, 0.2, 0, 0),
    row.names = NULL,
    stringsAsFactors = FALSE
  )
  expect_equal(experiment_freq, experiment_freq_test)

  expect_error(
    getExperimentFrequencies(matrix(LETTERS)),
    "values in experiment are not counts \\(a positive integers\\) or zeros."
  )

  expect_error(getExperimentFrequencies(experiment_matrix),
               "pop_mul is not a number \\(a length one numeric vector\\)."
  )

  expect_error(getExperimentFrequencies(experiment_matrix, 1, carrier_frequency = 1),
               "carrier_frequency is not a flag \\(a length one logical vector\\).")

  expect_error(getExperimentFrequencies(experiment_matrix, 1, ref = "foo"),
               "ref is not a data frame")
})

test_that("applyInheritanceModel", {
  experiment <- matrix(c(2, 0, 1, 1, 2, 1, 0, 2, 2), nrow = 3)

  inheritance_model <- "additive"
  additive <- applyInheritanceModel(experiment, inheritance_model)
  expect_equal(experiment, additive)

  inheritance_model <- "dominant"
  dominant <- applyInheritanceModel(experiment, inheritance_model)
  test_dominant <- matrix(c(1, 0, 1, 1, 1, 1, 0, 1, 1), nrow = 3)
  expect_equal(dominant, test_dominant)

  inheritance_model <- "recessive"
  recessive <- applyInheritanceModel(experiment, inheritance_model)
  test_recessive <- matrix(c(1, 0, 0, 0, 1, 0, 0, 1, 1), nrow = 3)
  expect_equal(recessive, test_recessive)

  inheritance_model <- "overdominant"
  recessive <- applyInheritanceModel(experiment, inheritance_model)
  test_recessive <- matrix(c(0, 0, 1, 1, 0, 1, 0, 0, 0), nrow = 3)
  expect_equal(recessive, test_recessive)

  # works on summarized experiment
  se <- SummarizedExperiment(
    assays = list(matrix(c(2, 0, 1, 1, 2, 1, 0, 2, 2), nrow = 3)),
    colData = data.frame(foo = 1:3, row.names = 1:3)
  )
  se_dominant <- applyInheritanceModel(se, "dominant")
  assay(se) <- ifelse(assay(se) == 0, 0, 1)
  expect_equal(se_dominant, se)
})

test_that("getFrequencyMask", {
  experiment_matrix <- matrix(
    data = c(0, 2, 0, 0, 0,
             0, 2, 0, 0, 0,
             2, 0, 0, 0, 0,
             0, 1, 1, 0, 0,
             0, 0, 0, 0, 0
    ),
    nrow = 5,
    ncol = 5,
    dimnames = list(
      c("A*01:01", "A*02:01", "A*02:06", "A*03:01", "A*23:01"),
      c("PAT1", "PAT2", "PAT3", "PAT4", "PAT5")
    )
  )
  experiment_matrix_freq <-
    getExperimentFrequencies(experiment_matrix, 2)
  mask <-
    getFrequencyMask(
      df = experiment_matrix_freq,
      lower_frequency_cutoff = 0.1,
      upper_frequency_cutoff = 0.5
    )
  expect_equal(mask, "A*01:01")

  mask <-
    getFrequencyMask(
      df = experiment_matrix_freq,
      lower_frequency_cutoff = 0.1,
      upper_frequency_cutoff = 0.51
    )
  expect_equal(mask, c("A*01:01", "A*02:01"))
})

test_that("filterExperimentByVariables", {
  experiment <- matrix(
    data = c(0, 2, 0, 0, 0,
             0, 2, 0, 0, 0,
             2, 0, 0, 0, 0,
             0, 1, 1, 0, 0,
             0, 0, 0, 0, 0),
    nrow = 5,
    ncol = 5,
    dimnames = list(
      c("A*01:01", "A*02:01", "A*02:06", "A*03:01", "A*23:01"),
      c("PAT1", "PAT2", "PAT3", "PAT4", "PAT5")
    )
  )
  experiment_filtered <- filterExperimentByVariables(experiment, c("A*01:01", "A*02:01"))
  expect_equal(experiment_filtered, experiment[1:2, ])

  experiment <- SummarizedExperiment::SummarizedExperiment(experiment)
  metadata(experiment)$omnibus_groups <-
    list(A = c("A*01:01", "A*02:01", "A*02:06", "A*03:01", "A*23:01"))
  experiment_filtered <- filterExperimentByVariables(experiment, c("A*01:01", "A*02:01"))
  test_experiment <- experiment[c("A*01:01", "A*02:01"), ]

  expect_equal(experiment_filtered, test_experiment)
})

test_that("getExperimentPopulationMultiplicator", {
  se <- SummarizedExperiment::SummarizedExperiment(
    assays = list(matrix(1:5)),
    metadata = list(pop_mul = 2)
  )
  expect_equal(
    getExperimentPopulationMultiplicator(se),
    2
  )

  mat <- matrix(1:5)
  expect_equal(
    getExperimentPopulationMultiplicator(mat),
    NULL
  )
})

test_that("isExperimentInheritanceModelApplicable", {
  se <- SummarizedExperiment::SummarizedExperiment(
    assays = list(matrix(1:5)),
    metadata = list(inheritance_model_applicable = TRUE)
  )
  expect_equal(
    isExperimentInheritanceModelApplicable(se),
    TRUE
  )

  mat <- matrix(1:5)
  expect_equal(
    isExperimentInheritanceModelApplicable(mat),
    FALSE
  )
})

context("MiDAS class longtests")

test_that("prepareMiDAS", {
  hla_calls <- reduceHlaCalls(MiDAS_tut_HLA, resolution = 4)
  kir_calls <- MiDAS_tut_KIR
  phenotype <- MiDAS_tut_pheno

  args_c <-
    expand.grid(
      lower_frequency_cutoff = c(0, 0.54),
      upper_frequency_cutoff = c(1, 0.63),
      stringsAsFactors = FALSE
    )

  for (i in 1:nrow(args_c)) {
    args <- as.list(args_c[i, , drop = FALSE])

    midas <- prepareMiDAS(
      hla_calls = hla_calls,
      kir_calls = kir_calls,
      colData = phenotype,
      experiment = c(
        "hla_alleles",
        # "hla_aa",
        "hla_g_groups",
        "hla_supertypes",
        "hla_NK_ligands",
        "kir_genes",
        "hla_kir_interactions",
        "hla_divergence"
      ),
      lower_frequency_cutoff = args$lower_frequency_cutoff,
      upper_frequency_cutoff = args$upper_frequency_cutoff
    )
    validObject(midas)
  }

  expect_error(
    prepareMiDAS(),
    "hla_calls or kir_calls argument has to be specified"
  )


  expect_error(
    prepareMiDAS(hla_calls = cars[1:2, ]),
    "values: 2, 10 in hla_calls doesn't follow HLA numbers specification"
  )

  expect_error(
    prepareMiDAS(hla_calls = hla_calls, colData = cars[1:2, ]),
    "first column in colData must be named 'ID'"
  )

  expect_error(
    prepareMiDAS(
      hla_calls = hla_calls,
      colData = phenotype,
      experiment = 1
    ),
    "experiment is not a character vector"
  )

  expect_error(
    prepareMiDAS(
      hla_calls = hla_calls,
      colData = phenotype,
      experiment = "foo"
    ),
    "experiment should match values \"hla_alleles\", \"hla_aa\", \"hla_g_groups\", \"hla_supertypes\", \"hla_NK_ligands\", \"kir_genes\", \"kir_haplotypes\", \"hla_kir_interactions\", \"hla_divergence\", \"hla_het\", \"hla_custom\", \"kir_custom\"."
  )

  expect_error(
    prepareMiDAS(
      hla_calls = hla_calls,
      colData = phenotype,
      experiment = "hla_alleles",
      placeholder = 1
    ),
    "placeholder is not a string \\(a length one character vector\\)."
  )

  expect_error(
    prepareMiDAS(
      hla_calls = hla_calls,
      colData = phenotype,
      experiment = "hla_alleles",
      placeholder = "outcome"
    ),
    "Placeholder 'outcome' can not be used, it is already used as column name in one of the inputs."
  )
})

test_that("prepareMiDAS_hla_aa", {
  args_c <- expand.grid(
    indels = c(TRUE, FALSE),
    unkchar = c(TRUE, FALSE),
    stringsAsFactors = FALSE
  )

  for (i in 1:nrow(args_c)) {
    args <- as.list(args_c[i, , drop = FALSE])
    args$hla_calls <- MiDAS_tut_HLA
    experiment <- do.call(prepareMiDAS_hla_aa, args)

    counts <-
      hlaToAAVariation(
        hla_calls = args$hla_calls,
        indels = args$indels,
        unkchar = args$unkchar
      )
    counts <-
      aaVariationToCounts(counts)
    counts <- dfToExperimentMat(counts)
    pos <- gsub("_.{1}$", "", rownames(counts))
    pos <- unique(pos)
    omnibus_groups <- lapply(pos, function(p) {
      grep(pattern = paste0("^", p, "_"),
           x = rownames(counts),
           value = TRUE)
    })
    names(omnibus_groups) <- pos
    experiment_test <-
      SummarizedExperiment(assays = counts,
                           metadata = list(
                             inheritance_model_applicable = TRUE,
                             pop_mul = 2,
                             omnibus_groups = omnibus_groups)
                           )
    expect_equal(experiment, experiment_test)
  }
})

#!/usr/bin/env R
# Migdal
# Run simple hla_aa workflow

devtools::load_all()

argv = commandArgs(trailingOnly=TRUE)
input <- argv[1] # input hla_calls

hla_calls <- readHlaCalls(input)
col_data <- data.frame(
  ID = hla_calls$ID,
  val = rbinom(nrow(hla_calls), 1, 0.2))

midas <-
  prepareMiDAS(
    hla_calls = hla_calls,
    colData = col_data,
    experiment = "hla_aa"
  )

model <- glm(val ~ term, data = midas, family = binomial())

hla_aa_result <- runMiDAS(model, "hla_aa", inheritance_model = "dominant")

#!/usr/bin/env R
# Migdal
# Simulate hla_calls data

devtools::load_all()

options(scipen = 999)

argv <- commandArgs(trailingOnly=TRUE)
out_prefix <- argv[1] # output prefix eg. inst/benchmark/hla_calls
genes <- argv[2:length(argv)] # genes for which to generate calls
size <- c(100, 1000, 10000, 100000) # generated data size
phomo = 0.108 # homozygote probability

genHlaData <- function(alleles, aprob, size=100, phomo=0.108) {
  al_1 <- sample(x = alleles, size = size, replace = TRUE, prob = aprob)
  al_2 <- ifelse(
    test = rbinom(n = size, size = 1, prob = phomo), 
    yes = al_1,
    no = sample(x = alleles, size = size, replace = TRUE, prob = aprob))
  df <- data.frame(paste0("SAM", 1:size), al_1, al_2, stringsAsFactors = FALSE)
  gn <- gsub("\\*.*", "", alleles[1])
  colnames(df) <- c("ID", paste0(gn, "_1"), paste0(gn, "_2"))
  
  return(df)
}

simHlaCalls <- function(allele_list, size, den, phomo) {
  out <- list()
  genes <- names(allele_list)
  for (gene in genes) {
    alleles <- allele_list[[gene]]
    aprob <- sample(x = den$x, size = length(alleles), replace = TRUE, prob = den$y)
    out[[length(out) + 1]] <- genHlaData(alleles, aprob, size, phomo)
  }
  out <- Reduce(f=function(...) left_join(..., by = "ID"), x=out)
  
  return(out)
}

# estimate frequencies density based on published data
dis <- filter(allele_frequencies, grepl("A\\*", var)) %>%
  filter(grepl("Poland pop 3", population))
den <- density(dis$frequency, adjust=3, from=0, to=1)

# Plot allele frequency distribution and fitted kernel
# hist(dis$frequency)
# lines(den, lty="dotted")

# get alleles
allele_list <- lapply(
  X = genes, 
  FUN = function (x) readHlaAlignments(gene = x) %>% rownames())
names(allele_list) <- genes

# simulate HLA data
for (s in size) {
  out <- simHlaCalls(allele_list, s, den, phomo)
  write.table(out, file = paste0(out_prefix, "_", s, ".tsv"), quote = FALSE, sep = "\t", row.names = FALSE, col.names = TRUE)
}

## ----my_setup, echo=FALSE, warning=FALSE, include=FALSE-----------------------
knitr::opts_chunk$set(echo = TRUE, fig.align="center")
devtools::load_all()

## ----logo, echo=FALSE, warning=FALSE------------------------------------------
htmltools::img(
  src = knitr::image_uri("MiDAS_logo.png"),
  alt = 'logo',
  style = 'position:absolute; top:0; right:0; padding:10px; width:250px'
  )

## ----get_data, echo=TRUE, warning=FALSE---------------------------------------
dat_pheno <-
  read.table(
  file = system.file("extdata", "MiDAS_tut_pheno.txt", package = "midasHLA"),
  header = TRUE
  )
dat_HLA <-
  readHlaCalls(
  file = system.file("extdata", "MiDAS_tut_HLA.txt", package = "midasHLA"),
  resolution = 4
  )

## ----show_imported_data, echo=FALSE, warning=FALSE----------------------------
dat_HLA %>%
  head(20) %>%
  kable(caption = "HLA data as imported by MiDAS") %>%
  kable_styling(bootstrap_options = c("striped", "hover", "condensed")) %>%
  scroll_box(width = "100%", height = "300px")

## ----get_frequencies, echo=TRUE, warning=FALSE--------------------------------
freq_HLA <- getHlaFrequencies(hla_calls = dat_HLA, compare = TRUE) %>%
  filter(Freq > 0.01)

## ----show_frequencies, echo=FALSE, warning=FALSE------------------------------
freq_HLA %>%
  head() %>%
  kable(caption = "HLA frequencies, compared to published references") %>%
  kable_styling(bootstrap_options = c("striped", "hover", "condensed"))

## ----plot_frequencies, echo=TRUE, warning=FALSE, fig.height=7, fig.width=7----
freq_HLA_long <- tidyr::gather(
  data = freq_HLA,
  key = "population",
  value = "freq",
  "Freq",
  "USA NMDP European Caucasian",
  "USA NMDP Chinese",
  "USA NMDP African American pop 2",
  factor_key = TRUE
) %>% 
  filter(grepl("^A", allele))

plot_HLAfreq <-
  ggplot2::ggplot(data = freq_HLA_long, ggplot2::aes(x = allele, y = freq, fill = population)) +
  ggplot2::geom_bar(
    stat = "identity",
    position = ggplot2::position_dodge(0.7),
    width = 0.7,
    colour = "black"
  ) +
  ggplot2::coord_flip() +
  ggplot2::scale_y_continuous(labels = formattable::percent)

plot_HLAfreq

## ----prep_HLA, echo=TRUE, warning=FALSE---------------------------------------
HLA <- prepareMiDAS(
  hla_calls = dat_HLA,
  colData = dat_pheno,
  experiment = "hla_alleles"
)

## ----HWE_filtering, echo=TRUE, warning=FALSE----------------------------------
HLA <- HWETest(
  object = HLA,
  experiment = "hla_alleles",
  HWE_cutoff = 0.05 / 447,
  as.MiDAS = TRUE
)

## ----run_HLA_allelic, echo=TRUE, warning=FALSE, message=FALSE-----------------
HLA_model <- glm(disease ~ term, data = HLA, family = binomial())
HLA_results <- runMiDAS(
  object = HLA_model, 
  experiment = "hla_alleles", 
  inheritance_model = "dominant",
  lower_frequency_cutoff = 0.02, 
  upper_frequency_cutoff = 0.98, 
  correction = "bonferroni", 
  exponentiate = TRUE
)

kableResults(HLA_results)

## ----run_HLA_allelic_cond, echo=TRUE, warning=FALSE, message=FALSE------------
HLA_results_cond <- runMiDAS(
  object = HLA_model, 
  experiment = "hla_alleles", 
  inheritance_model = "dominant", 
  conditional = TRUE,
  lower_frequency_cutoff = 0.02, 
  upper_frequency_cutoff = 0.98, 
  correction = "bonferroni", 
  exponentiate = TRUE
)

kableResults(HLA_results_cond, scroll_box_height = "200px")

## ----prepare_HLA_AA, echo=TRUE, warning=FALSE---------------------------------
HLA_AA <- prepareMiDAS(
  hla_calls = dat_HLA,
  colData = dat_pheno,
  experiment = "hla_aa"
)

## ----HLA_AA_to_df, echo=TRUE, warning=FALSE-----------------------------------
dat_HLA_AA <- HLA_AA[["hla_aa"]] %>% 
  assay() %>% 
  t() %>% 
  as.data.frame() %>% 
  select(starts_with("B_97_")) %>% 
  head()

## ----show_HLA_AA, echo=FALSE, warning=FALSE-----------------------------------
kable(dat_HLA_AA, caption = "HLA amino acid data as inferred by MiDAS") %>%
  kable_styling(bootstrap_options = c("striped", "hover", "condensed"))

## ----run_HLA_AA_omnibus, echo=TRUE, warning=FALSE, message=FALSE--------------
HLA_AA_model <- glm(disease ~ term, data = HLA_AA, family = binomial())
HLA_AA_omnibus_results <- runMiDAS(
  HLA_AA_model,
  experiment = "hla_aa",
  inheritance_model = "dominant",
  conditional = FALSE,
  omnibus = TRUE,
  lower_frequency_cutoff = 0.02,
  upper_frequency_cutoff = 0.98,
  correction = "bonferroni"
)

kableResults(HLA_AA_omnibus_results)

## ----run_HLA_AA_DQB1_9, echo=TRUE, warning=FALSE------------------------------
HLA_AA_DQB1_9_results <- runMiDAS(
  HLA_AA_model,
  experiment = "hla_aa",
  inheritance_model = "dominant",
  omnibus_groups_filter = "DQB1_9",
  lower_frequency_cutoff = 0.02,
  upper_frequency_cutoff = 0.98,
  correction = "bonferroni",
  exponentiate = TRUE
)

kableResults(HLA_AA_DQB1_9_results, scroll_box_height = "250px")

## ----alleles_for_aa, echo=TRUE, warning=FALSE---------------------------------
HLA_AA_DQB1_9_alleles <- getAllelesForAA(HLA_AA,"DQB1_9")

## ----get_HLA_AA_DQB1_9_alleles, echo=FALSE, warning=FALSE---------------------
kable(HLA_AA_DQB1_9_alleles, escape = FALSE) %>% 
  kable_styling(bootstrap_options = c("striped", "hover", "condensed"))

## ----prep_KIR_ligand, echo=TRUE, warning=FALSE--------------------------------
NKlig <- prepareMiDAS(
  hla_calls = dat_HLA,
  colData = dat_pheno,
  experiment = c("hla_alleles", "hla_NK_ligands")
)

## ----run_KIR_ligand, echo=TRUE, warning=FALSE, message=FALSE------------------
NKlig_model <- glm(disease ~ term, data = NKlig, family = binomial())
NKlig_results <- runMiDAS(
  NKlig_model,
  experiment = "hla_NK_ligands",
  inheritance_model = "dominant",
  correction = "bonferroni",
  exponentiate = TRUE
)

kableResults(NKlig_results)

## ----get_KIR, echo=TRUE, warning=FALSE----------------------------------------
dat_KIR <- readKirCalls(
  file = system.file("extdata", "MiDAS_tut_KIR.txt", package = "midasHLA")
)

## ----show_KIR, echo=FALSE, warning=FALSE--------------------------------------
kable(dat_KIR, caption = "KIR data as imported by MiDAS") %>%
  kable_styling(bootstrap_options = c("striped", "hover", "condensed"))  %>%
  scroll_box(height = "400px")

## ----KIR_frequency, echo=TRUE, warning=FALSE----------------------------------
kir_freq <- getKIRFrequencies(dat_KIR)

## ----show_KIR_frequency, echo=FALSE, warning=FALSE----------------------------
kable(kir_freq , caption = "KIR data as imported by MiDAS") %>%
  kable_styling(bootstrap_options = c("striped", "hover", "condensed")) %>%
  scroll_box(height = "400px")

## ----run_KIR_gene, echo=TRUE, warning=FALSE, message=FALSE--------------------
HLAKIR <- prepareMiDAS(
  hla_calls = dat_HLA,
  kir_calls = dat_KIR,
  colData = dat_pheno,
  experiment = c("hla_NK_ligands","kir_genes", "hla_kir_interactions")
)
KIR_model <- glm(disease ~ term, data = HLAKIR, family = binomial())
KIR_results <- runMiDAS(
  KIR_model,
  experiment = "kir_genes",
  lower_frequency_cutoff = 0.02,
  upper_frequency_cutoff = 0.98,
  exponentiate = TRUE
)

kableResults(KIR_results)

## ----HLA-KIR_interactions_frequency, echo=TRUE, warning=FALSE-----------------
hlakir_freq <- getFrequencies(HLAKIR, experiment = "hla_kir_interactions")

## ----show_HLA-KIR_interactions_frequency, echo=FALSE, warning=FALSE-----------
kable(hlakir_freq, caption = "HLA-KIR interaction frequencies") %>%
  kable_styling(bootstrap_options = c("striped", "hover", "condensed")) %>%
  scroll_box(height = "400px")

## ----run_HLA-KIR_interactions, echo=TRUE, warning=FALSE, message=FALSE--------
HLAKIR_model <- glm(disease ~ term, data = HLAKIR, family = binomial())
HLA_KIR_results <- runMiDAS(
  HLAKIR_model,
  experiment = "hla_kir_interactions",
  lower_frequency_cutoff = 0.02,
  upper_frequency_cutoff = 0.98,
  exponentiate = TRUE
)

kableResults(HLA_KIR_results)

## ----run_HLAhet, echo=TRUE, warning=FALSE, message=FALSE----------------------

HLA_het <- prepareMiDAS(
  hla_calls = dat_HLA, 
  colData = dat_pheno, 
  experiment = c("hla_het","hla_divergence")
)

HLA_het_model <- glm(outcome ~ term, data=HLA_het, family=binomial())

HLA_het_results <- runMiDAS(HLA_het_model, 
  experiment = "hla_het", 
  exponentiate = TRUE
)

kableResults(HLA_het_results)

HLA_div_results <- runMiDAS(HLA_het_model, 
  experiment = "hla_divergence", 
  exponentiate = TRUE
)

kableResults(HLA_div_results, scroll_box_height = "250px")

#' Read HLA allele calls
#'
#' \code{readHlaCalls} read HLA allele calls from file
#'
#' Input file has to be a tsv formatted table with a header. First column should
#' contain sample IDs, further columns hold HLA allele numbers. See
#' \code{system.file("extdata", "MiDAS_tut_HLA.txt", package = "midasHLA")} file
#' for an example.
#'
#' \code{resolution} parameter can be used to reduce HLA allele numbers. If
#' reduction is not needed \code{resolution} can be set to 8. \code{resolution}
#' parameter can take the following values: 2, 4, 6, 8. For more details
#' about HLA allele numbers resolution see
#' \url{http://hla.alleles.org/nomenclature/naming.html}.
#'
#' @inheritParams reduceAlleleResolution
#' @inheritParams utils::read.table
#' @param file Path to input file.
#'
#' @return HLA calls data frame. First column hold sample IDs, further columns 
#'   hold HLA allele numbers.
#'
#' @examples
#' file <- system.file("extdata", "MiDAS_tut_HLA.txt", package = "midasHLA")
#' hla_calls <- readHlaCalls(file)
#'
#' @importFrom assertthat assert_that is.readable see_if
#' @importFrom stats na.omit
#' @importFrom stringi stri_split_fixed
#' @importFrom utils read.table
#' @export
readHlaCalls <- function(file,
                         resolution = 4,
                         na.strings = c("Not typed", "-", "NA")) {
  assert_that(is.readable(file),
              is.count(resolution),
              is.character(na.strings)
  )
  hla_calls <- read.table(file,
                          header = TRUE,
                          sep = "\t",
                          stringsAsFactors = FALSE,
                          na.strings = na.strings
  )
  assert_that(checkHlaCallsFormat(hla_calls))

  # set colnames based on allele numbers
  gene_names <- vapply(X = 2:ncol(hla_calls),
                       FUN = function(i) {
                         names <- stri_split_fixed(hla_calls[, i], "*")
                         names <- vapply(X = names,
                                FUN = function(x) x[1],
                                FUN.VALUE = character(length = 1)
                         )
                         names <- unique(na.omit(names))
                         assert_that(
                           see_if(length(names) <= 1,
                                  msg = "Gene names in columns are not identical"
                           ),
                           see_if(length(names) != 0,
                                  msg = "One of the columns contains only NA"
                           )
                         )
                         return(names)
                       },
                       FUN.VALUE = character(length = 1)
  )
  ord <- order(gene_names)
  gene_names <- gene_names[ord]
  gene_names <- toupper(gene_names)
  gene_names_id <- unlist(lapply(table(gene_names), seq_len))
  gene_names <- paste(gene_names, gene_names_id, sep = "_")
  hla_calls <- hla_calls[, c(1, ord + 1)]
  colnames(hla_calls) <- c("ID", gene_names)

  hla_calls <- reduceHlaCalls(hla_calls, resolution = resolution)

  return(hla_calls)
}

#' Read HLA allele alignments
#'
#' \code{readHlaAlignments} read HLA allele alignments from file.
#'
#' HLA allele alignment file should follow EBI database format, for details
#' see
#' \url{ftp://ftp.ebi.ac.uk/pub/databases/ipd/imgt/hla/alignments/README.md}.
#'
#' All protein alignment files from the EBI database are shipped with the package.
#' They can be easily accessed using \code{gene} parameter. If \code{gene} is
#' set to \code{NULL}, \code{file} parameter is used instead and alignment is
#' read from the provided file. In EBI database alignments for DRB1, DRB3, DRB4
#' and DRB5 genes are provided as a single file, here they are separated.
#' Additionally, were possible sequences for alleles not present in the alignments have been 
#' inferred based on higher resolution alleles. To this end we have reduced 
#' alleles to 6 and 4 digit resolution and took consensus sequence to represent
#' missing alleles. Positions for which there was no full agreement were marked
#' as unknown.
#' 
#' 
#'
#' @inheritParams readHlaCalls
#' @param gene Character vector of length one specifying the name of a gene for
#'   which alignment is required. See details for further explanations.
#' @param trim Logical indicating if alignment should be trimmed to start codon
#'   of the mature protein.
#' @param unkchar Character to be used to represent positions with unknown
#'   sequence.
#'
#' @return Matrix containing HLA allele alignments.
#'
#'   Rownames correspond to allele numbers and columns to positions in the
#'   alignment. Sequences following the termination codon are marked as empty
#'   character (\code{""}). Unknown sequences are marked with a character of
#'   choice, by default \code{""}. Stop codons are represented by a hash (X).
#'   Insertion and deletions are marked with period (.).
#'
#' @examples
#' hla_alignments <- readHlaAlignments(gene = "A")
#'
#' @importFrom assertthat assert_that is.count is.readable is.string see_if
#' @importFrom stringi stri_flatten stri_split_regex stri_sub
#' @importFrom stringi stri_subset_fixed stri_read_lines stri_detect_regex
#' @export
readHlaAlignments <- function(file,
                              gene = NULL,
                              trim = FALSE,
                              unkchar = "") {
  assert_that(
    isTRUEorFALSE(trim),
    is.string(unkchar)
  )

  if (is.null(gene)) {
    assert_that(is.readable(file))
    aln_raw <- stri_read_lines(file)
    aln <- stri_split_regex(aln_raw, "\\s+")

    # extract lines containing alignments and omit empty alignment lines
    nonempty_lines <- vapply(aln, length, integer(length = 1)) >= 2
    aln <- aln[nonempty_lines]
    allele_numbers <- vapply(aln, `[`, character(length = 1), 2)
    allele_lines <- checkAlleleFormat(allele_numbers)

    assert_that(
      see_if(any(allele_lines),
             msg = "could not find alleles numbers in the alignment file"
      )
    )
    allele_numbers <- allele_numbers[allele_lines]
    aln <- aln[allele_lines]
    assert_that(
      see_if(all(stri_detect_regex(unlist(aln), "^[A-Z0-9:*.-]*$")),
                               msg = "alignments lines contain non standard characters"
      )
    )

    tmp_aln_env <- new.env(size = 5000)
    for (i in seq_along(allele_numbers)) {
      assign(
        x = allele_numbers[i],
        value = append(
          x = get0(
            x = allele_numbers[i],
            envir = tmp_aln_env,
            ifnotfound = character(length = 0)
          ),
          values = aln[[i]][-c(1, 2)] # discard empty element and allele number
        ),
        envir = tmp_aln_env
      )
    }
    aln_list <- as.list(tmp_aln_env)[unique(allele_numbers)] # convert to list and sort

    ref_seq <- stri_flatten(aln_list[[1]])
    seq_along_ref <- seq(1, nchar(ref_seq), 1)
    ref_seq <- stri_sub(ref_seq,
                        seq_along_ref,
                        seq_along_ref
    )
    ref_len <- length(ref_seq)
    aln <- do.call(rbind,
                   lapply(aln_list,
                          function(a) {
                            a <- stri_flatten(a)
                            a <- stri_sub(a,
                                          seq_along_ref,
                                          seq_along_ref
                            )
                            i <- a == "-"
                            a[i] <- ref_seq[i]

                            return(a)
                          }
                   )
    )

    # find AA positions numbers
    aln_raw <- aln_raw[nonempty_lines]
    raw_first_codon_idx <- nchar(stri_subset_fixed(aln_raw, "Prot")[1])
    raw_alignment_line <- stri_sub(aln_raw[allele_lines][1],
                                   1,
                                   raw_first_codon_idx
    )
    raw_alignment_seq <- stri_split_regex(raw_alignment_line, "\\s+")
    raw_alignment_seq <- unlist(raw_alignment_seq)[-c(1, 2)]
    first_codon_idx <- nchar(stri_flatten(raw_alignment_seq))
    assert_that(
      see_if(is.count(first_codon_idx),
             msg = "start codon is not marked properly in the input file"
      )
    )
    if (first_codon_idx > 1) {
      aln_colnames <- c(seq(1 - first_codon_idx, -1, 1),
                        seq(1, ncol(aln) + 1 - first_codon_idx, 1)
                      )
    } else {
      aln_colnames <- seq(1, ncol(aln) + 1 - first_codon_idx, 1)
    }
    colnames(aln) <- aln_colnames

    # discard aa '5 to start codon of mature protein
    if (trim) {
      aln <- aln[, first_codon_idx:ncol(aln)]
    }
  } else {
    assert_that(is.string(gene))
    gene <- toupper(gene)
    file <- paste0(system.file("extdata", package = "midasHLA"),
                   "/",
                   gene,
                   "_prot.Rdata"
    )
    available_genes <- list.files(
      path = system.file("extdata", package = "midasHLA"),
      pattern = "_prot.Rdata$",
      full.names = TRUE
    )
    assert_that(
      see_if(file %in% available_genes,
             msg = sprintf("alignment for %s is not available", gene)
      )
    )

    cached_aln_obj <- readRDS(file) # list(readHlaAlignments(file, trim = FALSE, unkchar = "*"), first_codon_idx)
    aln <- cached_aln_obj[[1]]

    # discard aa '5 to start codon of mature protein
    if (trim) {
      first_codon_idx <- cached_aln_obj[[2]]
      aln <- aln[, first_codon_idx:ncol(aln)]
    }
  }

  # substitute unkchar
  aln[aln == "*"] <- unkchar

  return(aln)
}

#' Read KIR calls
#'
#' \code{readKirCalls} read KIR calls from file.
#'
#' Input file has to be a tsv formatted table. First column should be named
#' "ID" and contain samples IDs, further columns should hold KIR genes presence
#' / absence indicators. See
#' \code{system.file("extdata", "MiDAS_tut_KIR", package = "midasHLA")} for an
#' example.
#'
#' @inheritParams utils::read.table
#' @param file Path to input file.
#'
#' @return Data frame containing KIR gene's counts. First column hold samples 
#'   IDs, further columns hold KIR genes presence / absence indicators.
#'
#' @examples
#' file <- system.file("extdata", "MiDAS_tut_KIR.txt", package = "midasHLA")
#' readKirCalls(file)
#'
#' @importFrom assertthat assert_that is.readable see_if
#' @importFrom dplyr left_join select
#' @importFrom stats na.omit setNames
#' @export
readKirCalls <- function(file,
                         na.strings = c("", "NA", "uninterpretable")) {
  assert_that(
    is.readable(file),
    is.character(na.strings)
  )

  kir_calls <- read.table(
    file = file,
    header = TRUE,
    sep = "\t",
    stringsAsFactors = FALSE,
    na.strings = na.strings
  )
  checkKirCallsFormat(kir_calls)

  return(kir_calls)
}

context("parsing functions")

test_that("readHlaCalls", {
  file <- system.file("extdata", "MiDAS_tut_HLA.txt", package = "midasHLA")
  hla_calls <- readHlaCalls(file)
  load(system.file("extdata", "test_hla_calls.Rdata", package = "midasHLA"))
  expect_equal(hla_calls, test_hla_calls)

  hla_calls_res2 <- readHlaCalls(file, resolution = 2)
  res2 <- getAlleleResolution(unlist(hla_calls_res2[, -1]))
  load(system.file("extdata", "test_hla_calls_res.Rdata", package = "midasHLA"))
  expect_equal(res2, test_hla_calls_res)

  expect_error(readHlaCalls(file.path("path", "to", "nonexisting", "file")),
               sprintf("Path '%s' does not exist",
                       file.path("path", "to", "nonexisting", "file")
               )
  )

  expect_error(readHlaCalls(file, resolution = "foo"),
               "resolution is not a count \\(a single positive integer\\)"
  )

  expect_error(readHlaCalls(file, na.strings = 1),
               "na.strings is not a character vector"
  )

  fake_calls <- data.frame(ID = c("Sample1", "Sample2", "Sample3"),
                           A_1 = c("A*01", "A*02", "A*03"),
                           A_2 = c("A*01", "B*02", "C*03")
  )

  fake_calls_non_uniq_genes <- tempfile()
  write.table(fake_calls,
              file = fake_calls_non_uniq_genes,
              sep = "\t",
              row.names = FALSE,
              col.names = TRUE
  )
  expect_error(readHlaCalls(fake_calls_non_uniq_genes, resolution = 2),
               "Gene names in columns are not identical"
  )
  unlink(fake_calls_non_uniq_genes)

  fake_calls_NA_col <- tempfile()
  fake_calls[, 3] <- NA
  write.table(fake_calls,
              file = fake_calls_NA_col,
              sep = "\t",
              row.names = FALSE,
              col.names = TRUE
  )
  expect_error(readHlaCalls(fake_calls_NA_col, resolution = 2),
               "One of the columns contains only NA")
  unlink(fake_calls_NA_col)
})

test_that("readHlaAlignments", {
  file <- system.file("extdata", "TAP1_prot.txt", package = "midasHLA")
  # our alignment files also contain infered alignment sequences
  m <- c("TAP1*01:02N", "TAP1*03:01", "TAP1*04:01", "TAP1*05:01", "TAP1*06:01", 
         "TAP1*02:01:01", "TAP1*02:01:02", "TAP1*01:01:01:01", "TAP1*01:01:01:02", 
         "TAP1*01:01:01:03", "TAP1*01:01:01:04", "TAP1*01:01:01:05")
  hla_alignments <- readHlaAlignments(file)[m, ]
  test_hla_alignments <- readHlaAlignments(gene = "TAP1")[m, ]
  expect_equal(hla_alignments, test_hla_alignments)

  expect_error(readHlaAlignments(file.path("path", "to", "nonexisting", "file")),
               sprintf("Path '%s' does not exist",
                       file.path("path", "to", "nonexisting", "file")
               )
  )

  expect_error(
    readHlaAlignments(system.file("extdata", "A_prot.txt", package = "midasHLA"),
                      trim = c(TRUE, TRUE),
                      unkchar = ""
    ),
    "trim is not a flag \\(a length one logical vector\\)."
  )

  expect_error(
    readHlaAlignments(system.file("extdata", "A_prot.txt", package = "midasHLA"),
                      trim = TRUE,
                      unkchar = c("a", "b", "c")
    ),
    "unkchar is not a string \\(a length one character vector\\)."
  )

  expect_error(readHlaAlignments(gene = "foo"),
               "alignment for FOO is not available"
  )

  aln_file <- system.file("extdata/TAP1_prot.txt", package = "midasHLA")
  hla_alignments <- readHlaAlignments(aln_file, trim = FALSE)
  fasta_file <- system.file("extdata", "TAP1_prot.fasta", package = "midasHLA")
  fasta <- seqinr::read.alignment(fasta_file, format = "fasta")
  fasta <- fasta$seq[[1]]
  expect_equal(paste(hla_alignments["TAP1*01:01:01:01", ], collapse = ""),
               toupper(fasta)
  ) # check sequence with sequence from fasta

  hla_alignments_trim <- readHlaAlignments(aln_file, trim = TRUE)
  n_trimmed <- ncol(hla_alignments) - ncol(hla_alignments_trim)
  expect_equal(n_trimmed, 0) # check if sequence is trimmed properly

  fake_aln <- readLines(aln_file)
  fake_aln <- vapply(X = fake_aln,
                     FUN = function(x) {
                       number <- stri_split_regex(x, "\\s+")[[1]]
                       ifelse(any(checkAlleleFormat(number)), "empty ", x)
                     },
                     FUN.VALUE = character(length = 1),
                     USE.NAMES = FALSE
  )
  fake_aln_tmp <- tempfile()
  writeLines(text = fake_aln, con = fake_aln_tmp)
  expect_error(readHlaAlignments(fake_aln_tmp),
               "could not find alleles numbers in the alignment file"
  )
  unlink(fake_aln_tmp)

  # alignments lines contain non standard characters
  fake_aln <- readLines(aln_file)
  fake_aln <- vapply(X = fake_aln,
                     FUN = function(x) {
                       number <- stri_split_regex(x, "\\s+")[[1]]
                       if (any(checkAlleleFormat(number))) {
                         li <- length(number) - 1
                         number[li] <- paste(sample(c("?", ">", "<", "#", "@", "!"),
                                                    nchar(number[li]),
                                                    replace = TRUE
                                             ),
                                             collapse = ""
                                       )
                         paste(number, collapse = " ")
                       } else {
                         x
                       }
                     },
                     FUN.VALUE = character(length = 1),
                     USE.NAMES = FALSE
  )
  fake_aln_tmp <- tempfile()
  writeLines(text = fake_aln, con = fake_aln_tmp)
  expect_error(readHlaAlignments(fake_aln_tmp),
               "alignments lines contain non standard characters"
  )
  unlink(fake_aln_tmp)

  fake_aln <- readLines(aln_file)
  fake_aln[grepl("Prot", fake_aln)] <- "Prot"
  fake_aln_tmp <- tempfile()
  writeLines(text = fake_aln, con = fake_aln_tmp)
  expect_error(readHlaAlignments(fake_aln_tmp, trim=TRUE),
               "start codon is not marked properly in the input file"
  )
  unlink(fake_aln_tmp)
})

test_that("readKirCalls", {
  kpi_output <- data.frame(
    ID = c("SAM24320917", "SAM24320918"),
    KIR3DL3 = c(1L, 1L),
    KIR2DS2 = 0:1,
    KIR2DL2 = 0:1,
    KIR2DL3 = c(1L, 1L),
    KIR2DP1 = c(1L, 1L),
    KIR2DL1 = c(1L, 1L),
    KIR3DP1 = c(1L, 1L),
    KIR2DL4 = c(1L, 1L),
    KIR3DL1 = c(1L, 1L),
    KIR3DS1 = c(0L, 0L),
    KIR2DL5 = c(0L, 0L),
    KIR2DS3 = c(0L, 0L),
    KIR2DS5 = c(0L, 0L),
    KIR2DS4 = c(1L, 1L),
    KIR2DS1 = 1:0,
    KIR3DL2 = c(1L, 1L),
    stringsAsFactors = FALSE
  )
  file <- tempfile()
  write.table(
    x = kpi_output,
    file = file,
    quote = FALSE,
    sep = "\t",
    row.names = FALSE,
    col.names = TRUE
  )
  kir_calls <- readKirCalls(file)
  test_kir_calls <- kpi_output
  expect_equal(kir_calls, test_kir_calls)

  colnames(kpi_output)[1] <- "SAMID"
  write.table(
    x = kpi_output,
    file = file,
    quote = FALSE,
    sep = "\t",
    row.names = FALSE,
    col.names = TRUE
  )
  expect_error(readKirCalls(file), "Columns: 'SAMID' in kir_calls should be named 'ID'")

  kpi_output <- kpi_output[-1]
  write.table(
    x = kpi_output,
    file = file,
    quote = FALSE,
    sep = "\t",
    row.names = FALSE,
    col.names = TRUE
  )
  expect_error(readKirCalls(file), "kir_calls shiuld have 17 columns: ID, KIR3DL3, KIR2DS2, KIR2DL2, KIR2DL3, KIR2DP1, KIR2DL1, KIR3DP1, KIR2DL4, KIR3DL1, KIR3DS1, KIR2DL5, KIR2DS3, KIR2DS5, KIR2DS4, KIR2DS1, KIR3DL2")
  unlink(file)
})

#!/usr/bin/env R
devtools::load_all()

MiDAS_tut_object <- prepareMiDAS(
  hla_calls = reduceHlaCalls(MiDAS_tut_HLA, resolution = 4),
  kir_calls = MiDAS_tut_KIR,
  colData = MiDAS_tut_pheno,
  experiment = c(
    "hla_alleles",
    "hla_aa",
    "hla_g_groups",
    "hla_supertypes",
    "hla_NK_ligands",
    "kir_genes",
    "kir_haplotypes",
    "hla_kir_interactions",
    "hla_divergence",
    "hla_het"
  )
)
usethis::use_data(MiDAS_tut_object, overwrite = TRUE)

#!/usr/bin/env R
# By Migdal 2018
# Downloads HLA alignments files
# If alignment files contain sequences for multiple genes those will be split into separate files (eg. DRB genes)
library("dplyr")
library("RCurl")
library("XML")
library("rvest")
devtools::load_all()

out_dir <- "alignments"
hla_alignmnets_url <- "ftp://ftp.ebi.ac.uk/pub/databases/ipd/imgt/hla/alignments/"
hla_alignmnets_db <- getURL(hla_alignmnets_url,
                            verbose=TRUE,
                            ftp.use.epsv= FALSE,
                            dirlistonly = TRUE
)
hla_alignmnets_db <- strsplit(hla_alignmnets_db, "\n")[[1]] %>%
  grep("_prot.txt", ., value = TRUE) %>%
  grep("ClassI_prot.txt", ., invert = TRUE, value = TRUE)
for (aln in hla_alignmnets_db) {
    download.file(paste0(hla_alignmnets_url, aln), destfile = paste0(out_dir, aln))
}
# check if alignemnt files contains mixed records
multi_aln <- lapply(
  paste0(out_dir, hla_alignmnets_db),
  function(aln_file) {
    numbers <- rownames(readHlaAlignments(aln_file))
    numbers <- vapply(strsplit(numbers, "\\*"), `[[`, 1, FUN.VALUE = character(length = 1))
    return(length(unique(numbers)) > 1)
  }
) %>%
  unlist()
for (aln_file in paste0(out_dir, hla_alignmnets_db)[multi_aln]) {
  aln <-readHlaAlignments(aln_file)
  genes <- rownames(aln)
  ref_name <- genes[1]
  genes <- vapply(strsplit(genes, "\\*"), `[[`, 1, FUN.VALUE = character(length = 1))
  genes <- unique(genes)
  raw_aln <- readLines(aln_file)
  ref_seq_ids <- grep(ref_name, raw_aln, fixed = TRUE)
  for (i in 1:length(genes)) {
    keep <- ! grepl(paste(genes[-i], collapse = "|"), raw_aln)
    keep[ref_seq_ids] <- TRUE
    writeLines(text = raw_aln[keep],
               con = paste0(out_dir, genes[i], "_prot.txt"),
               sep = "\n"
    )
  }
  unlink(aln_file)
}

#' MiDAS tutorial phenotype data
#'
#' Example phenotype data used in MiDAS tutorial
#'
#' @format Data frame with 1000 rows and 4 columns.
#'   \describe{
#'     \item{ID}{Character sample ID}
#'     \item{disease}{Integer}
#'     \item{lab_value}{Numeric}
#'     \item{outcome}{Integer}
#'   }
#'
"MiDAS_tut_pheno"

#' MiDAS tutorial KIR data
#'
#' Example KIRR presence/absence data used in MiDAS tutorial
#'
#' @format Data frame with 1000 rows and 17 columns. First column holds samples
#'   ID's, following columns holds presence/absence indicators for different
#'   KIR genes.
#'   \describe{
#'     \item{ID}{Character sample ID}
#'     \item{KIR3DL3}{Integer}
#'     \item{KIR2DS2}{Integer}
#'     \item{KIR2DL2}{Integer}
#'     \item{KIR2DL3}{Integer}
#'     \item{KIR2DP1}{Integer}
#'     \item{KIR2DL1}{Integer}
#'     \item{KIR3DP1}{Integer}
#'     \item{KIR2DL4}{Integer}
#'     \item{KIR3DL1}{Integer}
#'     \item{KIR3DS1}{Integer}
#'     \item{KIR2DL5}{Integer}
#'     \item{KIR2DS3}{Integer}
#'     \item{KIR2DS5}{Integer}
#'     \item{KIR2DS4}{Integer}
#'     \item{KIR2DS1}{Integer}
#'     \item{KIR3DL2}{Integer}
#'   }
#'
"MiDAS_tut_KIR"

#' MiDAS tutorial HLA data
#'
#' Example HLA calls data used in MiDAS tutorial
#'
#' @format Data frame with 1000 rows and 19 columns. First column holds samples
#'   ID's, following columns holds HLA alleles calls for different genes.
#'   \describe{
#'     \item{ID}{Character sample ID}
#'     \item{A_1}{Character}
#'     \item{A_2}{Character}
#'     \item{B_1}{Character}
#'     \item{B_2}{Character}
#'     \item{C_1}{Character}
#'     \item{C_2}{Character}
#'     \item{DPA1_1}{Character}
#'     \item{DPA1_2}{Character}
#'     \item{DPB1_1}{Character}
#'     \item{DPB1_2}{Character}
#'     \item{DQA1_1}{Character}
#'     \item{DQA1_2}{Character}
#'     \item{DQB1_1}{Character}
#'     \item{DQB1_2}{Character}
#'     \item{DRA_1}{Character}
#'     \item{DRA_2}{Character}
#'     \item{DRB1_1}{Character}
#'     \item{DRB1_2}{Character}
#'   }
#'
"MiDAS_tut_HLA"

#' MiDAS tutorial MiDAS object
#'
#' Example MiDAS object created with data used in MiDAS tutorial: 
#' \code{MiDAS_tut_HLA}, \code{MiDAS_tut_KIR}, \code{MiDAS_tut_pheno}.
#' Used in code examlpes and unit tests.
#'
#' @format MiDAS object with following experiments defined:
#'   \describe{
#'     \item{hla_alleles}{SummarizedExperiment with 447 rows and 1000 columns}
#'     \item{hla_aa}{SummarizedExperiment with 1223 rows and 1000 columns}
#'     \item{hla_g_groups}{SummarizedExperiment with 46 rows and 1000 columns}
#'     \item{hla_supertypes}{SummarizedExperiment with 12 rows and 1000 columns}
#'     \item{hla_NK_ligands}{SummarizedExperiment with 5 rows and 1000 columns}
#'     \item{kir_genes}{SummarizedExperiment with 16 rows and 1000 columns}
#'     \item{kir_haplotypes}{SummarizedExperiment with 6 rows and 1000 columns}
#'     \item{hla_kir_interactions}{SummarizedExperiment with 29 rows and 1000 columns}
#'     \item{hla_divergence}{matrix with 4 rows and 1000 columns}
#'     \item{hla_het}{SummarizedExperiment with 9 rows and 1000 columns}
#'   }
#'  
"MiDAS_tut_object"

#' Alleles frequencies scraped from allelefrequencies.net
#'
#' Accessed on 28.07.20
#'
#' A dataset containing allele frequencies across 5697 alleles
#' For details visit the search results page in the allelefrequencies.net
#' database website.
#'
#' @format A data frame with 2096 rows and 3 variables:
#' \describe{
#'   \item{var}{allele number, character}
#'   \item{population}{reference population name, character}
#'   \item{frequency}{allele frequency in reference population, float}
#' }
#'
#' @source \url{www.allelefrequencies.net}
"allele_frequencies"

#' Grantham distance
#'
#' Integer vector giving Grantham distance values between pairs of amino acid
#' residues.
#'
#' @format Named integer vector of length 400.
#'
"dict_dist_grantham"

#' KIR genes frequencies scraped from allelefrequencies.net
#'
#' Accessed on 28.08.20
#'
#' A dataset containing KIR genes frequencies across 16 genes.
#' For details visit the search results page in the allelefrequencies.net
#' database website.
#'
#' @format A data frame with 3744 rows and 3 variables:
#' \describe{
#'   \item{var}{allele number, character}
#'   \item{population}{reference population name, character}
#'   \item{frequency}{KIR genes carrier frequency in reference population, float}
#' }
#'
#' @source \url{www.allelefrequencies.net}
"kir_frequencies"

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(collapse = TRUE)

library("dplyr")
library("kableExtra")
library("knitr")
library("midasHLA")

## ----load_pheno, echo=TRUE, warning=FALSE-------------------------------------
pheno_file <- system.file("extdata", "MiDAS_tut_pheno.txt", package = "midasHLA")
pheno <- read.table(pheno_file, header = TRUE, stringsAsFactors = FALSE)

## ----show_pheno, echo=FALSE, warning=FALSE------------------------------------
pheno %>%
  head(10) %>%
  kable() %>%
  kable_styling(bootstrap_options = c("striped", "hover", "condensed"))

## ----load_hla, echo=TRUE, warning=FALSE---------------------------------------
# HLA calls can be loaded using the readHlaCalls function with the desired resolution
hla_calls_file <- system.file("extdata", "MiDAS_tut_HLA.txt", package = "midasHLA")
hla_calls <- readHlaCalls(hla_calls_file, resolution = 4)

## ----show_hla, echo=FALSE, warning=FALSE--------------------------------------
hla_calls %>%
  head(10) %>%
  kable() %>%
  kable_styling(bootstrap_options = c("striped", "hover", "condensed")) %>%
  scroll_box(width = "100%", height = "200px")

## ----load_kir, echo=TRUE, warning=FALSE---------------------------------------
# KIR calls (currently presence/absence calls, no allele-level resolution) can be loaded using the readKirCalls function
kir_calls_file <- system.file("extdata", "MiDAS_tut_KIR.txt", package = "midasHLA")
kir_calls <- readKirCalls(kir_calls_file)

## ----show_kir, echo=FALSE, warning=FALSE--------------------------------------
kir_calls %>%
  head(10) %>%
  kable() %>%
  kable_styling(bootstrap_options = c("striped", "hover", "condensed")) %>%
  scroll_box(width = "100%", height = "200px")

## ----test_data, echo=TRUE, warning=FALSE--------------------------------------
HLA <- reduceHlaCalls(MiDAS_tut_HLA, resolution = 4)
KIR <- MiDAS_tut_KIR
pheno <- MiDAS_tut_pheno

## ----creating_midas_data_set, echo=TRUE, warning=FALSE------------------------
midas <- prepareMiDAS(
  hla_calls = HLA,
  kir_calls = KIR,
  colData = pheno,
  experiment = c("hla_alleles", "hla_aa")
  )

## ----get_freq, echo=TRUE, warning=FALSE---------------------------------------
freq <- getFrequencies(
  object = midas,
  carrier_frequency = FALSE,
  experiment = "hla_alleles",
  compare = TRUE
)

## ----show_freq, echo=FALSE, warning=FALSE-------------------------------------
kable(freq) %>%
  kable_styling(bootstrap_options = c("striped", "hover", "condensed")) %>%
  scroll_box(width = "100%", height = "200px")

## ----filter_freq, echo=TRUE, warning=FALSE------------------------------------
midas <-
  filterByFrequency(
    object = midas,
    experiment = "hla_alleles",
    lower_frequency_cutoff = 0.01
    )

## ----model definition, echo=TRUE, warning=FALSE-------------------------------
# Logistic regression
object <- glm(disease ~ term, data = midas, family = binomial(link = "logit"))

## ----association_analysis, echo=TRUE, warning=FALSE---------------------------
results <-
  runMiDAS(
    object = object,
    experiment = "hla_alleles",
    inheritance_model = "dominant",
    conditional = FALSE,
    omnibus = FALSE,
    lower_frequency_cutoff = 0.05
    )

kableResults(results)

#' Association analysis
#'
#' \code{analyzeAssociations} perform association analysis on a single variable
#' level using a statistical model of choice.
#'
#' \code{correction} specifies p-value adjustment method to use, common choice
#' is Benjamini & Hochberg (1995) (\code{"BH"}). Internally this is passed to
#' \link[stats]{p.adjust}.
#'
#' @inheritParams updateModel
#' @param variables Character vector specifying variables to use in association
#'   tests.
#' @param placeholder String specifying term in \code{object}'s formula which
#'   should be substituted with variables during analysis.
#' @param correction String specifying multiple testing correction method. See
#'   details for further information.
#' @param n_correction Integer specifying number of comparisons to consider
#'   during multiple testing correction calculations. For Bonferroni correction
#'   it is possible to specify a number lower than the number of comparisons
#'   being made. This is useful in cases when knowledge about the biology or
#'   redundance of alleles reduces the need for correction. For other methods it
#'   must be at least equal to the number of comparisons being made; only set
#'   this (to non-default) when you know what you are doing!
#' @param exponentiate Logical flag indicating whether or not to exponentiate
#'   the coefficient estimates. Internally this is passed to
#'   \code{\link[broom]{tidy}}. This is typical for logistic and multinomial
#'   regressions, but a bad idea if there is no log or logit link. Defaults to
#'   FALSE.
#'
#' @return Tibble containing combined results for all \code{variables}. The 
#'   first column \code{"term"} hold the names of \code{variables}. Further
#'   columns depends on the used model and are determined by associated 
#'   \code{tidy} function. Generally they will include \code{"estimate"}, 
#'   \code{"std.error"}, \code{"statistic"}, \code{"p.value"}, \code{"conf.low"},
#'   \code{"conf.high"}, \code{"p.adjusted"}.
#'
#' @examples
#' midas <- prepareMiDAS(hla_calls = MiDAS_tut_HLA,
#'                       colData = MiDAS_tut_pheno,
#'                       experiment = "hla_alleles")
#'
#' # analyzeAssociations expects model data to be a data.frame
#' midas_data <- as.data.frame(midas)
#'
#' # define base model
#' object <- lm(disease ~ term, data = midas_data)
#'
#' # test for alleles associations
#' analyzeAssociations(object = object,
#'                     variables = c("B*14:02", "DRB1*11:01"))
#'
#' @importFrom assertthat assert_that see_if is.string
#' @importFrom broom tidy
#' @importFrom dplyr bind_rows
#' @export
analyzeAssociations <- function(object,
                                variables,
                                placeholder = "term",
                                correction = "bonferroni",
                                n_correction = NULL,
                                exponentiate = FALSE) {
  assert_that(
    checkStatisticalModel(object),
    hasTidyMethod(class(object)[1L])
  )
  object_call <- getCall(object)
  object_env <- attr(object$terms, ".Environment")
  object_data <- eval(object_call[["data"]], envir = object_env)
  object_variables <- colnames(object_data)[-1]

  assert_that(
    is.character(variables),
    see_if(
      all(test_vars <- variables %in% object_variables) | is.null(variables),
      msg = sprintf("%s can not be found in object data",
                    paste(variables[! test_vars], collapse = ", ")
      )
    ),
    is.string(placeholder),
    objectHasPlaceholder(object, placeholder),
    is.string(correction),
    isCountOrNULL(n_correction),
    isTRUEorFALSE(exponentiate)
  )

  results <- iterativeModel(object, placeholder, variables, exponentiate)

  nc <- ifelse(is.null(n_correction), length(results$p.value), n_correction)
  assert_that(
    nc >= length(results$p.value) || correction == "bonferroni",
    msg = sprintf("n_correction must be at least %i.", length(results$p.value))
  )
  results$p.adjusted <- adjustPValues(
    p = results$p.value,
    method = correction,
    n = nc
  )

  if (nrow(results) == 0) {
    warn("None of the variables could be tested. Returning empty table.")
  }

  return(results)
}

#' Stepwise conditional association analysis
#'
#' \code{analyzeConditionalAssociations} perform stepwise conditional testing
#' adding the previous top-associated variable as covariate, until there are no
#' more significant variables based on a self-defined threshold.
#'
#' @inheritParams updateModel
#' @inheritParams analyzeAssociations
#' @param th Number specifying threshold for a variable to be considered
#'   significant.
#' @param th_adj Logical flag indicating if adjusted p-value should be used as
#'   threshold criteria, otherwise unadjusted p-value is used.
#' @param keep Logical flag indicating if the output should be a list of results
#'   resulting from each selection step. Default is to return only the final
#'   result.
#' @param rss_th Number specifying residual sum of squares threshold at which
#'   function should stop adding additional variables. As the residual sum of
#'   squares approaches \code{0} the perfect fit is obtained making further
#'   attempts at variable selection nonsense. This behavior can be controlled
#'   using \code{rss_th}.
#'
#' @return Tibble with stepwise conditional testing results or a list of tibbles,
#'  see \code{keep} argument. The first column \code{"term"} hold the names of 
#'  \code{variables}. Further columns depends on the used model and are 
#'  determined by associated \code{tidy} function. Generally they will include 
#'  \code{"estimate"}, \code{"std.error"}, \code{"statistic"}, \code{"p.value"}, 
#'  \code{"conf.low"}, \code{"conf.high"}, \code{"p.adjusted"}.
#'
#' @examples
#' midas <- prepareMiDAS(hla_calls = MiDAS_tut_HLA,
#'                       colData = MiDAS_tut_pheno,
#'                       experiment = "hla_alleles")
#'
#' # analyzeConditionalAssociations expects model data to be a data.frame
#' midas_data <- as.data.frame(midas)
#'
#' # define base model
#' object <- lm(disease ~ term, data = midas_data)
#' analyzeConditionalAssociations(object,
#'                             variables = c("B*14:02", "DRB1*11:01"),
#'                             th = 0.05)
#'
#' @importFrom assertthat assert_that is.number is.string
#' @importFrom dplyr bind_rows tibble
#' @importFrom rlang warn
#' @importFrom stats formula resid
#' @export
analyzeConditionalAssociations <- function(object,
                                           variables,
                                           placeholder = "term",
                                           correction = "bonferroni",
                                           n_correction = NULL,
                                           th,
                                           th_adj = TRUE,
                                           keep = FALSE,
                                           rss_th = 1e-07,
                                           exponentiate = FALSE) {
  assert_that(
    checkStatisticalModel(object),
    hasTidyMethod(class(object)[1L])
  )
  object_call <- getCall(object)
  object_env <- attr(object$terms, ".Environment")
  object_formula <- eval(object_call[["formula"]], envir = object_env)
  object_data <- eval(object_call[["data"]], envir = object_env)
  object_variables <- colnames(object_data)[-1]

  assert_that(
    is.character(variables),
    see_if(
      all(test_vars <- variables %in% object_variables),
      msg = sprintf("%s can not be found in object data",
                    paste(variables[! test_vars], collapse = ", ")
      )
    ),
    is.string(placeholder),
    objectHasPlaceholder(object, placeholder),
    is.string(correction),
    isCountOrNULL(n_correction),
    is.number(th),
    isTRUEorFALSE(keep),
    is.number(rss_th),
    isTRUEorFALSE(exponentiate)
  )

  # select optimization criteria
  crit <- ifelse(th_adj, "p.adjusted", "p.value")

  prev_formula <- object_formula
  first_variables <- all.vars(object_formula)
  prev_variables <- first_variables
  new_variables <- variables[! variables %in% prev_variables]

  best <- list()
  i <- 1
  while (length(new_variables) > 0) {
    # reorder object formula such that 'term' is at the end, otherwise TL;DR
    # when the new covariates are added to the model formula start to look like
    # this: resp ~ term + A + B + C
    # as a result if any of the new variables have the same effect
    # as any old one (say X = c(0, 0, 1, 1), Z = c(0, 0, 1, 1)),
    # it won't be corrected for and we will get multiple vars with same estimate
    # instead formula should look like resp ~ A + B + C + term
    new_form <- paste0(". ~ . - ", placeholder, " + ", placeholder)
    object <- update(object, new_form, evaluate = FALSE)
    object <- eval(object, envir = object_env)

    results <- iterativeModel(object, placeholder, new_variables, exponentiate)

    nc <- ifelse(is.null(n_correction), length(results$p.value), n_correction)
    assert_that(
      nc >= length(results$p.value) || correction == "bonferroni",
      msg = sprintf("n_correction must be at least %i.", length(results$p.value))
    )
    results$p.adjusted <- adjustPValues(
      p = results$p.value,
      method = correction,
      n = nc
    )

    results <- results[! is.infinite(results[["p.value"]]), ]

    mask <- ! prev_variables %in% first_variables
    results$covariates <- paste(prev_variables[mask], collapse = " + ")

    i_min <- which.min(results[[crit]])
    if (length(i_min) == 0) break
    if (results[[crit]][i_min] > th) break

    object <- updateModel(object,
                          results$term[i_min],
                          backquote = TRUE,
                          collapse = " + "
    )

    if (sum(resid(object) ^ 2) <= rss_th) {
      warn("Perfect fit was reached attempting further model selection is nonsense.")
      break
    }
    prev_formula <- formula(object)
    prev_variables <- all.vars(prev_formula)
    new_variables <- variables[! variables %in% prev_variables]

    results$term <- gsub("`", "", results$term)
    best[[i]] <- results
    i <- i + 1
  }

  if (length(best) == 0) {
    warn("No significant variables found. Returning empty table.") # Tibble to be more precise?
  }

  if (keep) {
    results <- best
  } else {
    if (length(best) == 0) {
      results <- results[0, ]
    } else {
      results <- lapply(best, function(res) {
        i_min <- which.min(res[["p.value"]])
        res[i_min, ]
      })
      results <- bind_rows(results)
    }
  }

  return(results)
}

#' Omnibus test
#'
#' \code{OmnibusTest} calculates overall p-value for linear combination of
#' variables using likelihood ratio test.
#'
#' Likelihood ratio test is conducted by comparing a model given in an
#' \code{object} with an extended model, that is created by including the effect
#' of variables given in \code{variables} as their linear combination.
#'
#' @inheritParams analyzeAssociations
#' @param omnibus_groups List of character vectors giving sets of variables for
#'  which omnibus test should be applied.
#'
#' @return Data frame with columns:
#'   \itemize{
#'     \item{"group"}{ Omnibus group name}
#'     \item{"term"}{ Elements of omnibus group added to base model}
#'     \item{"df"}{ Difference in degrees of freedom between base and extended model}
#'     \item{"logLik"}{ Difference in log likelihoods between base and extended model}
#'     \item{"statistic"}{ Chisq statistic}
#'     \item{"p.value"}{ P-value}
#'     \item{"p.adjusted"}{ Adjusted p-value}
#'   }
#'
#' @examples
#' midas <- prepareMiDAS(hla_calls = MiDAS_tut_HLA,
#'                       colData = MiDAS_tut_pheno,
#'                       experiment = "hla_aa")
#'
#' # define base model
#' object <- lm(disease ~ term, data = midas)
#' omnibusTest(object,
#'             omnibus_groups = list(
#'               A_29 = c("A_29_D", "A_29_A"),
#'               A_43 = c("A_43_Q", "A_43_R")
#'             ))
#'
#' @importFrom dplyr bind_cols
#' @export
omnibusTest <- function(object,
                        omnibus_groups,
                        placeholder = "term",
                        correction = "bonferroni",
                        n_correction = NULL) {
  results <- iterativeLRT(object, placeholder, omnibus_groups)

  nc <- ifelse(is.null(n_correction), length(results$p.value), n_correction)
  assert_that(
    nc >= length(results$p.value) || correction == "bonferroni",
    msg = sprintf("n_correction must be at least %i.", length(results$p.value))
  )
  results$p.adjusted <- adjustPValues(
    p = results$p.value,
    method = correction,
    n = nc
  )

  return(results)
}

#' Run MiDAS statistical analysis
#'
#' \code{runMiDAS} perform association analysis on MiDAS data using statistical
#' model of choice. Function is intended for use with \code{\link{prepareMiDAS}}.
#' See examples section.
#'
#' By default statistical analysis is performed iteratively on each variable in
#' selected experiment. This is done by substituting \code{placeholder} in the
#' \code{object}'s formula with each variable in the experiment.
#'
#' Setting \code{conditional} argument to \code{TRUE} will cause the statistical
#' analysis to be performed in a stepwise conditional testing manner, adding the
#' previous top-associated variable as a covariate to \code{object}'s formula.
#' The analysis stops when there is no more significant variables, based on
#' self-defined threshold (\code{th} argument). Either adjusted or unadjusted
#' p-values can be used as the selection criteria, which is controlled using
#' \code{th_adj} argument.
#'
#' Setting \code{omnibus} argument to \code{TRUE} will cause the statistical
#' analysis to be performed iteratively on groups of variables (like residues at
#' particular amino acid position) using likelihood ratio test.
#'
#' Argument \code{inheritance_model} specifies the inheritance model that should
#' be applyed to experiment's data. Following choices are available: 
#' \itemize{
#'   \item{"dominant"}{
#'     carrier status is sufficient for expression of the phenotype (non-carrier: 
#'     0, heterozygous & homozygous carrier: 1).
#'   }
#'   \item{"recessive"}{
#'     two copies are required for expression of the phenotype (non-carrier & 
#'     heterozygous carrier: 0, homozygous carrier: 1).
#'   }
#'   \item{"additive"}{
#'     allele dosage matters, homozygous carriers show stronger phenotype 
#'     expression or higher risk than heterozygous carriers (non-carrier = 0, 
#'     heterozygous carrier = 1, homozygous carrier = 2).
#'   }
#'   \item{"overdominant"}{
#'     heterozygous carriers are at higher risk compared to non-carriers or 
#'     homozygous carriers (non-carrier & homozygous carrier = 0, heterozygous 
#'     carrier = 1).
#'   }
#' }  
#'  
#' \code{correction} specifies p-value adjustment method to use, common choice
#' is Benjamini & Hochberg (1995) (\code{"BH"}). Internally this is passed to
#' \link[stats]{p.adjust}.
#'
#' @inheritParams analyzeAssociations
#' @inheritParams analyzeConditionalAssociations
#' @inheritParams filterByFrequency
#' @inheritParams applyInheritanceModel
#' @param experiment String indicating the experiment associated with
#'   \code{object}'s \code{MiDAS} data to use. Valid values includes:
#'   \code{"hla_alleles"}, \code{"hla_aa"}, \code{"hla_g_groups"},
#'   \code{"hla_supertypes"}, \code{"hla_NK_ligands"}, \code{"kir_genes"},
#'   \code{"kir_haplotypes"}, \code{"hla_kir_interactions"},
#'   \code{"hla_divergence"}, \code{"hla_het"}, \code{"hla_custom"},
#'   \code{"kir_custom"}. See \code{\link{prepareMiDAS}} for more information.
#' @param conditional Logical flag indicating if conditional analysis should be
#'   performed.
#' @param omnibus Logical flag indicating if omnibus test should be used.
#' @param omnibus_groups_filter Character vector specifying omnibus groups to
#'   use.
#'
#' @return Analysis results, depending on the parameters:
#'   \describe{
#'     \item{\code{conditional=FALSE, omnibus=FALSE}}{
#'       Tibble with first column \code{"term"} holding names of tested 
#'       variables (eg. alleles). Further columns depends on the used 
#'       model and are determined by associated \code{tidy} function. Generally 
#'       they will include \code{"estimate"}, \code{"std.error"}, 
#'       \code{"statistic"}, \code{"p.value"}, \code{"conf.low"}, 
#'       \code{"conf.high"}, \code{"p.adjusted"}.
#'     }
#'     \item{\code{conditional=TRUE, omnibus=FALSE}}{
#'       Tibble or a list of tibbles, see \code{keep} argument. The first column 
#'       \code{"term"} hold names of tested variables. Further 
#'       columns depends on the used model and are determined by associated 
#'       \code{tidy} function. Generally they will include \code{"estimate"}, 
#'       \code{"std.error"}, \code{"statistic"}, \code{"p.value"}, 
#'       \code{"conf.low"}, \code{"conf.high"}, \code{"p.adjusted"}.
#'     }
#'     \item{\code{conditional=FALSE, omnibus=TRUE}}{
#'       Tibble with first column holding names of tested omnibus groups 
#'       (eg. amino acid positions) and second names of variables in the group
#'       (eg. residues). Further columns are: \code{"df"} giving difference in 
#'       degrees of freedom between base and extended model, \code{"statistic"}
#'       giving Chisq statistic, \code{"p.value"} and \code{"p.adjusted"}.
#'     }
#'     \item{\code{conditional=TRUE, omnibus=TRUE}}{
#'       Tibble or a list of tibbles, see \code{keep} argument. The first column 
#'       hold names of tested omnibus groups (eg. amino acid positions), second 
#'       column hold names of variables in the group (eg. residues). Further 
#'       columns are: \code{"df"} giving difference in degrees of freedom 
#'       between base and extended model, \code{"statistic"} giving Chisq 
#'       statistic, \code{"p.value"} and \code{"p.adjusted"}.
#'     }
#'   }
#'   
#' @examples
#' # create MiDAS object
#' midas <- prepareMiDAS(hla_calls = MiDAS_tut_HLA,
#'                       colData = MiDAS_tut_pheno,
#'                       experiment = c("hla_alleles", "hla_aa")
#' )
#'
#' # construct statistical model
#' object <- lm(disease ~ term, data = midas)
#'
#' # run analysis
#' runMiDAS(object, experiment = "hla_alleles", inheritance_model = "dominant")
#'
#' # omnibus test
#' # omnibus_groups_filter argument can be used to restrict omnibus test only
#' # to selected variables groups, here we restrict the analysis to HLA-A
#' # positions 29 and 43.
#' runMiDAS(
#'   object,
#'   experiment = "hla_aa",
#'   inheritance_model = "dominant",
#'   omnibus = TRUE,
#'   omnibus_groups_filter = c("A_29", "A_43")
#' )
#'
#' @importFrom assertthat assert_that is.number is.number is.string
#' @importFrom dplyr arrange as_tibble bind_rows mutate rename select
#' @importFrom magrittr %>%
#' @importFrom stats formula
#' @importFrom rlang call_modify warn !! :=
#' @export
runMiDAS <- function(object,
                     experiment,
                     inheritance_model = NULL,
                     conditional = FALSE,
                     omnibus = FALSE,
                     omnibus_groups_filter = NULL,
                     lower_frequency_cutoff = NULL,
                     upper_frequency_cutoff = NULL,
                     correction = "bonferroni",
                     n_correction = NULL,
                     exponentiate = FALSE,
                     th = 0.05,
                     th_adj = TRUE,
                     keep = FALSE,
                     rss_th = 1e-07
                    ) {
  assert_that(
    checkStatisticalModel(object),
    hasTidyMethod(class(object)[1L])
  )
  object_details <- getObjectDetails(object)

  assert_that(
    see_if(
      isClass(object_details$data, "MiDAS"),
      msg = "data associated with statistical model must be an instance of MiDAS class."
    ),
    validObject(object_details$data),
    objectHasPlaceholder(object, getPlaceholder(object_details$data)),
    is.string(experiment),
    stringMatches(experiment, choice = getExperiments(object_details$data)),
    isStringOrNULL(inheritance_model),
    isTRUEorFALSE(conditional),
    isTRUEorFALSE(omnibus),
    isCharacterOrNULL(omnibus_groups_filter),
    validateFrequencyCutoffs(lower_frequency_cutoff, upper_frequency_cutoff),
    is.string(correction),
    isCountOrNULL(n_correction),
    isTRUEorFALSE(exponentiate)
  )

  # convert experiment to specifed inheritance model
  if (isExperimentInheritanceModelApplicable(object_details$data[[experiment]])) {
    assert_that(
      is.string(inheritance_model),
      characterMatches(inheritance_model, c("dominant", "recessive", "additive", "overdominant"))
    )
    object_details$data[[experiment]] <- applyInheritanceModel(
      experiment = object_details$data[[experiment]],
      inheritance_model = inheritance_model
    )
  } else if (is.string(inheritance_model)) {
    warn(sprintf("Inheritance model can not be applied to experiment %s. Continuing without it.", experiment))
  }

  if (! is.null(omnibus_groups_filter)) {
    object_details$data <-
      filterByOmnibusGroups(
        object = object_details$data,
        experiment = experiment,
        groups = omnibus_groups_filter
      )
  }

  if (! is.null(lower_frequency_cutoff) || ! is.null(upper_frequency_cutoff)) {
    object_details$data <-
      filterByFrequency(
        object = object_details$data,
        experiment = experiment,
        lower_frequency_cutoff = lower_frequency_cutoff,
        upper_frequency_cutoff = upper_frequency_cutoff
      )
  }

  assert_that(
    length(suppressMessages(object_details$data[, , experiment])) != 0,
    msg = "No variables available for analysis, please revisit your filtration criteria."
  )

  args <- list(
    call = object_details$call,
    midas = object_details$data,
    experiment = experiment,
    test_covar = object_details$formula_vars[1],
    correction = correction,
    n_correction = n_correction,
    exponentiate = exponentiate,
    th = th,
    th_adj = th_adj,
    keep = keep,
    rss_th = rss_th
  )

  results <- if (! conditional && ! omnibus) {
    do.call(runMiDAS_linear, args)
  } else if (conditional && ! omnibus) {
    do.call(runMiDAS_conditional, args)
  } else if (! conditional && omnibus) {
    do.call(runMiDAS_linear_omnibus, args)
  } else if (conditional && omnibus) {
    do.call(runMiDAS_conditional_omnibus, args)
  }

  return(results)
}

#
runMiDAS_linear <- function(call,
                            midas,
                            experiment,
                            test_covar,
                            correction = "bonferroni",
                            n_correction = NULL,
                            exponentiate = FALSE,
                            ...) {
  test_var <- rownames(midas[[experiment]])
  placeholder <- getPlaceholder(midas)

  # insert data for analysis
  data <- as.data.frame(midas)
  call <- call_modify(substitute(call), data = data)
  object <- eval(call)

  # run analysis
  results <- analyzeAssociations(object,
                                 variables = test_var,
                                 placeholder = placeholder,
                                 correction = correction,
                                 n_correction = n_correction,
                                 exponentiate = exponentiate
  )

  assert_that(
    nrow(results) > 0,
    msg = "Could not process any variables. Please check warning messages for more information (warnings())."
  )

  # oreder results columns
  col_ord <- c("term", "p.value", "p.adjusted", "estimate", "std.error",
               "conf.low", "conf.high", "statistic")
  if (all(col_ord  %in% colnames(results))) {
    col_ord <- c(col_ord, colnames(results)[! colnames(results) %in% col_ord]) # append columns not specified in col_ord
    results <- results[, col_ord]
  }

  # format linear results
  ## add variables frequencies
  if (isExperimentCountsOrZeros(midas[[experiment]])) {
    results <-
      left_join(
        results,
        runMiDASGetVarsFreq(
          midas = midas,
          experiment = experiment,
          test_covar = test_covar
        ),
        by = "term"
      )
  }

  ## rename term
  term_name <- switch (experiment,
                       "hla_alleles" = "allele",
                       "hla_aa" = "aa",
                       "expression_level" = "allele",
                       "hla_g_groups" = "g.group",
                       "hla_supertypes" = "supertype",
                       "hla_NK_ligands" = "allele.group",
                       "kir_genes" = "kir.gene",
                       "hla_kir_interactions" = "hla.kir.interaction",
                       "term"
  )
  results <- rename(results, !! term_name := .data$term) %>%
    arrange(.data$p.value)

  return(results)
}

#
runMiDAS_conditional <- function(call,
                                 midas,
                                 experiment,
                                 test_covar,
                                 correction = "bonferroni",
                                 n_correction = NULL,
                                 exponentiate = FALSE,
                                 th = 0.05,
                                 th_adj = TRUE,
                                 keep = FALSE,
                                 rss_th = 1e-07,
                                 ...) {
  # get test covariates names
  test_var <- rownames(midas[[experiment]])
  placeholder <- getPlaceholder(midas)

  # insert data for analysis
  data <- as.data.frame(midas)
  call <- call_modify(substitute(call), data = data)
  object <- eval(call)

  # run analysis
  results <- analyzeConditionalAssociations(
    object,
    variables = test_var,
    placeholder = placeholder,
    correction = correction,
    n_correction = n_correction,
    th = th,
    th_adj = th_adj,
    keep = keep,
    rss_th = rss_th,
    exponentiate = exponentiate
  )

  assert_that(
    ! (nrow(results) == 0 && ! keep) || ! (length(results) == 0 && keep),
    msg = "Could not process any variables. Please check warning messages for more information (warnings())."
  )

 # oreder results columns
 col_ord <- c("term", "p.value", "p.adjusted", "estimate", "std.error",
              "conf.low", "conf.high", "statistic", "covariates")
 if (all(col_ord %in% colnames(results))) {
   col_ord <- c(col_ord, colnames(results)[! colnames(results) %in% col_ord]) # append columns not specified in col_ord
   results <- results[, col_ord]
 }

  # format conditional results
  term_name <- switch (experiment,
                       "hla_alleles" = "allele",
                       "hla_aa" = "aa",
                       "expression_level" = "allele",
                       "hla_g_groups" = "g.group",
                       "hla_supertypes" = "supertype",
                       "hla_NK_ligands" = "allele.group",
                       "kir_genes" = "kir.gene",
                       "hla_kir_interactions" = "hla.kir.interaction",
                       "term"
  )

  if (isExperimentCountsOrZeros(midas[[experiment]])) {
    if (keep) {
      results <- lapply(
        X = results,
        FUN = function(x) {
          x <-
            left_join(
              x,
              runMiDASGetVarsFreq(
                midas = midas,
                experiment = experiment,
                test_covar = test_covar
              ),
              by = "term"
            )
          rename(.data = x, !! term_name := .data$term) %>%
            arrange(.data$p.value)
        }
      )
    } else {
      results <-
        left_join(
          results,
          runMiDASGetVarsFreq(
            midas = midas,
            experiment = experiment,
            test_covar = test_covar
          ),
          by = "term"
        )
      results <- rename(results, !! term_name := .data$term) %>%
        arrange(.data$p.value)
    }
  }

  return(results)
}

#
runMiDAS_linear_omnibus <- function(call,
                                    midas,
                                    experiment,
                                    test_covar,
                                    correction = "bonferroni",
                                    n_correction = NULL,
                                    exponentiate = FALSE,
                                    ...) {
  omnibus_groups <- getOmnibusGroups(midas, experiment)
  assert_that(
    ! is.null(omnibus_groups),
    msg = sprintf("Omnibus test does not support experiment %s", experiment)
  )
  test_var <- rownames(midas[[experiment]])
  placeholder <- getPlaceholder(midas)

  # insert data for analysis
  data <- as.data.frame(midas)
  call <- call_modify(substitute(call), data = data)
  object <- eval(call)

  # run analysis
  results <- omnibusTest(object = object,
                         omnibus_groups = omnibus_groups,
                         placeholder = placeholder,
                         correction = correction,
                         n_correction = n_correction
  )

  assert_that(
    nrow(results) > 0,
    msg = "Could not process any variables. Please check warning messages for more information (warnings())."
  )

  # format linear omnibus results
  group_name <- switch (experiment,
                       "hla_aa" = "aa_pos",
                       "group"
  )
  term_prefix <- switch (experiment,
                         "hla_aa" = "[A-Z0-9]+_-*[0-9]+_",
                         ""
  )
  term_name <- switch (experiment,
                       "hla_aa" = "residues",
                       "term"
  )
  results <- results %>%
    as_tibble() %>%
    mutate(term = gsub(term_prefix, "", .data$term)) %>%
    select(
      !! group_name := .data$group,
      !! term_name := .data$term,
      .data$df,
      .data$statistic,
      .data$p.value,
      .data$p.adjusted
    ) %>%
    arrange(.data$p.value)

  return(results)
}

#
runMiDAS_conditional_omnibus <- function(call,
                                         midas,
                                         experiment,
                                         test_covar,
                                         correction = "bonferroni",
                                         n_correction = NULL,
                                         keep = FALSE,
                                         th,
                                         rss_th = 1e-07,
                                         exponentiate = FALSE,
                                         ...) {
  omnibus_groups <- getOmnibusGroups(midas, experiment)
  assert_that(
    is.flag(keep),
    is.number(th),
    is.number(rss_th),
    ! is.null(omnibus_groups),
    msg = sprintf("Omnibus test does not support experiment %s", experiment)
  )
  placeholder <- getPlaceholder(midas)

  # insert data for analysis
  data <- as.data.frame(midas)
  call <- call_modify(substitute(call), data = data)
  object <- eval(call)

  # run analysis
  prev_formula <- formula(object)
  first_variables <- all.vars(prev_formula)
  prev_omnibus_groups <- c()
  new_omnibus_groups <-
    omnibus_groups[! names(omnibus_groups) %in% first_variables]

  best <- list()
  i <- 1
  while (length(new_omnibus_groups) > 0) {
    # reorder object formula such that 'term' is at the end, otherwise TL;DR
    # when the new covariates are added to the model formula start to look like
    # this: resp ~ term + A + B + C
    # as a result if any of the new variables have the same effect
    # as any old one (say X = c(0, 0, 1, 1), Z = c(0, 0, 1, 1)),
    # it won't be corrected for and we will get multiple vars with same estimate
    # instead formula should look like resp ~ A + B + C + term
    new_form <- paste0(". ~ . - ", placeholder, " + ", placeholder)
    object <- update(object, new_form)

    results <- omnibusTest(
      object = object,
      omnibus_groups = new_omnibus_groups,
      placeholder = placeholder,
      correction = correction,
      n_correction = n_correction
    )

    results <- results[! is.infinite(results[["p.value"]]), ]

    mask <- ! prev_omnibus_groups %in% first_variables
    results$covariates <-
      paste(prev_omnibus_groups[mask], collapse = " + ")

    i_min <- which.min(results[["p.value"]])
    if (length(i_min) == 0) break
    if (results$p.value[i_min] > th) break

    gr_name <- results$group[i_min]
    prev_omnibus_groups <- c(prev_omnibus_groups, gr_name)
    object <- updateModel(object,
                          omnibus_groups[[gr_name]],
                          backquote = TRUE,
                          collapse = " + "
    )

    if (sum(resid(object) ^ 2) <= rss_th) {
      warn("Perfect fit was reached attempting further model selection is nonsense.")
      break
    }
    prev_formula <- formula(object)
    prev_variables <- all.vars(prev_formula)
    new_omnibus_groups <-
      new_omnibus_groups[! names(new_omnibus_groups) %in% prev_omnibus_groups]

    results$term <- gsub("`", "", results$term)
    best[[i]] <- results
    i <- i + 1
  }

  if (length(best) == 0) {
    warn("No significant variables found. Returning empty table.") # Tibble to be more precise?
  }

  if (keep) {
    results <- best
  } else {
    if (length(best) == 0) {
      results <- results[0,]
    } else {
      results <- lapply(best, function(res) {
        i_min <- which.min(res[["p.value"]])
        res[i_min,]
      })
      results <- bind_rows(results)
    }
  }

  # format linear omnibus results
  group_name <- switch (experiment,
                        "hla_aa" = "aa_pos",
                        "group"
  )
  term_prefix <- switch (experiment,
                         "hla_aa" = "[A-Z0-9]+_-*[0-9]+_",
                         ""
  )
  term_name <- switch (experiment,
                       "hla_aa" = "residues",
                       "term"
  )

  .formatResults <- function(df) {
    df %>%
      as_tibble() %>%
      mutate(term = gsub(term_prefix, "", .data$term)) %>%
      select(
        !! group_name := .data$group,
        !! term_name := .data$term,
        .data$df,
        .data$statistic,
        .data$p.value,
        .data$p.adjusted,
        .data$covariates
      ) %>%
      arrange(.data$p.value)
  }
  if (keep) {
    results <- lapply(results, .formatResults)
  } else {
    results <- .formatResults(results)
  }

  return(results)
}

#' Test for Hardy Weinberg equilibrium
#'
#' Test experiment features for Hardy Weinberg equilibrium.
#'
#' Setting \code{as.MiDAS} to \code{TRUE} will filter MiDAS object based on
#' p-value cut-off given by \code{HWE_cutoff}.
#'
#' @param object \code{\link{MiDAS}} object.
#' @param experiment String specifying experiment to test. Valid values
#'   includes \code{"hla_alleles"}, \code{"hla_aa"}, \code{"hla_g_groups"},
#'   \code{"hla_supertypes"}, \code{"hla_NK_ligands"}.
#' @param HWE_group Expression defining samples grouping to test for Hardy
#'   Weinberg equilibrium. By default samples are not grouped.
#' @param HWE_cutoff Number specifying p-value threshold. When \code{HWE_group}
#'   is specified both groups are thresholded.
#' @param as.MiDAS Logical flag indicating if MiDAS object should be returned.
#'
#' @return Data frame with Hardy Weinberg Equilibrium test results or a filtered
#'   MiDAS object.
#'
#' @examples
#' # create MiDAS object
#' midas <- prepareMiDAS(hla_calls = MiDAS_tut_HLA,
#'                       colData = MiDAS_tut_pheno,
#'                       experiment = "hla_alleles"
#' )
#'
#' # get HWE p-values as data frame
#' HWETest(midas, experiment = "hla_alleles")
#'
#' # get HWE in groups defined by disease status
#' # grouping by `disease == 1` will divide samples into two groups:
#' # `disease == 1` and `not disease == 1`
#' HWETest(midas, experiment = "hla_alleles", HWE_group = disease == 1)
#'
#' # filter MiDAS object by HWE test p-value
#' HWETest(midas, experiment = "hla_alleles", HWE_cutoff = 0.05, as.MiDAS = TRUE)
#'
#' @importFrom HardyWeinberg HWChisqStats
#' @importFrom assertthat assert_that is.string
#' @importFrom methods validObject
#' @importFrom SummarizedExperiment assay
#' @importFrom MultiAssayExperiment colData
#' @export
HWETest <-
  function(object,
           experiment = c("hla_alleles", "hla_aa", "hla_g_groups", "hla_supertypes", "hla_NK_ligands"),
           HWE_group = NULL,
           HWE_cutoff = NULL,
           as.MiDAS = FALSE) {
    experiment_choice <- eval(formals()[["experiment"]])
    assert_that(
      isClass(object, "MiDAS"),
      validObject(object),
      is.string(experiment),
      stringMatches(experiment, experiment_choice),
      isNumberOrNULL(HWE_cutoff),
      isTRUEorFALSE(as.MiDAS)
    )

    if (is(object[[experiment]], "SummarizedExperiment")) {
      x <- assay(object[[experiment]])
    } else {
      x <- object[[experiment]]
    }
    HWE_group <- substitute(HWE_group)
    if (is.null(HWE_group)) {
      X <- list(p.value = x)
    } else {
      colData <-
        do.call(subset,
                list(
                  x = colData(object),
                  subset = HWE_group
                )
        )
      subset_ids <- rownames(colData)
      X <- list(
        x[, colnames(x) %in% subset_ids],
        x[, ! colnames(x) %in% subset_ids]
      )
      names(X) <- c(deparse(HWE_group), paste0("not ", deparse(HWE_group)))
    }

    HWE.result <- data.frame(
      var = rownames(object[[experiment]]),
      stringsAsFactors = FALSE
    )
    for (i in seq_along(X)) {
      HWE.pvalue <- apply( # get haplotypes for each variable
        X = X[[i]],
        MARGIN = 1,
        FUN = function(x) {
          c(
            AA = sum(x == 0, na.rm = TRUE),
            AB = sum(x == 1, na.rm = TRUE),
            BB = sum(x == 2, na.rm = TRUE)
          )
        }
      ) %>%
        t() %>%
        HWChisqStats(x.linked = FALSE, pvalues = TRUE)
      nm <- names(X)[[i]]
      HWE.result[[nm]] <- HWE.pvalue[HWE.result$var] # NAs will be inserted on missing
    }

    # filter based on p-value cut-off
    if (! is.null(HWE_cutoff)) {
      # get p-value mask over columns ie. p.value or optional grouping columns
      mask <- lapply(seq_len(ncol(HWE.result) - 1), function(i) {
        m <- HWE.result[, i + 1] > HWE_cutoff
        m[is.na(m)] <- TRUE
        m
      })
      mask <- Reduce(f = `&`, x = mask)
      HWE.result <- HWE.result[mask, ]
    }

    if(as.MiDAS) {
      vars <- rownames(object[[experiment]])
      vars <- vars[vars %in% HWE.result$var]
      HWE.result <- filterByVariables(object, experiment, vars)
    }

    return(HWE.result)
  }

context("stats_longtests")

test_that("runMiDAS", {
  midas <- MiDAS_tut_object
  midas_data <- midasToWide(
    MiDAS_tut_object,
    experiment = c(
      "hla_alleles",
      "hla_aa",
      "hla_g_groups",
      "hla_supertypes",
      "hla_NK_ligands",
      "kir_genes",
      "hla_kir_interactions",
      "hla_divergence"
    )
  )

  # linear
  conditional = FALSE
  omnibus = FALSE
  experiment_choice <-
    c(
      "hla_alleles",
      "hla_aa",
      "hla_g_groups",
      "hla_supertypes",
      "hla_NK_ligands",
      "kir_genes",
      "hla_kir_interactions",
      "hla_divergence"
    )
  for (experiment in experiment_choice) {
    object <- lm(disease ~ term, data = midas)
    res <- runMiDAS(object,
                    inheritance_model = "additive",
                    conditional = conditional,
                    omnibus = omnibus,
                    experiment = experiment,
                    exponentiate = FALSE
    )

    object$call$data <- midas_data
    test_variables <- rownames(midas[[experiment]])
    test_res <-
      analyzeAssociations(object, variables = test_variables, exponentiate = FALSE)

    ex <- midas[[experiment]]
    if (is(ex, "SummarizedExperiment")) {ex <- assay(ex)}
    if (typeof(ex) == "integer") {
      variables_freq <-
        midasHLA:::runMiDASGetVarsFreq(
          midas = midas,
          experiment = experiment,
          test_covar = all.vars(formula(object))[1]
        )
      test_res <- dplyr::left_join(test_res, variables_freq, by = "term")
    }

    term_name <- switch (experiment,
                         "hla_alleles" = "allele",
                         "hla_aa" = "aa",
                         "expression_level" = "allele",
                         "hla_g_groups" = "g.group",
                         "hla_supertypes" = "supertype",
                         "hla_NK_ligands" = "allele.group",
                         "kir_genes" = "kir.gene",
                         "hla_kir_interactions" = "hla.kir.interaction",
                         "term"
    )
    test_res <- dplyr::rename(test_res, !!term_name := term)
    test_res <- dplyr::arrange(test_res, p.value)
    test_res <- test_res[, colnames(res)] # order columns


    expect_equal(as.data.frame(res), as.data.frame(test_res)) # Tibble doesn't respect tollerance https://github.com/tidyverse/tibble/issues/287 or something related mby
  }

  # conditional
  conditional <- TRUE
  omnibus <- FALSE
  th <- 0.2
  keep <- FALSE
  experiment_choice <-
    c(
      "hla_alleles",
      "hla_aa",
      "hla_g_groups",
      "hla_supertypes",
      "hla_NK_ligands",
      "kir_genes",
      "hla_kir_interactions",
      "hla_divergence"
    )
  for (experiment in experiment_choice) {
    object <- lm(disease ~ term, data = midas)
    res <- runMiDAS(object,
                    inheritance_model = "additive",
                    conditional = conditional,
                    omnibus = omnibus,
                    experiment = experiment,
                    exponentiate = FALSE,
                    th = th,
                    keep = keep
    )

    object$call$data <- midas_data
    test_variables <- rownames(midas[[experiment]])
    test_res <-
      analyzeConditionalAssociations(
        object,
        variables = test_variables,
        exponentiate = FALSE,
        th = th,
        keep = keep
      )

    ex <- midas[[experiment]]
    if (is(ex, "SummarizedExperiment")) {ex <- assay(ex)}
    if (typeof(ex) == "integer") {
      variables_freq <-
        midasHLA:::runMiDASGetVarsFreq(
          midas = midas,
          experiment = experiment,
          test_covar = all.vars(formula(object))[1]
        )
      test_res <- dplyr::left_join(test_res, variables_freq, by = "term")
    }

    term_name <- switch (experiment,
                         "hla_alleles" = "allele",
                         "hla_aa" = "aa",
                         "expression_level" = "allele",
                         "hla_g_groups" = "g.group",
                         "hla_supertypes" = "supertype",
                         "hla_NK_ligands" = "allele.group",
                         "kir_genes" = "kir.gene",
                         "hla_kir_interactions" = "hla.kir.interaction",
                         "term"
    )
    test_res <- dplyr::rename(test_res, !!term_name := term)
    test_res <- dplyr::arrange(test_res, p.value)
    test_res <- test_res[, colnames(res)] # order columns


    expect_equal(as.data.frame(res), as.data.frame(test_res))
  }

  # frequency filtration
  conditional <- FALSE
  omnibus <- FALSE
  experiment_choice <-
    c(
      "hla_alleles",
      "hla_supertypes"
    )
  lower_frequency_cutoff <- 0.02
  upper_frequency_cutoff <- 0.06
  for (experiment in experiment_choice) {
    object <- lm(disease ~ term, data = midas)
    res <- runMiDAS(object,
                    inheritance_model = "additive",
                    conditional = conditional,
                    omnibus = omnibus,
                    experiment = experiment,
                    lower_frequency_cutoff = lower_frequency_cutoff,
                    upper_frequency_cutoff = upper_frequency_cutoff,
                    exponentiate = FALSE
    )

    midas_filtered <-
      filterByFrequency(
        object = midas,
        experiment = experiment,
        lower_frequency_cutoff = lower_frequency_cutoff,
        upper_frequency_cutoff = upper_frequency_cutoff
      )
    test_variables <- rownames(midas_filtered[[experiment]])
    object$call$data <- midas_data
    test_res <- analyzeAssociations(
      object = object,
      variables = test_variables,
      exponentiate = FALSE
    )

    ex <- midas[[experiment]]
    if (is(ex, "SummarizedExperiment")) { ex <- assay(ex) }
    if (typeof(ex) == "integer") {
      variables_freq <-
        runMiDASGetVarsFreq(
          midas = midas_filtered,
          experiment = experiment,
          test_covar = all.vars(formula(object))[1]
        )
      test_res <-
        dplyr::left_join(test_res, variables_freq, by = "term")
    }

    term_name <- switch (experiment,
                         "hla_alleles" = "allele",
                         "hla_aa" = "aa",
                         "expression_level" = "allele",
                         "hla_g_groups" = "g.group",
                         "hla_supertypes" = "supertype",
                         "hla_NK_ligands" = "allele.group",
                         "kir_genes" = "kir.gene",
                         "hla_kir_interactions" = "hla.kir.interaction",
                         "term"
    )
    test_res <- dplyr::rename(test_res, !!term_name := term)
    test_res <- dplyr::arrange(test_res, p.value)
    test_res <- test_res[, colnames(res)] # order columns

    expect_equal(as.data.frame(res), as.data.frame(test_res))
  }

  # linear omnibus
  conditional <- FALSE
  omnibus <- TRUE
  experiment <- "hla_aa"
  object <- lm(disease ~ term, data = midas)
  res <- runMiDAS(
    object,
    inheritance_model = "additive",
    conditional = conditional,
    omnibus = omnibus,
    omnibus_groups_filter = c("A_6", "A_12"),
    experiment = experiment,
    exponentiate = FALSE
  )
  test_res <- dplyr::tibble(
    aa_pos = c("A_6", "A_12"),
    residues = c("R", "V"),
    df = c(1, 1),
    statistic = c(1.00150233709155, 0.43786032955245),
    p.value = c(0.316947259129448, 0.508156995160654),
    p.adjusted = c(0.633894518258896, 1)
  )

  expect_equal(as.data.frame(res), as.data.frame(test_res))

  # conditional omnibus
  conditional <- TRUE
  omnibus <- TRUE
  experiment <- "hla_aa"
  object <- lm(disease ~ term, data = midas)
  res <- runMiDAS(
    object,
    inheritance_model = "additive",
    conditional = conditional,
    omnibus = omnibus,
    omnibus_groups_filter = c("DRA_217", "DQA1_34"),
    experiment = experiment,
    exponentiate = FALSE
  )
  test_res <- dplyr::tibble(
    aa_pos = c("DRA_217", "DQA1_34"),
    residues = c("L", "Q"),
    df = c(1, 1),
    statistic = c(11.7515320865891, 8.92028215923278),
    p.value = c(0.000607931755127601, 0.00282020937328977),
    p.adjusted = c(0.00121586351025461, 0.00282020937329118),
    covariates = c("", "DRA_217")
  )
  expect_equal(as.data.frame(res), as.data.frame(test_res))

  res <- runMiDAS(
    object,
    inheritance_model = "additive",
    conditional = conditional,
    omnibus = omnibus,
    omnibus_groups_filter = c("B_178", "DRA_217"),
    experiment = experiment,
    exponentiate = FALSE,
    keep = TRUE
  )
  test_res <- list(
    dplyr::tibble(
      aa_pos = c("DRA_217", "B_178"),
      residues = c("L", "K"),
      df = c(1, 1),
      statistic = c(11.7515320865891, 5.63638399577462),
      p.value = c(0.000607931755127601, 0.0175914523736528),
      p.adjusted = c(0.0012158635102552, 0.0351829047473056),
      covariates = c("", "")
    )
  )
  expect_equal(lapply(res, as.data.frame), lapply(test_res, as.data.frame))

  expect_error(
    runMiDAS(
      object,
      inheritance_model = "additive",
      conditional = FALSE,
      omnibus = TRUE,
      experiment = "hla_alleles",
      exponentiate = FALSE
    ),
    "Omnibus test does not support experiment hla_alleles"
  )

  #
  object <- lm(disease ~ term, data = midas)

  expect_error(runMiDAS(list()),
               "object was not recognized as a fit from a model function \\(such as lm, glm and many others\\)."
  )

  fake_object <- list(call = list(formula = 1 ~ 1, data = 1:5))
  class(fake_object) <- "foo"
  expect_error(runMiDAS(fake_object),
               "Could not find 'tidy' function for statistical model 'foo'. Please ensure that 'tidy' for selected model is available. See the 'broom' package for more information on 'tidy' function."
  )

  fake_object <- object
  fake_midas <- midas
  class(fake_midas) <- structure("MultiAssayExperiment", package = "MultiAssayExperiment")
  fake_object$call$data <- fake_midas
  expect_error(runMiDAS(fake_object),
               "data associated with statistical model must be an instance of MiDAS class."
  )

  fake_object <- object
  fake_object$call$formula <- disease ~ 1
  expect_error(
    runMiDAS(fake_object),
    "placeholder 'term' could not be found in object's formula"
  )

  expect_error(runMiDAS(object, experiment = 1),
               "experiment is not a string \\(a length one character vector\\)."
  )

  expect_error(runMiDAS(object, experiment = "foo"),
               "experiment should be one of \"hla_alleles\", \"hla_aa\", \"hla_g_groups\", \"hla_supertypes\", \"hla_NK_ligands\", \"kir_genes\", \"kir_haplotypes\", \"hla_kir_interactions\", \"hla_divergence\", \"hla_het\"."
  )

  expect_error(runMiDAS(object, experiment = "hla_alleles", inheritance_model = 1),
               "inheritance_model is not a string \\(a length one character vector\\) or NULL."
  )

  expect_error(runMiDAS(object, experiment = "hla_alleles", inheritance_model = "foo"),
               "inheritance_model should match values \"dominant\", \"recessive\", \"additive\", \"overdominant\"."
  )

  expect_error(runMiDAS(object, experiment = "hla_alleles", conditional = 1),
               "conditional is not a flag \\(a length one logical vector\\)."
  )

  expect_error(
    runMiDAS(
      object,
      experiment = "hla_alleles",
      conditional = TRUE,
      omnibus = 1
    ),
    "omnibus is not a flag \\(a length one logical vector\\)."
  )

  expect_error(
    runMiDAS(
      object,
      experiment = "hla_alleles",
      omnibus_groups_filter = 1
    ),
    "omnibus_groups_filter is not a character."
  )

  expect_error(runMiDAS(object, experiment = "hla_alleles", correction = 1),
               "correction is not a string \\(a length one character vector\\)."
  )

  expect_error(
    runMiDAS(
      object,
      experiment = "hla_alleles",
      conditional = TRUE,
      omnibus = FALSE,
      n_correction = "foo"
    ),
    "n_correction is not a count \\(a single positive integer\\) or NULL."
  )

  expect_error(
    runMiDAS(
      object,
      experiment = "hla_alleles",
      conditional = TRUE,
      omnibus = FALSE,
      exponentiate = "foo"
    ),
    "exponentiate is not a flag \\(a length one logical vector\\)."
  )

  expect_error(
    runMiDAS(
      object,
      experiment = "hla_divergence",
      conditional = FALSE,
      lower_frequency_cutoff = 0.1,
      upper_frequency_cutoff = 0.8
    ),
    "Frequency filtration does not support experiment 'hla_divergence'"
  )

  expect_error(
    runMiDAS(
      object,
      inheritance_model = "additive",
      experiment = "hla_alleles",
      lower_frequency_cutoff = 0.53,
      upper_frequency_cutoff = 0.56
    ),
    "No variables available for analysis, please revisit your filtration criteria."
  )
})

context("stats")

test_that("analyzeAssociations", {
  midas_data <- midasToWide(MiDAS_tut_object, experiment = "hla_alleles")
  object <- lm(disease ~ term, data = midas_data)

  res <- analyzeAssociations(object,
                             variables = c("A*01:01", "A*02:01"),
                             correction = "BH"
  )

  test_res <- list(
    lm(disease ~ `A*01:01`, data = midas_data),
    lm(disease ~ `A*02:01`, data = midas_data)
  )
  test_res <- do.call("rbind", lapply(test_res, tidy, conf.int = TRUE))
  test_res$term <- gsub("`", "", test_res$term)
  test_res <- test_res[test_res$term %in% c("A*01:01", "A*02:01"), ]
  test_res$p.adjusted <- p.adjust(test_res$p.value, "BH")

  expect_equal(as.data.frame(res), as.data.frame(test_res)) # Tibble doesn't respect tollerance https://github.com/tidyverse/tibble/issues/287 or something related mby

  expect_error(analyzeAssociations(object, variables = 1),
               "variables is not a character vector"
  )

  expect_error(analyzeAssociations(object, variables = "thief"),
               "thief can not be found in object data"
  )

  expect_error(
    analyzeAssociations(object, variables = "A*01:01", placeholder = 1),
    "placeholder is not a string \\(a length one character vector\\)."
  )

  expect_error(
    analyzeAssociations(object, variables = "A*01:01", placeholder = "foo"),
    "placeholder 'foo' could not be found in object's formula"
  )

  expect_error(
    analyzeAssociations(object, variables = "A*01:01", n_correction = 1.5),
    "n_correction is not a count \\(a single positive integer\\) or NULL."
  )

  expect_error(
    analyzeAssociations(object, variables = "A*01:01", correction = 1),
    "correction is not a string \\(a length one character vector\\)."
  )

  expect_error(
    analyzeAssociations(object, variables = "A*01:01", exponentiate = 1),
    "exponentiate is not a flag \\(a length one logical vector\\)."
  )

  expect_error(
    analyzeAssociations(
      object,
      variables = c("A*01:01", "A*02:01"),
      correction = "BH",
      n_correction = 1
    ),
    "n_correction must be at least 2."
  )
})

test_that("analyzeConditionalAssociations", {
  midas_data <- midasToWide(MiDAS_tut_object, experiment = "hla_alleles")

  object <- lm(disease ~ term, data = midas_data)

  # keep = FALSE
  res <- analyzeConditionalAssociations(object,
                                        variables = c("DQB1*06:02", "B*57:01"),
                                        th = 0.05,
                                        keep = FALSE)
  res <- rapply(res, classes = "numeric", how = "replace", round, digits = 3)

  test_res <- tibble(term = c("DQB1*06:02", "B*57:01"),
                     estimate = c(0.15, 0.235),
                     std.error = c(0.035, 0.056),
                     statistic = c(4.319, 4.228),
                     p.value = c(0, 0),
                     conf.low = c(0.082, 0.126),
                     conf.high = c(0.219, 0.344),
                     p.adjusted = c(0, 0),
                     covariates = c("", "DQB1*06:02")
  )

  expect_equal(res, test_res)

  # keep = TRUE
  res <- analyzeConditionalAssociations(object,
                                        variables = c("DQB1*06:02", "B*57:01"),
                                        th = 0.05,
                                        keep = TRUE)
  res <- rapply(res, classes = "numeric", how = "replace", round, digits = 3)
  test_res <- list(
    tibble(term = c("DQB1*06:02", "B*57:01"),
           estimate = c(0.15, 0.236),
           std.error = c(0.035, 0.056),
           statistic = c(4.319, 4.21),
           p.value =  c(0, 0),
           conf.low = c(0.082, 0.126),
           conf.high = c(0.219, 0.346),
           p.adjusted = c(0, 0),
           covariates = c("", "")
    ),
    tibble(term = "B*57:01",
           estimate = 0.235,
           std.error = 0.056,
           statistic = 4.228,
           p.value = 0,
           conf.low = 0.126,
           conf.high = 0.344,
           p.adjusted = 0,
           covariates = "DQB1*06:02"
    )
  )
  expect_equal(res, test_res)

  expect_error(
    analyzeConditionalAssociations(object, variables = 1),
    "variables is not a character vector"
  )

  expect_error(analyzeConditionalAssociations(object, variables = "thief"),
               "thief can not be found in object data"
  )

  expect_error(
    analyzeConditionalAssociations(object, variables = "A*01:01", placeholder = 1),
    "placeholder is not a string \\(a length one character vector\\)."
  )

  expect_error(
    analyzeConditionalAssociations(object, variables = "A*01:01", placeholder = "foo"),
    "placeholder 'foo' could not be found in object's formula"
  )

  expect_error(
    analyzeConditionalAssociations(object, variables =  "A*01:01", correction = 1),
    "correction is not a string \\(a length one character vector\\)."
  )

  expect_error(
    analyzeConditionalAssociations(object, variables =  "A*01:01", n_correction = "foo"),
    "n_correction is not a count \\(a single positive integer\\) or NULL."
  )

  expect_error(
    analyzeConditionalAssociations(object, variables =  "A*01:01", th = "bar"),
    "th is not a number \\(a length one numeric vector\\)."
  )

  expect_error(
    analyzeConditionalAssociations(
      object,
      variables =  "A*01:01",
      th = 0.05,
      rss_th = "foo"
    ),
    "rss_th is not a number \\(a length one numeric vector\\)."
  )

  expect_error(
    analyzeConditionalAssociations(
      object,
      variables =  "A*01:01",
      th = 0.05,
      exponentiate = "yes"
    ),
    "exponentiate is not a flag \\(a length one logical vector\\)."
  )

  expect_error(
    analyzeConditionalAssociations(
      object,
      variables =  c("B*14:02", "DRB1*11:01"),
      th = 1,
      correction = "BH",
      n_correction = 1
    ),
    "n_correction must be at least 2."
  )
})

test_that("omnibusTest", {
  midas_data <- midasToWide(MiDAS_tut_object, experiment = "hla_aa")
  object <- lm(disease ~ term, data = midas_data)
  omnibus_groups <- list(
    A_77 = c("A_77_D", "A_77_N", "A_77_S"),
    A_79 = c("A_79_G", "A_79_R")
  )
  omnibus_res <- omnibusTest(object, omnibus_groups)

  obj_A77 <- lm(disease ~ A_77_D + A_77_N + A_77_S, data = midas_data)
  obj_A79 <- lm(disease ~ A_79_G + A_79_R , data = midas_data)
  LRT <-
    lapply(list(obj_A77, obj_A79),
           LRTest,
           mod0 = lm(disease ~ 1, data = midas_data))
  omnibus_res_test <- data.frame(
    group = c("A_77", "A_79"),
    term = c("A_77_D, A_77_N", "A_79_G"),
    df = sapply(LRT, `[[`, "df"),
    logLik = sapply(LRT, `[[`, "logLik"),
    statistic = sapply(LRT, `[[`, "statistic"),
    p.value = sapply(LRT, `[[`, "p.value"),
    p.adjusted = p.adjust(sapply(LRT, `[[`, "p.value"), method = "bonferroni"),
    stringsAsFactors = FALSE
  )
  expect_equal(omnibus_res, omnibus_res_test)
})

test_that("HWETest", {
  midas <- MiDAS_tut_object
  res <- HWETest(midas, experiment = "hla_alleles", HWE_cutoff = 0.988)
  rownames(res) <- NULL
  test_res <- data.frame(
    var = c("A*02:01", "DRB1*13:02"),
    p.value = c(0.993279078042026, 0.988280722372832),
    stringsAsFactors = FALSE
  )
  expect_equal(as.data.frame(res), as.data.frame(test_res))

  res <-
    HWETest(
      midas,
      experiment = "hla_alleles",
      HWE_cutoff = 0.988,
      as.MiDAS = TRUE
    )
  test_res <- filterByVariables(midas, "hla_alleles", c("A*02:01", "DRB1*13:02"))
  expect_equal(res, test_res)

  expect_error(HWETest("foo"), "object must be an instance of \"MiDAS\".")

  expect_error(HWETest(midas, experiment = 1), "experiment is not a string \\(a length one character vector\\).")

  expect_error(HWETest(midas, experiment = "foo"), "experiment should be one of \"hla_alleles\", \"hla_aa\", \"hla_g_groups\", \"hla_supertypes\", \"hla_NK_ligands\".")

  expect_error(HWETest(midas, experiment = "hla_alleles", HWE_cutoff = "foo"), "HWE_cutoff is not a number \\(a length one numeric vector\\) or NULL.")

  expect_error(HWETest(midas, experiment = "hla_alleles", as.MiDAS = "foo"), "as.MiDAS is not a flag \\(a length one logical vector\\).")
})

#!/usr/bin/env R
# Create Grantham distances vector
# each value gives Grantham distance for a pair of amino acids
# elements names are constructed by pasting the AA letters
# eg. "SS" or "SW"
path <- system.file("extdata", "grantham_distance_matrix.tsv", package = "MiDAS")
grantham_matrix <- read.table(path, header = TRUE, stringsAsFactors = FALSE)
dict_dist_grantham <- grantham_matrix %>%
  tidyr::gather(SECOND, SCORE, -FIRST)

# FIRST and SECOND contains all combinations of AA
# by using them as rownames efficient indexing will be a breeze
# and we can store it as a vector
idx <- paste(dict_dist_grantham[, "FIRST"], dict_dist_grantham[, "SECOND"], sep = "")
dict_dist_grantham <- setNames(dict_dist_grantham$SCORE, idx)

usethis::use_data(dict_dist_grantham, internal = FALSE, overwrite = TRUE)

#!/usr/bin/env R
devtools::load_all()

MiDAS_tut_pheno <-
  read.table("inst/extdata/MiDAS_tut_pheno.txt",
             header = TRUE,
             stringsAsFactors = FALSE)

usethis::use_data(MiDAS_tut_pheno, overwrite = TRUE)

---
title: "MiDAS quick start"
author: "Maciej Migdał & Christian Hammer"
date: "`r Sys.Date()`"
output: html_vignette
vignette: >
  %\VignetteIndexEntry{MiDAS quick start}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(collapse = TRUE)

library("dplyr")
library("kableExtra")
library("knitr")
library("midasHLA")
```

# Introduction
MiDAS is a comprehensive R package for immunogenetic data manipulation and statistical analysis. MiDAS recodes input data in the form of HLA alleles and KIR types into biologically meaningful variables, allowing HLA amino acid fine mapping, analyses of HLA evolutionary divergence as well as validated HLA-KIR interactions. Further, it allows comprehensive statistical association analysis workflows with phenotypes of diverse measurement scales. MiDAS thus closes the gap between the inference of immunogenetic variation and its efficient utilization to make relevant discoveries related to T cell, Natural Killer cell, and disease biology.

# Quick start

## Reading input data
`MiDAS` includes functions to read HLA and KIR typing data, checking for the correct format and adherence to the right nomenclature. HLA calls can be reduced to a desired resolution when importing it, e.g. from 6-digit to 4-digit. Phenotypic observations can be read e.g. using the `read.table` function (make sure to include `stringsAsFactors = FALSE` argument).

```{r load_pheno, echo=TRUE, warning=FALSE}
pheno_file <- system.file("extdata", "MiDAS_tut_pheno.txt", package = "midasHLA")
pheno <- read.table(pheno_file, header = TRUE, stringsAsFactors = FALSE)
```

```{r show_pheno, echo=FALSE, warning=FALSE}
pheno %>%
  head(10) %>%
  kable() %>%
  kable_styling(bootstrap_options = c("striped", "hover", "condensed"))
```

```{r load_hla, echo=TRUE, warning=FALSE}
# HLA calls can be loaded using the readHlaCalls function with the desired resolution
hla_calls_file <- system.file("extdata", "MiDAS_tut_HLA.txt", package = "midasHLA")
hla_calls <- readHlaCalls(hla_calls_file, resolution = 4)
```

```{r show_hla, echo=FALSE, warning=FALSE}
hla_calls %>%
  head(10) %>%
  kable() %>%
  kable_styling(bootstrap_options = c("striped", "hover", "condensed")) %>%
  scroll_box(width = "100%", height = "200px")
```

```{r load_kir, echo=TRUE, warning=FALSE}
# KIR calls (currently presence/absence calls, no allele-level resolution) can be loaded using the readKirCalls function
kir_calls_file <- system.file("extdata", "MiDAS_tut_KIR.txt", package = "midasHLA")
kir_calls <- readKirCalls(kir_calls_file)
```

```{r show_kir, echo=FALSE, warning=FALSE}
kir_calls %>%
  head(10) %>%
  kable() %>%
  kable_styling(bootstrap_options = c("striped", "hover", "condensed")) %>%
  scroll_box(width = "100%", height = "200px")
```

For convenience, we will here use test data shipped with the package.

```{r test_data, echo=TRUE, warning=FALSE}
HLA <- reduceHlaCalls(MiDAS_tut_HLA, resolution = 4)
KIR <- MiDAS_tut_KIR
pheno <- MiDAS_tut_pheno
```

## Creating midas objects
`MiDAS` provides the `prepareMiDAS` function to combine genetic and phenotypic data for subsequent analysis. In this step, it is also possible to infer amino acid level information from HLA calls, encode HLA-KIR interactions, or calculate HLA evolutionary divergence (`experiment` argument).

```{r creating_midas_data_set, echo=TRUE, warning=FALSE}
midas <- prepareMiDAS(
  hla_calls = HLA,
  kir_calls = KIR,
  colData = pheno,
  experiment = c("hla_alleles", "hla_aa")
  )
```

## MiDAS object
A MiDAS object contains our input data as well as defined transformations. This is an extension of a `MultiAssayExperiment` and can be handled as
such. `MiDAS` provides some functions to interact with `MiDAS` objects (check `?MiDAS-class` for a full list).

For example, we can explore the HLA alleles frequencies, compare them with published frequencies from the allelefrequencies.net database, and filter out low frequency alleles.

```{r get_freq, echo=TRUE, warning=FALSE}
freq <- getFrequencies(
  object = midas,
  carrier_frequency = FALSE,
  experiment = "hla_alleles",
  compare = TRUE
)
```

```{r show_freq, echo=FALSE, warning=FALSE}
kable(freq) %>%
  kable_styling(bootstrap_options = c("striped", "hover", "condensed")) %>%
  scroll_box(width = "100%", height = "200px")
```

```{r filter_freq, echo=TRUE, warning=FALSE}
midas <-
  filterByFrequency(
    object = midas,
    experiment = "hla_alleles",
    lower_frequency_cutoff = 0.01
    )
```

## Association analysis
### Model definition
Before the actual analysis can be run, we still need to define a statistical model we would like to use. We can use most of the statistical models available in R, such as `lm`, `glm`, `coxme` etc. (technically, they need to have a tidy method available).
`MiDAS` then provides a wrapper function that will evaluate our model for
each HLA allele in our data.

Here we will use a very simple formula `disease ~ term`, term being a placeholder for each tested HLA allele. This notation is necessary to also allow interaction tests (e.g. `disease ~ lab_value:term`) and also works with other appropriate operations.

`midas` has to be passed as a `data` argument to our statistical function, here `glm`.

```{r model definition, echo=TRUE, warning=FALSE}
# Logistic regression
object <- glm(disease ~ term, data = midas, family = binomial(link = "logit"))
```

### Running analysis
To run our analysis, we will use the `runMiDAS` function. This function offers multiple analysis scenarios which can be tuned using `conditional` and `omnibus` arguments. It can also pre-filter input data based on frequency (check `?runMiDAS` to learn more).

```{r association_analysis, echo=TRUE, warning=FALSE}
results <-
  runMiDAS(
    object = object,
    experiment = "hla_alleles",
    inheritance_model = "dominant",
    conditional = FALSE,
    omnibus = FALSE,
    lower_frequency_cutoff = 0.05
    )

kableResults(results)
```
 

---
title: "MiDAS tutorial"
author: "Maciej Migdał & Christian Hammer"
date: "`r Sys.Date()`"
output: 
  html_vignette:
    toc: true
    toc_depth: 2
vignette: >
  %\VignetteIndexEntry{MiDAS tutorial}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r my_setup, echo=FALSE, warning=FALSE, include=FALSE}
knitr::opts_chunk$set(echo = TRUE, fig.align="center")
devtools::load_all()
```

```{r logo, echo=FALSE, warning=FALSE}
htmltools::img(
  src = knitr::image_uri("MiDAS_logo.png"),
  alt = 'logo',
  style = 'position:absolute; top:0; right:0; padding:10px; width:250px'
  )
```

## Introduction

Welcome to MiDAS. This tutorial is supposed to help you get started with your analyses of immunogenetic associations. We will work with a simulated data set of 500 patients and 500 controls with a binary disease diagnosis.

We also have high resolution HLA alleles (4 - 6 digit), and presence/absence calls for KIR genes.

## Data import and sanity check

First, let's import the phenotype data and HLA calls using MiDAS import functions. MiDAS will check for correct nomenclature of HLA. We can also define 4-digit resolution for HLA alleles as import format, which means that alleles with higher resolution will be reduced.

```{r get_data, echo=TRUE, warning=FALSE}
dat_pheno <-
  read.table(
  file = system.file("extdata", "MiDAS_tut_pheno.txt", package = "midasHLA"),
  header = TRUE
  )
dat_HLA <-
  readHlaCalls(
  file = system.file("extdata", "MiDAS_tut_HLA.txt", package = "midasHLA"),
  resolution = 4
  )
```

Let's take a look at the imported HLA data tables:

```{r show_imported_data, echo=FALSE, warning=FALSE}
dat_HLA %>%
  head(20) %>%
  kable(caption = "HLA data as imported by MiDAS") %>%
  kable_styling(bootstrap_options = c("striped", "hover", "condensed")) %>%
  scroll_box(width = "100%", height = "300px")
```

Next, we want to check our HLA allele frequencies, and compare them to known frequencies from major populations. Here, we only include alleles with an allele frequency of 5% or higher in our study cohort. By default, MiDAS will output comparisons including the following populations, based on published data from [allelefrequencies.net](www.allelefrequencies.net):

MiDAS comes with some pre-defined reference populations, but it is possible to customize these comparisons (see documentation).

```{r get_frequencies, echo=TRUE, warning=FALSE}
freq_HLA <- getHlaFrequencies(hla_calls = dat_HLA, compare = TRUE) %>%
  filter(Freq > 0.01)
```

```{r show_frequencies, echo=FALSE, warning=FALSE}
freq_HLA %>%
  head() %>%
  kable(caption = "HLA frequencies, compared to published references") %>%
  kable_styling(bootstrap_options = c("striped", "hover", "condensed"))
```

Let's assume our cohort is of predominantly European ancestry. We can plot the following comparison to see if allele frequencies in our data are distributed as expected, for example by visualizing common HLA-A allele frequencies in comparison with European, Chinese, and African American reference populations: 

```{r plot_frequencies, echo=TRUE, warning=FALSE, fig.height=7, fig.width=7}
freq_HLA_long <- tidyr::gather(
  data = freq_HLA,
  key = "population",
  value = "freq",
  "Freq",
  "USA NMDP European Caucasian",
  "USA NMDP Chinese",
  "USA NMDP African American pop 2",
  factor_key = TRUE
) %>% 
  filter(grepl("^A", allele))

plot_HLAfreq <-
  ggplot2::ggplot(data = freq_HLA_long, ggplot2::aes(x = allele, y = freq, fill = population)) +
  ggplot2::geom_bar(
    stat = "identity",
    position = ggplot2::position_dodge(0.7),
    width = 0.7,
    colour = "black"
  ) +
  ggplot2::coord_flip() +
  ggplot2::scale_y_continuous(labels = formattable::percent)

plot_HLAfreq
```

## HLA association analysis

### Are classical HLA alleles associated with disease status?

The following function prepares our data for analysis, combining HLA and phenotypic data into one object. Here, we are interested in analyzing our data on the level of **classical HLA alleles**.

```{r prep_HLA, echo=TRUE, warning=FALSE}
HLA <- prepareMiDAS(
  hla_calls = dat_HLA,
  colData = dat_pheno,
  experiment = "hla_alleles"
)
```

We can now test our HLA data for deviations from Hardy-Weinberg-Equilibrium (HWE) to filter out alleles that strongly deviate from HWE expectations (imputation or genotyping errors, ...). Here, let's remove alleles with a HWE p-value below 0.05 divided by the number of alleles tested / present in our data (N=447). We can create a filtered MiDAS object right away (`as.MiDAS = TRUE`), as done in this example, or output actual HWE test results.

```{r HWE_filtering, echo=TRUE, warning=FALSE}
HLA <- HWETest(
  object = HLA,
  experiment = "hla_alleles",
  HWE_cutoff = 0.05 / 447,
  as.MiDAS = TRUE
)
```

Now, we define our statistical model and run the analysis. Since we want to test for association with disease status, we use a logistic regression approach. The `term` is necessary as placeholder for the tested HLA alleles and needs to be included. It will become handy when for example defining more complex interaction models.

In the `runMiDAS` function, we then refer to this model, choose our analysis type and define a inheritance model. Here we use dominant model, meaning that individuals will be defined as non-carriers (0) vs. carriers (1) for a given allele. Alternatively, it is also possible to choose recessive (0 = non-carrier or heterozygous carrier, 1 = homozygous carrier), overdominant (assuming heterozygous (dis)advantage: 0 = non-carrier or homozygous carrier, 1 = heterozygous carrier), or additive (N of alleles) inheritance models. Moreover, we define allele inclusion criteria, such that we only consider alleles frequencies above 2% and below 98%. We also apply the *Bonferroni* method to not only get nominal P values, but also such adjusted for multiple testing. For alternative multiple testing correction methods, as well as the option to choose a custom number of tests, please refer to the documentation.  `exponentiate = TRUE` means that the effect estimate will already be shown as odds ratio, since we use a logistic regression model.

```{r run_HLA_allelic, echo=TRUE, warning=FALSE, message=FALSE}
HLA_model <- glm(disease ~ term, data = HLA, family = binomial())
HLA_results <- runMiDAS(
  object = HLA_model, 
  experiment = "hla_alleles", 
  inheritance_model = "dominant",
  lower_frequency_cutoff = 0.02, 
  upper_frequency_cutoff = 0.98, 
  correction = "bonferroni", 
  exponentiate = TRUE
)

kableResults(HLA_results)
```

Three HLA alleles show significant association with the disease after multiple testing adjustment. Due to the complex linkage disequilibrium structure in the MHC, it is likely that associations are not statistically independent. The two alleles *HLA-DRB1\*15:01* and *HLA-DQB1\*06:02* are a common class II haplotype. We can therefore test if there are associations that are statistically independent of our top-associated allele, by setting the `conditional` flag to `TRUE`. MiDAS will now perform stepwise conditional testing until the top associated allele does not reach a defined significance threshold (here `th = 0.05`, based on adjusted p value).

```{r run_HLA_allelic_cond, echo=TRUE, warning=FALSE, message=FALSE}
HLA_results_cond <- runMiDAS(
  object = HLA_model, 
  experiment = "hla_alleles", 
  inheritance_model = "dominant", 
  conditional = TRUE,
  lower_frequency_cutoff = 0.02, 
  upper_frequency_cutoff = 0.98, 
  correction = "bonferroni", 
  exponentiate = TRUE
)

kableResults(HLA_results_cond, scroll_box_height = "200px")
```

The results for conditional testing are displayed in a way that for each step the top associated allele is shown, along with a list of alleles conditioned on.

As we can see, *HLA-DRB1\*15:01* was not independently associated with the disease when correcting for our top-associated allele *HLA-DQB1\*06:02*. However, *HLA-B\*57:01* can be considered an independent association signal.

## HLA association fine-mapping on amino acid level

Next, we want to find out what are the strongest associated amino acid positions, corresponding to our allele-level associations. This can help fine-mapping the associated variants to e.g. the peptide binding region or other functionally distinct parts of the protein. We thus prepare a MiDAS object with experiment type "hla_aa", which includes the inference of amino acid variation from allele calls.

```{r prepare_HLA_AA, echo=TRUE, warning=FALSE}
HLA_AA <- prepareMiDAS(
  hla_calls = dat_HLA,
  colData = dat_pheno,
  experiment = "hla_aa"
)
```

Amino acid data will be stored in a MiDAS object, but we can extract it to a data frame and select a couple of variables to display how this looks like:

```{r HLA_AA_to_df, echo=TRUE, warning=FALSE}
dat_HLA_AA <- HLA_AA[["hla_aa"]] %>% 
  assay() %>% 
  t() %>% 
  as.data.frame() %>% 
  select(starts_with("B_97_")) %>% 
  head()
```

```{r show_HLA_AA, echo=FALSE, warning=FALSE}
kable(dat_HLA_AA, caption = "HLA amino acid data as inferred by MiDAS") %>%
  kable_styling(bootstrap_options = c("striped", "hover", "condensed"))
```

Now, we run the association test based on amino acid variation. To first identify the most relevant associated amino acid positions, we run a likelihood ratio (omnibus) test, which groups all residues at each amino acid position.

```{r run_HLA_AA_omnibus, echo=TRUE, warning=FALSE, message=FALSE}
HLA_AA_model <- glm(disease ~ term, data = HLA_AA, family = binomial())
HLA_AA_omnibus_results <- runMiDAS(
  HLA_AA_model,
  experiment = "hla_aa",
  inheritance_model = "dominant",
  conditional = FALSE,
  omnibus = TRUE,
  lower_frequency_cutoff = 0.02,
  upper_frequency_cutoff = 0.98,
  correction = "bonferroni"
)

kableResults(HLA_AA_omnibus_results)
```

Next, we can investigate how effect estimates are distributed for a given associated amino acid position, e.g. DQB1_9:

```{r run_HLA_AA_DQB1_9, echo=TRUE, warning=FALSE}
HLA_AA_DQB1_9_results <- runMiDAS(
  HLA_AA_model,
  experiment = "hla_aa",
  inheritance_model = "dominant",
  omnibus_groups_filter = "DQB1_9",
  lower_frequency_cutoff = 0.02,
  upper_frequency_cutoff = 0.98,
  correction = "bonferroni",
  exponentiate = TRUE
)

kableResults(HLA_AA_DQB1_9_results, scroll_box_height = "250px")
```

This shows us that individuals carrying a Phenylalanine (F) at position 9 of DQB1 have a significantly increased risk, whereas individuals carrying a Tyrosine (Y) at the same amino acid position have a decreased risk.

It is logical to hypothesize that the risk residue is found on *HLA-DQB1\*06:02*, the previously associated HLA risk allele. MiDAS thus provides the function `getAllelesforAA` to map amino acid residues back to the respective HLA alleles.

```{r alleles_for_aa, echo=TRUE, warning=FALSE}
HLA_AA_DQB1_9_alleles <- getAllelesForAA(HLA_AA,"DQB1_9")
```

```{r get_HLA_AA_DQB1_9_alleles, echo=FALSE, warning=FALSE}
kable(HLA_AA_DQB1_9_alleles, escape = FALSE) %>% 
  kable_styling(bootstrap_options = c("striped", "hover", "condensed"))
```

Finally, it is also interesting to note that there are several amino acid positions coming up that determine the Bw4 binding motif (e.g. B_81), which is a determinant for interactions of HLA class I alleles with KIR on Natural Killer cells.

### Can we find evidence for a role of HLA variation related to NK cell interactions?

Let's assume outcome differences in our disease of interest have been shown to be related to NK cell biology. HLA class I alleles can be grouped according to how they interact with KIR, expressed on NK cells. We here now prepare a new MiDAS object, grouping HLA alleles into categories defining their interactions with KIRs (**Bw4 vs. Bw6, C1 vs. C2**). Then we test these variables for association with disease outcome:


```{r prep_KIR_ligand, echo=TRUE, warning=FALSE}
NKlig <- prepareMiDAS(
  hla_calls = dat_HLA,
  colData = dat_pheno,
  experiment = c("hla_alleles", "hla_NK_ligands")
)
```

```{r run_KIR_ligand, echo=TRUE, warning=FALSE, message=FALSE}
NKlig_model <- glm(disease ~ term, data = NKlig, family = binomial())
NKlig_results <- runMiDAS(
  NKlig_model,
  experiment = "hla_NK_ligands",
  inheritance_model = "dominant",
  correction = "bonferroni",
  exponentiate = TRUE
)

kableResults(NKlig_results)
```

We find that *HLA-Bw6* and *HLA-Bw4* carrier status are associated with decreased and increased disease risk, respectively. 
Of course, this is interesting enough for us to invest in some KIR typing efforts.

## KIR associations and HLA-KIR interactions

### Do we see association on the level of KIR genes, and when considering defined HLA-KIR interactions?

Now that we have performed KIR genotyping, or e.g. inferred KIR types from available whole-genome sequencing data, we can import this information, and check the gene frequencies. In our example, we could successfully infer KIR gene presence status for 935 out of the 1,000 individuals in our data set. 

```{r get_KIR, echo=TRUE, warning=FALSE}
dat_KIR <- readKirCalls(
  file = system.file("extdata", "MiDAS_tut_KIR.txt", package = "midasHLA")
)
```

```{r show_KIR, echo=FALSE, warning=FALSE}
kable(dat_KIR, caption = "KIR data as imported by MiDAS") %>%
  kable_styling(bootstrap_options = c("striped", "hover", "condensed"))  %>%
  scroll_box(height = "400px")
```

Next, we want to check our KIR genes frequencies.
```{r KIR_frequency, echo=TRUE, warning=FALSE}
kir_freq <- getKIRFrequencies(dat_KIR)
```

```{r show_KIR_frequency, echo=FALSE, warning=FALSE}
kable(kir_freq , caption = "KIR data as imported by MiDAS") %>%
  kable_styling(bootstrap_options = c("striped", "hover", "condensed")) %>%
  scroll_box(height = "400px")
```

Next, we rerun our `prepareMiDAS` function, this time including the KIR data. We prepare the data to test for both KIR gene associations, as well as HLA-KIR interactions.
But first, let's `runMiDAS` on the level of KIR genes.

```{r run_KIR_gene, echo=TRUE, warning=FALSE, message=FALSE}
HLAKIR <- prepareMiDAS(
  hla_calls = dat_HLA,
  kir_calls = dat_KIR,
  colData = dat_pheno,
  experiment = c("hla_NK_ligands","kir_genes", "hla_kir_interactions")
)
KIR_model <- glm(disease ~ term, data = HLAKIR, family = binomial())
KIR_results <- runMiDAS(
  KIR_model,
  experiment = "kir_genes",
  lower_frequency_cutoff = 0.02,
  upper_frequency_cutoff = 0.98,
  exponentiate = TRUE
)

kableResults(KIR_results)
```

We found an association of KIR3DL1 gene presence with disease status. Since HLA alleles encoding Bw4 epitopes are ligands for KIR3DL1, we can now ask the question whether patients coding for both receptor and ligand are at increased risk for our disease phenotype.  

## HLA-KIR interactions

### Do known biological interactions between KIR receptors and their HLA ligands show significant assocation?

If both HLA alleles and KIR gene presence / absence information is available, MiDAS can encode experimentally validated receptor-ligand interactions, defined according to [Pende et al](https://www.ncbi.nlm.nih.gov/pmc/articles/PMC6558367/). Please note that there is extensive allelic variation in KIR genes, as well as evidence that their interaction with HLA does not only depend on the presence of the KIR gene, but also allele status. Currently, MiDAS does not consider allelic variation in KIR, but a custom dictionary can be provided by the user (see documentation).

First let's explore HLA-KIR interactions frequencies
```{r HLA-KIR_interactions_frequency, echo=TRUE, warning=FALSE}
hlakir_freq <- getFrequencies(HLAKIR, experiment = "hla_kir_interactions")
```

```{r show_HLA-KIR_interactions_frequency, echo=FALSE, warning=FALSE}
kable(hlakir_freq, caption = "HLA-KIR interaction frequencies") %>%
  kable_styling(bootstrap_options = c("striped", "hover", "condensed")) %>%
  scroll_box(height = "400px")
```

```{r run_HLA-KIR_interactions, echo=TRUE, warning=FALSE, message=FALSE}
HLAKIR_model <- glm(disease ~ term, data = HLAKIR, family = binomial())
HLA_KIR_results <- runMiDAS(
  HLAKIR_model,
  experiment = "hla_kir_interactions",
  lower_frequency_cutoff = 0.02,
  upper_frequency_cutoff = 0.98,
  exponentiate = TRUE
)

kableResults(HLA_KIR_results)
```

Patients who are carriers of both *HLA-Bw4* and *KIR3DL1* are at a significantly increased risk for having the disease, which is consistent with the associations we saw on KIR ligand and KIR gene level.


Finally, let's now take a look at some additional ways to analyze immunogenetics data within MiDAS, which are probably not relevant for most users.

## HLA heterozygosity and evolutionary divergence

Instead of focusing on single HLA alleles or their interactions, you might be interested in HLA diversity. For example, it has been shown that [MHC heterozygosity confers a selective advantage](https://www.pnas.org/content/99/17/11260) against infections with multiple *Salmonella* strains. But given the degree of variability in HLA genes, heterozygosity is a rather crude measure. On the amino acid sequence level, it is possible to perform more refined analyses, by calculating the level of evolutionary divergence between pairs of HLA alleles of different genes. [Pierini and Lenz](https://academic.oup.com/mbe/article/35/9/2145/5034935) have found Grantham's distance score to be a good proxy for HLA functional divergence. It has been demonstrated that *HLA-C* allelic divergence was associated with [HIV viral load](https://academic.oup.com/mbe/article/37/3/639/5607306). In addition, there is evidence for a role of HLA class I divergence in the [efficacy of cancer immunotherapy](https://www.nature.com/articles/s41591-019-0639-4).<br />

MiDAS provides experiment types `hla_het` to analyze heterozygosity of class I and II genes, as well as `hla_divergence` to analyze classical class I genes using Grantham's distance:

```{r run_HLAhet, echo=TRUE, warning=FALSE, message=FALSE}

HLA_het <- prepareMiDAS(
  hla_calls = dat_HLA, 
  colData = dat_pheno, 
  experiment = c("hla_het","hla_divergence")
)

HLA_het_model <- glm(outcome ~ term, data=HLA_het, family=binomial())

HLA_het_results <- runMiDAS(HLA_het_model, 
  experiment = "hla_het", 
  exponentiate = TRUE
)

kableResults(HLA_het_results)

HLA_div_results <- runMiDAS(HLA_het_model, 
  experiment = "hla_divergence", 
  exponentiate = TRUE
)

kableResults(HLA_div_results, scroll_box_height = "250px")
```

In our example dataset, our results show that there is no significant association of HLA heterozygosity or evolutionary divergence with our disease phenotype of interest.

We hope that this tutorial is useful to get you started working with MiDAS. Please don't hesitate to contact us if you have questions or suggestions for improvement.

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stats.R
\name{analyzeConditionalAssociations}
\alias{analyzeConditionalAssociations}
\title{Stepwise conditional association analysis}
\usage{
analyzeConditionalAssociations(
  object,
  variables,
  placeholder = "term",
  correction = "bonferroni",
  n_correction = NULL,
  th,
  th_adj = TRUE,
  keep = FALSE,
  rss_th = 1e-07,
  exponentiate = FALSE
)
}
\arguments{
\item{object}{An existing fit from a model function such as lm, glm and many
others.}

\item{variables}{Character vector specifying variables to use in association
tests.}

\item{placeholder}{String specifying term to substitute with value from
\code{x}. Ignored if set to \code{NULL}.}

\item{correction}{String specifying multiple testing correction method. See
details for further information.}

\item{n_correction}{Integer specifying number of comparisons to consider
during multiple testing correction calculations. For Bonferroni correction
it is possible to specify a number lower than the number of comparisons
being made. This is useful in cases when knowledge about the biology or
redundance of alleles reduces the need for correction. For other methods it
must be at least equal to the number of comparisons being made; only set
this (to non-default) when you know what you are doing!}

\item{th}{Number specifying threshold for a variable to be considered
significant.}

\item{th_adj}{Logical flag indicating if adjusted p-value should be used as
threshold criteria, otherwise unadjusted p-value is used.}

\item{keep}{Logical flag indicating if the output should be a list of results
resulting from each selection step. Default is to return only the final
result.}

\item{rss_th}{Number specifying residual sum of squares threshold at which
function should stop adding additional variables. As the residual sum of
squares approaches \code{0} the perfect fit is obtained making further
attempts at variable selection nonsense. This behavior can be controlled
using \code{rss_th}.}

\item{exponentiate}{Logical flag indicating whether or not to exponentiate
the coefficient estimates. Internally this is passed to
\code{\link[broom]{tidy}}. This is typical for logistic and multinomial
regressions, but a bad idea if there is no log or logit link. Defaults to
FALSE.}
}
\value{
Tibble with stepwise conditional testing results or a list of tibbles,
 see \code{keep} argument. The first column \code{"term"} hold the names of 
 \code{variables}. Further columns depends on the used model and are 
 determined by associated \code{tidy} function. Generally they will include 
 \code{"estimate"}, \code{"std.error"}, \code{"statistic"}, \code{"p.value"}, 
 \code{"conf.low"}, \code{"conf.high"}, \code{"p.adjusted"}.
}
\description{
\code{analyzeConditionalAssociations} perform stepwise conditional testing
adding the previous top-associated variable as covariate, until there are no
more significant variables based on a self-defined threshold.
}
\examples{
midas <- prepareMiDAS(hla_calls = MiDAS_tut_HLA,
                      colData = MiDAS_tut_pheno,
                      experiment = "hla_alleles")

# analyzeConditionalAssociations expects model data to be a data.frame
midas_data <- as.data.frame(midas)

# define base model
object <- lm(disease ~ term, data = midas_data)
analyzeConditionalAssociations(object,
                            variables = c("B*14:02", "DRB1*11:01"),
                            th = 0.05)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{kir_frequencies}
\alias{kir_frequencies}
\title{KIR genes frequencies scraped from allelefrequencies.net}
\format{
A data frame with 3744 rows and 3 variables:
\describe{
  \item{var}{allele number, character}
  \item{population}{reference population name, character}
  \item{frequency}{KIR genes carrier frequency in reference population, float}
}
}
\source{
\url{www.allelefrequencies.net}
}
\usage{
kir_frequencies
}
\description{
Accessed on 28.08.20
}
\details{
A dataset containing KIR genes frequencies across 16 genes.
For details visit the search results page in the allelefrequencies.net
database website.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{adjustPValues}
\alias{adjustPValues}
\title{Adjust P-values for Multiple Comparisons}
\usage{
adjustPValues(p, method, n = length(p))
}
\arguments{
\item{p}{numeric vector of p-values (possibly with
    \code{\link{NA}}s).  Any other \R object is coerced by
    \code{\link{as.numeric}}.}

\item{method}{correction method.  Can be abbreviated.}

\item{n}{number of comparisons, must be at least \code{length(p)}; only set
this (to non-default) when you know what you are doing! Note that for
Bonferroni correction it is possible to specify number lower than
\code{length(p)}.}
}
\value{
A numeric vector of corrected p-values (of the same length as p, with
  names copied from p).
}
\description{
Given a set of p-values, returns p-values adjusted using one of several
methods.
}
\details{
This function modifies \code{stats::p.adjust} method such that for Bonferroni
correction it is possible to specify \code{n} lower than \code{length(p)}.
This feature is useful in cases when knowledge about the biology or
redundance of alleles reduces the need for correction.

See \code{\link[stats]{p.adjust}} for more details.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{LRTest}
\alias{LRTest}
\title{Likelihood ratio test}
\usage{
LRTest(mod0, mod1)
}
\arguments{
\item{mod0}{An existing fit from a model function such as lm, glm and many
others.}

\item{mod1}{Object of the same class as \code{mod0} with extra terms
included.}
}
\value{
Data frame with the results of likelihood ratio test of the supplied
  models.

  Column \code{term} holds new variables appearing in \code{mod1},
  \code{df} difference in degrees of freedom between models, \code{logLik}
  difference in log likelihoods, \code{statistic} \code{Chisq} statistic and
  \code{p.value} corresponding p-value.
}
\description{
\code{LRTest} carry out an asymptotic likelihood ratio test for two models.
}
\details{
\code{mod0} have to be a reduced version of \code{mod1}. See examples.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/transformationFunctions.R
\name{applyInheritanceModel}
\alias{applyInheritanceModel}
\alias{applyInheritanceModel.matrix}
\alias{applyInheritanceModel.SummarizedExperiment}
\title{Apply inheritance model}
\usage{
applyInheritanceModel(
  experiment,
  inheritance_model = c("dominant", "recessive", "additive", "overdominant")
)

\method{applyInheritanceModel}{matrix}(
  experiment,
  inheritance_model = c("dominant", "recessive", "additive", "overdominant")
)

\method{applyInheritanceModel}{SummarizedExperiment}(
  experiment,
  inheritance_model = c("dominant", "recessive", "additive", "overdominant")
)
}
\arguments{
\item{experiment}{Matrix or SummarizedExperiment object.}

\item{inheritance_model}{String specifying inheritance model to use.
Available choices are \code{"dominant"}, \code{"recessive"},
\code{"additive"}.}
}
\value{
\code{experiment} converted to specified inheritance model.
}
\description{
Helper function transforming experiment counts to selected
\code{inheritance_model}.
}
\details{
Under \code{"dominant"} model homozygotes and heterozygotes are coded as
\code{1}. In \code{"recessive"} model homozygotes are coded as \code{1} and
other as \code{0}. In \code{"additive"} model homozygotes are coded as
\code{2} and heterozygotes as \code{1}. In \code{"overdominant"} homozygotes
(both \code{0} and \code{2}) are coded as \code{0} and heterozygotes as \code{1}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{MiDAS_tut_KIR}
\alias{MiDAS_tut_KIR}
\title{MiDAS tutorial KIR data}
\format{
Data frame with 1000 rows and 17 columns. First column holds samples
  ID's, following columns holds presence/absence indicators for different
  KIR genes.
  \describe{
    \item{ID}{Character sample ID}
    \item{KIR3DL3}{Integer}
    \item{KIR2DS2}{Integer}
    \item{KIR2DL2}{Integer}
    \item{KIR2DL3}{Integer}
    \item{KIR2DP1}{Integer}
    \item{KIR2DL1}{Integer}
    \item{KIR3DP1}{Integer}
    \item{KIR2DL4}{Integer}
    \item{KIR3DL1}{Integer}
    \item{KIR3DS1}{Integer}
    \item{KIR2DL5}{Integer}
    \item{KIR2DS3}{Integer}
    \item{KIR2DS5}{Integer}
    \item{KIR2DS4}{Integer}
    \item{KIR2DS1}{Integer}
    \item{KIR3DL2}{Integer}
  }
}
\usage{
MiDAS_tut_KIR
}
\description{
Example KIRR presence/absence data used in MiDAS tutorial
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/parsingFunctions.R
\name{readKirCalls}
\alias{readKirCalls}
\title{Read KIR calls}
\usage{
readKirCalls(file, na.strings = c("", "NA", "uninterpretable"))
}
\arguments{
\item{file}{Path to input file.}

\item{na.strings}{a character vector of strings which are to be
    interpreted as \code{\link{NA}} values.  Blank fields are also
    considered to be missing values in logical, integer, numeric and
    complex fields.  Note that the test happens \emph{after} 
    white space is stripped from the input, so \code{na.strings} 
    values may need their own white space stripped in advance.}
}
\value{
Data frame containing KIR gene's counts. First column hold samples 
  IDs, further columns hold KIR genes presence / absence indicators.
}
\description{
\code{readKirCalls} read KIR calls from file.
}
\details{
Input file has to be a tsv formatted table. First column should be named
"ID" and contain samples IDs, further columns should hold KIR genes presence
/ absence indicators. See
\code{system.file("extdata", "MiDAS_tut_KIR", package = "midasHLA")} for an
example.
}
\examples{
file <- system.file("extdata", "MiDAS_tut_KIR.txt", package = "midasHLA")
readKirCalls(file)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{listMiDASDictionaries}
\alias{listMiDASDictionaries}
\title{List HLA alleles dictionaries}
\usage{
listMiDASDictionaries(pattern = "allele", file.names = FALSE)
}
\arguments{
\item{pattern}{String used to match dictionary names, it can be a regular
expression. By default all names are matched.}

\item{file.names}{Logical value. If FALSE, only the names of dictionaries are
returned. If TRUE their paths are returned.}
}
\value{
Character vector giving names of available HLA alleles dictionaries.
}
\description{
\code{listMiDASDictionaries} lists dictionaries shipped with the MiDAS package.
See \code{\link{hlaToVariable}} for more details on dictionaries.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{getObjectDetails}
\alias{getObjectDetails}
\title{Get attributes of statistical model object}
\usage{
getObjectDetails(object)
}
\arguments{
\item{object}{An existing fit from a model function such as lm, glm and many
others.}
}
\value{
List with following elements:
\describe{
  \item{call}{Object's call}
  \item{formula_vars}{Character containing names of variables in object
    formula}
  \item{data}{MiDAS object associated with model}
}
}
\description{
\code{getObjectDetails} extracts some of the statistical model object
attributes that are needed for \code{runMiDAS} internal calculations.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/asserts.R
\name{isNumberOrNULL}
\alias{isNumberOrNULL}
\title{Check if object is number or NULL}
\usage{
isNumberOrNULL(x)
}
\arguments{
\item{x}{object to test.}
}
\value{
Logical indicating if object is number or NULL
}
\description{
\code{isNumberOrNULL} checks if object is number (a length one numeric
vector) or NULL.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/transformationFunctions.R
\name{getHlaFrequencies}
\alias{getHlaFrequencies}
\title{Calculate HLA allele frequencies}
\usage{
getHlaFrequencies(
  hla_calls,
  carrier_frequency = FALSE,
  compare = FALSE,
  ref_pop = c("USA NMDP African American pop 2", "USA NMDP Chinese",
    "USA NMDP European Caucasian", "USA NMDP Hispanic South or Central American",
    "USA NMDP Japanese", "USA NMDP North American Amerindian",
    "USA NMDP South Asian Indian"),
  ref = allele_frequencies
)
}
\arguments{
\item{hla_calls}{HLA calls data frame, as returned by
\code{\link{readHlaCalls}} function.}

\item{carrier_frequency}{Logical flag indicating if carrier frequency should
be returned.}

\item{compare}{Logical flag indicating if \code{hla_calls} frequencies
should be compared to reference frequencies given in \code{ref}.}

\item{ref_pop}{Character vector giving names of reference populations in
\code{ref} to compare with. Optionally vector can be named, then those
names will be used as population names.}

\item{ref}{Data frame giving reference allele frequencies. See
\code{\link{allele_frequencies}} for an example.}
}
\value{
Data frame with each row holding HLA allele, it's count and 
  frequency.
}
\description{
\code{getHlaFrequencies} calculates allele frequencies in HLA calls data
frame.
}
\details{
Both gene copies are taken into consideration for frequencies calculation,
\code{frequency = n / (2 * j)} where \code{n} is the number of allele
occurrences and \code{j} is the number of samples in \code{hla_calls}.
}
\examples{
getHlaFrequencies(MiDAS_tut_HLA)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class.R
\name{prepareMiDAS_hla_aa}
\alias{prepareMiDAS_hla_aa}
\title{Prepare MiDAS data on HLA amino acid level}
\usage{
prepareMiDAS_hla_aa(hla_calls, indels = TRUE, unkchar = FALSE, ...)
}
\arguments{
\item{hla_calls}{HLA calls data frame, as returned by
\code{\link{readHlaCalls}} function.}

\item{indels}{Logical indicating whether indels should be considered when
checking variability.}

\item{unkchar}{Logical indicating whether unknown characters in the alignment
should be considered when checking variability.}

\item{...}{Not used}
}
\value{
SummarizedExperiment
}
\description{
Prepare MiDAS data on HLA amino acid level
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{updateModel}
\alias{updateModel}
\title{Extend and Re-fit a Model Call}
\usage{
updateModel(object, x, placeholder = NULL, backquote = TRUE, collapse = " + ")
}
\arguments{
\item{object}{An existing fit from a model function such as lm, glm and many
others.}

\item{x}{Character vector specifying variables to be added to model.}

\item{placeholder}{String specifying term to substitute with value from
\code{x}. Ignored if set to \code{NULL}.}

\item{backquote}{Logical indicating if added variables should be quoted.
Elements of this vector are recycled over \code{x}.}

\item{collapse}{String specifying how variables should be combined. Defaults
to \code{" + "} ie. linear combination.}
}
\value{
Updated fitted object.
}
\description{
\code{updateModel} adds new variables to model and re-fit it.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/transformationFunctions.R
\name{reduceHlaCalls}
\alias{reduceHlaCalls}
\title{Reduce HLA calls resolution}
\usage{
reduceHlaCalls(hla_calls, resolution = 4)
}
\arguments{
\item{hla_calls}{HLA calls data frame, as returned by
\code{\link{readHlaCalls}} function.}

\item{resolution}{Number specifying desired resolution.}
}
\value{
HLA calls data frame reduced to specified resolution.
}
\description{
\code{reduceHlaCalls} reduces HLA calls data frame to specified resolution.
}
\details{
Alleles with resolution greater than \code{resolution} or optional suffixes
are returned unchanged.
}
\examples{
reduceHlaCalls(MiDAS_tut_HLA, resolution = 2)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/asserts.R
\name{colnamesMatches}
\alias{colnamesMatches}
\title{Check column names}
\usage{
colnamesMatches(x, cols)
}
\arguments{
\item{x}{Data frame to test.}

\item{cols}{Ordered character vector to test against \code{x}'s colnames.}
}
\value{
Logical indicating if \code{x}'s colnames equals \code{choice}.
}
\description{
\code{colnamesMatches} check if  data frame's columns are named as specified
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/transformationFunctions.R
\name{kableResults}
\alias{kableResults}
\title{Create association analysis results table in HTML or LaTeX}
\usage{
kableResults(
  results,
  colnames = NULL,
  header = "MiDAS analysis results",
  pvalue_cutoff = NULL,
  format = getOption("knitr.table.format"),
  scroll_box_height = "400px"
)
}
\arguments{
\item{results}{Tibble as returned by \code{\link{runMiDAS}}.}

\item{colnames}{Character vector of form \code{c("new_name" = "old_name")},
used to rename \code{results} colnames.}

\item{header}{String specifying results table header.}

\item{pvalue_cutoff}{Number specifying p-value cutoff for results to be
included in output. If \code{NULL} no filtering is done.}

\item{format}{String \code{"latex"} or \code{"html"}.}

\item{scroll_box_height}{A character string indicating the height of the table.}
}
\value{
Association analysis results table in HTML or LaTeX.
}
\description{
\code{kableResults} convert results table (\code{\link{runMiDAS}} output) to
HTML or LaTeX format.
}
\examples{
midas <- prepareMiDAS(hla_calls = MiDAS_tut_HLA,
                      colData = MiDAS_tut_pheno,
                      experiment = "hla_alleles")
object <- lm(disease ~ term, data = midas)
res <- runMiDAS(object, experiment = "hla_alleles", inheritance_model = "additive")
kableResults(results = res,
             colnames = c("HLA allele" = "allele"))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/transformationFunctions.R
\name{getAAFrequencies}
\alias{getAAFrequencies}
\title{Calculate amino acid frequencies}
\usage{
getAAFrequencies(aa_variation)
}
\arguments{
\item{aa_variation}{Amino acid variation data frame as returned by
\link{hlaToAAVariation}.}
}
\value{
Data frame with each row holding specific amino acid position, it's 
  count and frequency.
}
\description{
\code{getAAFrequencies} calculates amino acid frequencies in amino acid
data frame.
}
\details{
Both gene copies are taken into consideration for frequencies calculation,
\code{frequency = n / (2 * j)} where \code{n} is the number of amino acid
occurrences and \code{j} is the number of samples in \code{aa_variation}.
}
\examples{
aa_variation <- hlaToAAVariation(MiDAS_tut_HLA)
getAAFrequencies(aa_variation)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/transformationFunctions.R
\name{formatResults}
\alias{formatResults}
\title{Pretty format statistical analysis results helper}
\usage{
formatResults(
  results,
  filter_by = "p.value <= 0.05",
  arrange_by = "p.value",
  select_cols = c("term", "estimate", "std.error", "p.value", "p.adjusted"),
  format = c("html", "latex"),
  header = NULL,
  scroll_box_height = "400px"
)
}
\arguments{
\item{results}{Tibble as returned by \code{\link{runMiDAS}}.}

\item{filter_by}{Character vector specifying conditional expression used to
filter \code{results}, this is equivalent to \code{...} argument passed to
\code{\link[dplyr]{filter}}.}

\item{arrange_by}{Character vector specifying variable names to use for
sorting. Equivalent to \code{...} argument passed to
\code{\link[dplyr]{arrange}}.}

\item{select_cols}{Character vector specifying variable names that should be
included in the output table. Can be also used to rename selected
variables, see examples.}

\item{format}{String \code{"latex"} or \code{"html"}.}

\item{header}{String specifying header for result table. If \code{NULL} no header is added.}

\item{scroll_box_height}{A character string indicating the height of the table.}
}
\value{
Character vector of formatted table source code.
}
\description{
\code{formatResults} format statistical analysis results table to html or
latex format.
}
\examples{
\dontrun{
midas <- prepareMiDAS(hla_calls = MiDAS_tut_HLA,
                      colData = MiDAS_tut_pheno,
                      experiment = "hla_alleles")
object <- lm(disease ~ term, data = midas)
res <- runMiDAS(object, 
                experiment = "hla_alleles", 
                inheritance_model = "dominant")
formatResults(res,
              filter_by = c("p.value <= 0.05", "estimate > 0"),
              arrange_by = c("p.value * estimate"),
              select_cols = c("allele", "p-value" = "p.value"),
              format = "html",
              header = "HLA allelic associations")
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{hlaCallsGranthamDistance}
\alias{hlaCallsGranthamDistance}
\title{Calculate Grantham distance between HLA alleles}
\usage{
hlaCallsGranthamDistance(
  hla_calls,
  genes = c("A", "B", "C"),
  aa_selection = "binding_groove"
)
}
\arguments{
\item{hla_calls}{HLA calls data frame, as returned by
\code{\link{readHlaCalls}} function.}

\item{genes}{Character vector specifying genes for which allelic distance
should be calculated.}

\item{aa_selection}{String specifying variable region in peptide binding
groove which should be considered for Grantham distance calculation. Valid
choices includes: \code{"binding_groove"}, \code{"B_pocket"},
\code{"F_pocket"}. See details for more information.}
}
\value{
Data frame of normalized Grantham distances between pairs of alleles
  for each specified HLA gene. First column (\code{ID}) is the same as in
  \code{hla_calls}, further columns are named as given by \code{genes}.
}
\description{
\code{hlaCallsGranthamDistance} calculate Grantham distance between two HLA
alleles of a given, using original formula by
\href{http://www.sciencemag.org/content/185/4154/862.long}{Grantham R. 1974.}.
}
\details{
Grantham distance is calculated only for class I HLA alleles. First
exons forming the variable region in the peptide binding groove are selected.
Here we provide option to choose either  \code{"binding_groove"} - exon 2 and
3 (positions 1-182 in IMGT/HLA alignments, however here we take 2-182 as many
1st positions are missing), \code{"B_pocket"} -  residues 7, 9, 24, 25, 34,
45, 63, 66, 67, 70, 99 and \code{"F_pocket"} - residues 77, 80, 81, 84, 95,
116, 123, 143, 146, 147. Then all the alleles containing gaps, stop codons or
indels are discarded. Finally distance is calculated for each pair.

See \href{https://europepmc.org/article/med/28650991}{Robinson J. 2017.} for
more details on the choice of exons 2 and 3.
}
\examples{
hlaCallsGranthamDistance(MiDAS_tut_HLA, genes = "A")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class.R
\name{getHlaCalls}
\alias{getHlaCalls}
\title{Get HLA calls from MiDAS object.}
\usage{
getHlaCalls(object)
}
\arguments{
\item{object}{\code{\link{MiDAS}} object.}
}
\value{
HLA calls data frame.
}
\description{
Get HLA calls from MiDAS object.
}
\examples{
getHlaCalls(object = MiDAS_tut_object)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/asserts.R
\name{isCountsOrZeros}
\alias{isCountsOrZeros}
\title{Check if vector contains only counts or zeros}
\usage{
isCountsOrZeros(x, na.rm = TRUE)
}
\arguments{
\item{x}{Numeric vector or object that can be \code{unlist} to numeric
vector.}

\item{na.rm}{Logical indicating if \code{NA} values should be accepted.}
}
\value{
Logical indicating if provided vector contains only positive integers
  or zeros.
}
\description{
\code{isCountsOrZeros} checks if vector contains only positive integers or
zeros.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/transformationFunctions.R
\name{countsToVariables}
\alias{countsToVariables}
\title{Convert counts table to variables}
\usage{
countsToVariables(counts, dictionary, na.value = NA, nacols.rm = TRUE)
}
\arguments{
\item{counts}{Data frame with counts, such as returned by
\code{\link{hlaCallsToCounts}} function. First column should contain
samples IDs, following columns should contain counts (natural numbers
including zero).}

\item{dictionary}{Path to file containing variables dictionary or data
frame. See details for further explanations.}

\item{na.value}{Vector of length one speciyfing value for variables with no
matching entry in \code{dictionary}. Default is to use \code{0}.}

\item{nacols.rm}{Logical indicating if result columns that contain only
\code{NA} should be removed.}
}
\value{
Data frame with variable number of columns. First column named 
  \code{"ID"} corresponds to \code{"ID"} column in \code{counts}, further
  columns hold indicators for converted variables. \code{1} and \code{0} 
  code presence and absence of a variable respectively.
}
\description{
\code{countsToVariables} converts counts table to additional variables.
}
\details{
\code{dictionary} file should be a tsv format with header and two columns.
First column should be named \code{"Name"} and hold variable name, second
should be named \code{"Expression"} and hold expression used to identify
variable (eg. \code{"KIR2DL3 & ! KIR2DL2"} will match all samples with
\code{KIR2DL3} and without \code{KIR2DL2}). Optionally a data frame formatted
in the same manner can be passed instead.

Dictionaries shipped with the package:
\describe{
  \item{\code{kir_haplotypes}}{
    KIR genes to KIR haplotypes dictionary.
  }
}
}
\examples{
countsToVariables(MiDAS_tut_KIR, "kir_haplotypes")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/transformationFunctions.R
\name{getExperimentPopulationMultiplicator}
\alias{getExperimentPopulationMultiplicator}
\alias{getExperimentPopulationMultiplicator.matrix}
\alias{getExperimentPopulationMultiplicator.SummarizedExperiment}
\title{Get experiment's population multiplicator}
\usage{
getExperimentPopulationMultiplicator(experiment)

\method{getExperimentPopulationMultiplicator}{matrix}(experiment)

\method{getExperimentPopulationMultiplicator}{SummarizedExperiment}(experiment)
}
\arguments{
\item{experiment}{Matrix or SummarizedExperiment object.}
}
\value{
Experiment's population multiplicator number.
}
\description{
\code{getExperimentPopulationMultiplicator} extracts population multiplicator
from experiment's metadata.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{checkKirGenesFormat}
\alias{checkKirGenesFormat}
\title{Check KIR genes format}
\usage{
checkKirGenesFormat(genes)
}
\arguments{
\item{genes}{Character vector with KIR gene names.}
}
\value{
Logical vector specifying if \code{genes} elements follow KIR genes
  naming conventions.
}
\description{
\code{checkKirGenesFormat} test if the input character follows KIR gene names
naming conventions.
}
\details{
KIR genes: "KIR3DL3", "KIR2DS2", "KIR2DL2", "KIR2DL3", "KIR2DP1", "KIR2DL1",
"KIR3DP1", "KIR2DL1", "KIR3DP1", "KIR2DL4", "KIR3DL1", "KIR3DS1", "KIR2DL5",
"KIR2DS3", "KIR2DS5", "KIR2DS4", "KIR2DS1", "KIR3DL2".
}
\examples{
checkKirGenesFormat(c("KIR3DL3", "KIR2DS2", "KIR2DL2"))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/asserts.R
\name{isStringOrNULL}
\alias{isStringOrNULL}
\title{Check if object is string or NULL}
\usage{
isStringOrNULL(x)
}
\arguments{
\item{x}{object to test.}
}
\value{
Logical indicating if object is string or NULL
}
\description{
\code{isStringOrNULL} checks if object is string (a length one character
vector) or NULL.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/asserts.R
\name{isClass}
\alias{isClass}
\title{Check if object is of class x}
\usage{
isClass(x, class)
}
\arguments{
\item{x}{object to test.}

\item{class}{String specifying class to test.}
}
\value{
Logical indicating if \code{x} is an instance of \code{class}.
}
\description{
\code{isClassOrNULL} checks if object is an instance of a specified class or
is null.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/asserts.R
\name{isExperimentCountsOrZeros}
\alias{isExperimentCountsOrZeros}
\title{Check if frequencies can be calculated for an experiment}
\usage{
isExperimentCountsOrZeros(x, na.rm = TRUE)
}
\arguments{
\item{x}{Matrix or SummarizedExperiment object.}

\item{na.rm}{Logical indicating if \code{NA} values should be accepted.}
}
\value{
Logical indicating if \code{x} contains only positive integers or
  zeros.
}
\description{
\code{isExperimentCountsOrZeros} checks if experiment contains only positive
integers or zeros.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{dict_dist_grantham}
\alias{dict_dist_grantham}
\title{Grantham distance}
\format{
Named integer vector of length 400.
}
\usage{
dict_dist_grantham
}
\description{
Integer vector giving Grantham distance values between pairs of amino acid
residues.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class.R
\name{prepareMiDAS_hla_custom}
\alias{prepareMiDAS_hla_custom}
\title{Prepare MiDAS data on custom HLA level}
\usage{
prepareMiDAS_hla_custom(hla_calls, hla_dictionary, ...)
}
\arguments{
\item{hla_calls}{HLA calls data frame, as returned by
\code{\link{readHlaCalls}} function.}

\item{hla_dictionary}{Data frame giving HLA allele dictionary. See
\code{\link{hlaToVariable}} for more details.}

\item{...}{Not used}
}
\value{
Matrix
}
\description{
Prepare MiDAS data on custom HLA level
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/asserts.R
\name{checkColDataFormat}
\alias{checkColDataFormat}
\title{Assert colData data}
\usage{
checkColDataFormat(data_frame)
}
\arguments{
\item{data_frame}{Data frame containing colData data used to construct
\code{\link{MiDAS}} object.}
}
\value{
Logical indicating if \code{data_frame} is properly formatted.
  Otherwise raise an error.
}
\description{
\code{checkColDataFormat} asserts if the colData data frame has proper format.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{iterativeModel}
\alias{iterativeModel}
\title{Iteratively evaluate model for different variables}
\usage{
iterativeModel(object, placeholder, variables, exponentiate = FALSE)
}
\arguments{
\item{object}{An existing fit from a model function such as lm, glm and many
others.}

\item{placeholder}{String specifying term to substitute with value from
\code{x}. Ignored if set to \code{NULL}.}

\item{variables}{Character vector specifying variables to use in association
tests.}

\item{exponentiate}{Logical flag indicating whether or not to exponentiate
the coefficient estimates. Internally this is passed to
\code{\link[broom]{tidy}}. This is typical for logistic and multinomial
regressions, but a bad idea if there is no log or logit link. Defaults to
FALSE.}
}
\value{
Tibble containing per variable summarised model statistics. The exact
  output format is model dependent and controlled by model's dedicated 
  \code{tidy} function.
}
\description{
Information about variable statistic from each model is extracted using 
\code{tidy} function.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/asserts.R
\name{isTRUEorFALSE}
\alias{isTRUEorFALSE}
\title{Check if object is TRUE or FALSE flag}
\usage{
isTRUEorFALSE(x)
}
\arguments{
\item{x}{object to test.}
}
\value{
Logical indicating if object is TRUE or FALSE flag
}
\description{
\code{isTRUEorFALSE} check if object is a flag (a length one logical vector)
except NA.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class.R
\name{getAllelesForAA}
\alias{getAllelesForAA}
\title{Get HLA alleles for amino acid position}
\usage{
getAllelesForAA(object, aa_pos)
}
\arguments{
\item{object}{\code{\link{MiDAS}} object.}

\item{aa_pos}{String specifying gene and amino acid position, example
\code{"A_9"}.}
}
\value{
Data frame containing HLA alleles, their corresponding amino acid
  residues and frequencies at requested position.
}
\description{
List HLA alleles and amino acid residues at a given position.
}
\examples{
getAllelesForAA(object = MiDAS_tut_object, aa_pos = "A_9")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class.R
\name{prepareMiDAS_hla_alleles}
\alias{prepareMiDAS_hla_alleles}
\title{Prepare MiDAS data on HLA allele level}
\usage{
prepareMiDAS_hla_alleles(hla_calls, ...)
}
\arguments{
\item{hla_calls}{HLA calls data frame, as returned by
\code{\link{readHlaCalls}} function.}

\item{...}{Not used}
}
\value{
Matrix
}
\description{
Prepare MiDAS data on HLA allele level
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{getAlleleResolution}
\alias{getAlleleResolution}
\title{Infer HLA allele resolution}
\usage{
getAlleleResolution(allele)
}
\arguments{
\item{allele}{Character vector with HLA allele numbers.}
}
\value{
Integer vector specifying allele resolutions.
}
\description{
\code{getAlleleResolution} returns the resolution of input HLA allele
numbers.
}
\details{
HLA allele resolution can take the following values: 2, 4, 6, 8. See
\url{http://hla.alleles.org/nomenclature/naming.html} for more details.

\code{NA} values are accepted and returned as \code{NA}.
}
\examples{
allele <- c("A*01:01", "A*01:02")
getAlleleResolution(allele)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/asserts.R
\name{validateFrequencyCutoffs}
\alias{validateFrequencyCutoffs}
\title{Validate frequency cutoffs}
\usage{
validateFrequencyCutoffs(lower_frequency_cutoff, upper_frequency_cutoff)
}
\arguments{
\item{lower_frequency_cutoff}{Number}

\item{upper_frequency_cutoff}{Number}
}
\value{
Logical indicating if \code{lower_frequency_cutoff} and
  \code{upper_frequency_cutoff} are valid.
}
\description{
\code{validateFrequencyCutoffs} checks if \code{lower_frequency_cutoff} and
\code{upper_frequency_cutoff} are valid.
}
\details{
\code{lower_frequency_cutoff} and \code{upper_frequency_cutoff} should be a
positive numbers, giving either frequency or counts.
\code{lower_frequency_cutoff} has to be lower than
\code{upper_frequency_cutoff}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/asserts.R
\name{objectHasPlaceholder}
\alias{objectHasPlaceholder}
\title{Check if placeholder is present in object formula}
\usage{
objectHasPlaceholder(object, placeholder)
}
\arguments{
\item{object}{statistical model to test.}

\item{placeholder}{string specifying name of placeholder.}
}
\value{
Logical indicating if placeholder is present in object formula.
}
\description{
\code{isTRUEorFALSE} check if object is a flag (a length one logical vector)
except NA.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/asserts.R
\name{checkStatisticalModel}
\alias{checkStatisticalModel}
\title{Assert statistical model}
\usage{
checkStatisticalModel(object)
}
\arguments{
\item{object}{An existing fit from a model function such as lm, glm and many
others.}
}
\value{
Logical indicating if \code{object} is an existing fit from a
model functions such as lm, glm and many others. Containing MiDAS object as
its data attribute. Otherwise raise an error.
}
\description{
\code{checkStatisticalModel} asserts if object is an existing fit from a
model functions such as lm, glm and many others. Containing MiDAS object as
its data atribute.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/transformationFunctions.R
\name{getHlaKirInteractions}
\alias{getHlaKirInteractions}
\title{Get HLA - KIR interactions}
\usage{
getHlaKirInteractions(
  hla_calls,
  kir_calls,
  interactions_dict = system.file("extdata", "Match_counts_hla_kir_interactions.txt",
    package = "midasHLA")
)
}
\arguments{
\item{hla_calls}{HLA calls data frame, as returned by
\code{\link{readHlaCalls}} function.}

\item{kir_calls}{KIR calls data frame, as returned by
\code{\link{readKirCalls}} function.}

\item{interactions_dict}{Path to HLA - KIR interactions dictionary.}
}
\value{
Data frame with variable number of columns. First column named 
  \code{"ID"} corresponds to \code{"ID"} column in \code{counts}, further
  columns hold indicators for HLA - KIR interactions. \code{1} and \code{0} 
  code presence and absence of a variable respectively.
}
\description{
\code{getHlaKirInteractions} calculate presence-absence matrix of HLA - KIR
interactions.
}
\details{
\code{hla_calls} are first reduced to all possible resolutions and converted
to additional variables, such as G groups, using dictionaries shipped with
the package.

\code{interactions_dict} file should be a tsv format with header and two
columns. First column should be named \code{"Name"} and hold interactions
names, second should be named \code{"Expression"} and hold expression used to
identify interaction (eg. \code{"C2 & KIR2DL1"} will match all samples
with \code{C2} and \code{KIR2DL1}). The package is shipped with an interactions
file based on \href{https://www.ncbi.nlm.nih.gov/pmc/articles/PMC6558367/}{Pende et al., 2019.}
}
\examples{
getHlaKirInteractions(
  hla_calls = MiDAS_tut_HLA, 
  kir_calls = MiDAS_tut_KIR, 
  interactions_dict = system.file(
    "extdata", "Match_counts_hla_kir_interactions.txt", 
    package = "midasHLA")
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{MiDAS_tut_HLA}
\alias{MiDAS_tut_HLA}
\title{MiDAS tutorial HLA data}
\format{
Data frame with 1000 rows and 19 columns. First column holds samples
  ID's, following columns holds HLA alleles calls for different genes.
  \describe{
    \item{ID}{Character sample ID}
    \item{A_1}{Character}
    \item{A_2}{Character}
    \item{B_1}{Character}
    \item{B_2}{Character}
    \item{C_1}{Character}
    \item{C_2}{Character}
    \item{DPA1_1}{Character}
    \item{DPA1_2}{Character}
    \item{DPB1_1}{Character}
    \item{DPB1_2}{Character}
    \item{DQA1_1}{Character}
    \item{DQA1_2}{Character}
    \item{DQB1_1}{Character}
    \item{DQB1_2}{Character}
    \item{DRA_1}{Character}
    \item{DRA_2}{Character}
    \item{DRB1_1}{Character}
    \item{DRB1_2}{Character}
  }
}
\usage{
MiDAS_tut_HLA
}
\description{
Example HLA calls data used in MiDAS tutorial
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{checkAlleleFormat}
\alias{checkAlleleFormat}
\title{Check HLA allele format}
\usage{
checkAlleleFormat(allele)
}
\arguments{
\item{allele}{Character vector with HLA allele numbers.}
}
\value{
Logical vector specifying if \code{allele} elements follows HLA
  alleles naming conventions.
}
\description{
\code{checkAlleleFormat} test if the input character follows HLA nomenclature
specifications.
}
\details{
Correct HLA number should consist of HLA gene name followed by "*" and sets
of digits separated with ":". Maximum number of sets of digits is 4 which
is termed 8-digit resolution. Optionally HLA numbers can be supplemented with
additional suffix indicating its expression status. See
\url{http://hla.alleles.org/nomenclature/naming.html} for more details.

HLA alleles with identical sequences across exons encoding the peptide
binding domains might be designated with G group allele numbers. Those
numbers have additional G or GG suffix. See
\url{http://hla.alleles.org/alleles/g_groups.html} for more details. They are
interpreted as valid HLA alleles designations.
}
\examples{
allele <- c("A*01:01", "A*01:02")
checkAlleleFormat(allele)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/transformationFunctions.R
\name{aaVariationToCounts}
\alias{aaVariationToCounts}
\title{Transform amino acid variation data frame into counts table}
\usage{
aaVariationToCounts(aa_variation)
}
\arguments{
\item{aa_variation}{Amino acid variation data frame as returned by
\link{hlaToAAVariation}.}
}
\value{
Amino acid counts data frame. First column holds samples ID's, 
  further columns, corresponding to specific amino acid positions, give 
  information on the number of their occurrences in each sample.
}
\description{
\code{aaVariationToCounts} convert amino acid variation data frame into
counts table.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{MiDAS_tut_pheno}
\alias{MiDAS_tut_pheno}
\title{MiDAS tutorial phenotype data}
\format{
Data frame with 1000 rows and 4 columns.
  \describe{
    \item{ID}{Character sample ID}
    \item{disease}{Integer}
    \item{lab_value}{Numeric}
    \item{outcome}{Integer}
  }
}
\usage{
MiDAS_tut_pheno
}
\description{
Example phenotype data used in MiDAS tutorial
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{hlaAlignmentGrantham}
\alias{hlaAlignmentGrantham}
\title{Helper function returning alignment for Grantham distance calculations}
\usage{
hlaAlignmentGrantham(gene, aa_sel = 2:182)
}
\arguments{
\item{gene}{Character vector specifying HLA gene.}

\item{aa_sel}{Numeric vector specifying amino acids that should be extracted.}
}
\value{
HLA alignment processed for grantham distance calculation. Processing 
  includes extracting specific amino acids, masking indels, gaps and stop 
  codons.
}
\description{
Helper function returning alignment for Grantham distance calculations
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/asserts.R
\name{checkHlaCallsFormat}
\alias{checkHlaCallsFormat}
\title{Assert hla calls data frame format}
\usage{
checkHlaCallsFormat(hla_calls)
}
\arguments{
\item{hla_calls}{HLA calls data frame, as returned by
\code{\link{readHlaCalls}} function.}
}
\value{
Logical indicating if \code{hla_calls} follows hla calls data frame
  format. Otherwise raise an error.
}
\description{
\code{checkHlaCallsFormat} asserts if hla calls data frame have proper
format.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class.R
\name{as.data.frame.MiDAS}
\alias{as.data.frame.MiDAS}
\title{Coerce MiDAS to Data Frame}
\usage{
\method{as.data.frame}{MiDAS}(x, ...)
}
\arguments{
\item{x}{any \R object.}

\item{...}{additional arguments to be passed to or from methods.}
}
\value{
Data frame representation of MiDAS object. Consecutive columns hold
  values of variables from MiDAS's experiments and colData. The metadata
  associated with experiments is not preserved.
}
\description{
Coerce MiDAS to Data Frame
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class.R
\name{getOmnibusGroups}
\alias{getOmnibusGroups}
\title{Get omnibus groups from MiDAS object.}
\usage{
getOmnibusGroups(object, experiment)
}
\arguments{
\item{object}{\code{\link{MiDAS}} object.}

\item{experiment}{String specifying experiment.}
}
\value{
List of omnibus groups for a given experiment.
}
\description{
Get omnibus groups from MiDAS object.
}
\details{
For some experiments features can be naturally divided into groups
(here called omnibus groups). For example, in \code{"hla_aa"} experiment
features can be grouped by amino acid position (\code{"B_46_E"},
\code{"B_46_A"}) can be grouped into \code{B_46} group). Such groups can be
then used to perform omnibus test, see \code{\link{runMiDAS}} for more
details.
}
\examples{
getOmnibusGroups(object = MiDAS_tut_object,
                 experiment = "hla_aa")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/transformationFunctions.R
\name{filterExperimentByVariables}
\alias{filterExperimentByVariables}
\alias{filterExperimentByVariables.matrix}
\alias{filterExperimentByVariables.SummarizedExperiment}
\title{Filter experiment by variable}
\usage{
filterExperimentByVariables(experiment, variables)

\method{filterExperimentByVariables}{matrix}(experiment, variables)

\method{filterExperimentByVariables}{SummarizedExperiment}(experiment, variables)
}
\arguments{
\item{experiment}{Matrix or SummarizedExperiment object.}

\item{variables}{Character vector specifying features to choose.}
}
\value{
Filtered \code{experiment} object.
}
\description{
Helper function for experiments filtering
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/transformationFunctions.R
\name{isExperimentInheritanceModelApplicable}
\alias{isExperimentInheritanceModelApplicable}
\alias{isExperimentInheritanceModelApplicable.matrix}
\alias{isExperimentInheritanceModelApplicable.SummarizedExperiment}
\title{Check if experiment is inheritance model applicable}
\usage{
isExperimentInheritanceModelApplicable(experiment)

\method{isExperimentInheritanceModelApplicable}{matrix}(experiment)

\method{isExperimentInheritanceModelApplicable}{SummarizedExperiment}(experiment)
}
\arguments{
\item{experiment}{Matrix or SummarizedExperiment object.}
}
\value{
Logical flag.
}
\description{
\code{isExperimentInheritanceModelApplicable} check experiment's metadata
for presence of \code{"inheritance_model_applicable"} flag, indicating if
inheritance model can be applied.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/asserts.R
\name{checkKirCallsFormat}
\alias{checkKirCallsFormat}
\title{Assert KIR counts data frame format}
\usage{
checkKirCallsFormat(kir_calls)
}
\arguments{
\item{kir_calls}{KIR calls data frame, as returned by
\code{\link{readKirCalls}} function.}
}
\value{
Logical indicating if \code{kir_calls} follow KIR counts data frame
  format. Otherwise raise an error.
}
\description{
\code{checkKirCallsFormat} asserts if KIR counts data frame have proper
format.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{backquote}
\alias{backquote}
\title{Backquote character}
\usage{
backquote(x)
}
\arguments{
\item{x}{Character vector.}
}
\value{
Character vector with its elements backticked.
}
\description{
\code{backquote} places backticks around elements of character vector
}
\details{
\code{backquote} is useful when using HLA allele numbers in formulas, where
\code{'*'} and \code{':'} characters have special meanings.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/asserts.R
\name{isCharacterOrNULL}
\alias{isCharacterOrNULL}
\title{Check if object is character vector or NULL}
\usage{
isCharacterOrNULL(x)
}
\arguments{
\item{x}{object to test.}
}
\value{
Logical indicating if object is character vector or NULL
}
\description{
\code{isCharacterOrNULL} checks if the object is a character vector or NULL.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/asserts.R
\name{hasTidyMethod}
\alias{hasTidyMethod}
\title{Check if tidy method for class exist}
\usage{
hasTidyMethod(class)
}
\arguments{
\item{class}{String giving object class.}
}
\value{
Logical indicating if there is a tidy method for a given class.
}
\description{
\code{hasTidyMethod} check if there is a tidy method available for a given class.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class.R
\name{getExperiments}
\alias{getExperiments}
\title{Get available experiments in MiDAS object.}
\usage{
getExperiments(object)
}
\arguments{
\item{object}{\code{\link{MiDAS}} object.}
}
\value{
Character vector giving names of experiments in \code{object}.
}
\description{
Get available experiments in MiDAS object.
}
\examples{
getExperiments(object = MiDAS_tut_object)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/asserts.R
\name{isCountOrNULL}
\alias{isCountOrNULL}
\title{Check if object is count or NULL}
\usage{
isCountOrNULL(x)
}
\arguments{
\item{x}{object to test.}
}
\value{
Logical indicating if object is count or NULL
}
\description{
\code{isCountOrNULL} check if object is a count (a single positive integer)
or NULL.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{getVariableAAPos}
\alias{getVariableAAPos}
\title{Find variable positions in sequence alignment}
\usage{
getVariableAAPos(alignment, varchar = "[A-Z]")
}
\arguments{
\item{alignment}{Matrix containing amino acid level alignment, as returned by
\code{\link{readHlaAlignments}},}

\item{varchar}{Regex matching characters that should be considered when
looking for variable amino acid positions. See details for further
explanations.}
}
\value{
Integer vector specifying which alignment columns are variable.
}
\description{
\code{getVariableAAPos} finds variable amino acid positions in protein
sequence alignment.
}
\details{
The variable amino acid positions in the alignment are those at which
different amino acids can be found. As the alignments can also contain indels
and unknown characters, the user choice might be to consider those positions
as variable or not. This can be achieved by passing appropriate regular
expression in \code{varchar}. Eg. when \code{varchar = "[A-Z]"} occurence of
deletion/insertion (".") will not be treated as variability. In order to
detect this kind of variability \code{varchar = "[A-Z\\\\.]"} should be used.
}
\examples{
alignment <- readHlaAlignments(gene = "TAP1")
getVariableAAPos(alignment)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/transformationFunctions.R
\name{getExperimentFrequencies}
\alias{getExperimentFrequencies}
\alias{getExperimentFrequencies.matrix}
\alias{getExperimentFrequencies.SummarizedExperiment}
\title{Calculate experiment's features frequencies}
\usage{
getExperimentFrequencies(
  experiment,
  pop_mul = NULL,
  carrier_frequency = FALSE,
  ref = NULL
)

\method{getExperimentFrequencies}{matrix}(
  experiment,
  pop_mul = NULL,
  carrier_frequency = FALSE,
  ref = NULL
)

\method{getExperimentFrequencies}{SummarizedExperiment}(
  experiment,
  pop_mul = NULL,
  carrier_frequency = FALSE,
  ref = NULL
)
}
\arguments{
\item{experiment}{Matrix or SummarizedExperiment object.}

\item{pop_mul}{Number by which number of samples should be multiplied to get
the population size.}

\item{carrier_frequency}{Logical flag indicating if carrier frequency should
be returned.}

\item{ref}{Wide format data frame with first column named "var" holding
features matching \code{experiment} and specific populations frequencies in
following columns. See \code{\link{getReferenceFrequencies}} for more
details.}
}
\value{
Data frame with each row holding specific variable, it's count and 
  frequency.
}
\description{
\code{getExperimentFrequencies} calculate features frequencies.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/asserts.R
\name{isFlagOrNULL}
\alias{isFlagOrNULL}
\title{Check if object is flag or NULL}
\usage{
isFlagOrNULL(x)
}
\arguments{
\item{x}{object to test.}
}
\value{
Logical indicating if object is flag or NULL
}
\description{
\code{isFlagOrNULL} checks if object is flag (a length one logical vector) or
NULL.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class.R
\name{prepareMiDAS_kir_custom}
\alias{prepareMiDAS_kir_custom}
\title{Prepare MiDAS data on custom KIR level}
\usage{
prepareMiDAS_kir_custom(kir_calls, kir_dictionary, ...)
}
\arguments{
\item{kir_calls}{KIR calls data frame, as returned by
\code{\link{readKirCalls}} function.}

\item{kir_dictionary}{Data frame giving KIR genes dictionary. See
\code{\link{countsToVariables}} for more details.}

\item{...}{Not used}
}
\value{
Matrix
}
\description{
Prepare MiDAS data on custom KIR level
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class.R
\name{prepareMiDAS}
\alias{prepareMiDAS}
\title{Construct a MiDAS object}
\usage{
prepareMiDAS(
  hla_calls = NULL,
  kir_calls = NULL,
  colData,
  experiment = c("hla_alleles", "hla_aa", "hla_g_groups", "hla_supertypes",
    "hla_NK_ligands", "kir_genes", "kir_haplotypes", "hla_kir_interactions",
    "hla_divergence", "hla_het", "hla_custom", "kir_custom"),
  placeholder = "term",
  lower_frequency_cutoff = NULL,
  upper_frequency_cutoff = NULL,
  indels = TRUE,
  unkchar = FALSE,
  hla_divergence_aa_selection = "binding_groove",
  hla_het_resolution = 8,
  hla_dictionary = NULL,
  kir_dictionary = NULL
)
}
\arguments{
\item{hla_calls}{HLA calls data frame, as returned by
\code{\link{readHlaCalls}} function.}

\item{kir_calls}{KIR calls data frame, as returned by
\code{\link{readKirCalls}} function.}

\item{colData}{Data frame holding additional variables like phenotypic
observations or covariates. It have to contain \code{'ID'} column holding
samples identifiers corresponding to identifiers in \code{hla_calls} and
\code{kir_calls}. Importantly rows of \code{hla_calls} and
\code{kir_calls} without corresponding phenotype are discarded.}

\item{experiment}{Character vector indicating analysis type for which data
should be prepared. Valid choices are \code{"hla_alleles"},
\code{"hla_aa"}, \code{"hla_g_groups"}, \code{"hla_supertypes"},
\code{"hla_NK_ligands"}, \code{"kir_genes"}, \code{"hla_kir_interactions"},
\code{"hla_divergence"}, \code{"hla_het"}.
See details for further explanations.}

\item{placeholder}{String giving name for dummy variable inserted to
\code{colData}. This variable can be than used to define base statistical
model used by \code{\link{runMiDAS}}.}

\item{lower_frequency_cutoff}{Number giving lower frequency threshold.
Numbers greater than 1 are interpreted as the number of feature occurrences,
numbers between 0 and 1 as fractions.}

\item{upper_frequency_cutoff}{Number giving upper frequency threshold.
Numbers greater than 1 are interpreted as the number of feature occurrences,
numbers between 0 and 1 as fractions.}

\item{indels}{Logical indicating whether indels should be considered when
checking amino acid variability in \code{'hla_aa'} experiment.}

\item{unkchar}{Logical indicating whether unknown characters in the alignment
should be considered when checking amino acid variability in
\code{'hla_aa'} experiment.}

\item{hla_divergence_aa_selection}{String specifying variable region in peptide binding
groove which should be considered for Grantham distance calculation. Valid
choices includes: \code{"binding_groove"}, \code{"B_pocket"},
\code{"F_pocket"}. See details for more information.}

\item{hla_het_resolution}{Number specifying HLA alleles resolution used to
calculate heterogeneity in \code{"hla_het"} experiment.}

\item{hla_dictionary}{Data frame giving HLA allele dictionary used in
\code{'hla_custom'} experiment. See \code{\link{hlaToVariable}} for more
details.}

\item{kir_dictionary}{Data frame giving KIR genes dictionary used in
\code{'kir_custom'} experiment. See \code{\link{countsToVariables}} for more
details.}
}
\value{
Object of class \code{\link{MiDAS}}
}
\description{
\code{prepareMiDAS} transform HLA alleles calls and KIR calls according
to selected \code{experiment}s creating a \code{\link{MiDAS}} object.
}
\details{
\code{experiment} specifies analysis types for which \code{hla_calls} and
\code{kir_call} should be prepared.
\describe{
  \item{\code{'hla_alleles'}}{
    \code{hla_calls} are transformed to counts matrix describing number of
    allele occurrences for each sample. This experiment is used to test
    associations on HLA alleles level.
  }
  \item{\code{'hla_aa'}}{
    \code{hla_calls} are transformed to a matrix of variable amino acid
    positions. See \code{\link{hlaToAAVariation}} for more details. This
    experiment is used to test associations on amino acid level.
  }
  \item{\code{"hla_g_groups"}}{
    \code{hla_calls} are translated into HLA G groups and transformed to
    matrix describing number of G group occurrences for each sample. See
    \code{\link{hlaToVariable}} for more details. This experiment is used to
    test associations on HLA G groups level.
  }
  \item{\code{"hla_supertypes"}}{
    \code{hla_calls} are translated into HLA supertypes and transformed to
    matrix describing number of G group occurrences for each sample. See
    \code{\link{hlaToVariable}} for more details. This experiment is used to
    test associations on HLA supertypes level.
  }
  \item{\code{"hla_NK_ligands"}}{
    \code{hla_calls} are translated into NK ligands, which includes HLA
    Bw4/Bw6 and HLA C1/C2 groups and transformed to matrix describing number
    of their occurrences for each sample. See \code{\link{hlaToVariable}} for
    more details.This experiment is used to test associations on HLA NK
    ligands level.
  }
  \item{\code{"kir_genes"}}{
    \code{kir_calls} are transformed to counts matrix describing number of
    KIR gene occurrences for each sample. This experiment is used to test
    associations on KIR genes level.
  }
  \item{\code{"hla_kir_interactions"}}{
    \code{hla_calls} and \code{kir_calls} are translated to HLA - KIR
    interactions as defined in
    \href{https://www.ncbi.nlm.nih.gov/pmc/articles/PMC6558367/}{Pende et al., 2019.}.
    See \code{\link{getHlaKirInteractions}} for more details. This experiment
    is used to test associations on HLA - KIR interactions level.
  }
  \item{\code{"hla_divergence"}}{
    Grantham distance for class I HLA alleles is calculated based on
    \code{hla_calls} using original formula by
    \href{http://www.sciencemag.org/content/185/4154/862.long}{Grantham R. 1974.}.
    See \code{\link{hlaCallsGranthamDistance}} for more details. This
    experiment is used to test associations on HLA divergence level measured
    by Grantham distance.
  }
  \item{\code{"hla_het"}}{
    \code{hla_calls} are transformed to heterozygosity status, where \code{1}
    designates a heterozygote and \code{0} homozygote. Heterozygosity status
    is calculated only for classical HLA genes (A, B, C, DQA1, DQB1, DRA,
    DRB1, DPA1, DPB1). This experiment is used to test associations on HLA
    divergence level measured by heterozygosity.
  }
}
}
\examples{
midas <- prepareMiDAS(hla_calls = MiDAS_tut_HLA,
                      kir_calls = MiDAS_tut_KIR,
                      colData = MiDAS_tut_pheno,
                      experiment = "hla_alleles")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/asserts.R
\name{stringMatches}
\alias{stringMatches}
\title{Check if string matches one of possible values}
\usage{
stringMatches(x, choice)
}
\arguments{
\item{x}{string to test.}

\item{choice}{Character vector with possible values for \code{x}.}
}
\value{
Logical indicating if \code{x} matches one of the strings in
  \code{choice}.
}
\description{
\code{stringMatches} checks if string is equal to one of the choices.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class.R
\name{filterByOmnibusGroups}
\alias{filterByOmnibusGroups}
\title{Filter MiDAS object by omnibus groups}
\usage{
filterByOmnibusGroups(object, experiment, groups)
}
\arguments{
\item{object}{\code{\link{MiDAS}} object.}

\item{experiment}{String specifying experiment.}

\item{groups}{Character vector specifying omnibus groups to select. See
\code{\link{getOmnibusGroups}} for more details.}
}
\value{
Filtered \code{\link{MiDAS}} object.
}
\description{
Filter MiDAS object by omnibus groups
}
\examples{
filterByOmnibusGroups(object = MiDAS_tut_object,
                      experiment = "hla_aa",
                      groups = c("A_3", "A_6", "C_1"))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class.R
\name{prepareMiDAS_kir_genes}
\alias{prepareMiDAS_kir_genes}
\title{Prepare MiDAS data on KIR genes level}
\usage{
prepareMiDAS_kir_genes(kir_calls, ...)
}
\arguments{
\item{kir_calls}{KIR calls data frame, as returned by
\code{\link{readKirCalls}} function.}

\item{...}{Not used}
}
\value{
Matrix
}
\description{
Prepare MiDAS data on KIR genes level
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{lapply_tryCatch}
\alias{lapply_tryCatch}
\title{lapply with tryCatch routine}
\usage{
lapply_tryCatch(X, FUN, err_res, ...)
}
\arguments{
\item{X}{a vector (atomic or list) or an \code{\link[base]{expression}}
    object.  Other objects (including classed objects) will be coerced
    by \code{base::\link[base]{as.list}}.}

\item{FUN}{the function to be applied to each element of \code{X}:
    see \sQuote{Details}.  In the case of functions like
    \code{+}, \code{\%*\%}, the function name must be backquoted or quoted.}

\item{err_res}{Function creating a result that should be output in case of 
error.}

\item{...}{optional arguments to \code{FUN}.}
}
\value{
List of elements as returned by \code{FUN}.
}
\description{
Used to run function iteratively over list, while using tryCatch to
catch warnings and errors to finally present a summary of issues rather
than error on each and every one. Used in \code{iterativeLRT} and
\code{iterativeModel}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{dfToExperimentMat}
\alias{dfToExperimentMat}
\title{Helper transform data frame to experiment matrix}
\usage{
dfToExperimentMat(df)
}
\arguments{
\item{df}{Data frame}
}
\value{
Matrix representation of \code{df}.
}
\description{
Function deletes 'ID' column from a \code{df}, then transpose it and sets
the column names to values from deleted 'ID' column.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{distGrantham}
\alias{distGrantham}
\title{Calculate Grantham distance between amino acid sequences}
\usage{
distGrantham(aa1, aa2)
}
\arguments{
\item{aa1}{Character vector giving amino acid sequence using one letter
codings. Each element must correspond to single amino acid.}

\item{aa2}{Character vector giving amino acid sequence using one letter
codings. Each element must correspond to single amino acid.}
}
\value{
Numeric vector of normalized Grantham distance between \code{aa1} and
  \code{aa2}.
}
\description{
\code{distGrantham} calculates normalized Grantham distance between two
amino acid sequences. For details on calculations see
\href{http://www.sciencemag.org/content/185/4154/862.long}{Grantham R. 1974.}.
}
\details{
Distance between amino acid sequences is normalized by length of compared
sequences.

Lengths of \code{aa1} and \code{aa2} must be equal.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/parsingFunctions.R
\name{readHlaCalls}
\alias{readHlaCalls}
\title{Read HLA allele calls}
\usage{
readHlaCalls(file, resolution = 4, na.strings = c("Not typed", "-", "NA"))
}
\arguments{
\item{file}{Path to input file.}

\item{resolution}{Number specifying desired resolution.}

\item{na.strings}{a character vector of strings which are to be
    interpreted as \code{\link{NA}} values.  Blank fields are also
    considered to be missing values in logical, integer, numeric and
    complex fields.  Note that the test happens \emph{after} 
    white space is stripped from the input, so \code{na.strings} 
    values may need their own white space stripped in advance.}
}
\value{
HLA calls data frame. First column hold sample IDs, further columns 
  hold HLA allele numbers.
}
\description{
\code{readHlaCalls} read HLA allele calls from file
}
\details{
Input file has to be a tsv formatted table with a header. First column should
contain sample IDs, further columns hold HLA allele numbers. See
\code{system.file("extdata", "MiDAS_tut_HLA.txt", package = "midasHLA")} file
for an example.

\code{resolution} parameter can be used to reduce HLA allele numbers. If
reduction is not needed \code{resolution} can be set to 8. \code{resolution}
parameter can take the following values: 2, 4, 6, 8. For more details
about HLA allele numbers resolution see
\url{http://hla.alleles.org/nomenclature/naming.html}.
}
\examples{
file <- system.file("extdata", "MiDAS_tut_HLA.txt", package = "midasHLA")
hla_calls <- readHlaCalls(file)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{reduceAlleleResolution}
\alias{reduceAlleleResolution}
\title{Reduce HLA alleles}
\usage{
reduceAlleleResolution(allele, resolution = 4)
}
\arguments{
\item{allele}{Character vector with HLA allele numbers.}

\item{resolution}{Number specifying desired resolution.}
}
\value{
Character vector containing reduced HLA allele numbers.
}
\description{
\code{reduceAlleleResolution} reduce HLA allele numbers resolution.
}
\details{
In cases when allele number contain additional suffix their resolution
can not be unambiguously reduced. These cases are returned unchanged.
Function behaves in the same manner if \code{resolution} is higher than
resolution of input HLA allele numbers.

\code{NA} values are accepted and returned as \code{NA}.

TODO here we give such warning when alleles have G or GG suffix (see
http://hla.alleles.org/alleles/g_groups.html)
  "Reducing G groups alleles, major allele gene name will be used."
I dond't really remember why we are doing this xd These allele numbers are
processed as normal alleles (without suffix). Let me know if this warning is
relevant or we could go without it. If we want to leave it lets also add text
in documentation.
}
\examples{
reduceAlleleResolution(c("A*01", "A*01:24", "C*05:24:55:54"), 2)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{getReferenceFrequencies}
\alias{getReferenceFrequencies}
\title{Helper transforming reference frequencies}
\usage{
getReferenceFrequencies(ref, pop, carrier_frequency = FALSE)
}
\arguments{
\item{ref}{Long format data frame with three columns "var", "population",
"frequency".}

\item{pop}{Character giving names of populations to include}

\item{carrier_frequency}{Logical indicating if carrier frequency should be
returned instead of frequency. Carrier frequency is calculated based on
Hardy-Weinberg equilibrium model.}
}
\value{
Wide format data frame with population frequencies as columns.
}
\description{
Helper transforming reference frequencies
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/transformationFunctions.R
\name{getFrequencyMask}
\alias{getFrequencyMask}
\title{Helper function for filtering frequency data frame}
\usage{
getFrequencyMask(
  df,
  lower_frequency_cutoff = NULL,
  upper_frequency_cutoff = NULL
)
}
\arguments{
\item{df}{Data frame as returned by \code{getExperimentFrequencies}.}

\item{lower_frequency_cutoff}{Positive number or \code{NULL}. Numbers greater
than 1 are interpreted as number of feature occurrences, numbers between 0
and 1 as fractions.}

\item{upper_frequency_cutoff}{Positive number or \code{NULL}. Numbers greater
than 1 are interpreted as number of feature occurrences, numbers between 0
and 1 as fractions.}
}
\value{
Character vector containing names of variables after filtration.
}
\description{
Helper function for filtering frequency data frame
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/transformationFunctions.R
\name{filterExperimentByFrequency}
\alias{filterExperimentByFrequency}
\alias{filterExperimentByFrequency.matrix}
\alias{filterExperimentByFrequency.SummarizedExperiment}
\title{Filter experiment by frequency}
\usage{
filterExperimentByFrequency(
  experiment,
  carrier_frequency = FALSE,
  lower_frequency_cutoff = NULL,
  upper_frequency_cutoff = NULL
)

\method{filterExperimentByFrequency}{matrix}(
  experiment,
  carrier_frequency = FALSE,
  lower_frequency_cutoff = NULL,
  upper_frequency_cutoff = NULL
)

\method{filterExperimentByFrequency}{SummarizedExperiment}(
  experiment,
  carrier_frequency = FALSE,
  lower_frequency_cutoff = NULL,
  upper_frequency_cutoff = NULL
)
}
\arguments{
\item{experiment}{Matrix or SummarizedExperiment object.}

\item{carrier_frequency}{Logical flag indicating if carrier frequency should
be returned.}

\item{lower_frequency_cutoff}{Positive number or \code{NULL}. Numbers greater
than 1 are interpreted as number of feature occurrences, numbers between 0
and 1 as fractions.}

\item{upper_frequency_cutoff}{Positive number or \code{NULL}. Numbers greater
than 1 are interpreted as number of feature occurrences, numbers between 0
and 1 as fractions.}
}
\value{
Filtered experiment matrix.
}
\description{
Helper function for experiments filtering
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{iterativeLRT}
\alias{iterativeLRT}
\title{Iterative likelihood ratio test}
\usage{
iterativeLRT(object, placeholder, omnibus_groups)
}
\arguments{
\item{object}{An existing fit from a model function such as lm, glm and many
others.}

\item{placeholder}{String specifying term to substitute with value from
\code{x}. Ignored if set to \code{NULL}.}

\item{omnibus_groups}{List of character vectors giving sets of variables for
which omnibus test should be applied.}
}
\value{
Data frame containing summarised likelihood ratio test results.
}
\description{
\code{iterativeLRT} performs likelihood ratio test in an iterative manner
over groups of variables given in \code{omnibus_groups}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/transformationFunctions.R
\name{hlaToAAVariation}
\alias{hlaToAAVariation}
\title{Generate amino acid variation matrix}
\usage{
hlaToAAVariation(hla_calls, indels = TRUE, unkchar = FALSE, as_df = TRUE)
}
\arguments{
\item{hla_calls}{HLA calls data frame, as returned by
\code{\link{readHlaCalls}} function.}

\item{indels}{Logical indicating whether indels should be considered when
checking variability.}

\item{unkchar}{Logical indicating whether unknown characters in the alignment
should be considered when checking variability.}

\item{as_df}{Logical indicating if data frame should be returned.
Otherwise a matrix is returned.}
}
\value{
Matrix or data frame containing variable amino acid positions.
  Rownames corresponds to ID column in \code{hla_calls}, and colnames to
  alignment positions. If no variation is found one column matrix filled with
  \code{NA}'s is returned.
}
\description{
\code{hlaToAAVariation} convert HLA calls data frame to a matrix of variable
 amino acid positions.
}
\details{
Variable amino acid positions are found by comparing elements of the
alignment column wise. Some of the values in alignment can be treated
specially using \code{indels} and \code{unkchar} arguments. Function
processes alignments for all HLA genes found in \code{hla_calls}.

Variable amino acid position uses protein alignments from
\href{ftp://ftp.ebi.ac.uk/pub/databases/ipd/imgt/hla/alignments/}{EBI database}.
}
\examples{
hlaToAAVariation(MiDAS_tut_HLA)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/transformationFunctions.R
\name{getKIRFrequencies}
\alias{getKIRFrequencies}
\title{Calculate KIR genes frequencies}
\usage{
getKIRFrequencies(kir_calls)
}
\arguments{
\item{kir_calls}{KIR calls data frame, as returned by
\code{\link{readKirCalls}} function.}
}
\value{
Data frame with each row holding KIR gene, it's count and 
  frequency.
}
\description{
\code{getKIRFrequencies} calculates KIR genes frequencies in KIR calls data
frame.
}
\examples{
getKIRFrequencies(MiDAS_tut_KIR)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/summarise.R
\name{summariseAAPosition}
\alias{summariseAAPosition}
\title{Summarize amino acid position}
\usage{
summariseAAPosition(hla_calls, aa_pos, aln = NULL, na.rm = FALSE)
}
\arguments{
\item{hla_calls}{HLA calls data frame, as returned by
\code{\link{readHlaCalls}} function.}

\item{aa_pos}{String specifying gene and amino acid position, example
\code{"A_9"}.}

\item{aln}{Matrix containing amino acid sequence alignments as returned by
\code{\link{readHlaAlignments}} function. By default function will use
alignment files shipped with the package.}

\item{na.rm}{Logical flag indicating if \code{NA} values should be considered
for frequency calculations.}
}
\value{
Data frame containing HLA alleles, their corresponding amino acid
  residues and frequencies at requested position.
}
\description{
List HLA alleles and amino acid residues at a given position.
}
\examples{
summariseAAPosition(MiDAS_tut_HLA, "A_9")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{getHlaCallsGenes}
\alias{getHlaCallsGenes}
\title{Get HLA calls genes}
\usage{
getHlaCallsGenes(hla_calls)
}
\arguments{
\item{hla_calls}{HLA calls data frame, as returned by
\code{\link{readHlaCalls}} function.}
}
\value{
Character vector of genes in \code{hla_calls}.
}
\description{
\code{getHlaCallsGenes} get's genes found in HLA calls.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class.R
\name{filterByFrequency}
\alias{filterByFrequency}
\title{Filter MiDAS object by frequency}
\usage{
filterByFrequency(
  object,
  experiment,
  lower_frequency_cutoff = NULL,
  upper_frequency_cutoff = NULL,
  carrier_frequency = FALSE
)
}
\arguments{
\item{object}{\code{\link{MiDAS}} object.}

\item{experiment}{String specifying experiment.}

\item{lower_frequency_cutoff}{Number giving lower frequency threshold.
Numbers greater than 1 are interpreted as the number of feature occurrences,
numbers between 0 and 1 as fractions.}

\item{upper_frequency_cutoff}{Number giving upper frequency threshold.
Numbers greater than 1 are interpreted as the number of feature occurrences,
numbers between 0 and 1 as fractions.}

\item{carrier_frequency}{Logical flag indicating if carrier frequency should
be returned.}
}
\value{
Filtered \code{\link{MiDAS}} object.
}
\description{
Filter MiDAS object by frequency
}
\examples{
filterByFrequency(object = MiDAS_tut_object, 
                  experiment = "hla_alleles",
                  lower_frequency_cutoff = 0.05,
                  upper_frequency_cutoff = 0.95,
                  carrier_frequency = TRUE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stats.R
\name{omnibusTest}
\alias{omnibusTest}
\title{Omnibus test}
\usage{
omnibusTest(
  object,
  omnibus_groups,
  placeholder = "term",
  correction = "bonferroni",
  n_correction = NULL
)
}
\arguments{
\item{object}{An existing fit from a model function such as lm, glm and many
others.}

\item{omnibus_groups}{List of character vectors giving sets of variables for
which omnibus test should be applied.}

\item{placeholder}{String specifying term in \code{object}'s formula which
should be substituted with variables during analysis.}

\item{correction}{String specifying multiple testing correction method. See
details for further information.}

\item{n_correction}{Integer specifying number of comparisons to consider
during multiple testing correction calculations. For Bonferroni correction
it is possible to specify a number lower than the number of comparisons
being made. This is useful in cases when knowledge about the biology or
redundance of alleles reduces the need for correction. For other methods it
must be at least equal to the number of comparisons being made; only set
this (to non-default) when you know what you are doing!}
}
\value{
Data frame with columns:
  \itemize{
    \item{"group"}{ Omnibus group name}
    \item{"term"}{ Elements of omnibus group added to base model}
    \item{"df"}{ Difference in degrees of freedom between base and extended model}
    \item{"logLik"}{ Difference in log likelihoods between base and extended model}
    \item{"statistic"}{ Chisq statistic}
    \item{"p.value"}{ P-value}
    \item{"p.adjusted"}{ Adjusted p-value}
  }
}
\description{
\code{OmnibusTest} calculates overall p-value for linear combination of
variables using likelihood ratio test.
}
\details{
Likelihood ratio test is conducted by comparing a model given in an
\code{object} with an extended model, that is created by including the effect
of variables given in \code{variables} as their linear combination.
}
\examples{
midas <- prepareMiDAS(hla_calls = MiDAS_tut_HLA,
                      colData = MiDAS_tut_pheno,
                      experiment = "hla_aa")

# define base model
object <- lm(disease ~ term, data = midas)
omnibusTest(object,
            omnibus_groups = list(
              A_29 = c("A_29_D", "A_29_A"),
              A_43 = c("A_43_Q", "A_43_R")
            ))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class.R
\name{prepareMiDAS_hla_het}
\alias{prepareMiDAS_hla_het}
\title{Prepare MiDAS data on HLA heterozygosity level}
\usage{
prepareMiDAS_hla_het(hla_calls, hla_het_resolution = 8, ...)
}
\arguments{
\item{hla_calls}{HLA calls data frame, as returned by
\code{\link{readHlaCalls}} function.}

\item{hla_het_resolution}{Number specifying HLA alleles resolution used to
calculate heterogeneity.}

\item{...}{Not used}
}
\value{
Matrix
}
\description{
Prepare MiDAS data on HLA heterozygosity level
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{experimentMatToDf}
\alias{experimentMatToDf}
\title{Helper transform experiment matrix to data frame}
\usage{
experimentMatToDf(mat)
}
\arguments{
\item{mat}{Matrix}
}
\value{
Data frame representation of \code{mat}.
}
\description{
Function transpose \code{mat} and inserts column names of input \code{mat} as
a 'ID' column.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class.R
\name{prepareMiDAS_hla_divergence}
\alias{prepareMiDAS_hla_divergence}
\title{Prepare MiDAS data on HLA divergence level}
\usage{
prepareMiDAS_hla_divergence(
  hla_calls,
  hla_divergence_aa_selection = "binding_groove",
  ...
)
}
\arguments{
\item{hla_calls}{HLA calls data frame, as returned by
\code{\link{readHlaCalls}} function.}

\item{hla_divergence_aa_selection}{String specifying variable region in peptide binding
groove which should be considered for Grantham distance calculation. Valid
choices includes: \code{"binding_groove"}, \code{"B_pocket"},
\code{"F_pocket"}. See details for more information.}

\item{...}{Not used}
}
\value{
Matrix
}
\description{
Prepare MiDAS data on HLA divergence level
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stats.R
\name{analyzeAssociations}
\alias{analyzeAssociations}
\title{Association analysis}
\usage{
analyzeAssociations(
  object,
  variables,
  placeholder = "term",
  correction = "bonferroni",
  n_correction = NULL,
  exponentiate = FALSE
)
}
\arguments{
\item{object}{An existing fit from a model function such as lm, glm and many
others.}

\item{variables}{Character vector specifying variables to use in association
tests.}

\item{placeholder}{String specifying term in \code{object}'s formula which
should be substituted with variables during analysis.}

\item{correction}{String specifying multiple testing correction method. See
details for further information.}

\item{n_correction}{Integer specifying number of comparisons to consider
during multiple testing correction calculations. For Bonferroni correction
it is possible to specify a number lower than the number of comparisons
being made. This is useful in cases when knowledge about the biology or
redundance of alleles reduces the need for correction. For other methods it
must be at least equal to the number of comparisons being made; only set
this (to non-default) when you know what you are doing!}

\item{exponentiate}{Logical flag indicating whether or not to exponentiate
the coefficient estimates. Internally this is passed to
\code{\link[broom]{tidy}}. This is typical for logistic and multinomial
regressions, but a bad idea if there is no log or logit link. Defaults to
FALSE.}
}
\value{
Tibble containing combined results for all \code{variables}. The 
  first column \code{"term"} hold the names of \code{variables}. Further
  columns depends on the used model and are determined by associated 
  \code{tidy} function. Generally they will include \code{"estimate"}, 
  \code{"std.error"}, \code{"statistic"}, \code{"p.value"}, \code{"conf.low"},
  \code{"conf.high"}, \code{"p.adjusted"}.
}
\description{
\code{analyzeAssociations} perform association analysis on a single variable
level using a statistical model of choice.
}
\details{
\code{correction} specifies p-value adjustment method to use, common choice
is Benjamini & Hochberg (1995) (\code{"BH"}). Internally this is passed to
\link[stats]{p.adjust}.
}
\examples{
midas <- prepareMiDAS(hla_calls = MiDAS_tut_HLA,
                      colData = MiDAS_tut_pheno,
                      experiment = "hla_alleles")

# analyzeAssociations expects model data to be a data.frame
midas_data <- as.data.frame(midas)

# define base model
object <- lm(disease ~ term, data = midas_data)

# test for alleles associations
analyzeAssociations(object = object,
                    variables = c("B*14:02", "DRB1*11:01"))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{MiDAS_tut_object}
\alias{MiDAS_tut_object}
\title{MiDAS tutorial MiDAS object}
\format{
MiDAS object with following experiments defined:
  \describe{
    \item{hla_alleles}{SummarizedExperiment with 447 rows and 1000 columns}
    \item{hla_aa}{SummarizedExperiment with 1223 rows and 1000 columns}
    \item{hla_g_groups}{SummarizedExperiment with 46 rows and 1000 columns}
    \item{hla_supertypes}{SummarizedExperiment with 12 rows and 1000 columns}
    \item{hla_NK_ligands}{SummarizedExperiment with 5 rows and 1000 columns}
    \item{kir_genes}{SummarizedExperiment with 16 rows and 1000 columns}
    \item{kir_haplotypes}{SummarizedExperiment with 6 rows and 1000 columns}
    \item{hla_kir_interactions}{SummarizedExperiment with 29 rows and 1000 columns}
    \item{hla_divergence}{matrix with 4 rows and 1000 columns}
    \item{hla_het}{SummarizedExperiment with 9 rows and 1000 columns}
  }
}
\usage{
MiDAS_tut_object
}
\description{
Example MiDAS object created with data used in MiDAS tutorial: 
\code{MiDAS_tut_HLA}, \code{MiDAS_tut_KIR}, \code{MiDAS_tut_pheno}.
Used in code examlpes and unit tests.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/transformationFunctions.R
\name{hlaCallsToCounts}
\alias{hlaCallsToCounts}
\title{Transform HLA calls to counts table}
\usage{
hlaCallsToCounts(hla_calls, check_hla_format = TRUE)
}
\arguments{
\item{hla_calls}{HLA calls data frame, as returned by
\code{\link{readHlaCalls}} function.}

\item{check_hla_format}{Logical indicating if \code{hla_calls} format should
be checked. This is useful if one wants to use \code{hlaCallsToCounts} with
input not adhering to HLA nomenclature standards. See examples.}
}
\value{
HLA allele counts data frame. First column holds samples ID's, further 
  columns, corresponding to specific alleles, give information on the number 
  of their occurrences in each sample.
}
\description{
\code{hlaCallsToCounts} converts HLA calls data frame into a counts table.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/parsingFunctions.R
\name{readHlaAlignments}
\alias{readHlaAlignments}
\title{Read HLA allele alignments}
\usage{
readHlaAlignments(file, gene = NULL, trim = FALSE, unkchar = "")
}
\arguments{
\item{file}{Path to input file.}

\item{gene}{Character vector of length one specifying the name of a gene for
which alignment is required. See details for further explanations.}

\item{trim}{Logical indicating if alignment should be trimmed to start codon
of the mature protein.}

\item{unkchar}{Character to be used to represent positions with unknown
sequence.}
}
\value{
Matrix containing HLA allele alignments.

  Rownames correspond to allele numbers and columns to positions in the
  alignment. Sequences following the termination codon are marked as empty
  character (\code{""}). Unknown sequences are marked with a character of
  choice, by default \code{""}. Stop codons are represented by a hash (X).
  Insertion and deletions are marked with period (.).
}
\description{
\code{readHlaAlignments} read HLA allele alignments from file.
}
\details{
HLA allele alignment file should follow EBI database format, for details
see
\url{ftp://ftp.ebi.ac.uk/pub/databases/ipd/imgt/hla/alignments/README.md}.

All protein alignment files from the EBI database are shipped with the package.
They can be easily accessed using \code{gene} parameter. If \code{gene} is
set to \code{NULL}, \code{file} parameter is used instead and alignment is
read from the provided file. In EBI database alignments for DRB1, DRB3, DRB4
and DRB5 genes are provided as a single file, here they are separated.

Additionally, for the alleles without sequence defined in the original 
alignment files we have infered thier sequence based on known higher resolution
alleles.
}
\examples{
hla_alignments <- readHlaAlignments(gene = "A")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{midasToWide}
\alias{midasToWide}
\title{Transform MiDAS to wide format data.frame}
\usage{
midasToWide(object, experiment)
}
\arguments{
\item{object}{Object of class MiDAS}

\item{experiment}{Character specifying experiments to include}
}
\value{
Data frame representation of MiDAS object. Consecutive columns holds
  values of variables from MiDAS's experiments and colData. The metadata
  associated with experiments is not preserved.
}
\description{
Transform MiDAS to wide format data.frame
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class.R
\docType{class}
\name{MiDAS-class}
\alias{MiDAS-class}
\alias{MiDAS}
\alias{getExperiments,MiDAS-method}
\alias{getHlaCalls,MiDAS-method}
\alias{getKirCalls,MiDAS-method}
\alias{getPlaceholder,MiDAS-method}
\alias{getOmnibusGroups,MiDAS-method}
\alias{getFrequencies,MiDAS-method}
\alias{filterByFrequency,MiDAS-method}
\alias{filterByOmnibusGroups,MiDAS-method}
\alias{filterByVariables,MiDAS-method}
\alias{getAllelesForAA,MiDAS-method}
\title{MiDAS class}
\usage{
\S4method{getExperiments}{MiDAS}(object)

\S4method{getHlaCalls}{MiDAS}(object)

\S4method{getKirCalls}{MiDAS}(object)

\S4method{getPlaceholder}{MiDAS}(object)

\S4method{getOmnibusGroups}{MiDAS}(object, experiment)

\S4method{getFrequencies}{MiDAS}(
  object,
  experiment,
  carrier_frequency = FALSE,
  compare = FALSE,
  ref_pop = list(hla_alleles = c("USA NMDP African American pop 2", "USA NMDP Chinese",
    "USA NMDP European Caucasian", "USA NMDP Hispanic South or Central American",
    "USA NMDP Japanese", "USA NMDP North American Amerindian",
    "USA NMDP South Asian Indian"), kir_genes = c("USA California African American KIR",
    "USA California Asian American KIR", "USA California Caucasians KIR",
    "USA California Hispanic KIR")),
  ref = list(hla_alleles = allele_frequencies, kir_genes = kir_frequencies)
)

\S4method{filterByFrequency}{MiDAS}(
  object,
  experiment,
  lower_frequency_cutoff = NULL,
  upper_frequency_cutoff = NULL,
  carrier_frequency = FALSE
)

\S4method{filterByOmnibusGroups}{MiDAS}(object, experiment, groups)

\S4method{filterByVariables}{MiDAS}(object, experiment, variables)

\S4method{getAllelesForAA}{MiDAS}(object, aa_pos)
}
\arguments{
\item{object}{\code{\link{MiDAS}} object.}

\item{experiment}{String specifying experiment.}

\item{carrier_frequency}{Logical flag indicating if carrier frequency should
be returned.}

\item{compare}{Logical flag indicating if \code{hla_calls} frequencies
should be compared to reference frequencies given in \code{ref}.}

\item{ref_pop}{Named list of character vectors giving names of reference
populations in \code{ref} to compare with. Optionally vectors can be named,
then those names will be used as population names. Each vector should
correspond to a specific experiment.}

\item{ref}{Named list of reference frequencies data frames. Each element
should give reference for a specific experiment. See
\code{\link{allele_frequencies}} for an example on how reference
frequency data frame should be formatted.}

\item{lower_frequency_cutoff}{Number giving lower frequency threshold.
Numbers greater than 1 are interpreted as the number of feature occurrences,
numbers between 0 and 1 as fractions.}

\item{upper_frequency_cutoff}{Number giving upper frequency threshold.
Numbers greater than 1 are interpreted as the number of feature occurrences,
numbers between 0 and 1 as fractions.}

\item{groups}{Character vector specifying omnibus groups to select. See
\code{\link{getOmnibusGroups}} for more details.}

\item{variables}{Character vector specifying features to select.}

\item{aa_pos}{String specifying gene and amino acid position, example
\code{"A_9"}.}
}
\value{
Instance of class MiDAS
}
\description{
The \code{MiDAS} class is a \code{\link{MultiAssayExperiment}} object
containing data and metadata required for MiDAS analysis.

Valid \code{MiDAS} object must have unique features names across all
experiments and colData. It's metadata list needs to have a \code{placeholder}
element, which is a string specifying name of column in colData used when
defining statistical model for downstream analyses (see
\code{\link{runMiDAS}} for more details). Optionally the object's metadata
can also store \code{'hla_calls'} and \code{'kir_calls'} data frames (see
\code{\link{prepareMiDAS}} for more details).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/transformationFunctions.R
\name{hlaToVariable}
\alias{hlaToVariable}
\title{Convert HLA calls to variables}
\usage{
hlaToVariable(
  hla_calls,
  dictionary,
  reduce = TRUE,
  na.value = 0,
  nacols.rm = TRUE
)
}
\arguments{
\item{hla_calls}{HLA calls data frame, as returned by
\code{\link{readHlaCalls}} function.}

\item{dictionary}{Path to file containing HLA allele dictionary or a
data frame.}

\item{reduce}{Logical indicating if function should try to reduce allele
resolution when no matching entry  in the dictionary is found. See details.}

\item{na.value}{Vector of length one speciyfing value for alleles with
no matching entry in \code{dictionary}. Default is to use \code{0}.}

\item{nacols.rm}{Logical indicating if result columns that contain only
\code{NA} should be removed.}
}
\value{
Data frame with variable number of columns. First column named 
  \code{"ID"} corresponds to \code{"ID"} column in \code{hla_calls}, further
  columns holds converted HLA variables.
}
\description{
\code{hlaToVariable} converts HLA calls data frame to additional variables.
}
\details{
\code{dictionary} file should be a tsv format with header and two columns.
First column should hold allele numbers and second corresponding additional
variables. Optionally a data frame formatted in the same manner can be passed
instead.

\code{dictionary} can be also used to access dictionaries shipped with the
package. They can be referred to by using one of the following strings:
\describe{
  \item{\code{"allele_HLA_Bw"}}{
    Translates HLA-B alleles together with A*23, A*24 and A*32 into Bw4 and
    Bw6 allele groups. In some cases HLA alleles containing Bw4 epitope, on
    nucleotide level actually carries a premature stop codon. Meaning that
    although on nucleotide level the allele would encode a Bw4 epitope it's
    not really there and it is assigned to Bw6 group. However in 4-digit
    resolution these alleles can not be distinguished from other Bw4 groups.
    Since alleles with premature stop codons are rare, Bw4 group is assigned.
  }
  \item{\code{"allele_HLA-B_only_Bw"}}{
    Translates HLA-B alleles (without A*23, A*24 and A*32) into Bw4 and Bw6
    allele groups.
  }
  \item{\code{"allele_HLA-C_C1-2"}}{
    Translates HLA-C alleles into C1 and C2 allele groups.
  }
  \item{\code{"allele_HLA_supertype"}}{
   Translates HLA-A and HLA-B alleles into supertypes, a classification that
   group HLA alleles based on peptide binding specificities.
  }
  \item{\code{"allele_HLA_Ggroup"}}{
    Translates HLA alleles into G groups, which defines amino acid identity
    only in the exons relevant for peptide binding. Note that alleles
    DRB1*01:01:01 and DRB1*01:16 match more than one G group, here this
    ambiguity was removed by deleting matching with DRB5*01:01:01G group.
  }
}

\code{reduce} control if conversion should happen in a greedy way, such that
if some HLA number cannot be converted, it's resolution is reduced by 2 and
another attempt is taken. This process stops when alleles cannot be further
reduced or all have been successfully converted.
}
\examples{
hlaToVariable(MiDAS_tut_HLA, dictionary = "allele_HLA_supertype")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class.R
\name{filterByVariables}
\alias{filterByVariables}
\title{Filter MiDAS object by features}
\usage{
filterByVariables(object, experiment, variables)
}
\arguments{
\item{object}{\code{\link{MiDAS}} object.}

\item{experiment}{String specifying experiment.}

\item{variables}{Character vector specifying features to select.}
}
\value{
Filtered \code{\link{MiDAS}} object.
}
\description{
Filter MiDAS object by features
}
\examples{
filterByVariables(object = MiDAS_tut_object,
                  experiment = "hla_alleles",
                  variables = c("A*25:01", "A*26:01", "B*07:02"))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{filterListByElements}
\alias{filterListByElements}
\title{Filter list by elements}
\usage{
filterListByElements(list, elements)
}
\arguments{
\item{list}{A list.}

\item{elements}{Character vector of elements to keep.}
}
\value{
List filtered according to \code{elements} argument.
}
\description{
Filter two level list by its secondary elements and remove empty items
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stats.R
\name{HWETest}
\alias{HWETest}
\title{Test for Hardy Weinberg equilibrium}
\usage{
HWETest(
  object,
  experiment = c("hla_alleles", "hla_aa", "hla_g_groups", "hla_supertypes",
    "hla_NK_ligands"),
  HWE_group = NULL,
  HWE_cutoff = NULL,
  as.MiDAS = FALSE
)
}
\arguments{
\item{object}{\code{\link{MiDAS}} object.}

\item{experiment}{String specifying experiment to test. Valid values
includes \code{"hla_alleles"}, \code{"hla_aa"}, \code{"hla_g_groups"},
\code{"hla_supertypes"}, \code{"hla_NK_ligands"}.}

\item{HWE_group}{Expression defining samples grouping to test for Hardy
Weinberg equilibrium. By default samples are not grouped.}

\item{HWE_cutoff}{Number specifying p-value threshold. When \code{HWE_group}
is specified both groups are thresholded.}

\item{as.MiDAS}{Logical flag indicating if MiDAS object should be returned.}
}
\value{
Data frame with Hardy Weinberg Equilibrium test results or a filtered
  MiDAS object.
}
\description{
Test experiment features for Hardy Weinberg equilibrium.
}
\details{
Setting \code{as.MiDAS} to \code{TRUE} will filter MiDAS object based on
p-value cut-off given by \code{HWE_cutoff}.
}
\examples{
# create MiDAS object
midas <- prepareMiDAS(hla_calls = MiDAS_tut_HLA,
                      colData = MiDAS_tut_pheno,
                      experiment = "hla_alleles"
)

# get HWE p-values as data frame
HWETest(midas, experiment = "hla_alleles")

# get HWE in groups defined by disease status
# grouping by `disease == 1` will divide samples into two groups:
# `disease == 1` and `not disease == 1`
HWETest(midas, experiment = "hla_alleles", HWE_group = disease == 1)

# filter MiDAS object by HWE test p-value
HWETest(midas, experiment = "hla_alleles", HWE_cutoff = 0.05, as.MiDAS = TRUE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stats.R
\name{runMiDAS}
\alias{runMiDAS}
\title{Run MiDAS statistical analysis}
\usage{
runMiDAS(
  object,
  experiment,
  inheritance_model = NULL,
  conditional = FALSE,
  omnibus = FALSE,
  omnibus_groups_filter = NULL,
  lower_frequency_cutoff = NULL,
  upper_frequency_cutoff = NULL,
  correction = "bonferroni",
  n_correction = NULL,
  exponentiate = FALSE,
  th = 0.05,
  th_adj = TRUE,
  keep = FALSE,
  rss_th = 1e-07
)
}
\arguments{
\item{object}{An existing fit from a model function such as lm, glm and many
others.}

\item{experiment}{String indicating the experiment associated with
\code{object}'s \code{MiDAS} data to use. Valid values includes:
\code{"hla_alleles"}, \code{"hla_aa"}, \code{"hla_g_groups"},
\code{"hla_supertypes"}, \code{"hla_NK_ligands"}, \code{"kir_genes"},
\code{"kir_haplotypes"}, \code{"hla_kir_interactions"},
\code{"hla_divergence"}, \code{"hla_het"}, \code{"hla_custom"},
\code{"kir_custom"}. See \code{\link{prepareMiDAS}} for more information.}

\item{inheritance_model}{String specifying inheritance model to use.
Available choices are \code{"dominant"}, \code{"recessive"},
\code{"additive"}.}

\item{conditional}{Logical flag indicating if conditional analysis should be
performed.}

\item{omnibus}{Logical flag indicating if omnibus test should be used.}

\item{omnibus_groups_filter}{Character vector specifying omnibus groups to
use.}

\item{lower_frequency_cutoff}{Number giving lower frequency threshold.
Numbers greater than 1 are interpreted as the number of feature occurrences,
numbers between 0 and 1 as fractions.}

\item{upper_frequency_cutoff}{Number giving upper frequency threshold.
Numbers greater than 1 are interpreted as the number of feature occurrences,
numbers between 0 and 1 as fractions.}

\item{correction}{String specifying multiple testing correction method. See
details for further information.}

\item{n_correction}{Integer specifying number of comparisons to consider
during multiple testing correction calculations. For Bonferroni correction
it is possible to specify a number lower than the number of comparisons
being made. This is useful in cases when knowledge about the biology or
redundance of alleles reduces the need for correction. For other methods it
must be at least equal to the number of comparisons being made; only set
this (to non-default) when you know what you are doing!}

\item{exponentiate}{Logical flag indicating whether or not to exponentiate
the coefficient estimates. Internally this is passed to
\code{\link[broom]{tidy}}. This is typical for logistic and multinomial
regressions, but a bad idea if there is no log or logit link. Defaults to
FALSE.}

\item{th}{Number specifying threshold for a variable to be considered
significant.}

\item{th_adj}{Logical flag indicating if adjusted p-value should be used as
threshold criteria, otherwise unadjusted p-value is used.}

\item{keep}{Logical flag indicating if the output should be a list of results
resulting from each selection step. Default is to return only the final
result.}

\item{rss_th}{Number specifying residual sum of squares threshold at which
function should stop adding additional variables. As the residual sum of
squares approaches \code{0} the perfect fit is obtained making further
attempts at variable selection nonsense. This behavior can be controlled
using \code{rss_th}.}
}
\value{
Analysis results, depending on the parameters:
  \describe{
    \item{\code{conditional=FALSE, omnibus=FALSE}}{
      Tibble with first column \code{"term"} holding names of tested 
      variables (eg. alleles). Further columns depends on the used 
      model and are determined by associated \code{tidy} function. Generally 
      they will include \code{"estimate"}, \code{"std.error"}, 
      \code{"statistic"}, \code{"p.value"}, \code{"conf.low"}, 
      \code{"conf.high"}, \code{"p.adjusted"}.
    }
    \item{\code{conditional=TRUE, omnibus=FALSE}}{
      Tibble or a list of tibbles, see \code{keep} argument. The first column 
      \code{"term"} hold names of tested variables. Further 
      columns depends on the used model and are determined by associated 
      \code{tidy} function. Generally they will include \code{"estimate"}, 
      \code{"std.error"}, \code{"statistic"}, \code{"p.value"}, 
      \code{"conf.low"}, \code{"conf.high"}, \code{"p.adjusted"}.
    }
    \item{\code{conditional=FALSE, omnibus=TRUE}}{
      Tibble with first column holding names of tested omnibus groups 
      (eg. amino acid positions) and second names of variables in the group
      (eg. residues). Further columns are: \code{"df"} giving difference in 
      degrees of freedom between base and extended model, \code{"statistic"}
      giving Chisq statistic, \code{"p.value"} and \code{"p.adjusted"}.
    }
    \item{\code{conditional=TRUE, omnibus=TRUE}}{
      Tibble or a list of tibbles, see \code{keep} argument. The first column 
      hold names of tested omnibus groups (eg. amino acid positions), second 
      column hold names of variables in the group (eg. residues). Further 
      columns are: \code{"df"} giving difference in degrees of freedom 
      between base and extended model, \code{"statistic"} giving Chisq 
      statistic, \code{"p.value"} and \code{"p.adjusted"}.
    }
  }
}
\description{
\code{runMiDAS} perform association analysis on MiDAS data using statistical
model of choice. Function is intended for use with \code{\link{prepareMiDAS}}.
See examples section.
}
\details{
By default statistical analysis is performed iteratively on each variable in
selected experiment. This is done by substituting \code{placeholder} in the
\code{object}'s formula with each variable in the experiment.

Setting \code{conditional} argument to \code{TRUE} will cause the statistical
analysis to be performed in a stepwise conditional testing manner, adding the
previous top-associated variable as a covariate to \code{object}'s formula.
The analysis stops when there is no more significant variables, based on
self-defined threshold (\code{th} argument). Either adjusted or unadjusted
p-values can be used as the selection criteria, which is controlled using
\code{th_adj} argument.

Setting \code{omnibus} argument to \code{TRUE} will cause the statistical
analysis to be performed iteratively on groups of variables (like residues at
particular amino acid position) using likelihood ratio test.

Argument \code{inheritance_model} specifies the inheritance model that should
be applyed to experiment's data. Following choices are available: 
\itemize{
  \item{"dominant"}{
    carrier status is sufficient for expression of the phenotype (non-carrier: 
    0, heterozygous & homozygous carrier: 1).
  }
  \item{"recessive"}{
    two copies are required for expression of the phenotype (non-carrier & 
    heterozygous carrier: 0, homozygous carrier: 1).
  }
  \item{"additive"}{
    allele dosage matters, homozygous carriers show stronger phenotype 
    expression or higher risk than heterozygous carriers (non-carrier = 0, 
    heterozygous carrier = 1, homozygous carrier = 2).
  }
  \item{"overdominant"}{
    heterozygous carriers are at higher risk compared to non-carriers or 
    homozygous carriers (non-carrier & homozygous carrier = 0, heterozygous 
    carrier = 1).
  }
}  
 
\code{correction} specifies p-value adjustment method to use, common choice
is Benjamini & Hochberg (1995) (\code{"BH"}). Internally this is passed to
\link[stats]{p.adjust}.
}
\examples{
# create MiDAS object
midas <- prepareMiDAS(hla_calls = MiDAS_tut_HLA,
                      colData = MiDAS_tut_pheno,
                      experiment = c("hla_alleles", "hla_aa")
)

# construct statistical model
object <- lm(disease ~ term, data = midas)

# run analysis
runMiDAS(object, experiment = "hla_alleles", inheritance_model = "dominant")

# omnibus test
# omnibus_groups_filter argument can be used to restrict omnibus test only
# to selected variables groups, here we restrict the analysis to HLA-A
# positions 29 and 43.
runMiDAS(
  object,
  experiment = "hla_aa",
  inheritance_model = "dominant",
  omnibus = TRUE,
  omnibus_groups_filter = c("A_29", "A_43")
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class.R
\name{getFrequencies}
\alias{getFrequencies}
\title{Calculate features frequencies for a given experiment in MiDAS object.}
\usage{
getFrequencies(
  object,
  experiment,
  carrier_frequency = FALSE,
  compare = FALSE,
  ref_pop = list(hla_alleles = c("USA NMDP African American pop 2", "USA NMDP Chinese",
    "USA NMDP European Caucasian", "USA NMDP Hispanic South or Central American",
    "USA NMDP Japanese", "USA NMDP North American Amerindian",
    "USA NMDP South Asian Indian"), kir_genes = c("USA California African American KIR",
    "USA California Asian American KIR", "USA California Caucasians KIR",
    "USA California Hispanic KIR")),
  ref = list(hla_alleles = allele_frequencies, kir_genes = kir_frequencies)
)
}
\arguments{
\item{object}{\code{\link{MiDAS}} object.}

\item{experiment}{Matrix or SummarizedExperiment object.}

\item{carrier_frequency}{Logical flag indicating if carrier frequency should
be returned.}

\item{compare}{Logical flag indicating if \code{hla_calls} frequencies
should be compared to reference frequencies given in \code{ref}.}

\item{ref_pop}{Named list of character vectors giving names of reference
populations in \code{ref} to compare with. Optionally vectors can be named,
then those names will be used as population names. Each vector should
correspond to a specific experiment.}

\item{ref}{Named list of reference frequencies data frames. Each element
should give reference for a specific experiment. See
\code{\link{allele_frequencies}} for an example on how reference
frequency data frame should be formatted.}
}
\value{
Data frame with features from selected experiment and their
  corresponding frequencies. Column \code{"term"} hold features names, 
  \code{"Counts"} hold number of feature occurrences, \code{"Freq"} hold 
  feature frequencies. If argument \code{compare} is set to \code{TRUE}, 
  further columns will hold frequencies in reference populations.
}
\description{
Calculate features frequencies for a given experiment in MiDAS object.
}
\examples{
# using default reference populations
getFrequencies(object = MiDAS_tut_object, 
               experiment = "hla_alleles", 
               compare = TRUE)

# using customized set of reference populations
getFrequencies(
  object = MiDAS_tut_object, 
  experiment = "hla_alleles", 
  compare = TRUE,
  ref_pop = list(
    hla_alleles = c("USA NMDP Chinese", "USA NMDP European Caucasian")
  ),
  ref = list(hla_alleles = allele_frequencies)
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/asserts.R
\name{characterMatches}
\alias{characterMatches}
\title{Check if character matches one of possible values}
\usage{
characterMatches(x, choice)
}
\arguments{
\item{x}{Character vector to test.}

\item{choice}{Character vector with possible values for \code{x}.}
}
\value{
Logical indicating if \code{x}'s elements matches any of the values
in \code{choice}.
}
\description{
\code{characterMatches} checks if all elements of a character vector matches
values in choices.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{convertAlleleToVariable}
\alias{convertAlleleToVariable}
\title{Convert allele numbers to additional variables}
\usage{
convertAlleleToVariable(allele, dictionary)
}
\arguments{
\item{allele}{Character vector with HLA allele numbers.}

\item{dictionary}{Path to file containing HLA allele dictionary or a
data frame.}
}
\value{
Vector containing HLA allele numbers converted to additional
  variables according to \code{dictionary}.
}
\description{
\code{convertAlleleToVariable} converts input HLA allele numbers to additional
variables based on the supplied dictionary.
}
\details{
\code{dictionary} file should be a tsv format with header and two columns.
First column should hold allele numbers, second additional variables (eg.
expression level).

Type of the returned vector depends on the type of the additional variable.
}
\examples{
dictionary <- system.file("extdata", "Match_allele_HLA_supertype.txt", package = "midasHLA")
convertAlleleToVariable(c("A*01:01", "A*02:01"), dictionary = dictionary)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{runMiDASGetVarsFreq}
\alias{runMiDASGetVarsFreq}
\title{Get variables frequencies from MiDAS}
\usage{
runMiDASGetVarsFreq(midas, experiment, test_covar)
}
\arguments{
\item{midas}{MiDAS object.}

\item{experiment}{String specifying experiment from \code{midas}.}

\item{test_covar}{String giving name of test covariate.}
}
\value{
Data frame with variable number of columns. First column,
  \code{"term"} holds experiment's variables, further columns hold number of
  variable occurrence and their frequencies.
}
\description{
Helper getting variables frequencies from MiDAS object. Additionally for
binary test covariate frequencies per phenotype are added. Used in scope of 
\code{runMiDAS}.
}
